This directory contains routines for the Lapack version 3 eigenvalue/vector
routine DSYEVR.  A minimal set of support routines needed to run the
software in the Karman Linux Beowulf cluster is included.  I have made some
changes to the original DSYEVR, which are now in DSYEVR_EK.F, to accommodate
the lack of IEEE support in the Lahey Fortran compiler.

      SUBROUTINE dcrft(x,ldx,y,ldy,n,m,scale,table,ifac)

      implicit none
      integer ldx,ldy,n,m,i,j,ifac(15)
      real x(2*ldx,*),y(ldy,*),scale,table(n)
        real work(n)

!OCL NOVREC
        DO j=1,m
          y(1,j)=x(1,j)
          DO i=2,n
      	  y(i,j)=x(i+1,j)
          ENDDO
          CALL rfftb1(n,y(1,j),work,table,ifac)
          DO i=1,n
      	  y(i,j)=scale*y(i,j)
          ENDDO
        ENDDO
      RETURN
      END
c
c***********************************************************************
c
      SUBROUTINE drcft(x,ldx,y,ldy,n,m,scale,table,ifac)

      implicit none
      integer ldx,ldy,n,m,i,j,ifac(15)
      real x(ldx,*),y(2*ldy,*),scale,table(n)
        real work(n)

      DO j=1,m
        DO i=1,n
          y(i,j)=x(i,j)
        ENDDO
        CALL rfftf1(n,y(1,j),work,table,ifac)
        DO i=1,n
          y(i,j)=scale*y(i,j)
        ENDDO
        DO i=n,2,-1
          y(i+1,j)=y(i,j)
        ENDDO
        y(2,j)=0.
      ENDDO
      RETURN
      END
c
c     ******************************************************************
c     ******************************************************************
c     ******                                                      ******
c     ******                        FFTPACK                       ******
c     ******                                                      ******
c     ******************************************************************
c     ******************************************************************
c
      SUBROUTINE RFFTF (N,R,WSAVE)
      DIMENSION       R(1)       ,WSAVE(1)
      IF (N .EQ. 1) RETURN
      CALL RFFTF1 (N,R,WSAVE,WSAVE(N+1),WSAVE(2*N+1))
      RETURN
      END
      SUBROUTINE RFFTB (N,R,WSAVE)
      DIMENSION       R(1)       ,WSAVE(1)
      IF (N .EQ. 1) RETURN
      CALL RFFTB1 (N,R,WSAVE,WSAVE(N+1),WSAVE(2*N+1))
      RETURN
      END
      SUBROUTINE RFFTI (N,WSAVE)
      DIMENSION       WSAVE(1)
      IF (N .EQ. 1) RETURN
      CALL RFFTI1 (N,WSAVE(N+1),WSAVE(2*N+1))
      RETURN
      END
      SUBROUTINE RFFTB1 (N,C,CH,WA,IFAC)
      DIMENSION       CH(1)      ,C(1)       ,WA(1)      ,IFAC(*)
      NF = IFAC(2)
      NA = 0
      L1 = 1
      IW = 1
      DO 116 K1=1,NF
         IP = IFAC(K1+2)
         L2 = IP*L1
         IDO = N/L2
         IDL1 = IDO*L1
         IF (IP .NE. 4) GO TO 103
         IX2 = IW+IDO
         IX3 = IX2+IDO
         IF (NA .NE. 0) GO TO 101
         CALL RADB4 (IDO,L1,C,CH,WA(IW),WA(IX2),WA(IX3))
         GO TO 102
  101    CALL RADB4 (IDO,L1,CH,C,WA(IW),WA(IX2),WA(IX3))
  102    NA = 1-NA
         GO TO 115
  103    IF (IP .NE. 2) GO TO 106
         IF (NA .NE. 0) GO TO 104
         CALL RADB2 (IDO,L1,C,CH,WA(IW))
         GO TO 105
  104    CALL RADB2 (IDO,L1,CH,C,WA(IW))
  105    NA = 1-NA
         GO TO 115
  106    IF (IP .NE. 3) GO TO 109
         IX2 = IW+IDO
         IF (NA .NE. 0) GO TO 107
         CALL RADB3 (IDO,L1,C,CH,WA(IW),WA(IX2))
         GO TO 108
  107    CALL RADB3 (IDO,L1,CH,C,WA(IW),WA(IX2))
  108    NA = 1-NA
         GO TO 115
  109    IF (IP .NE. 5) GO TO 112
         IX2 = IW+IDO
         IX3 = IX2+IDO
         IX4 = IX3+IDO
         IF (NA .NE. 0) GO TO 110
         CALL RADB5 (IDO,L1,C,CH,WA(IW),WA(IX2),WA(IX3),WA(IX4))
         GO TO 111
  110    CALL RADB5 (IDO,L1,CH,C,WA(IW),WA(IX2),WA(IX3),WA(IX4))
  111    NA = 1-NA
         GO TO 115
  112    IF (NA .NE. 0) GO TO 113
         CALL RADBG (IDO,IP,L1,IDL1,C,C,C,CH,CH,WA(IW))
         GO TO 114
  113    CALL RADBG (IDO,IP,L1,IDL1,CH,CH,CH,C,C,WA(IW))
  114    IF (IDO .EQ. 1) NA = 1-NA
  115    L1 = L2
         IW = IW+(IP-1)*IDO
  116 CONTINUE
      IF (NA .EQ. 0) RETURN
      DO 117 I=1,N
         C(I) = CH(I)
  117 CONTINUE
      RETURN
      END
      SUBROUTINE RFFTF1 (N,C,CH,WA,IFAC)
      DIMENSION       CH(1)      ,C(1)       ,WA(1)      ,IFAC(*)
      NF = IFAC(2)
      NA = 1
      L2 = N
      IW = N
      DO 111 K1=1,NF
         KH = NF-K1
         IP = IFAC(KH+3)
         L1 = L2/IP
         IDO = N/L2
         IDL1 = IDO*L1
         IW = IW-(IP-1)*IDO
         NA = 1-NA
         IF (IP .NE. 4) GO TO 102
         IX2 = IW+IDO
         IX3 = IX2+IDO
         IF (NA .NE. 0) GO TO 101
         CALL RADF4 (IDO,L1,C,CH,WA(IW),WA(IX2),WA(IX3))
         GO TO 110
  101    CALL RADF4 (IDO,L1,CH,C,WA(IW),WA(IX2),WA(IX3))
         GO TO 110
  102    IF (IP .NE. 2) GO TO 104
         IF (NA .NE. 0) GO TO 103
         CALL RADF2 (IDO,L1,C,CH,WA(IW))
         GO TO 110
  103    CALL RADF2 (IDO,L1,CH,C,WA(IW))
         GO TO 110
  104    IF (IP .NE. 3) GO TO 106
         IX2 = IW+IDO
         IF (NA .NE. 0) GO TO 105
         CALL RADF3 (IDO,L1,C,CH,WA(IW),WA(IX2))
         GO TO 110
  105    CALL RADF3 (IDO,L1,CH,C,WA(IW),WA(IX2))
         GO TO 110
  106    IF (IP .NE. 5) GO TO 108
         IX2 = IW+IDO
         IX3 = IX2+IDO
         IX4 = IX3+IDO
         IF (NA .NE. 0) GO TO 107
         CALL RADF5 (IDO,L1,C,CH,WA(IW),WA(IX2),WA(IX3),WA(IX4))
         GO TO 110
  107    CALL RADF5 (IDO,L1,CH,C,WA(IW),WA(IX2),WA(IX3),WA(IX4))
         GO TO 110
  108    IF (IDO .EQ. 1) NA = 1-NA
         IF (NA .NE. 0) GO TO 109
         CALL RADFG (IDO,IP,L1,IDL1,C,C,C,CH,CH,WA(IW))
         NA = 1
         GO TO 110
  109    CALL RADFG (IDO,IP,L1,IDL1,CH,CH,CH,C,C,WA(IW))
         NA = 0
  110    L2 = L1
  111 CONTINUE
      IF (NA .EQ. 1) RETURN
      DO 112 I=1,N
         C(I) = CH(I)
  112 CONTINUE
      RETURN
      END
      SUBROUTINE RFFTI1 (N,WA,IFAC)
      DIMENSION       WA(1)      ,IFAC(*)    ,NTRYH(4)
      DATA NTRYH(1),NTRYH(2),NTRYH(3),NTRYH(4)/4,2,3,5/
      NL = N
      NF = 0
      J = 0
  101 J = J+1
      IF (J-4) 102,102,103
  102 NTRY = NTRYH(J)
      GO TO 104
  103 NTRY = NTRY+2
  104 NQ = NL/NTRY
      NR = NL-NTRY*NQ
      IF (NR) 101,105,101
  105 NF = NF+1
      IFAC(NF+2) = NTRY
      NL = NQ
      IF (NTRY .NE. 2) GO TO 107
      IF (NF .EQ. 1) GO TO 107
      DO 106 I=2,NF
         IB = NF-I+2
         IFAC(IB+2) = IFAC(IB+1)
  106 CONTINUE
      IFAC(3) = 2
  107 IF (NL .NE. 1) GO TO 104
      IFAC(1) = N
      IFAC(2) = NF
      TPI = 6.28318530717959
      ARGH = TPI/FLOAT(N)
      IS = 0
      NFM1 = NF-1
      L1 = 1
      IF (NFM1 .EQ. 0) RETURN
!OCL NOVREC
      DO 110 K1=1,NFM1
         IP = IFAC(K1+2)
         LD = 0
         L2 = L1*IP
         IDO = N/L2
         IPM = IP-1
         DO 109 J=1,IPM
            LD = LD+L1
            I = IS
            ARGLD = FLOAT(LD)*ARGH
            FI = 0
!OCL SCALAR
            DO 108 II=3,IDO,2
               I = I+2
               FI = FI+1
               ARG = FI*ARGLD
               WA(I-1) = COS(ARG)
               WA(I) = SIN(ARG)
  108       CONTINUE
            IS = IS+IDO
  109    CONTINUE
         L1 = L2
  110 CONTINUE
      RETURN
      END
      SUBROUTINE RADB2 (IDO,L1,CC,CH,WA1)
      DIMENSION       CC(IDO,2,L1)           ,CH(IDO,L1,2)           ,
     1                WA1(1)
      DO 101 K=1,L1
         CH(1,K,1) = CC(1,1,K)+CC(IDO,2,K)
         CH(1,K,2) = CC(1,1,K)-CC(IDO,2,K)
  101 CONTINUE
      IF (IDO-2) 107,105,102
  102 IDP2 = IDO+2
!OCL NOVREC
      DO 104 K=1,L1
         DO 103 I=3,IDO,2
            IC = IDP2-I
            CH(I-1,K,1) = CC(I-1,1,K)+CC(IC-1,2,K)
            TR2 = CC(I-1,1,K)-CC(IC-1,2,K)
            CH(I,K,1) = CC(I,1,K)-CC(IC,2,K)
            TI2 = CC(I,1,K)+CC(IC,2,K)
            CH(I-1,K,2) = WA1(I-2)*TR2-WA1(I-1)*TI2
            CH(I,K,2) = WA1(I-2)*TI2+WA1(I-1)*TR2
  103    CONTINUE
  104 CONTINUE
      IF (MOD(IDO,2) .EQ. 1) RETURN
  105 DO 106 K=1,L1
         CH(IDO,K,1) = CC(IDO,1,K)+CC(IDO,1,K)
         CH(IDO,K,2) = -(CC(1,2,K)+CC(1,2,K))
  106 CONTINUE
  107 RETURN
      END
      SUBROUTINE RADB3 (IDO,L1,CC,CH,WA1,WA2)
      DIMENSION       CC(IDO,3,L1)           ,CH(IDO,L1,3)           ,
     1                WA1(1)     ,WA2(1)
      DATA TAUR,TAUI /-.5,.866025403784439/
      DO 101 K=1,L1
         TR2 = CC(IDO,2,K)+CC(IDO,2,K)
         CR2 = CC(1,1,K)+TAUR*TR2
         CH(1,K,1) = CC(1,1,K)+TR2
         CI3 = TAUI*(CC(1,3,K)+CC(1,3,K))
         CH(1,K,2) = CR2-CI3
         CH(1,K,3) = CR2+CI3
  101 CONTINUE
      IF (IDO .EQ. 1) RETURN
      IDP2 = IDO+2
!OCL NOVREC
      DO 103 K=1,L1
         DO 102 I=3,IDO,2
            IC = IDP2-I
            TR2 = CC(I-1,3,K)+CC(IC-1,2,K)
            CR2 = CC(I-1,1,K)+TAUR*TR2
            CH(I-1,K,1) = CC(I-1,1,K)+TR2
            TI2 = CC(I,3,K)-CC(IC,2,K)
            CI2 = CC(I,1,K)+TAUR*TI2
            CH(I,K,1) = CC(I,1,K)+TI2
            CR3 = TAUI*(CC(I-1,3,K)-CC(IC-1,2,K))
            CI3 = TAUI*(CC(I,3,K)+CC(IC,2,K))
            DR2 = CR2-CI3
            DR3 = CR2+CI3
            DI2 = CI2+CR3
            DI3 = CI2-CR3
            CH(I-1,K,2) = WA1(I-2)*DR2-WA1(I-1)*DI2
            CH(I,K,2) = WA1(I-2)*DI2+WA1(I-1)*DR2
            CH(I-1,K,3) = WA2(I-2)*DR3-WA2(I-1)*DI3
            CH(I,K,3) = WA2(I-2)*DI3+WA2(I-1)*DR3
  102    CONTINUE
  103 CONTINUE
      RETURN
      END
      SUBROUTINE RADB4 (IDO,L1,CC,CH,WA1,WA2,WA3)
      DIMENSION       CC(IDO,4,L1)           ,CH(IDO,L1,4)           ,
     1                WA1(1)     ,WA2(1)     ,WA3(1)
      DATA SQRT2 /1.414213562373095/
      DO 101 K=1,L1
         TR1 = CC(1,1,K)-CC(IDO,4,K)
         TR2 = CC(1,1,K)+CC(IDO,4,K)
         TR3 = CC(IDO,2,K)+CC(IDO,2,K)
         TR4 = CC(1,3,K)+CC(1,3,K)
         CH(1,K,1) = TR2+TR3
         CH(1,K,2) = TR1-TR4
         CH(1,K,3) = TR2-TR3
         CH(1,K,4) = TR1+TR4
  101 CONTINUE
      IF (IDO-2) 107,105,102
  102 IDP2 = IDO+2
!OCL NOVREC
      DO 104 K=1,L1
         DO 103 I=3,IDO,2
            IC = IDP2-I
            TI1 = CC(I,1,K)+CC(IC,4,K)
            TI2 = CC(I,1,K)-CC(IC,4,K)
            TI3 = CC(I,3,K)-CC(IC,2,K)
            TR4 = CC(I,3,K)+CC(IC,2,K)
            TR1 = CC(I-1,1,K)-CC(IC-1,4,K)
            TR2 = CC(I-1,1,K)+CC(IC-1,4,K)
            TI4 = CC(I-1,3,K)-CC(IC-1,2,K)
            TR3 = CC(I-1,3,K)+CC(IC-1,2,K)
            CH(I-1,K,1) = TR2+TR3
            CR3 = TR2-TR3
            CH(I,K,1) = TI2+TI3
            CI3 = TI2-TI3
            CR2 = TR1-TR4
            CR4 = TR1+TR4
            CI2 = TI1+TI4
            CI4 = TI1-TI4
            CH(I-1,K,2) = WA1(I-2)*CR2-WA1(I-1)*CI2
            CH(I,K,2) = WA1(I-2)*CI2+WA1(I-1)*CR2
            CH(I-1,K,3) = WA2(I-2)*CR3-WA2(I-1)*CI3
            CH(I,K,3) = WA2(I-2)*CI3+WA2(I-1)*CR3
            CH(I-1,K,4) = WA3(I-2)*CR4-WA3(I-1)*CI4
            CH(I,K,4) = WA3(I-2)*CI4+WA3(I-1)*CR4
  103    CONTINUE
  104 CONTINUE
      IF (MOD(IDO,2) .EQ. 1) RETURN
  105 CONTINUE
      DO 106 K=1,L1
         TI1 = CC(1,2,K)+CC(1,4,K)
         TI2 = CC(1,4,K)-CC(1,2,K)
         TR1 = CC(IDO,1,K)-CC(IDO,3,K)
         TR2 = CC(IDO,1,K)+CC(IDO,3,K)
         CH(IDO,K,1) = TR2+TR2
         CH(IDO,K,2) = SQRT2*(TR1-TI1)
         CH(IDO,K,3) = TI2+TI2
         CH(IDO,K,4) = -SQRT2*(TR1+TI1)
  106 CONTINUE
  107 RETURN
      END
      SUBROUTINE RADB5 (IDO,L1,CC,CH,WA1,WA2,WA3,WA4)
      DIMENSION       CC(IDO,5,L1)           ,CH(IDO,L1,5)           ,
     1                WA1(1)     ,WA2(1)     ,WA3(1)     ,WA4(1)
      DATA TR11,TI11,TR12,TI12 /.309016994374947,.951056516295154,
     1-.809016994374947,.587785252292473/
      DO 101 K=1,L1
         TI5 = CC(1,3,K)+CC(1,3,K)
         TI4 = CC(1,5,K)+CC(1,5,K)
         TR2 = CC(IDO,2,K)+CC(IDO,2,K)
         TR3 = CC(IDO,4,K)+CC(IDO,4,K)
         CH(1,K,1) = CC(1,1,K)+TR2+TR3
         CR2 = CC(1,1,K)+TR11*TR2+TR12*TR3
         CR3 = CC(1,1,K)+TR12*TR2+TR11*TR3
         CI5 = TI11*TI5+TI12*TI4
         CI4 = TI12*TI5-TI11*TI4
         CH(1,K,2) = CR2-CI5
         CH(1,K,3) = CR3-CI4
         CH(1,K,4) = CR3+CI4
         CH(1,K,5) = CR2+CI5
  101 CONTINUE
      IF (IDO .EQ. 1) RETURN
      IDP2 = IDO+2
      DO 103 K=1,L1
         DO 102 I=3,IDO,2
            IC = IDP2-I
            TI5 = CC(I,3,K)+CC(IC,2,K)
            TI2 = CC(I,3,K)-CC(IC,2,K)
            TI4 = CC(I,5,K)+CC(IC,4,K)
            TI3 = CC(I,5,K)-CC(IC,4,K)
            TR5 = CC(I-1,3,K)-CC(IC-1,2,K)
            TR2 = CC(I-1,3,K)+CC(IC-1,2,K)
            TR4 = CC(I-1,5,K)-CC(IC-1,4,K)
            TR3 = CC(I-1,5,K)+CC(IC-1,4,K)
            CH(I-1,K,1) = CC(I-1,1,K)+TR2+TR3
            CH(I,K,1) = CC(I,1,K)+TI2+TI3
            CR2 = CC(I-1,1,K)+TR11*TR2+TR12*TR3
            CI2 = CC(I,1,K)+TR11*TI2+TR12*TI3
            CR3 = CC(I-1,1,K)+TR12*TR2+TR11*TR3
            CI3 = CC(I,1,K)+TR12*TI2+TR11*TI3
            CR5 = TI11*TR5+TI12*TR4
            CI5 = TI11*TI5+TI12*TI4
            CR4 = TI12*TR5-TI11*TR4
            CI4 = TI12*TI5-TI11*TI4
            DR3 = CR3-CI4
            DR4 = CR3+CI4
            DI3 = CI3+CR4
            DI4 = CI3-CR4
            DR5 = CR2+CI5
            DR2 = CR2-CI5
            DI5 = CI2-CR5
            DI2 = CI2+CR5
            CH(I-1,K,2) = WA1(I-2)*DR2-WA1(I-1)*DI2
            CH(I,K,2) = WA1(I-2)*DI2+WA1(I-1)*DR2
            CH(I-1,K,3) = WA2(I-2)*DR3-WA2(I-1)*DI3
            CH(I,K,3) = WA2(I-2)*DI3+WA2(I-1)*DR3
            CH(I-1,K,4) = WA3(I-2)*DR4-WA3(I-1)*DI4
            CH(I,K,4) = WA3(I-2)*DI4+WA3(I-1)*DR4
            CH(I-1,K,5) = WA4(I-2)*DR5-WA4(I-1)*DI5
            CH(I,K,5) = WA4(I-2)*DI5+WA4(I-1)*DR5
  102    CONTINUE
  103 CONTINUE
      RETURN
      END
      SUBROUTINE RADBG (IDO,IP,L1,IDL1,CC,C1,C2,CH,CH2,WA)
      DIMENSION       CH(IDO,L1,IP)          ,CC(IDO,IP,L1)          ,
     1                C1(IDO,L1,IP)          ,C2(IDL1,IP),
     2                CH2(IDL1,IP)           ,WA(1)
      DATA TPI/6.28318530717959/
      ARG = TPI/FLOAT(IP)
      DCP = COS(ARG)
      DSP = SIN(ARG)
      IDP2 = IDO+2
      NBD = (IDO-1)/2
      IPP2 = IP+2
      IPPH = (IP+1)/2
      IF (IDO .LT. L1) GO TO 103
      DO 102 K=1,L1
         DO 101 I=1,IDO
            CH(I,K,1) = CC(I,1,K)
  101    CONTINUE
  102 CONTINUE
      GO TO 106
  103 DO 105 I=1,IDO
         DO 104 K=1,L1
            CH(I,K,1) = CC(I,1,K)
  104    CONTINUE
  105 CONTINUE
!OCL NOVREC
  106 DO 108 J=2,IPPH
         JC = IPP2-J
         J2 = J+J
         DO 107 K=1,L1
            CH(1,K,J) = CC(IDO,J2-2,K)+CC(IDO,J2-2,K)
            CH(1,K,JC) = CC(1,J2-1,K)+CC(1,J2-1,K)
  107    CONTINUE
  108 CONTINUE
      IF (IDO .EQ. 1) GO TO 116
      IF (NBD .LT. L1) GO TO 112
!OCL NOVREC
      DO 111 J=2,IPPH
         JC = IPP2-J
         DO 110 K=1,L1
            DO 109 I=3,IDO,2
               IC = IDP2-I
               CH(I-1,K,J) = CC(I-1,2*J-1,K)+CC(IC-1,2*J-2,K)
               CH(I-1,K,JC) = CC(I-1,2*J-1,K)-CC(IC-1,2*J-2,K)
               CH(I,K,J) = CC(I,2*J-1,K)-CC(IC,2*J-2,K)
               CH(I,K,JC) = CC(I,2*J-1,K)+CC(IC,2*J-2,K)
  109       CONTINUE
  110    CONTINUE
  111 CONTINUE
      GO TO 116
  112 DO 115 J=2,IPPH
         JC = IPP2-J
         DO 114 I=3,IDO,2
            IC = IDP2-I
            DO 113 K=1,L1
               CH(I-1,K,J) = CC(I-1,2*J-1,K)+CC(IC-1,2*J-2,K)
               CH(I-1,K,JC) = CC(I-1,2*J-1,K)-CC(IC-1,2*J-2,K)
               CH(I,K,J) = CC(I,2*J-1,K)-CC(IC,2*J-2,K)
               CH(I,K,JC) = CC(I,2*J-1,K)+CC(IC,2*J-2,K)
  113       CONTINUE
  114    CONTINUE
  115 CONTINUE
  116 AR1 = 1.
      AI1 = 0.
!OCL NOVREC
      DO 120 L=2,IPPH
         LC = IPP2-L
         AR1H = DCP*AR1-DSP*AI1
         AI1 = DCP*AI1+DSP*AR1
         AR1 = AR1H
         DO 117 IK=1,IDL1
            C2(IK,L) = CH2(IK,1)+AR1*CH2(IK,2)
            C2(IK,LC) = AI1*CH2(IK,IP)
  117    CONTINUE
         DC2 = AR1
         DS2 = AI1
         AR2 = AR1
         AI2 = AI1
!OCL NOVREC
         DO 119 J=3,IPPH
            JC = IPP2-J
            AR2H = DC2*AR2-DS2*AI2
            AI2 = DC2*AI2+DS2*AR2
            AR2 = AR2H
            DO 118 IK=1,IDL1
               C2(IK,L) = C2(IK,L)+AR2*CH2(IK,J)
               C2(IK,LC) = C2(IK,LC)+AI2*CH2(IK,JC)
  118       CONTINUE
  119    CONTINUE
  120 CONTINUE
!OCL NOVREC
      DO 122 J=2,IPPH
         DO 121 IK=1,IDL1
            CH2(IK,1) = CH2(IK,1)+CH2(IK,J)
  121    CONTINUE
  122 CONTINUE
!OCL NOVREC
      DO 124 J=2,IPPH
         JC = IPP2-J
         DO 123 K=1,L1
            CH(1,K,J) = C1(1,K,J)-C1(1,K,JC)
            CH(1,K,JC) = C1(1,K,J)+C1(1,K,JC)
  123    CONTINUE
  124 CONTINUE
      IF (IDO .EQ. 1) GO TO 132
      IF (NBD .LT. L1) GO TO 128
!OCL NOVREC
      DO 127 J=2,IPPH
         JC = IPP2-J
         DO 126 K=1,L1
            DO 125 I=3,IDO,2
               CH(I-1,K,J) = C1(I-1,K,J)-C1(I,K,JC)
               CH(I-1,K,JC) = C1(I-1,K,J)+C1(I,K,JC)
               CH(I,K,J) = C1(I,K,J)+C1(I-1,K,JC)
               CH(I,K,JC) = C1(I,K,J)-C1(I-1,K,JC)
  125       CONTINUE
  126    CONTINUE
  127 CONTINUE
      GO TO 132
  128 DO 131 J=2,IPPH
         JC = IPP2-J
         DO 130 I=3,IDO,2
            DO 129 K=1,L1
               CH(I-1,K,J) = C1(I-1,K,J)-C1(I,K,JC)
               CH(I-1,K,JC) = C1(I-1,K,J)+C1(I,K,JC)
               CH(I,K,J) = C1(I,K,J)+C1(I-1,K,JC)
               CH(I,K,JC) = C1(I,K,J)-C1(I-1,K,JC)
  129       CONTINUE
  130    CONTINUE
  131 CONTINUE
  132 CONTINUE
      IF (IDO .EQ. 1) RETURN
      DO 133 IK=1,IDL1
         C2(IK,1) = CH2(IK,1)
  133 CONTINUE
      DO 135 J=2,IP
         DO 134 K=1,L1
            C1(1,K,J) = CH(1,K,J)
  134    CONTINUE
  135 CONTINUE
      IF (NBD .GT. L1) GO TO 139
      IS = -IDO
      DO 138 J=2,IP
         IS = IS+IDO
         IDIJ = IS
         DO 137 I=3,IDO,2
            IDIJ = IDIJ+2
            DO 136 K=1,L1
               C1(I-1,K,J) = WA(IDIJ-1)*CH(I-1,K,J)-WA(IDIJ)*CH(I,K,J)
               C1(I,K,J) = WA(IDIJ-1)*CH(I,K,J)+WA(IDIJ)*CH(I-1,K,J)
  136       CONTINUE
  137    CONTINUE
  138 CONTINUE
      GO TO 143
  139 IS = -IDO
!OCL NOVREC
      DO 142 J=2,IP
         IS = IS+IDO
         DO 141 K=1,L1
            IDIJ = IS
            DO 140 I=3,IDO,2
               IDIJ = IDIJ+2
               C1(I-1,K,J) = WA(IDIJ-1)*CH(I-1,K,J)-WA(IDIJ)*CH(I,K,J)
               C1(I,K,J) = WA(IDIJ-1)*CH(I,K,J)+WA(IDIJ)*CH(I-1,K,J)
  140       CONTINUE
  141    CONTINUE
  142 CONTINUE
  143 RETURN
      END
      SUBROUTINE RADF2 (IDO,L1,CC,CH,WA1)
      DIMENSION       CH(IDO,2,L1)           ,CC(IDO,L1,2)           ,
     1                WA1(1)
      DO 101 K=1,L1
         CH(1,1,K) = CC(1,K,1)+CC(1,K,2)
         CH(IDO,2,K) = CC(1,K,1)-CC(1,K,2)
  101 CONTINUE
      IF (IDO-2) 107,105,102
  102 IDP2 = IDO+2
      DO 104 K=1,L1
         DO 103 I=3,IDO,2
            IC = IDP2-I
            TR2 = WA1(I-2)*CC(I-1,K,2)+WA1(I-1)*CC(I,K,2)
            TI2 = WA1(I-2)*CC(I,K,2)-WA1(I-1)*CC(I-1,K,2)
            CH(I,1,K) = CC(I,K,1)+TI2
            CH(IC,2,K) = TI2-CC(I,K,1)
            CH(I-1,1,K) = CC(I-1,K,1)+TR2
            CH(IC-1,2,K) = CC(I-1,K,1)-TR2
  103    CONTINUE
  104 CONTINUE
      IF (MOD(IDO,2) .EQ. 1) RETURN
  105 DO 106 K=1,L1
         CH(1,2,K) = -CC(IDO,K,2)
         CH(IDO,1,K) = CC(IDO,K,1)
  106 CONTINUE
  107 RETURN
      END
      SUBROUTINE RADF3 (IDO,L1,CC,CH,WA1,WA2)
      DIMENSION       CH(IDO,3,L1)           ,CC(IDO,L1,3)           ,
     1                WA1(1)     ,WA2(1)
      DATA TAUR,TAUI /-.5,.866025403784439/
      DO 101 K=1,L1
         CR2 = CC(1,K,2)+CC(1,K,3)
         CH(1,1,K) = CC(1,K,1)+CR2
         CH(1,3,K) = TAUI*(CC(1,K,3)-CC(1,K,2))
         CH(IDO,2,K) = CC(1,K,1)+TAUR*CR2
  101 CONTINUE
      IF (IDO .EQ. 1) RETURN
      IDP2 = IDO+2
      DO 103 K=1,L1
         DO 102 I=3,IDO,2
            IC = IDP2-I
            DR2 = WA1(I-2)*CC(I-1,K,2)+WA1(I-1)*CC(I,K,2)
            DI2 = WA1(I-2)*CC(I,K,2)-WA1(I-1)*CC(I-1,K,2)
            DR3 = WA2(I-2)*CC(I-1,K,3)+WA2(I-1)*CC(I,K,3)
            DI3 = WA2(I-2)*CC(I,K,3)-WA2(I-1)*CC(I-1,K,3)
            CR2 = DR2+DR3
            CI2 = DI2+DI3
            CH(I-1,1,K) = CC(I-1,K,1)+CR2
            CH(I,1,K) = CC(I,K,1)+CI2
            TR2 = CC(I-1,K,1)+TAUR*CR2
            TI2 = CC(I,K,1)+TAUR*CI2
            TR3 = TAUI*(DI2-DI3)
            TI3 = TAUI*(DR3-DR2)
            CH(I-1,3,K) = TR2+TR3
            CH(IC-1,2,K) = TR2-TR3
            CH(I,3,K) = TI2+TI3
            CH(IC,2,K) = TI3-TI2
  102    CONTINUE
  103 CONTINUE
      RETURN
      END
      SUBROUTINE RADF4 (IDO,L1,CC,CH,WA1,WA2,WA3)
      DIMENSION       CC(IDO,L1,4)           ,CH(IDO,4,L1)           ,
     1                WA1(1)     ,WA2(1)     ,WA3(1)
      DATA HSQT2 /.7071067811865475/
      DO 101 K=1,L1
         TR1 = CC(1,K,2)+CC(1,K,4)
         TR2 = CC(1,K,1)+CC(1,K,3)
         CH(1,1,K) = TR1+TR2
         CH(IDO,4,K) = TR2-TR1
         CH(IDO,2,K) = CC(1,K,1)-CC(1,K,3)
         CH(1,3,K) = CC(1,K,4)-CC(1,K,2)
  101 CONTINUE
      IF (IDO-2) 107,105,102
  102 IDP2 = IDO+2
!OCL NOVREC
      DO 104 K=1,L1
         DO 103 I=3,IDO,2
            IC = IDP2-I
            CR2 = WA1(I-2)*CC(I-1,K,2)+WA1(I-1)*CC(I,K,2)
            CI2 = WA1(I-2)*CC(I,K,2)-WA1(I-1)*CC(I-1,K,2)
            CR3 = WA2(I-2)*CC(I-1,K,3)+WA2(I-1)*CC(I,K,3)
            CI3 = WA2(I-2)*CC(I,K,3)-WA2(I-1)*CC(I-1,K,3)
            CR4 = WA3(I-2)*CC(I-1,K,4)+WA3(I-1)*CC(I,K,4)
            CI4 = WA3(I-2)*CC(I,K,4)-WA3(I-1)*CC(I-1,K,4)
            TR1 = CR2+CR4
            TR4 = CR4-CR2
            TI1 = CI2+CI4
            TI4 = CI2-CI4
            TI2 = CC(I,K,1)+CI3
            TI3 = CC(I,K,1)-CI3
            TR2 = CC(I-1,K,1)+CR3
            TR3 = CC(I-1,K,1)-CR3
            CH(I-1,1,K) = TR1+TR2
            CH(IC-1,4,K) = TR2-TR1
            CH(I,1,K) = TI1+TI2
            CH(IC,4,K) = TI1-TI2
            CH(I-1,3,K) = TI4+TR3
            CH(IC-1,2,K) = TR3-TI4
            CH(I,3,K) = TR4+TI3
            CH(IC,2,K) = TR4-TI3
  103    CONTINUE
  104 CONTINUE
      IF (MOD(IDO,2) .EQ. 1) RETURN
  105 CONTINUE
      DO 106 K=1,L1
         TI1 = -HSQT2*(CC(IDO,K,2)+CC(IDO,K,4))
         TR1 = HSQT2*(CC(IDO,K,2)-CC(IDO,K,4))
         CH(IDO,1,K) = TR1+CC(IDO,K,1)
         CH(IDO,3,K) = CC(IDO,K,1)-TR1
         CH(1,2,K) = TI1-CC(IDO,K,3)
         CH(1,4,K) = TI1+CC(IDO,K,3)
  106 CONTINUE
  107 RETURN
      END
      SUBROUTINE RADF5 (IDO,L1,CC,CH,WA1,WA2,WA3,WA4)
      DIMENSION       CC(IDO,L1,5)           ,CH(IDO,5,L1)           ,
     1                WA1(1)     ,WA2(1)     ,WA3(1)     ,WA4(1)
      DATA TR11,TI11,TR12,TI12 /.309016994374947,.951056516295154,
     1-.809016994374947,.587785252292473/
      DO 101 K=1,L1
         CR2 = CC(1,K,5)+CC(1,K,2)
         CI5 = CC(1,K,5)-CC(1,K,2)
         CR3 = CC(1,K,4)+CC(1,K,3)
         CI4 = CC(1,K,4)-CC(1,K,3)
         CH(1,1,K) = CC(1,K,1)+CR2+CR3
         CH(IDO,2,K) = CC(1,K,1)+TR11*CR2+TR12*CR3
         CH(1,3,K) = TI11*CI5+TI12*CI4
         CH(IDO,4,K) = CC(1,K,1)+TR12*CR2+TR11*CR3
         CH(1,5,K) = TI12*CI5-TI11*CI4
  101 CONTINUE
      IF (IDO .EQ. 1) RETURN
      IDP2 = IDO+2
      DO 103 K=1,L1
         DO 102 I=3,IDO,2
            IC = IDP2-I
            DR2 = WA1(I-2)*CC(I-1,K,2)+WA1(I-1)*CC(I,K,2)
            DI2 = WA1(I-2)*CC(I,K,2)-WA1(I-1)*CC(I-1,K,2)
            DR3 = WA2(I-2)*CC(I-1,K,3)+WA2(I-1)*CC(I,K,3)
            DI3 = WA2(I-2)*CC(I,K,3)-WA2(I-1)*CC(I-1,K,3)
            DR4 = WA3(I-2)*CC(I-1,K,4)+WA3(I-1)*CC(I,K,4)
            DI4 = WA3(I-2)*CC(I,K,4)-WA3(I-1)*CC(I-1,K,4)
            DR5 = WA4(I-2)*CC(I-1,K,5)+WA4(I-1)*CC(I,K,5)
            DI5 = WA4(I-2)*CC(I,K,5)-WA4(I-1)*CC(I-1,K,5)
            CR2 = DR2+DR5
            CI5 = DR5-DR2
            CR5 = DI2-DI5
            CI2 = DI2+DI5
            CR3 = DR3+DR4
            CI4 = DR4-DR3
            CR4 = DI3-DI4
            CI3 = DI3+DI4
            CH(I-1,1,K) = CC(I-1,K,1)+CR2+CR3
            CH(I,1,K) = CC(I,K,1)+CI2+CI3
            TR2 = CC(I-1,K,1)+TR11*CR2+TR12*CR3
            TI2 = CC(I,K,1)+TR11*CI2+TR12*CI3
            TR3 = CC(I-1,K,1)+TR12*CR2+TR11*CR3
            TI3 = CC(I,K,1)+TR12*CI2+TR11*CI3
            TR5 = TI11*CR5+TI12*CR4
            TI5 = TI11*CI5+TI12*CI4
            TR4 = TI12*CR5-TI11*CR4
            TI4 = TI12*CI5-TI11*CI4
            CH(I-1,3,K) = TR2+TR5
            CH(IC-1,2,K) = TR2-TR5
            CH(I,3,K) = TI2+TI5
            CH(IC,2,K) = TI5-TI2
            CH(I-1,5,K) = TR3+TR4
            CH(IC-1,4,K) = TR3-TR4
            CH(I,5,K) = TI3+TI4
            CH(IC,4,K) = TI4-TI3
  102    CONTINUE
  103 CONTINUE
      RETURN
      END
      SUBROUTINE RADFG (IDO,IP,L1,IDL1,CC,C1,C2,CH,CH2,WA)
      DIMENSION       CH(IDO,L1,IP)          ,CC(IDO,IP,L1)          ,
     1                C1(IDO,L1,IP)          ,C2(IDL1,IP),
     2                CH2(IDL1,IP)           ,WA(1)
      DATA TPI/6.28318530717959/
      ARG = TPI/FLOAT(IP)
      DCP = COS(ARG)
      DSP = SIN(ARG)
      IPPH = (IP+1)/2
      IPP2 = IP+2
      IDP2 = IDO+2
      NBD = (IDO-1)/2
      IF (IDO .EQ. 1) GO TO 119
      DO 101 IK=1,IDL1
         CH2(IK,1) = C2(IK,1)
  101 CONTINUE
      DO 103 J=2,IP
         DO 102 K=1,L1
            CH(1,K,J) = C1(1,K,J)
  102    CONTINUE
  103 CONTINUE
      IF (NBD .GT. L1) GO TO 107
      IS = -IDO
      DO 106 J=2,IP
         IS = IS+IDO
         IDIJ = IS
         DO 105 I=3,IDO,2
            IDIJ = IDIJ+2
            DO 104 K=1,L1
               CH(I-1,K,J) = WA(IDIJ-1)*C1(I-1,K,J)+WA(IDIJ)*C1(I,K,J)
               CH(I,K,J) = WA(IDIJ-1)*C1(I,K,J)-WA(IDIJ)*C1(I-1,K,J)
  104       CONTINUE
  105    CONTINUE
  106 CONTINUE
      GO TO 111
  107 IS = -IDO
      DO 110 J=2,IP
         IS = IS+IDO
         DO 109 K=1,L1
            IDIJ = IS
            DO 108 I=3,IDO,2
               IDIJ = IDIJ+2
               CH(I-1,K,J) = WA(IDIJ-1)*C1(I-1,K,J)+WA(IDIJ)*C1(I,K,J)
               CH(I,K,J) = WA(IDIJ-1)*C1(I,K,J)-WA(IDIJ)*C1(I-1,K,J)
  108       CONTINUE
  109    CONTINUE
  110 CONTINUE
  111 IF (NBD .LT. L1) GO TO 115
      DO 114 J=2,IPPH
         JC = IPP2-J
         DO 113 K=1,L1
            DO 112 I=3,IDO,2
               C1(I-1,K,J) = CH(I-1,K,J)+CH(I-1,K,JC)
               C1(I-1,K,JC) = CH(I,K,J)-CH(I,K,JC)
               C1(I,K,J) = CH(I,K,J)+CH(I,K,JC)
               C1(I,K,JC) = CH(I-1,K,JC)-CH(I-1,K,J)
  112       CONTINUE
  113    CONTINUE
  114 CONTINUE
      GO TO 121
  115 DO 118 J=2,IPPH
         JC = IPP2-J
         DO 117 I=3,IDO,2
            DO 116 K=1,L1
               C1(I-1,K,J) = CH(I-1,K,J)+CH(I-1,K,JC)
               C1(I-1,K,JC) = CH(I,K,J)-CH(I,K,JC)
               C1(I,K,J) = CH(I,K,J)+CH(I,K,JC)
               C1(I,K,JC) = CH(I-1,K,JC)-CH(I-1,K,J)
  116       CONTINUE
  117    CONTINUE
  118 CONTINUE
      GO TO 121
  119 DO 120 IK=1,IDL1
         C2(IK,1) = CH2(IK,1)
  120 CONTINUE
  121 DO 123 J=2,IPPH
         JC = IPP2-J
         DO 122 K=1,L1
            C1(1,K,J) = CH(1,K,J)+CH(1,K,JC)
            C1(1,K,JC) = CH(1,K,JC)-CH(1,K,J)
  122    CONTINUE
  123 CONTINUE
C
      AR1 = 1.
      AI1 = 0.
      DO 127 L=2,IPPH
         LC = IPP2-L
         AR1H = DCP*AR1-DSP*AI1
         AI1 = DCP*AI1+DSP*AR1
         AR1 = AR1H
         DO 124 IK=1,IDL1
            CH2(IK,L) = C2(IK,1)+AR1*C2(IK,2)
            CH2(IK,LC) = AI1*C2(IK,IP)
  124    CONTINUE
         DC2 = AR1
         DS2 = AI1
         AR2 = AR1
         AI2 = AI1
         DO 126 J=3,IPPH
            JC = IPP2-J
            AR2H = DC2*AR2-DS2*AI2
            AI2 = DC2*AI2+DS2*AR2
            AR2 = AR2H
            DO 125 IK=1,IDL1
               CH2(IK,L) = CH2(IK,L)+AR2*C2(IK,J)
               CH2(IK,LC) = CH2(IK,LC)+AI2*C2(IK,JC)
  125       CONTINUE
  126    CONTINUE
  127 CONTINUE
      DO 129 J=2,IPPH
         DO 128 IK=1,IDL1
            CH2(IK,1) = CH2(IK,1)+C2(IK,J)
  128    CONTINUE
  129 CONTINUE
C
      IF (IDO .LT. L1) GO TO 132
      DO 131 K=1,L1
         DO 130 I=1,IDO
            CC(I,1,K) = CH(I,K,1)
  130    CONTINUE
  131 CONTINUE
      GO TO 135
  132 DO 134 I=1,IDO
         DO 133 K=1,L1
            CC(I,1,K) = CH(I,K,1)
  133    CONTINUE
  134 CONTINUE
  135 DO 137 J=2,IPPH
         JC = IPP2-J
         J2 = J+J
         DO 136 K=1,L1
            CC(IDO,J2-2,K) = CH(1,K,J)
            CC(1,J2-1,K) = CH(1,K,JC)
  136    CONTINUE
  137 CONTINUE
      IF (IDO .EQ. 1) RETURN
      IF (NBD .LT. L1) GO TO 141
      DO 140 J=2,IPPH
         JC = IPP2-J
         J2 = J+J
         DO 139 K=1,L1
            DO 138 I=3,IDO,2
               IC = IDP2-I
               CC(I-1,J2-1,K) = CH(I-1,K,J)+CH(I-1,K,JC)
               CC(IC-1,J2-2,K) = CH(I-1,K,J)-CH(I-1,K,JC)
               CC(I,J2-1,K) = CH(I,K,J)+CH(I,K,JC)
               CC(IC,J2-2,K) = CH(I,K,JC)-CH(I,K,J)
  138       CONTINUE
  139    CONTINUE
  140 CONTINUE
      RETURN
  141 DO 144 J=2,IPPH
         JC = IPP2-J
         J2 = J+J
         DO 143 I=3,IDO,2
            IC = IDP2-I
            DO 142 K=1,L1
               CC(I-1,J2-1,K) = CH(I-1,K,J)+CH(I-1,K,JC)
               CC(IC-1,J2-2,K) = CH(I-1,K,J)-CH(I-1,K,JC)
               CC(I,J2-1,K) = CH(I,K,J)+CH(I,K,JC)
               CC(IC,J2-2,K) = CH(I,K,JC)-CH(I,K,J)
  142       CONTINUE
  143    CONTINUE
  144 CONTINUE
      RETURN
      END

!-----------------------------------------------------------------------------
!  DATA_ASSIM - do one data analysis step on one latitudinal strip of data.
!  See driver.f90 for command line and usage information.
!
    program data_assim
    use driver
    use command_line_support,only:program_exit
    implicit none
    integer::retcode
    real::t0,t1
    logical::partial  ! true if input grid is not the whole globe
    logical::yes  ! true if we're computing diagnostics
!
    call cpu_time(t0)
    call parseline(partial)
    call readin(partial)
    inquire(unit=DIAGUNIT,opened=yes)
    call mainloop(retcode)
!
!  Don't compute and print diagnostics for the observations unless their
!  computation has been requested (i.e., a diagnostics filename must have
!  been specified on the command line, in which case we would have opened
!  it already).
!
!   if(yes) call observation_diagnostics
    call cpu_time(t1)
    write(LOGFILE,100) t1-t0
100 format('total cpu time (sec):',f9.2)
    call program_exit(retcode)
    end program data_assim

    module driver
!
!  SYNOPSIS
!    use driver
!
!  DESCRIPTION
!  This file defines the main program and "driver" subroutines to run
!  the data assimilation code.
!
!  COMMAND-LINE OPTIONS SUPPORTED IN THIS VERSION
!  -h         : print explanation of command line and exit
!  -g         : indicates a global field; useful for debugging
!  -b  file   : file containing background state (default: 'egrid')
!  -a  file   : file containing analysis vectors (default: 'egrid.out')
!  -o  file   : file containing the observations (default: 'yobs')
!  -d  file   : file to which we print diagnostics
!  -m  file   : file containing analysis ensemble mean (default: none)
!  -n  nsol  : number of ensemble solutions (default 10)
!  -N  file   : reads namelist input from file.  Values in this file
!               overwrite those set by the command line arguments that
!               appear to the left of -N and are overwritten by command line
!               arguments that appear to the right of -N.
!  -c  check  : type of consistency check (if any) to apply to the observations.
!               CHECK may be one of "whitaker" or "obs"/"observation" or "none"
!               according as Whitaker's criterion or an observation-based
!               criterion is to be used.  The default is "none".
!  -e  errthresh : if the data assimilation cannot be completed on
!               more than ERRTHRESH of the patches, then judge the run
!               a failure.
!  -q  id     : sequence id (if any; usually the date in yyyymmddhh format)
!  -t  truegrid_file : file containing the "true" atmospheric state vector
!  -v  lev    : verbosity level: 0 (quiet), 1 (default: basic info)
!               2 (shows progress), 3 (chatty)
!  -W         : apply Whitaker's internal data consistency check
!  -x  xwidth : number of longitude points ON EACH SIDE of center (default 3)
!  -y  ywidth : number of latitude points ON EACH SIDE of center (default 3)
!               The default yields a 7x7 patch (3*2+1 points per side)
!  -z  file   : file containing vertical levels as function of latitude
!
!  REQUIRED PACKAGES
!  io, precision, ferror, command_line_support - in support directory
!  brian, diagnostics, grid_model, grid_obs, grid_io - in current directory
!
!  ROUTINES IMPLEMENTED
!
!   subroutine readin(partial_grid)
!   subroutine mainloop(retcode)
!   subroutine update_errcount(diag,errcount,ok)
!   subroutine parseline(partial_grid)
!   subroutine print_usage
!   subroutine initialize(partial)
!   program data_assim
!
!  MODIFICATION HISTORY
!  09/27/05 - Added facilities to vary the vertical coordinate of observations
!             based on the surface pressure of individual ensemble solutions.
!  08/08/05 - Added facilities for verbose dumps of background and obs in
!             selected patches.
!  07/11/05 - Made all internal computations in energy units; garbage values
!             are now regarded as a non-fatal error (we return the background
!             instead).
!  06/22/05 - Added enhanced variance inflation (brian.f90 and covar_setup.f90).
!  06/11/05 - Returns an error status if any garbage values are generated
!             along the way, irrespective of any other error threshold.
!  03/29/05 - Modified namelist to accept observation consistency check option
!  01/27/05 - Bug fixes to 01/21/05 version; moved main program to a separate 
!             source file; added -T option so temperature observations can 
!             be specified in either Celsius or Kelvin
!  01/21/05 - Changes to handle real observations.
!  12/14/04 - bug fixes and changes to grid_model for more efficient array
!             handling in pre- and postanalysis.  (Cache-unfriendly parts are
!             relegated here for overall cluster speed.)
!  10/11/04 - Changes in called routines to handle "real" data.
!  09/29/04 - modified internal arrays to have NSOL as the first dimension.
!             Only P, T, U, V are assimilated.
!  09/18/04 - Removed original assimilation scheme and replaced with Brian's.
!             Return matrix E that gives optimal linear combination of
!             the perturbations at the center for eventual use in handling
!             unassimilated variables and surface boundary conditions.
!  08/01/04 - Added code to assim.f90 to determine the extent to which the
!             analysis ensemble agrees with the computed analysis covariance
!             matrix.  Also added -B flag to omit Brian's method.
!  07/28/04 - Small changes to logfile printouts.
!  06/26/04 - Bug fixes and optimization for Brian's method to compute only
!             the center point of the patch.
!  06/17/04 - Changes to support both Brian's method and the original one,
!             including diagnostics for both.
!  06/14/04 - Added option to read namelist input.
!  06/08/04 - New version to implement Brian's assimilation scheme.
!             Incorporates some previous changes to precompute the ensemble
!             means.
!  03/19/04 - bug fix to correct patch initialization.
!  12/05/03 - added option to vary random perturbations, covariance inflation
!             and method by latitude and vertical level.
!  11/10/03 - added option for random pertubations at surface and to use
!             enhanced variance inflation at surface and simple inflation
!             elsewhere.
!  11/02/03 - added extra diagnostics to detect NaNs and Infs on input.
!  10/31/03 - version to implement vertical localization.  Also added
!             -e errthresh flag to set failure threshold.
!  08/31/03 - accommodate assimilation by latitudinal strips instead of
!             longitudinal ones.  Removed support for averaging.
!             Added support for centering patches at the poles.
!  08/12/03 - added measures of ensemble spread to diagnostics package
!             (extra.f90).  We compute and print the standard deviation of
!             selected atmospheric vector components at the center of each 
!             patch.
!  07/28/03 - modified solution 3 to use Eq. (66) in revised MWR paper instead
!             of Eqs. (79)-(80).  This version appears to eliminate the
!             catastrophic cancelation that occurs with the other formulation.
!  07/23/03 - added option for conventional variance inflation instead of
!             the enhanced scheme (which remains the default)
!  05/19/03 - revised diagnostics for case of missing observations
!  05/15/03 - added extra diagnostics
!  03/03/03 - more modifications to diagnostics output
!  02/25/03 - added -d option and extra diagnostics on patches
!  02/08/03 - miscellaneous enhancements and bug fixes.
!  01/28/03 - "parallelized" version that can assimilate in longitudinal
!             strips on independent processors.  Includes new "grid manager"
!             interface for handling data transmission to and from the
!             model grid.
!  12/09/02 - bug fixes: ensemble size set to k+1 if kprime is not specified;
!             prints xwin, ywin and patch size on log file.
!  11/21/02 - first production version by Eric; incorporated Solution 3
!             and averaging
!-----------------------------------------------------------------------------
!  DRIVER - supporting driver routines.
!  For convenience, we maintain the list of input and output files here.
!  These names are used and manipulated only by the routines in this
!  file.
!
    use assimilation
    use diagnostics
    use command_line_support
    implicit none
!
!  Counts of reasons that a given assimilation might fail.
!  See assim_vars and assim for more details.
!
    character(*),parameter::VERSION='09/27/05: varying z in observations'
!
    type error_reason  ! see assim_vars
       integer::attempted     ! number of times the method was attempted
       integer::no_obs=0      ! no observations in patch
       integer::symsqrt_fail=0   ! can't compute symmetric sqrt
       integer::no_pa_ev=0       ! can't do eigen decomp of P^a
       integer::neg_cov_ev=0  ! P^a has negative eigenvalues
       integer::pa_sing=0     ! P^a is singular
       integer::enh_fail=0    ! enhanced variance inflation failed
       integer::garbage=0     ! method generates garbage values in analysis
       integer::brian=0       ! Brian's method failed
       integer::other=0       ! any other reason
    end type error_reason
!
!  File containing the background model grid
!
    character(MAX_FILE_NAME_LEN),save,private::bfile='egrid'
!
!  File to be created that contains the analysis model grid
!
    character(MAX_FILE_NAME_LEN),save,private::afile='egrid.out'
!
!  File containing the observations
!
    character(MAX_FILE_NAME_LEN),save,private::ofile='yobs'
!
!  File containing the vertical levels as function of latitude.
!  If no such file is present (the default), then we don't do
!  vertical localization or covariance inflation.
!
    character(MAX_FILE_NAME_LEN),save,private::zfile=' '
!
!  File (if any) to be created that contains the analysis mean
!
    character(MAX_FILE_NAME_LEN),save,private::mfile=' '
!
!  File (if any) to be created that contains the diagnostics
!
    character(MAX_FILE_NAME_LEN),save,private::dfile='diag'
!
!  File (if any) containing the "true" nature grid
!
    character(MAX_FILE_NAME_LEN),save,private::tfile=' '
!
!  Debugging options: process just one or a few model grid points.
!  idxgrid(:,1) contains longitudes, (:,2) latitudes, (:,3) levels.
!  Normally, (:,2) is set in mainloop and the remaining values are
!  unchanged.  For debugging, however, values can be set via
!  NAMELIST using the -N option; see PARSELINE, below.
!
    integer,save,private::idxgrid(2,3)
    data idxgrid/1,LONF,0,0,1,LEVS/
!
!  If a fraction greater than ERRTHRESH of the total patches has
!  a numerical or other problem such that the assimilation cannot
!  be completed, then judge the run a failure.
!
    real,save,private::errthresh=0.0
!
    contains
!-----------------------------------------------------------------------------
    subroutine readin(partial_grid)
!  READIN - read in background grid and observations; allocate storage (once
!  per program invocation).  Exit if the indicated files cannot be opened
!  for writing.
!
    logical,intent(in)::partial_grid  ! true if assimilating partial global grid
!
!  Local variables
!
    integer::ix,iy,south,north,kept,nobs,nsol
    real::t0,t1
    character(4),save::gridhdr='grid'  ! defaults for latitude strips
    character(4),save::obshdr='obs '
    character(4)::header='none'
    character(NUM_OBS_TYPES)::obslist
    character::tunit
!
!  Announcements
!
    call cpu_time(t0)
    write(LOGFILE,100) "assim_p: Brian's method: version",version
    write(LOGFILE,100) 'background data file:',trim(bfile)
    if(partial_grid) then
       write(LOGFILE,100) 'partial grids'
    else
       write(LOGFILE,100) 'global grids '
    endif
    write(LOGFILE,100) 'observation data file:',trim(ofile)
    call get_observation_types(temp_units=tunit)
    write(LOGFILE,100) 'observation temperature units:',tunit
    if(len_trim(tfile).gt.0) &
       write(LOGFILE,100) 'nature run grid file:',trim(tfile)
100 format(a,1x,a)
!
!  First check that the output files are writable.  No point in doing
!  a lot of work if they aren't!
!
    if(partial_grid) header='true'  ! need slice of true grid with 'true' header
    call check_writable(afile)
    write(LOGFILE,100) 'analysis file:',trim(afile)
    if(len_trim(mfile).gt.0) then
       call check_writable(mfile)
       write(LOGFILE,100) 'analysis mean file:',trim(mfile)
    endif
!
!  Vertical localization input file - this must be read before observation
!  quality control is done so that we apply any requested background
!  covariance inflation.
!
    if(len_trim(zfile).gt.0) then
       write(LOGFILE,101) trim(zfile)
101    format('file defining vertical localization: ',a)
       call vertical_localization_setup(zfile)
    else
       write(LOGFILE,102)
102    format('no vertical localization')
    endif
!
!  Read in the background grid and the observations
!
    if(.not.partial_grid) then    ! whole globe file has no header
       gridhdr='none'
       obshdr='none'
    endif
    nsol=ensemble_size()
    write(LOGFILE,103) 'ensemble size:',nsol
103 format(a,1x,2i8)
    call model_grid_init(bfile,afile,mfile,dfile,gridhdr)
    call obs_init(ofile,obshdr,nobs,nsol)
    call precompute_ensemble_differences
    call model_grid_boundary(south,north)
    write(LOGFILE,104) 'model grid boundaries:',south,RLATS(south),north, &
       RLATS(north)
104 format(a,'  S: ',i3,' (',f7.3,' deg) N: ',i3,' (',f7.3,' deg)')
    write(LOGFILE,105) seqid()
105 format('input grid sequence id: ',i0)
!
!  Parse the diagnostics file and initialize the "true" background
!  grid, if applicable.
!
    if(len_trim(dfile).gt.0) then
       call diag_init(header,dfile,tfile,bfile,seqid(),ofile,afile)
       write(LOGFILE,100) 'diagnostics file:',trim(dfile)
    endif
!
!  Miscellaneous details
!
    write(LOGFILE,106) errthresh
106 format('max tolerable fraction of patches with assimilation errors: ',f6.3)
    call patch_radius(lon=ix,lat=iy)
    write(LOGFILE,101) 'patch width (long) x height (lat):',2*ix+1,2*iy+1
    call assimilation_boundary(south,north)
    write(LOGFILE,104) 'assimilation latitude boundaries:', &
       south,RLATS(south),north,RLATS(north)
    call get_observation_types(obslist)
    write(LOGFILE,107) obslist
107 format('observation types assimilated: ',a)
!
    call cpu_time(t1)
    write(LOGFILE,120) 'initialization time (sec):',t1-t0
120 format(a,f10.2)
    return
!
    contains
       subroutine check_writable(filename)
       character(*),intent(in)::filename
       character(8)::writable
!
       open(unit=OUTNOSWAP,file=filename,form='unformatted')
       inquire(unit=OUTNOSWAP,write=writable)
       if(writable.eq.'NO') call fexit(trim(filename)//': not writable',2)
       close(OUTNOSWAP)
       return
       end subroutine check_writable
    end subroutine readin
!---------------------------------------------------------------------------
    subroutine mainloop(retcode)
! MAINLOOP - do one data assimilation step by looping through all
! longitude,latitude pairs.
!
!  Required packages:
!
!  Argument:
!  RETCODE := return code; 0 for no errors, nonzero otherwise.
!
    integer,intent(out)::retcode
!
!  Local variables.  The arrays are allocatable to avoid stack overflow.
!
    integer::ix,iy,iz,asouth,anorth
    integer::npatch,nfail,nsol,completed
    type(patch_index)::loc
    real(D),allocatable::w(:,:),sv(:)
    real::t0,t1,tcpu
    logical::have_analysis,exceeded_errthresh
    type(error_reason)::errcount
    type(patch_diag)::diag
!
!  Initialize.  ASOUTH and ANORTH give the boundaries of the latitudinal strip
!  over which we center grids for the analysis.
!
    call cpu_time(t0)
    nsol=ensemble_size()
    allocate(w(nsol,nsol))
    call assimilation_boundary(asouth,anorth)
!
!  Main processing loop.  Proceed in latitude-major order.
!  The number of rows in XHAT and AMEAN always equals the number of
!  dynamical variables in the patch.  NFAIL counts the number of assimilation
!  errors for reasons other than a lack of observations in the patch.
!  We quit if assimilation errors occur on more than ERRTHRESH of the
!  patches after we're a quarter of the way through our assigned grid points.
!  IDXGRID lets us run only a single patch if we choose (useful for
!  debugging) without changing any code.
!
    if(any(idxgrid(:,2).eq.0)) idxgrid(:,2)=(/asouth,anorth/)
    npatch=product(idxgrid(2,:)-idxgrid(1,:)+1)
    !!allocate(diag%iceb_sing(nsol))  ! debug: write out singular values
    nfail=0
    completed=0   ! total number of completed patches
    do ix=idxgrid(1,1),idxgrid(2,1)  ! normally 1,LONF
       do iy=idxgrid(1,2),idxgrid(2,2)  ! normally asouth,anorth
          do iz=idxgrid(1,3),idxgrid(2,3)  ! normally 1,LEVS
             loc=patch_index(ix,iy,iz)
             call assimilate(loc,nsol,w,diag)
             call output_patch_diag(loc,diag)
             call update_errcount(diag,errcount,have_analysis)
             completed=completed+1
             if(.not.have_analysis) nfail=nfail+1
             exceeded_errthresh=completed.ge.npatch/4.and.&
                real(nfail)/real(npatch).gt.errthresh
             if(exceeded_errthresh) goto 10
          enddo
       enddo
       if(verbosity().gt.VERB_TERSE) then
          call cpu_time(tcpu)
          write(IERR,130) ix,tcpu,nfail
       endif
    enddo
130 format('mainloop: finished longitude',i4,' time:',f9.2, &
       ' failures so far:',i7)
!
!  All done.
!
 10 continue
!
!  Always report the total CPU time for the assimilation step.
!
    call cpu_time(t1)
    write(LOGFILE,135) 'assimilation processing time',t1-t0
135 format(a,' (sec):',f9.2)
    t0=t1  ! reset the clock
!
!  If we exceeded the error threshold then no analysis grid is generated,
!  as we've terminated the analysis early.
!
    if(exceeded_errthresh) then
       if(verbosity().gt.VERB_TERSE) call finfo('error threshold exceeded')
       write(LOGFILE,136) nfail,npatch,real(nfail)/real(npatch)
136    format('assimilation failed on ',i0,' of ',i0,' patches; ', &
          'fraction: ',f7.4)
       retcode=1
       return
    endif
!
!  Output the analysis grid and optionally the analysis mean, along with
!  observation diagnostics.
!
    call report("Statistics on Brian's method",errcount)
    call model_grid_fini
    call summary_diagnostics(nsol,len_trim(tfile).gt.0)
    if(verbosity().gt.VERB_SILENT) then
       call cpu_time(t1)
       write(LOGFILE,135) 'output time',t1-t0
    endif
!
!  If the method has generated garbage values along the way (as opposed
!  to other non-fatal problems), then flag an error return.
!  For debugging purposes, we still want to have output the analysis grid,
!  which is why this check is postponed till last.
!
    if(errcount%garbage.gt.0) then
       call finfo('Garbage values in analysis grid')
       retcode=1
    else
       retcode=0
    endif
    return
    contains
!-----------
       subroutine report(label,e)
       character(*),intent(in)::label
       type(error_reason),intent(in)::e
!
       write(LOGFILE,140) label
140    format(/a)
       write(LOGFILE,141) e%attempted,'total attempts'
       write(LOGFILE,141) e%no_obs,'patches with no observations'
       write(LOGFILE,141) e%symsqrt_fail,'symmetric sqrt failed'
       write(LOGFILE,141) e%no_pa_ev,'eigenval decomp of P^a failed'
       write(LOGFILE,141) e%neg_cov_ev,'P^a had negative eigenvalues'
       write(LOGFILE,141) e%pa_sing,'P^a was singular'
       write(LOGFILE,141) e%enh_fail,'enhanced inflation failed'
       write(LOGFILE,141) e%garbage,'method generated garbage values'
       write(LOGFILE,141) e%other,'other reason'
       write(LOGFILE,141) e%brian,'Brian''s method failed; original substituted'
141    format(i8,1x,a)
       return
       end subroutine report
!-----------
    end subroutine mainloop
!---------------------------
    subroutine update_errcount(diag,errcount,ok)
!  UPDATE_ERRCOUNT - update the error count for each assimilation method.
!  Arguments:
!   DIAG : structure containing patch diags and return code from assim
!   ERRCOUNT :=: updated error count.
!   OK := set to true if we were still able to update
!        the patch when observations are available.  Also set to true if
!        there are no observations, since we simply
!        return the background as the maximum-likelihood analysis.
!
    type(patch_diag),intent(in)::diag
    type(error_reason),intent(inout)::errcount
    logical,intent(out)::ok
!
    errcount%attempted=errcount%attempted+1
    select case(diag%info)
    case(0)   ! success or not called - no error
       ok=.true.
       return
    case(NO_OBS_UPDATE)
       ok=.true.
       errcount%no_obs=errcount%no_obs+1
    case(INFLATION_FAIL)
       ok=.true.
       errcount%enh_fail=errcount%enh_fail+1
    case(SYM_SQRT_FAIL)
       ok=.false.
       errcount%symsqrt_fail=errcount%symsqrt_fail+1
    case(PA_NO_EV)
       ok=.false.
       errcount%no_pa_ev=errcount%no_pa_ev+1
    case(P_NEG_EV)
       ok=.false.
       errcount%neg_cov_ev=errcount%neg_cov_ev+1
    case(PA_SINGULAR)
       ok=.true.
       errcount%pa_sing=errcount%pa_sing+1
    case(GARBAGE_VALUES)
       ok=.false.
       errcount%garbage=errcount%garbage+1
    case default
       ok=.false.
       errcount%other=errcount%other+1
    endselect
    if(diag%brian_failed) errcount%brian=errcount%brian+1
    return
    end subroutine update_errcount
!---------------------------
    subroutine parseline(partial_grid)
!  PARSELINE - parse execute line.  Getopt works much like the C version
!  (man 3c getopt).
!
!  Arguments:
!  PATCHW, PATCHH    := width and height, respectively, of the grid patches
!  PARTIAL_GRID := set when the -p option is specified; we look for 
!                  a partial grid file with appropriate header
!  Side effects:
!  - may alter the filenames in DRIVER
!  - sets many write-once global variables in grid_manager
!
    logical,intent(out)::partial_grid
!
!  Local variables
!
    character(50),save::options='A:b:c:a:d:e:ghm:n:N:o:q:T:t:v:x:y:z:'
!
    character(MAX_FILE_NAME_LEN)::optarg,nmlfile
    integer::iopt,optind,iseq,nsol,verblev
    integer::lonrad,latrad
    character::opt,obs_temp_units='K'
    character(4)::obstypes='PTUV'
    character(12)::obs_consistency_check='none'
!
!  Optional namelist input can affect most variables.  For convenience in
!  specifying the size of the ensemble, we use a local variable called NSOL
!  and overwrite the value of the corresponding variable in assim_vars
!  as needed.
!
    namelist/nlvars/ bfile,afile,ofile,tfile,dfile,mfile,zfile,idxgrid, &
       verblev,nsol,lonrad,latrad,errthresh,partial_grid,obstypes,iseq, &
       obs_temp_units,obs_consistency_check,dump_loc
!
    call patch_radius(lon=lonrad,lat=latrad)  ! get default value
    partial_grid=.true.  ! assume partial grid by default
    do
       call getopt(iopt,optarg,optind,options)
       if(iopt.lt.0) exit
       opt=char(iopt)
       select case(opt)  
       case('A')  ! decide which observations we'll assimilate (PTUV)
          obstypes=optarg
       case('a')
          afile=optarg
       case('b')
          bfile=optarg
       case('c')
          obs_consistency_check=optarg
       case('d')
          dfile=optarg
       case('e')
          read(optarg,*) errthresh
       case('h')
          call print_usage
          call program_exit(1)
       case('g')
          partial_grid=.false.
       case('m')
          mfile=optarg
       case('n')
          read(optarg,*) nsol
       case('N')
          nmlfile=optarg
          open(IN,file=nmlfile,status='old')
          read(IN,nlvars)
          close(IN)
          call set_observation_types(temp_units=obs_temp_units)
       case('o')
          ofile=optarg
       case('q')
          read(optarg,*) iseq
          call set_sequence_id(iseq)
       case('t')
          tfile=optarg
       case('T')  ! arg must be 'C' or 'K' for Celsius or Kelvin
          call set_observation_types(temp_units=optarg)
       case('v')
          read(optarg,*) verblev
       case('x')
          read(optarg,*) lonrad
       case('y')
          read(optarg,*) latrad
       case('z')
          zfile=optarg
       case default
          write(IERR,110) opt
          call program_exit(1)
       endselect
    enddo
!
    call set_verbosity(verblev)
    call set_observation_types(obstypes)
    call set_ensemble_size(nsol)
    call set_patch_radius(lonrad,latrad)
    call apply_consistency_check(obs_consistency_check)
!
110 format('unknown option ',a)
!
!  Sanity checks on command-line data
!
    if(errthresh.gt.1.0.or.errthresh.lt.0.0) &
       call fexit('errthresh must be in [0,1]',2)
    return
    end subroutine parseline
!-----------------------------------------------------------------------------
    subroutine print_usage
!  PRINT_USAGE - print a brief synopsis of the command line on the standard
!  error stream.
!
    character(MAX_FILE_NAME_LEN)::arg
!
    call getarg(0,arg)
    write(IERR,100) trim(arg),version
100 format(a,': Version ',a,': Options are:')
    write(IERR,110) '-A assim_variable_list (subset of PTUV)'
    write(IERR,110) '-a output_analysis_file'
110 format(a)
    write(IERR,110) '-b background_ensemble_file'
    write(IERR,110) '-d diagnostics_output_file'
    write(IERR,110) '-e error_fraction_threshold'
    write(IERR,110) '-m analysis_mean_file'
    write(IERR,110) '-n number_of_bred_vectors (kprime+1)'
    write(IERR,110) '-N namelist_input_file'
    write(IERR,110) '-o observations_file'
    write(IERR,110) '-q seqid (require specified sequence id for input grid)'
    write(IERR,110) '-T obs_temp_units (C or K); default is K=Kelvin)'
    write(IERR,110) '-t true_grid_file'
    write(IERR,110) '-v verbosity level (0:quiet), (1:default),'
    write(IERR,110) '   (2:show progress), (3:chatty)'
    write(IERR,110) '-W (apply Whitaker''s data consistency check)'
    write(IERR,110) '-x width (of longitude patch)'
    write(IERR,110) '-y width (of latitude patch)'
    write(IERR,110) '   each patch is a (2x+1)*(2y+1) rectangle of grid points'
    write(IERR,110) '-z zrad_dat_file'
    return
    end subroutine print_usage
!--------------------------------------------------------------------------
    end module driver

    module interpolate
!
!  SYNOPSIS
!     use interpolate
!
!  DESCRIPTION
!    INTERPOLATE contains routines for binary lookup of
!    tables of unique values in ascending and descending order and
!    for index interpolation.
!
!  ROUTINES IMPLEMENTED
!    pure function index_interp(val,table,n)
!    pure subroutine lookup(val,table,n,ibracket)
!    pure subroutine lookdown(val,table,n,ibracket)
!  
!  REQUIRED PACKAGES
!    None.
!
!  MODIFICATION HISTORY
!    01/12/05 - first implementation.
!
!  PROGRAMMER
!    Eric Kostelich, Dept. of Mathematics and Statistics,
!    Arizona State University, Tempe, AZ 85287-1804, kostelich@asu.edu
!
    contains
! ------------------------------------------------------------------- 
    pure real function index_interp(val,table,n)
!  INDEX_INTERP - Given a table of length N in sorted order and a value VAL,
!  apply linear interpolation to find the "subscript" R such TABLE(R)=VAL.
!  For example, if VAL is halfway between TABLE(J) and TABLE(J+1), then
!  INDEX_INTERP returns the floating-point number J+0.5.
!
    implicit none
    integer,intent(in)::n
    real,intent(in)::val,table(n)
!
!  Local variables
!
    integer::b(2)
!
    if(n.le.1) then
       index_interp=real(n)
       return
    endif
!
    if(table(1).lt.table(2)) then  ! assume ascending order
       call lookup(val,table(1:n),n,b)
    else
       call lookdown(val,table(1:n),n,b)
    endif
    if(b(1).eq.0) then
       index_interp=merge(1.0,0.0,val.eq.table(b(2)))
    else if(b(2).gt.n) then
       index_interp=real(n+1)
    else
       index_interp=b(1)+(val-table(b(1)))/(table(b(2))-table(b(1)))
    endif
    return
    end function index_interp
! ------------------------------------------------------------------- 
    pure subroutine lookup(val,table,n,ibracket)
!  LOOKUP - does binary search for the real value VAL in the real
!  table TABLE of length N, which is assumed sorted in ascending order
!  (this is not checked).  LOOKUP returns the 2-vector IBRACKET such that
!  TABLE(IBRACKET(1)) < VAL <= TABLE(IBRACKET(2)).
!  If VAL < TABLE(1) then IBRACKET = [0,1];
!  if VAL > TABLE(N) then IBRACKET = [N,N+1].
!
    implicit none
    integer,intent(in)::n
    real,intent(in)::val,table(n)
    integer,intent(out)::ibracket(2)
!
!  Local variables
!
    integer::lo,hi,mid
!
    if(val.le.table(1)) then
       ibracket=(/0,1/)
    else if(val.gt.table(n)) then
       ibracket=(/n,n+1/)
    else
       lo=1
       hi=n
       do while(hi-lo.gt.1)
          mid=(hi+lo)/2
          if(val.le.table(mid)) then
             hi=mid
          else
             lo=mid
          endif
       enddo
       ibracket=(/lo,hi/)
    endif
    return
    end subroutine lookup
! ------------------------------------------------------------------- 
    pure subroutine lookdown(val,table,n,ibracket)
!  LOOKDOWN - does binary search for the real value VAL in the real
!  table TABLE of length N, which is assumed sorted in descending order
!  (this is not checked).  LOOKDOWN returns the 2-vector IBRACKET such that
!  TABLE(IBRACKET(1)) > VAL >= TABLE(IBRACKET(2)).
!  If VAL > TABLE(1) then IBRACKET = [0,1];
!  if VAL < TABLE(N) then IBRACKET = [N,N+1].
!
    implicit none
    integer,intent(in)::n
    real,intent(in)::val,table(n)
    integer,intent(out)::ibracket(2)
!
!  Local variables
!
    integer::lo,hi,mid
!
    if(val.ge.table(1)) then
       ibracket=(/0,1/)
    else if(val.lt.table(n)) then
       ibracket=(/n,n+1/)
    else
       lo=1
       hi=n
       do while(hi-lo.gt.1)
          mid=(hi+lo)/2
          if(val.ge.table(mid)) then
             hi=mid
          else
             lo=mid
          endif
       enddo
       ibracket=(/lo,hi/)
    endif
    return
    end subroutine lookdown
! ------------------------------------------------------------------- 
    end module interpolate

!  NAT2OBS - convert nature-run, synthetic observations to the raw_obs
!  file format used in newer versions of the data assimilation code.
!  This program can handle the obsgrid format in /raid/szunyogh/observations.
!  Note: the input files are big-endian.
!
    use grid_types
    use grid_obs,only:raw_obs
    use mrf_ids
    use ferror
    use io
    implicit none
    character(MAX_FILE_NAME_LEN)::infn,outfn
    integer::j,k,nrandom,verblev,idate,ioerr,nobs
    type(patch_index)::loc(LONF,LATG),loc1(LONF*LATG)
    equivalence(loc,loc1)
    real(D)::obsgrid(LONFD,2,8,LATG2,LEVS)
    integer::idx(LONF*LATG)=(/(j,j=1,LONF*LATG)/)
!
    call parseline(infn,outfn,idate,nrandom,verblev)
    open(unit=INSWAP,file=infn,form='unformatted',status='old',iostat=ioerr)
    if(ioerr.ne.0) call fexit(trim(infn)//': cannot open')
    open(unit=OUTNOSWAP,file=outfn,form='unformatted',status='replace', &
       iostat=ioerr)
    if(ioerr.ne.0) call fexit(trim(outfn)//': cannot create')
!
    read(INSWAP,err=911) obsgrid
    write(OUTNOSWAP) idate
    do k=1,LATG
       do j=1,LONF
          loc(j,k)=patch_index(j,k,1)
       enddo
    enddo
    nobs=nrandom
    if(nrandom.lt.LONF*LATG) call randperm(idx,LONF*LATG)
    if(verblev.gt.0) then
       write(IERR,100) infn,outfn,nrandom
       write(IERR,101) minval(loc1(idx(1:nrandom))%y), &
          maxval(loc1(idx(1:nrandom))%y)
    endif
100 format('nat2obs: input: ',a/'output: ',a/'nobs: ',i0)
101 format('nat2obs: check latitudes: min: ',i0,' max: ',i0)
!
    do j=1,nobs
       call process(verblev,obsgrid,loc1(idx(j)),Q)  ! surface pressure
       call process(verblev,obsgrid,loc1(idx(j)),TE)  ! temperature
       call process(verblev,obsgrid,loc1(idx(j)),UG)  ! uwind
       call process(verblev,obsgrid,loc1(idx(j)),VG)  ! vwind
    enddo
    stop
!
911 continue
    call finfo('i/o error; on Lahey, export FORT90L="-Wl,-T1,-T2"')
    end
!------------------------------------------------------------------------------
    subroutine parseline(infn,outfn,idate,nrandom,verblev)
!  PARSELINE - parse the command line.
!
    use resolution
    use io
    use command_line_support
    implicit none
    character(*),intent(out)::infn,outfn
    integer,intent(out)::nrandom,idate,verblev
!
!  Local variables
!
    character(*),parameter::OPTLIST='d:hi:o:n:v:'
    character(MAX_FILE_NAME_LEN)::optarg
    integer::nargs,iopt,optind
    integer,external::iargc
!
!  NARGS is the number of command-line arguments EXCLUDING the program name
!
    nargs=iargc()
    infn=' '  ! no defaults; -i and -o must be specified
    outfn=' ' 
    idate=0  ! -d should be specified
    verblev=0  ! 0 => silent, increasing chattiness with level
    nrandom=LONF*LATG  ! full observing network by default
    do 
       call getopt(iopt,optarg,optind,OPTLIST)
       if(iopt.lt.0) exit
       select case(char(iopt))
       case('d')
          read(optarg,*) idate   !  in yyyymmddhh format
       case('i')  ! list of variables to be assimilated
          infn=optarg
       case('o')
          outfn=optarg
       case('h')
          call usage
       case('n')    ! N random locations
          read(optarg,*) nrandom
       case('v')
          read(optarg,*) verblev
       case default
          call program_exit(1)     ! getopt prints message
       endselect
    enddo
!
!  Get the required argument if no namelist input is given
!
    if(len_trim(infn).eq.0.or.len_trim(outfn).eq.0) then
       call usage
       call program_exit(1)
    endif
!
    contains
       subroutine usage
       write(IERR,103)
103    format('nat2obs -i infile -o outfile [-n #random] [-v verblev]'/ &
          '[-d date (yyyymmddhh format)]'/ &
          '-i and -o must be specified.'/ &
          'If -n is omitted or value is 0 then all observations are copied;'/ &
          'otherwise N randomly-chosen (x,y) points are chosen'/ &
          'and data for PTUV are output at every level')
       call program_exit(1)
       end subroutine usage
    end subroutine parseline
!------------------------------------------------------------------------------
    subroutine process(verblev,obsgrid,loc,var)
!  PROCESS - construct and output an observation in raw_obs format from
!  the synthetic observations on the model grid for variables of type VAR.
!  We output values at all vertical levels for all dynamical variables
!  for the (x,y) coordinate given in LOC.
!
    use grid_types
    use grid_obs,only:raw_obs
    use resolution
    use mrf_ids
    use ferror
    use io
    implicit none
    integer,intent(in)::verblev,var
    real(D),intent(in)::obsgrid(LONFD,2,8,LATG2,LEVS)
    type(patch_index),intent(in)::loc
!
    integer::ix,ih,iy,iz,nobs,ioerr,lat
    integer,parameter::NH=1,SH=2  ! Northern & Southern hemispheres
    type(raw_obs)::robs
!
!  GFS/obsgrid indexing:  IY=1 <=> pole, IY=LATG2 <=> equator
!  Our physical grid indexing:  Y=1 <=> South Pole, Y=LATG <=> North Pole
!
    ix=loc%x
    if(loc%y.le.LATG2) then  ! our Southern Hemisphere
       ih=SH
       iy=loc%y
    else                     ! our Northern Hemisphere
       ih=NH
       iy=LATG-loc%y+1
    endif
!
!  Dummy values for irrelevant fields; fake values for others
!
    robs%typecode=0
    robs%lev=0
    robs%time_diff=0.0
    robs%p_lev=0.0  ! special flag value for synthetic observations
    robs%qcm=1.0  ! high quality obs
    robs%cat=0
    robs%prss=1000.0
    robs%grp='NATURE'
    robs%sid='NATU'
!
    select case(var)
    case(Q)
       robs%field='P'
    case(TE)
       robs%field='T'
    case(UG)
       robs%field='U'
    case(VG)
       robs%field='V'
    case default
       call fabort('unknown variable type')
    endselect
    robs%x_grd=loc%x  ! same internal (x,y) indexing
    robs%y_grd=loc%y
    !
    !  LONSPERLAT is indexed from 1 to LATG2
    !  RLATS is indexed from 1 to LATG
    !  See ~/support/resolution.f90 for details.
    !
    robs%lambda=(360.0/LONSPERLAT(iy))*(ix-1) ! 0 degrees <=> ix=1
    robs%phi=RLATS(loc%y)
    if(var.eq.Q) then  ! surface pressure on level 1 only
       robs%sigma=1.0
       robs%value=obsgrid(ix,ih,Q,iy,1) ! log(dPa)
       robs%sdev=1.0e-04  ! dummy value so grid_obs will substitute 4e-04
       write(OUTNOSWAP) robs
    else
       robs%sdev=merge(1.0,1.1,robs%field.eq.'T') ! T=>1.0 K, wind=> 1.1 m/s
       do iz=1,LEVS
          robs%sigma=iz
          robs%value=obsgrid(ix,ih,var,iy,iz)
          write(OUTNOSWAP) robs
       enddo
    endif
    return
    end subroutine process
!------------------------------------------------------------------------------
    subroutine randperm(ix,n)
!  RANDPERM - create a random permutation of the integers 1 to N and place
!  into IX.
!
    implicit none
    integer,intent(in)::n
    integer,intent(out)::ix(n)
!
    integer::j,idx,itemp
    real::r
!
    !!call random_seed  - always use the same observing network
    do j=1,n
       call random_number(r)
       idx=min(int(r*n)+1,n)
       itemp=ix(n)
       ix(n)=ix(idx)
       ix(idx)=itemp
    enddo
    return
    end subroutine randperm

    module diagnostics
!
!  SYNOPSIS
!    use diagnostics
!
!  DESCRIPTION
!  Implements diagnostics for Brian's version of the data assimilation method.
!
!  ROUTINES IMPLEMENTED
!   subroutine diag_init(header,diagfn,truthfn,backfn,seq,obsfn,analfn)
!   subroutine output_patch_diag(loc,pd)
!   subroutine compute_rms
!   private subroutine report_rms
!   subroutine summary_diagnostics(nsol,have_natgrid)
!   private subroutine standard_units
!
!  REQUIRED PACKAGES
!   grid_obs - in current directory
!   precision, ferror, io, command_line_support - in support directory
!
!  MODIFICATION HISTORY
!  09/24/05 -  Output results on observations is converted to physical units.
!  08/08/05 -  Added optional reporting on the singular values of the
!              matrix (k-1)I+Eb^T*inv(R)*Eb.
!  07/20/05 -  Replaced "BV" field of diagnostics with "EDIM" to reflect
!              current terminology.
!  07/16/05 -  Updated list of error codes from assimilation method;
!              adjusted entries of ERROR_REASON type.
!  06/26/05 -  Added reporting for enhanced variance inflation.
!  06/18/05 -  Consolidated observation diagnostics back here.  Added
!              interpolation to nature grid so we can compute obs minus truth.
!  01/21/05  - Moved observation diagnostics to grid_obs.
!              Diagnostic output no longer is appended to previous log files
!              of the same name; instead, all previous content is overwritten.
!  12/16/04  - bug fixes to 11/19/04 version.
!  11/19/04  - modifications to deal with new grid i/o formats.  Still need
!              a way to select particular observations and report the
!              interpolated model grid values there.
!  06/22/04  - add computation and output of maximum deviation from truth
!              at patch center.
!  06/19/04  - replace 'cond' with 'rcond' everywhere, since we're computing
!              the reciprocal condition number.  Also print out ensemble
!              spread and additional data when rcond < 1e-4.
!  06/17/04  - support for both Brian's method and the original scheme.
!  06/07/04  - modified to work with Brian's assimilation scheme.
!              Removed code to compute explained variance (since we don't
!              have a Q matrix any more).  BV dimension is computed using
!              the eigenvalues of P^a (which we need anyway to get the
!              symmetric square root).
!  04/19/04  - added output of background ensemble mean of p,t,u,v
!  12/05/03  - moved physical scalings to separate module
!  11/11/03  - revision to supply conversion coefficients to physical units.
!  10/19/03  - revision to handle vertical localization and to output
!              traces of background and analysis covariance matrices.
!  08/31/03  - revision to handle latitudinal strips and patches at poles.
!  08/11/03  - no longer require observations at every point
!            and add 'es' lines to estimate ensemble spread.
!
    use grid_obs
    use command_line_support
    implicit none
!
    character(*),parameter,private::VERSION='09/24/05'
!
!  The "true" model variables from the nature run, if available;
!  natgrid is not associated otherwise.
!
    real(D),allocatable,save,private::natgrid(:,:,:,:) 
                                           ! (south:north,LEVS,LONF,NVAR)
!
!  Determine which diagnostics we're going to compute.
!  By default, we do NOT compute and display ensemble statistics for each
!  observation.
!
    logical,save,private::obs_statistics=.false.
!
    type patch_diag
       real(D)::edim=0.0  ! E-dimension of the patch
       real(D)::rcondpb=0.0  ! recip condition numbe of Pb~ (Ed only)
       real(D)::rcondice=0.0  ! recip cond number of (I+C*Eb) (both methods)
       real(D),allocatable::iceb_sing(:)  ! singular vals of (I+C*Eb) (both)
       real(D)::smax=0.0  ! largest eigenval of F in enhanced inflation
       integer::effrank=0  ! effective rank of F in enhanced inflation
       integer::info=0  ! valid return codes are nonnegative
       integer::nobs=0  ! number of observations in the patch
       logical::brian_failed=.false.  ! true if Brian's method failed
    end type patch_diag
!
!  Error return values for assim()
!
!    INFLATION_FAIL :  enhanced variance inflation failed.
!    SYM_SQRT_FAIL :  the computation of the matrix Y failed (singular)
!    PA_NO_EV      :  computation of eigenvectors of the covar mtx failed
!    P_NEG_EV     :   covariance matrix has nontrivial negative eigenvalue
!    NO_OBS_UPDATE :  No observations available to complete the update
!    INFLATE_FAIL  :  Enhanced variance inflation failed
!    P_SINGULAR    :  Either Pb or Pa is numerically singular
!
    integer,parameter::INFLATION_FAIL=1
    integer,parameter::SYM_SQRT_FAIL=2
    integer,parameter::PA_NO_EV=3
    integer,parameter::P_NEG_EV=4
    integer,parameter::NO_OBS_UPDATE=5
    integer,parameter::PA_SINGULAR=6
    integer,parameter::GARBAGE_VALUES=7
    integer,parameter::PB_NO_EV=8
    integer,parameter::OTHER_REASON=9
    character(26),parameter::errcodes(OTHER_REASON)=(/ &
       "enhanced inflation failed ", &
       "can't compute sym sqrt    ", &
       "can't compute analysis Pa ", &
       "covar matrix asymmetric   ", &
       "no observations in patch  ", &
       "singular covariance matrix", &
       "svd of P^b failed         ", & 
       "method generates garbage  ", &
       "other unspecified problem "/)
!
!  Local routines for reporting results in physical units
!
    private::standard_units,report_rms
    contains
! -----------------------------------------------------------------------------
    subroutine diag_init(header,diagfn,truthfn,backfn,seq,obsfn,analfn)
!  DIAG_INIT - initialize diagnostics package for the data
!  assimilation algorithm.
!  HEADER : 4-character string to expect when reading the "true" atmospheric
!           state file (if any).  Use 'none' of no header is expected.
!  DIAGFN : name of file to which diagnostic output should go.
!  TRUTHFN : name of file (if any) containing the "true" atmospheric state
!  BACKFN  : name of the file (if any) containing the background.
!  SEQ     : sequence id (if any) of the background file
!  OBSFN   : name of the file (if any) containing the observations
!  ANALFN  : name of the file (if any) containing the analysis
!
!  Side effects/requirements:
!  - READIN must have been called first
!  - kills the program if problems arise trying to read the "true" grid file.
!  - opens DIAGUNIT and prints info on background, truth, and analysis files
!
!  NOTE:  this interface is incomplete.  Ultimately we should have
!  switches to control how much information about the observations is
!  written (e.g., 'none', 'all', or 'rejected') and whether all the singular
!  values of I+Eb^T*inv(R)*Eb are written out.  For the moment we'll just
!  determine in MAINLOOP whether the singular values are written out,
!  and we'll dump the data on all the observations.
!
    use grid_io
    implicit none
    character(*),intent(in)::header,diagfn
    character(*),intent(in)::truthfn,backfn,obsfn,analfn
    integer,intent(in)::seq
!
!  Local variables
!  PSOUTH, PNORTH define latitude strip at which assimilation patches can
!  be centered (not important here for the nature grid but are checked
!  for consistency).  INORTH, ISOUTH define the latitude strip containing
!  the nature grid; they must coincide with the latitude strip for each
!  ensemble model grid.
!
    if(len_trim(diagfn).eq.0) &
       call fexit('diag_init: no diagnostic output file specified',2)
    open(unit=DIAGUNIT,file=diagfn,action='write')
!
!  Get the "true" nature (sub)grid and check for compatible boundaries
!
    write(DIAGUNIT,100) VERSION
100 format('#diagnostics package: version ',a)
    if(len_trim(truthfn).gt.0) call read_nature_grid(header,truthfn,seq)
101 format('#',a,1x,a)
    if(len_trim(backfn).gt.0) write(DIAGUNIT,101) 'background',trim(backfn)
    write(DIAGUNIT,102) 'seqid',seq
102 format('#',a,1x,i0)
    if(len_trim(obsfn).gt.0) write(DIAGUNIT,101) 'observations',trim(obsfn)
    if(len_trim(analfn).gt.0) write(DIAGUNIT,101) 'analysis',trim(analfn)
!
!  Explain what the entries mean
!
    write(DIAGUNIT,110) 'loc gives (ix iy iz thickness inflation)'
    write(DIAGUNIT,110) '  where inflation=simple,enhanced,Snyder-Zhang)'
    write(DIAGUNIT,110) 'output values are in physical units'
    write(DIAGUNIT,110) 'patch gives nobs edim rcondice [rcondpb], where'
    write(DIAGUNIT,110) '  nobs is number of observations in the patch'
    write(DIAGUNIT,110) '  edim is E-dimension over entire patch'
    write(DIAGUNIT,110) '  rcondice is recip cond number of I+Eb^T*inv(R)*Eb'
    write(DIAGUNIT,110) '  rcondpb is reciprocal condition number of Pb^'
    write(DIAGUNIT,110) 'SV is singular vals of I+Eb^T*inv(R)*Eb'
110 format('#',a)
    return
    end subroutine diag_init
! -----------------------------------------------------------------------------
    subroutine output_patch_diag(loc,pd)
!  OUTPUT_DIAGS - print out the diagnostics.
!  Side effects: writes to DIAGUNIT
!
    type(patch_index),intent(in)::loc
    type(patch_diag),intent(in)::pd
!
    integer::low,high
    type(inflation_info)::inflate
!
!  If there are no observations, then no useful diagnostics are computed.
!
    if(pd%nobs.eq.0) return
!
!  If there was an error in the data assimilation step other than no
!  observations, display it here.
!
    call zdiam(loc,low,high)
    call inflation(loc,inflate)
    write(DIAGUNIT,100) loc,high-low+1,inflate
100 format('loc ',4i4,3f9.3)
    if(pd%brian_failed) then  ! we used the original formulation
       write(DIAGUNIT,101) pd%nobs,pd%edim,pd%rcondice,pd%rcondpb
    else
       write(DIAGUNIT,101) pd%nobs,pd%edim,pd%rcondice
    endif
101 format('p ',i4,f9.3,2es11.3)
    if(pd%info.ne.0) write(DIAGUNIT,102) 'failed:',errcodes(pd%info)
102 format(a,1x,a)
    if(pd%effrank.gt.0) write(DIAGUNIT,103) pd%effrank,pd%smax
103 format('F',i4,es11.3)
    if(allocated(pd%iceb_sing)) write(DIAGUNIT,104) pd%iceb_sing
104 format('SV',7es11.4/('> ',7es11.4))
    return
    end subroutine output_patch_diag
! ----------------------------------------------------------------------
    subroutine compute_rms
!  COMPUTE_RMS - compute the sum of squares of the difference
!  between the analysis grid (AGRID) and the nature grid over the strip
!  processed by this assimilation run at selected atmospheric levels.
!  (The surface pressure is accessed only at level 1.)
!  This routine assumes that the nature grid is available!  Calling it without
!  a nature grid WILL crash the program.
!  Results are computed and displayed to DIAGUNIT.
!
    integer::levlist(3)=(/1,5,15/)
    integer::asouth,anorth
!
    call assimilation_boundary(asouth,anorth)
    write(DIAGUNIT,100)
100 format('#rms var lat lev value')
!
!  Surface pressure first - level 1 only.
!
    call report_rms(asouth,anorth,levlist(1:1),PRES_TYPE)
!
!  Next temperature at the selected atmospheric levels
!
    call report_rms(asouth,anorth,levlist,TEMP_TYPE)
!
!  Finally, the U component of the wind.  We won't repeat the computation
!  for V since I expect the results to be comparable for both.
!
    call report_rms(asouth,anorth,levlist,UWIND_TYPE)
    return
    end subroutine compute_rms
!----------------------------------------------------------------------------
    subroutine report_rms(asouth,anorth,levlist,typ)
!  REPORT_RMS - compute and report the RMS between the analysis and the truth
!  for the specified variable TYP between the indicated latitudes for the
!  specified model atmospheric levels.
!  Results go to DIAGUNIT.
!
    integer,intent(in)::asouth,anorth,typ,levlist(:)
!
    real(D)::aval(1),natval(1)  ! must be arrays, despite logical scalar quality
    real(D)::rms(asouth:anorth,size(levlist))
    real::v
    type(patch_index)::loc
    integer::ix,iy,k,lev
!
    rms=0.0
    do ix=1,LONF
       do k=1,size(levlist)
          lev=levlist(k)
          do iy=asouth,anorth
             loc=patch_index(ix,iy,lev)
             call copy_grid_point(loc,aval,typ,'amean')
             call copy_grid_point(loc,natval,typ,'nature')
             v=real(aval(1),R)
             call standard_units(v,typ,real(lev))
             aval(1)=v
             v=real(natval(1),R)
             call standard_units(v,typ,real(lev))
             natval(1)=v
             rms(iy,k)=rms(iy,k)+(aval(1)-natval(1))**2
          enddo
       enddo
    enddo
    rms=sqrt(rms/LONF)
    do k=1,size(levlist)
       lev=levlist(k)
       do iy=asouth,anorth
          write(DIAGUNIT,100) TYPEOF(typ),iy,lev,rms(iy,k)
       enddo
    enddo
    return
100 format('rms ',a,2i4,es11.3)
    end subroutine report_rms
!---------------------------------------------------------------------------
    subroutine summary_diagnostics(nsol,have_natgrid)
!  SUMMARY_DIAGNOSTICS - compute and display statistics for each
!  observation that appears in the final analysis grid.  Output goes
!  to the diagnostics file.   We report on all observations that are
!  of types that are assimilated.  (For example, if we don't assimilate
!  surface pressure, then no statistics about pressure observations and
!  the associated interpolated model grid points are output.)
!  Lines beginning with 'o' are observations that pass all applicable
!  consistency checks; 'r' are those that fail some consistency test.
!  IN ADDITION, we compute the global RMS at selected atmospheric levels.
!
!  HAVE_NATGRID : if true, then the nature grid is available for comparison.
!
    implicit none
!
    integer,intent(in)::nsol  ! needed for analysis sdev computation
    logical,intent(in)::have_natgrid
!
    type(ensemble_stat)::bgstat  ! background statistics
    type(ensemble_stat)::anstat  ! analysis statistics
    integer::asouth,anorth,k,total_kept,total_obs,ierr
    character::mnemonic
    real::phisouth,phinorth,v,s,zmean
    real(D)::hx(nsol)
    type(model_obs)::obs
!
    if(have_natgrid) call compute_rms
!
    call assimilation_boundary(asouth,anorth)
    if(asouth.le.1) then  ! assimilation goes to south pole
       phisouth=-90.0
    else
       phisouth=RLATS(asouth)
    endif
    if(anorth.ge.LATG) then  ! assimilation goes to north pole
       phinorth=90.0
    else
       phinorth=RLATS(anorth)
    endif
!
!  Statistics on retained observations
!
    write(DIAGUNIT,100) 'lambda','phi','z','value','sdev', &
        'back mean','back sdev','anal mean','anal sdev','nature val'
100 format('#o|r',2x,2a8,a7,9a11)
!
    call obs_count(total_kept,total_obs)
    do k=1,total_kept
       call kth_obs(k,obs,ierr,bgstat,zmean)
       if(ierr.eq.0.and.obs%phi.ge.phisouth.and.obs%phi.lt.phinorth) then
          call linear_interp(k,nsol,hx,'analysis',anstat)
          call standard_units(obs%value,obs%typ,zmean,obs%sdev)
          v=real(bgstat%mean,R)
          s=real(bgstat%sdev,R)
          call standard_units(v,obs%typ,zmean,s)
          bgstat%mean=v
          bgstat%sdev=s
          v=real(anstat%mean,R)
          s=real(anstat%sdev,R)
          call standard_units(v,obs%typ,zmean,s)
          anstat%mean=v
          anstat%sdev=s
          mnemonic=TYPEOF(obs%typ)
          if(have_natgrid) then
             call linear_interp(k,1,hx,'nature')
             v=real(hx(1),R)
             call standard_units(v,obs%typ,zmean)
             hx(1)=v
             write(DIAGUNIT,110) 'o',obs%typecode,mnemonic, &  ! types
                obs%lambda,obs%phi,obs%x_grd(3), &  ! location
                obs%value,obs%sdev,bgstat%mean,bgstat%sdev, &
                anstat%mean,anstat%sdev,hx(1)
          else
             write(DIAGUNIT,110) 'o',obs%typecode,mnemonic, &  ! types
                obs%lambda,obs%phi,obs%x_grd(3), &  ! location
                obs%value,obs%sdev,bgstat%mean,bgstat%sdev, &
                anstat%mean,anstat%sdev
          endif
       endif
    enddo
110 format(a1,i4,a2,2f8.3,f7.3,7es11.3)
!
!  Statistics on rejected observations
!
    do k=total_kept+1,total_obs
       call kth_obs(k,obs,ierr,bgstat,zmean)
       if(ierr.eq.0.and.obs%phi.ge.phisouth.and.obs%phi.lt.phinorth) then
          call standard_units(obs%value,obs%typ,obs%x_grd(3),obs%sdev)
          v=real(bgstat%mean,R)
          s=real(bgstat%sdev,R)
          call standard_units(v,obs%typ,zmean,s)
          bgstat%mean=v
          bgstat%sdev=s
          mnemonic=TYPEOF(obs%typ)
          if(have_natgrid) then
             call linear_interp(k,1,hx,'nature')
             v=real(hx(1),R)
             call standard_units(v,obs%typ,zmean)
             write(DIAGUNIT,110) 'r',obs%typecode,mnemonic, &  ! types
                obs%lambda,obs%phi,obs%x_grd(3), &  ! location
                obs%value,obs%sdev,bgstat%mean,bgstat%sdev,v
          else
             write(DIAGUNIT,110) 'r',obs%typecode,mnemonic, &  ! types
                obs%lambda,obs%phi,obs%x_grd(3), &  ! location
                obs%value,obs%sdev,bgstat%mean,bgstat%sdev
          endif
       endif
    enddo
    return
    end subroutine summary_diagnostics
! ----------------------------------------------------------------------
    pure subroutine standard_units(val,typ,z,sdev)
!  STANDARD_UNITS - return the relevant value of the arguments in
!  "standard" physical units; see spectral.f90 for the definition of 
!  "standard".
!
    real(R),intent(inout)::val
    integer,intent(in)::typ
    real(R),intent(in)::z
    real(R),intent(inout),optional::sdev
!
    select case(typ)
    case(PRES_TYPE)  ! ln(dPa) -> hPa; Taylor gives log(v/10+s)~log(v/10)+10s/v
       val=10.0*exp(energy_to_pres(val))
       if(present(sdev)) sdev=energy_to_pres(sdev)*val/10.0
    case(TEMP_TYPE)
       val=energy_to_temp(val,z)
       if(present(sdev)) sdev=energy_to_temp(sdev,z)
    case(UWIND_TYPE,VWIND_TYPE)
       val=energy_to_wind(val,z)
       if(present(sdev)) sdev=energy_to_wind(sdev,z)
    case default
       val=0.0
       if(present(sdev)) sdev=0.0
    endselect
    return
    end subroutine standard_units
! ----------------------------------------------------------------------
    end module diagnostics

    module gfs_ids
!  GFS_IDS - parameters that select the dynamical variables from the GFS grid.
!  
    integer::UTOP,VTOP,XTOP,WTOP
    parameter(UTOP=1,VTOP=2,XTOP=3,WTOP=4)
    integer,parameter::NVAR=8
    end module gfs_ids

    module covar_setup
!  COVAR_SETUP - read the ensemble covariance inflation file and report
!  the nature of the covariance inflation that is to be applied to the
!  ensemble at each vertical level.
!  MODIFICATION HISTORY
!  07/11/05 - deleted sigma file name from vertical information file;
!             see read_vert_info_file.
!  06/23/05 - added support for enhanced inflation on selected variables.
!  06/21/05 - added support for enhanced variance inflation
!  01/27/05 - new version to add the Zhang, Snyder, and Sun correction to
!    the analysis ensemble.  The covariance data file is NOT COMPATIBLE
!    with that of previous versions of the code.
!
    use grid_types
    use assim_vars
    use io
    implicit none
!
!  Types of variance inflation that the program eventually can handle.
!  "Zhang" inflation is the linear combination (homotopy) of the background
!  ensemble differences and the analysis ensemble differences computed by
!  the EKTF.  If alpha=0.5, for example, we take the average of the two
!  for the final analysis.  The goal is to keep the ensemble from collapsing.
!  See Zhang, Snyder, and Sun, MWR 132 (May 2004), 1238-1253, Eq. (5).
!  By default, we don't apply the Zhang inflation (i.e., alpha=0).
!  Values of alpha < 1 mean to move the analysis ensemble closer to the
!  background.  We require 0 <= alpha < 1.
!
    type inflation_info
       sequence
       real(R)::covar=0.04_R  ! size of covariance inflation; 4% by default
       real(R)::enhanced=0.0  ! size of enhanced inflation; none by default
       real(R)::alpha=0.0  ! Snyder-Zhang inflation term
    end type inflation_info
!
!  Vertical radius and inflation info by level and latitude
!
    type(inflation_info),save,private::infl(LEVS,LATG)
!
    integer,save,private::enhanced_inflation_varlist(NAVARS)= &
       (/PRES_TYPE,TEMP_TYPE,UWIND_TYPE,VWIND_TYPE/)
    contains
!---------------------------------------------------------------------------
    pure subroutine inflation(loc,inflate,vars)
!  INFLATION - return the covariance inflation factor and method, and optionally
!  the list of variables for which enhanced inflation is to be attempted
!  for the patch centered at LOC.
!
    type(patch_index),intent(in)::loc
    type(inflation_info),intent(out)::inflate
    integer,intent(out),optional::vars(NAVARS)
!
    if(loc%z.lt.1.or.loc%z.gt.LEVS.or.loc%y.lt.1.or.loc%y.gt.LATG) then
       inflate=inflation_info(0.0,0.0,0.0)   ! out of bounds
    else
       inflate=infl(loc%z,loc%y)
    endif
    if(present(vars)) vars=enhanced_inflation_varlist
    return
    end subroutine inflation
!---------------------------------------------------------------------------
    subroutine read_vert_info_file(zfile,zradius)
!  READ_VERT_INFO_FILE - read the file containing information about the
!  vertical localization, and covariance inflation and method at each 
!  level.
!  Because it seems most convenient to have one file to specify vertical
!  localization and covariance data, this routine is placed in this module,
!  even though the vertical level thickness arguably belongs to the indexing
!  routines.
!  The format of the user-created input file is as follows:
!  Lines beginning with # are comments.
!  All subsequent non-comment lines have the form
!    startlat endlat
!    level  zradius  covariance method alpha.
!  The values for the indicated levels apply for all
!  latitudes in the range from STARTLAT to ENDLAT.
!  If no vertical localization is to be done, but we do want covariance
!  inflation, then set the Z radius to LEVS (28).
!
    implicit none
    character(*),intent(in)::zfile
    integer,intent(out)::zradius(LEVS,LATG)
!
!  Local variables
!
    integer::j,lowlat,highlat,prevhigh,lev,lineno,zwin
    real(R)::covar,alpha,enhanced
    character(80)::line
    logical::eof
!
    if(len_trim(zfile).eq.0) return
    if(verbosity().gt.VERB_SILENT) write(LOGFILE,100) trim(zfile)
100 format('vertical localization data file: ',a)
    open(unit=IN,file=zfile,status='old',iostat=j)
    if(j.ne.0) call fexit('read_vert_info_file: cannot open '//trim(zfile),2)
!
!  Subsequent lines:  look for
!   startlat endlat
!  followed by
!   lev zradius covariance alpha
!  and do basic sanity checks.
!
    lineno=0
    prevhigh=0
    do
       call skip_comments(line,lineno,eof)
       if(eof) exit
       read(line,*) lowlat,highlat
       if(lowlat.ne.prevhigh+1.or.highlat.lt.lowlat) then
          write(IERR,900) trim(zfile),lineno,'latitudes overlap'
900       format(a,': line ',i0,': ',a)
          write(IERR,901) lowlat,highlat,prevhigh
901       format('lowlat: ',i0,' highlat: ',i0,' prevhigh: ',i0)
          call fexit(trim(zfile)//': error in input',2)
       else if(highlat.lt.1.or.highlat.gt.LATG) then
          write(IERR,900) trim(zfile),lineno,'bad latitude value'
          call fexit(trim(zfile)//': error in input',2)
       endif
       prevhigh=highlat
       do j=1,LEVS
          call skip_comments(line,lineno,eof)
          if(eof) goto 10   ! quit
          read(line,*) lev,zwin,covar,alpha,enhanced
          if(min(covar,alpha,enhanced).lt.0.0.or.alpha.ge.1.0) then
             write(IERR,900) trim(zfile),lineno,'bad variance inflation value'
             call fexit(trim(zfile)//': error in input',2)
          endif
          if(lev.ne.j) then
             write(IERR,900) trim(zfile),lineno,'bad level index'
             call fexit(trim(zfile)//': error in input',2)
          else if(lev.eq.1.and.zwin.eq.LEVS) then   ! no vertical localization
             zradius(:,lowlat)=LEVS
             infl(:,lowlat)%covar=covar
             infl(:,lowlat)%alpha=alpha
             infl(:,lowlat)%enhanced=enhanced
             exit
          else if(lev+zwin.gt.LEVS.or.lev-zwin.lt.1) then
             write(IERR,900) trim(zfile),lineno,'z radius out of range'
             call fexit(trim(zfile)//': error in input',2)
          else
             zradius(j,lowlat)=zwin
             infl(j,lowlat)%covar=covar
             infl(j,lowlat)%alpha=alpha
             infl(j,lowlat)%enhanced=enhanced
          endif
       enddo
       !
       !  The thickness of the layers is independent of longitude for now
       !
       do j=lowlat+1,highlat
          infl(:,j)=infl(:,lowlat)
          zradius(:,j)=zradius(:,lowlat)
       enddo
    enddo
 10 continue
    close(IN)
    return
    contains
       ! -------------------
       subroutine skip_comments(ln,no,eof)
       !  SKIP_COMMENTS - skip blank and comment lines
       !
       character(*),intent(out)::ln
       integer,intent(inout)::no
       logical,intent(out)::eof
       !
       eof=.false.
       do
          no=no+1
          read(IN,'(a)',end=90) ln
          if(ln(1:1).ne.'#'.and.len_trim(ln).gt.0) exit
       enddo
       return
 90    eof=.true.
       return
       end subroutine skip_comments
       ! -------------------
    end subroutine read_vert_info_file
!---------------------------------------------------------------------------
    end module covar_setup

    module surface
! SURFACE - support code for reading the MRF surface analysis files
! and for computing means of the relevant quantities.
! SYNOPSIS
!    use surface
!
! DEPENDENCIES
!    fixio - in current directory
!    resolution, precision, io, ferror, command_line_support - in support dir
!
! MODIFICATION HISTORY
! 08/11/05 - Changed name of module to "surface" and gave a matching filename,
! 07/21/04 - First implementation by Eric to compute and write an averaged
!            surface analysis file for the MRF code.
! 07/26/04 - Istvan made a major reduction (simplification) of the code by
!            eliminating several subroutines and variables, and
!            shortening the parameter list of a few subroutines. The
!            eliminated structures were mainly associated with the
!            mpi implementation of the original MRF code. The most extensive
!            changes were done in fixi.f90. 
!
    use fixio
    use resolution
    use precision
    use io
    use ferror
    use command_line_support,only:program_exit
    implicit none
!
!  On Lahey Intel Linux, input and output binary data require byte-swapping.
!
    integer,save,private::nread=INSWAP
    integer,save,private::nwrite=OUTSWAP
!
    type sfcanl
       real(D)::smc(LONF,LATG,LSOIL)
       real(D)::stc(LONF,LATG,LSOIL)
       real(D)::tsea(LONF,LATG)
       real(D)::sheleg(LONF,LATG)
       real(D)::tg3(LONF,LATG)
       real(D)::zorl(LONF,LATG)
       real(D)::cv(LONF,LATG)
       real(D)::cvb(LONF,LATG)
       real(D)::cvt(LONF,LATG)
       real(D)::alvsf(LONF,LATG)
       real(D)::alvwf(LONF,LATG)
       real(D)::alnsf(LONF,LATG)
       real(D)::alnwf(LONF,LATG)
       real(D)::slmsk(LONF,LATG)
       real(D)::vfrac(LONF,LATG)
       real(D)::canopy(LONF,LATG)
       real(D)::f10m(LONF,LATG)
       real(D)::vtype(LONF,LATG)
       real(D)::stype(LONF,LATG)
       real(D)::facsf(LONF,LATG)
       real(D)::facwf(LONF,LATG)
       real(D)::uustar(LONF,LATG)
       real(D)::ffmm(LONF,LATG)
       real(D)::ffhh(LONF,LATG)
    end type sfcanl
!
!  We assume no parallel processing (1 cpu) 
!
!  No explicit routines are needed for assignment, as the default Fortran
!  operator suffices for sfcanl.
!
    interface operator(+)
       module procedure add_sfcanl
    end interface
    interface operator(/)
       module procedure div_sfcanl_n
    end interface
    contains
!------------------------------
    subroutine read_sfcanl(fn,sfc,fhour,idate)
    implicit none
    character(*),intent(in)::fn
    type(sfcanl),intent(out)::sfc
    real(R),intent(out)::fhour
    integer,intent(out)::idate(4)  ! hh,mm,dd,yyyy
!
    integer::ioerr
!
    open(unit=nread,file=fn,form='unformatted',position='rewind', &
       status='old',iostat=ioerr)
    if(ioerr.ne.0) then
       write(IERR,900) trim(fn),nread
       call program_exit(1)
    endif
900 format('read_sfcanl: cannot open ',a/ &
       'On Lahey, setting the environment variable "FORT90L=-Wl,-T',i0, &
       '"is required if the input files are byte-swapped')
!
    call para_fixio_r(LONF,LONF2,LATG,LATG2,sfc%tsea,sfc%smc,sfc%sheleg, &
       sfc%stc,sfc%tg3, &
       sfc%zorl,sfc%cv,sfc%cvb,sfc%cvt,sfc%alvsf,sfc%alvwf,sfc%alnsf,sfc%alnwf,&
       sfc%slmsk,sfc%vfrac,sfc%canopy,sfc%f10m,sfc%vtype,sfc%stype,sfc%facsf, &
       sfc%facwf,sfc%uustar,sfc%ffmm,sfc%ffhh,nread, &
       fhour,idate)
    close(nread)
    return
    end subroutine read_sfcanl
!------------------------------
    subroutine write_sfcanl(fn,sfc,fhour,cdate)
    implicit none
    character(*),intent(in)::fn
    type(sfcanl),intent(in)::sfc
    real(R),intent(in)::fhour
    character(*),intent(in)::cdate  ! yyyyddmmhh format
!
    integer::ioerr,idate(4)
!
    open(unit=nwrite,file=fn,form='unformatted',position='rewind',iostat=ioerr)
    if(ioerr.ne.0) then
       write(IERR,900) trim(fn)
       call program_exit(1)
    endif
900 format('write_sfcanl: cannot create ',a/a)
!
!    nlats=LATG2
!
!  The input date string has the format yyyymmddhh, but the date
!  format in the MRF sigma files is hh mm dd yyyy.
!
    if(len_trim(cdate).eq.10) then
       read(cdate,'(i4,3i2)') idate(4),idate(2),idate(3),idate(1)
    else
       idate=0
    endif

    call para_fixio_w(LONF,LONF2,LATG,LATG2,sfc%tsea,sfc%smc,sfc%sheleg, &
       sfc%stc,sfc%tg3, &
       sfc%zorl,sfc%cv,sfc%cvb,sfc%cvt,sfc%alvsf,sfc%alvwf,sfc%alnsf,sfc%alnwf,&
       sfc%slmsk,sfc%vfrac,sfc%canopy,sfc%f10m,sfc%vtype,sfc%stype,sfc%facsf, &
       sfc%facwf,sfc%uustar,sfc%ffmm,sfc%ffhh,nwrite, &
       fhour,idate)
    close(nwrite)
    return
    end subroutine write_sfcanl
!------------------------------
    elemental function add_sfcanl(x,y) result(z)
    implicit none
    type(sfcanl),intent(in)::x,y
    type(sfcanl)::z
!
!  Add all the array components of sfcanl pairwise
!
    z%smc=x%smc+y%smc
    z%stc=x%stc+y%stc
    z%tsea=x%tsea+y%tsea
    z%sheleg=x%sheleg+y%sheleg
    z%tg3=x%tg3+y%tg3
    z%zorl=x%zorl+y%zorl
    z%cv=x%cv+y%cv
    z%cvb=x%cvb+y%cvb
    z%cvt=x%cvt+y%cvt
    z%alvsf=x%alvsf+y%alvsf
    z%alvwf=x%alvwf+y%alvwf
    z%alnsf=x%alnsf+y%alnsf
    z%alnwf=x%alnwf+y%alnwf
    z%slmsk=x%slmsk+y%slmsk
    z%vfrac=x%vfrac+y%vfrac
    z%canopy=x%canopy+y%canopy
    z%f10m=x%f10m+y%f10m
    z%vtype=x%vtype+y%vtype
    z%stype=x%stype+y%stype
    z%facsf=x%facsf+y%facsf
    z%facwf=x%facwf+y%facwf
    z%uustar=x%uustar+y%uustar
    z%ffmm=x%ffmm+y%ffmm
    z%ffhh=x%ffhh+y%ffhh
    return
    end function add_sfcanl
!------------------------------
    elemental function div_sfcanl_n(x,n) result(z)
    implicit none
    type(sfcanl),intent(in)::x
    integer,intent(in)::n
    type(sfcanl)::z
!
!  Divide each component array element by n
!
    z%smc=x%smc/n
    z%stc=x%stc/n
    z%tsea=x%tsea/n
    z%sheleg=x%sheleg/n
    z%tg3=x%tg3/n
    z%zorl=x%zorl/n
    z%cv=x%cv/n
    z%cvb=x%cvb/n
    z%cvt=x%cvt/n
    z%alvsf=x%alvsf/n
    z%alvwf=x%alvwf/n
    z%alnsf=x%alnsf/n
    z%alnwf=x%alnwf/n
    z%slmsk=x%slmsk/n
    z%vfrac=x%vfrac/n
    z%canopy=x%canopy/n
    z%f10m=x%f10m/n
    z%vtype=x%vtype/n
    z%stype=x%stype/n
    z%facsf=x%facsf/n
    z%facwf=x%facwf/n
    z%uustar=x%uustar/n
    z%ffmm=x%ffmm/n
    z%ffhh=x%ffhh/n
    return
    end function div_sfcanl_n
!------------------------------
    end module surface

    module mrf_ids
!  MRF_IDS - parameters that select the dynamical variables from the MRF grid.
!  
    integer::Q,TE,RQ,OZ,ZE,DI,ULN,VLN
    parameter(Q=1,TE=2,RQ=3,OZ=4,ULN=5,VLN=6,DI=7,ZE=8)
    integer::UTOP,VTOP,XTOP,WTOP,UG,VG
    parameter(UTOP=1,VTOP=2,XTOP=3,WTOP=4,UG=5,VG=6)
    integer,parameter::NVAR=8
    end module mrf_ids

    module spectral
!  SPECTRAL_MOD - module containing the interface to GFS spectral
!  transform routines.
!
!  SYNOPSIS
!     use spectral
!
!  DESCRIPTION
!  The routines here handle the conversion between
!  the model observation grid and the scaled physical variables used in
!  our data assimilation routines.  In particular, this version allows us
!  to assimilate wind and, if desired, relative humidity, ozone, and
!  other tracers.
!
!  The GFS model uses observations grids with leading dimension 1:LONFD,
!  where LONFD > LONF, the number of actual longitudes.  We therefore
!  only create and use arrays of leading dimension 1:LONF for the data
!  assimilation.  We pad with zeros on output and strip the extra rows
!  on input as needed.
!
!  ROUTINES IMPLEMENTED
!   subroutine spectral_code_init(fn,header,coeff)
!   subroutine to_physical_space(spect,physgrid)
!   pure subroutine to_standard_units(gfs,phys)
!   subroutine from_physical_space(physgrid,spect)
!   generic elemental function pres_to_energy(lndpa)
!   generic elemental function temp_to_energy(lndpa,lev or z)
!   generic elemental function wind_to_energy(lndpa,lev or z)
!   generic elemental function energy_to_pres(p)
!   generic elemental function energy_to_temp(t,lev or z)
!   generic elemental function energy_to_wind(w,lev or z)
!   pure subroutine from_standard_units(phys,gfs)
!   subroutine read_sigma_file(fn,header,coeff)
!   subroutine write_sigma_file(fn,header,coeff)
!   pure function rmsof(f)
!   subroutine output_sinlat(fn)
!   subroutine dump_header(fn,iunit,header)
!   subroutine report_rms(coeff)
!
!  MACHINE DEPENDENCIES
!  On Linux clusters, we may need to set the environment variable
!  FORT90L="-Wl,-T1" and/or FORT90L="-Wl,-T2" to effect byte-swapping
!  on logical units 1 (INSWAP) and 2 (OUTSWAP), which we use for binary data.
!  The reason is that the model is compiled with the big-endian library
!  for creating sigma files and such, and Intel-based clusters are
!  little-endian machines.
!
!  MODIFICATION HISTORY
!  09/23/05 - Added variable_to_energy conversion routines for consistent
!             application throughout the code.  Removed the
!             GET_CONVERSION_COEFFS interface in view of this.
!  08/27/05 - added compatibility to 2004 GFS as well as 2001 version;
!             added optional arg to DUMP_HEADER for benefit of pre/postanalysis.
!  06/29/05 - added routines to implement energy units and corrected comments
!             in a few locations.
!  06/19/05 - changes to header and to WRITE_SIGMA_FILE to be compatible
!             with the 2001 GFS.
!  06/13/05 - fixed errors in calls to inverse transforms; eliminated
!             tread/twrite in favor of read/write_sigma_file.
!  05/23/05 - eliminated global variables previously used by preanalysis.
!  04/11/05 - corrections to NH/SH indexing in the MRF grid.  (I think this
!             is finally correct and consistent with the 2001 version.)
!  03/04/05 - revised version by Eric.
!
!  REQUIRED PACKAGES
!
    use grid_indexing
    use gfs_init
    use gfs_transforms
    use constant  ! the rest of these from the support directory
    use resolution
    use gfs_ids
    use io
    use ferror
    implicit none
!
!  Single-precision reals in sigma files
!
    integer,parameter::IO4=R
!
! Northern and Southern Hemispheres
!
    integer,parameter::NH=1,SH=2
!
!  Parameters needed to convert to and from physical units.
!  Initialized in spectral_code_init.
!
    real(D),save,private::sinlat(LATG2),wgt(LATG2)
    real(D),save,private::wslev(LEVS)
    real(D),save,private::wq,wte  ! for energy unit conversion
    real(D),save,private::pln(LNTD,LATG2),plntop(JCAP1,LATG2)
    logical,save,private::initialized=.false.
!
!  Name of the sigma file, if any, from which the above coefficients
!  were initialized.
!
    character(MAX_FILE_NAME_LEN),save,private::init_sigma_fn=' '
!
!  This header is valid for the 2001 version of the GFS code that we use.
!  We supply default values for most components, as the only ones that
!  are likely to change in our simulations are the forecast hour
!  and the date.  These default values simplify the construction of the
!  data assimilation scripts because we don't need to pass around a reference
!  sigma file for the XI and XL coefficients.
!
    type sigma_file_header
       sequence   ! important for working around Lahey byte-swapping deficiency
       real(IO4)::fhour4=0.0  ! forecast hour
       integer::idate(4)=0  ! hh dd mm yyyy
       !
       !  XI defines values that are used to compute WSLEV and energy units
       !
       real(IO4)::xi(LEVS+1)=(/1.0_IO4,0.99000001_IO4,0.974179983_IO4, &
          0.954590023_IO4,0.930540025_IO4,0.901350021_IO4,0.866419971_IO4, &
          0.825269997_IO4,0.777729988_IO4,0.724009991_IO4,0.664820015_IO4, &
          0.601350009_IO4,0.535290003_IO4,0.468600005_IO4,0.403340012_IO4, &
          0.341369987_IO4,0.284209996_IO4,0.232859999_IO4,0.187830001_IO4, &
          0.149159998_IO4,0.116540000_IO4,0.0894500017_IO4,0.0672300011_IO4, &
          0.0491999984_IO4,0.0346900001_IO4,0.0230899993_IO4,0.0138600003_IO4, &
          0.0065700002_IO4,0.0_IO4/)
       !
       !  XL defines the sigma levels
       !
       real(IO4)::xl(LEVS)=(/0.994996905_IO4,0.982082129_IO4,0.96437335_IO4, &
          0.942546666_IO4,0.915917397_IO4,0.88384378_IO4,0.84578532_IO4, &
          0.801416039_IO4,0.750755608_IO4,0.694264889_IO4,0.632895589_IO4, &
          0.568091393_IO4,0.501681089_IO4,0.435679018_IO4,0.372047603_IO4, &
          0.312478721_IO4,0.258230925_IO4,0.210057467_IO4,0.168230236_IO4, &
          0.132610902_IO4,0.102782242_IO4,0.0781517029_IO4,0.0580480471_IO4, &
          0.041794762_IO4,0.0287503004_IO4,0.0183360856_IO4,0.0100562088_IO4, &
          0.00272623356_IO4/)
       real(IO4)::dummy(201-LEVP1-LEVS)=0.0
       real(IO4)::waves=JCAP
       real(IO4)::xlayers=LEVS
       real(IO4)::trun=1.0
       real(IO4)::order=2.0
       real(IO4)::realform=1.0
       real(IO4)::gencode=78.0
       real(IO4)::rlond=LONF
       real(IO4)::rlatd=LATG
       real(IO4)::rlonp=LONF
       real(IO4)::rlatp=LATG
       real(IO4)::rlonr=LONF
       real(IO4)::rlatr=LATG
       real(IO4)::tracers=2.0  ! relative humidity and ozone, presumably
       real(IO4)::subcen=0.0
       real(IO4)::ensemble(2)=0.0
       real(IO4)::ppid=0.0
       real(IO4)::slid=0.0
       real(IO4)::vcid=0.0
       real(IO4)::vmid=0.0
       real(IO4)::vtid=0.0
       real(IO4)::runid4=0.0
       real(IO4)::usrid4=0.0
       !
       !  The next three fields are broken out in the 2004 GFS; the 2001 GFS
       !  has DUMMY2 as length 21.
       !
       real(IO4)::pdryini4=0.0
       real(IO4)::xncld=0.0
       real(IO4)::xgf=0.0
       real(IO4)::dummy2(18)=0.0
    end type sigma_file_header
!
!  The following is needed for the messy workaround to Lahey runtime 
!  byte-swapping bugs.  SIGMA_HEADER_LENGTH is the number of default real
!  and integer elements in the file header.
!
    integer,parameter::SIGMA_HEADER_LENGTH=250
!
!  The naming conventions below are the same as those in the 2001 GFS code
!
    type spectral_coeffs
       sequence
       real(D)::gz(LNTD,2)   ! geopotential height
       real(D)::q(LNTD,2)  ! surface pressure
       real(D)::te(LNTD,2,LEVS)  ! temperature
       real(D)::di(LNTD,2,LEVS)  ! divergence
       real(D)::ze(LNTD,2,LEVS)  ! vorticity
       real(D)::rq(LNTD,2,LEVS)  ! relative humidity
       real(D)::oz(LNTD,2,LEVS,NTRAC)  ! ozone plus other tracers
    end type spectral_coeffs
!
!  Physical ("standard") unit to energy unit conversions
!
    interface pres_to_energy
       module procedure pres_to_energy_r,pres_to_energy_d
    end interface
    interface temp_to_energy
       module procedure temp_to_energy_lev,temp_to_energy_z
    end interface
    interface wind_to_energy
       module procedure wind_to_energy_lev,wind_to_energy_z
    end interface
!
!  Energy to physical ("standard") unit conversions
!
    interface energy_to_pres
       module procedure energy_to_pres_r,energy_to_pres_d
    end interface
    interface energy_to_temp
       module procedure energy_to_temp_lev,energy_to_temp_z
    end interface
    interface energy_to_wind
       module procedure energy_to_wind_lev,energy_to_wind_z
    end interface
!
    private::report_rms
    contains
!---------------------------------------------------------------------------
    subroutine spectral_code_init(file,header,coeff)
!  SPECTRAL_CODE_INIT - initialize the GFS spectral transforms.
!  FILE  : if present, then we read in the header from FILE; otherwise,
!     we use the default values supplied above.
!  HEADER := if present, we fill in the values using the sigma file header
!     from FILE or the default header values otherwise.
!  COEFF := if present, the spectral coefficients from the sigma file if present
!     or from the default header values otherwise.
!
    character(*),intent(in),optional::file
    type(sigma_file_header),intent(out),optional::header
    type(spectral_coeffs),intent(out),optional::coeff
!
!  Local variables
!
    type(sigma_file_header)::hdr  ! inherits default values from above
    real(D)::rmu(LEVS),rnu(LEVS),tov(LEVS)
    real(D)::colat1,coslat(LATG2),rcs2(LATG2)
    real(D)::rdel2(LEVS),slk(LEVS),rk,sl1,colrad(LATG2)
    real(D)::sl(LEVS),si(LEVP1),cl(LEVS),del(LEVS),qln(LNTD)
    integer::levshc,j
!
    if(present(file)) call read_sigma_file(file,hdr,coeff)
    if(present(header)) header=hdr
!
!  Initialize module variables
!
    wte=sqrt(CP/TR)  ! these values in module constant
    wq=SQRT(RD*TR)
    wslev=real(sqrt(hdr%xi(1:LEVS)-hdr%xi(2:LEVS+1)),kind(wslev))
!
    si=real(hdr%xi,kind(si))  ! any type conversion is deliberate
    sl=real(hdr%xl,kind(sl))
    call init_vert(cl,sl,del,si,tov,rmu,rnu,rdel2,rk,slk,sl1,levshc)
    call glats(colrad,wgt,rcs2,sinlat,coslat,colat1)  ! SINLAT is module var
    call gpln2i
    call ggozrm
    do j=1,LATG2  !  PLN and PLNTOP are module vars
       call pln2i(pln(1,j),qln,plntop(1,j),rcs2(j),colrad(j))
    enddo
    call toevenodd(LATG2,pln)
    initialized=.true.  ! module var
    if(present(file)) init_sigma_fn=file  ! for record-keeping purposes
    return
    end subroutine spectral_code_init
!---------------------------------------------------------------------------
    subroutine to_physical_space(spect,physgrid)
!  TO_PHYSICAL_SPACE - given the spectral coefficients in SPECT (and
!  other coeffs computed from SPECTRAL_CODE_INIT), compute the physical
!  grid.  The variables in the physical grid are in "standard" units
!  viz., surface pressure in ln(dPa);
!        temperature in Kelvin;
!        wind in meters per second.
!  and are indexed using the same conventions as the GFS.
!  SPECT : input spectral coefficients.
!  PHYSGRID := the physical grid (in units as listed above).  At any given
!     atmospheric level, the physical grid is indexed just as the GFS.
!     (However, the longitudinal dimension of the physical grid is LONF,
!     not LONFD, as in the GFS.)
!
    type(spectral_coeffs),intent(in)::spect
    real(GRIDKIND),intent(out)::physgrid(LONF,NAVARS,LATG,LEVS)
!
!  Local variables
!
    real(D)::coeffs(LNTD,2,NAVARS)
    real(D)::ftop(0:JCAP,2,2)
    real(D)::gfsgrid(LONFD,2,NAVARS,LATG2)  ! transform routines are d.p.
    integer::k,ivect(2)
!
    if(.not.initialized) &
       call fexit('to_physical_space: spectral_code_init must be called first')
!
!  Proceed by level to convert from spectral to physical units.
!  The surface pressure is transformed at each atmospheric level.
!
    do k=1,LEVS
       ftop=0.0  ! just in case; output arg in DZ2UV
       gfsgrid=0.0  ! just in case; output arg in FLN2FOUR
       call dz2uv(spect%di(:,:,k),spect%ze(:,:,k),coeffs(:,:,UWIND_TYPE), &
          coeffs(:,:,VWIND_TYPE),ftop(:,:,1),ftop(:,:,2))
       coeffs(:,:,PRES_TYPE)=spect%q
       coeffs(:,:,TEMP_TYPE)=spect%te(:,:,k)
       call toevenodd(2*NAVARS,coeffs)
       ivect=(/UWIND_TYPE,VWIND_TYPE/)  ! indexes GFSGRID in FLN2FOUR
       call fln2four(NAVARS,LATG2,NAVARS,coeffs,gfsgrid, &
          pln,2,ivect,ftop,plntop,LATG2,LONSPERLAT)
       call four2grid(NAVARS,LATG2,NAVARS,gfsgrid,LATG2,LONSPERLAT)
       call to_standard_units(gfsgrid,physgrid(:,:,:,k))
    enddo
    call to_energy_units(physgrid,1,LATG)
    return
    end subroutine to_physical_space
!---------------------------------------------------------------------------
    pure subroutine to_standard_units(gfs,phys)
!  TO_STANDARD_UNITS  - Utility routine to convert the transformed
!  coefficients in GFS to "standard" units in PHYS, as follows:
!     surface pressure in ln(dPa);
!     temperature in Kelvin;
!     wind components in meters per second (from pseudo-wind).
!  This routine does not alter the units of temperature or surface pressure.
!  It also handles Northern/Southern Hemisphere conversions and so must be
!  called with the entire physical grid at a given atmospheric level.
!  GFS : intermediate coefficients from GFS transform routines for
!    one atmospheric level.  This array is assumed to contain pseudo-wind,
!    and we convert to wind.
!  PHYS := converted values for one atmospheric leve.
!
    real(D),intent(in)::gfs(LONFD,2,NAVARS,LATG2)
    real(GRIDKIND),intent(out)::phys(LONF,NAVARS,LATG)
!
!  Local variables
!
    integer::j
    real(kind(gfs))::rcl
!
!  The data assimilation code uses the convention that latitude 1 is
!  the latitude closest to the South Pole and latitude LATG is the latitude
!  closest to the North Pole.  The GFS code uses two subscripts: (lat,k)
!  for this purpose.  K=1 corresponds to the Northern Hemisphere and K=2
!  to the Southern Hemisphere.  The latitude index runs from 1 (pole) to
!  LATG/2 (equator).  We make these adjustments here.
!  We do not use the extra LONF+1:LONFD rows of data in the GFS grid
!  in the data assimilation.
!
    do j=1,LATG2
       !
       !  South Pole to Equator
       !
       phys(:,PRES_TYPE,j)=real(gfs(1:LONF,SH,PRES_TYPE,j),kind(phys))
       phys(:,TEMP_TYPE,j)=real(gfs(1:LONF,SH,TEMP_TYPE,j),kind(phys))
       rcl=1.0/sqrt(1.0-sinlat(j)**2)  ! pseudo-wind -> wind
       phys(:,UWIND_TYPE,j)=real(gfs(1:LONF,SH,UWIND_TYPE,j)*rcl,kind(phys))
       phys(:,VWIND_TYPE,j)=real(gfs(1:LONF,SH,VWIND_TYPE,j)*rcl,kind(phys))
       !
       !  Equator to North Pole; otherwise identical conversions
       !
       phys(:,PRES_TYPE,j+LATG2)= &
          real(gfs(1:LONF,NH,PRES_TYPE,LATG2-j+1),kind(phys))
       phys(:,TEMP_TYPE,j+LATG2)= &
          real(gfs(1:LONF,NH,TEMP_TYPE,LATG2-j+1),kind(phys))
       rcl=1.0/sqrt(1.0-sinlat(LATG2-j+1)**2)
       phys(:,UWIND_TYPE,j+LATG2)= &
          real(gfs(1:LONF,NH,UWIND_TYPE,LATG2-j+1)*rcl,kind(phys))
       phys(:,VWIND_TYPE,j+LATG2)= &
          real(gfs(1:LONF,NH,VWIND_TYPE,LATG2-j+1)*rcl,kind(phys))
    enddo
    return
    end subroutine to_standard_units
!---------------------------------------------------------------------------
    elemental function pres_to_energy_r(lndpa)
!  PRES_TO_ENERGY_R - return the surface pressure (in ln(dPa)) in energy units.
!
    real(R)::pres_to_energy_r
    real(R),intent(in)::lndpa
!
    pres_to_energy_r=real(lndpa*wq,R)
    return
    end function pres_to_energy_r
!---------------------------------------------------------------------------
    elemental function pres_to_energy_d(lndpa)
!  PRES_TO_ENERGY_D - return the surface pressure (in ln(dPa)) in energy units.
!  Like PRES_TO_ENERGY_R, but the PRES argument - and the value of
!  the function - is real(D).
!
    real(D)::pres_to_energy_d
    real(D),intent(in)::lndpa
!
    pres_to_energy_d=lndpa*wq
    return
    end function pres_to_energy_d
!---------------------------------------------------------------------------
    elemental function temp_to_energy_lev(tkelvin,lev)
!  TEMP_TO_ENERGY_LEV - return the temperature (in Kelvin) in energy units
!  assuming that one is at level LEV in the model grid.
!  If LEV < 1 or LEV > 28, then return 0.
!
    real(R)::temp_to_energy_lev
    real(R),intent(in)::tkelvin
    integer,intent(in)::lev
!
    if(lev.lt.1.or.lev.gt.LEVS) then
       temp_to_energy_lev=0.0
    else
       temp_to_energy_lev=real(tkelvin*wte*wslev(lev),R)
    endif
    return
    end function temp_to_energy_lev
!---------------------------------------------------------------------------
    elemental function temp_to_energy_z(tkelvin,z)
!  TEMP_TO_ENERGY_Z - return the temperature (in Kelvin) in energy units
!  assuming that one is at level Z in the model grid.  Do the necessary
!  linear interpolation by model level.
!  If Z < 1, then return 0.
!
    real(R)::temp_to_energy_z
    real(R),intent(in)::tkelvin,z
!
    integer::iw
    real(D)::w
!
    iw=int(z)
    if(iw.ge.LEVS) then
       w=wslev(LEVS)
    else if(iw.ge.1) then
       w=wslev(iw)+(z-iw)*(wslev(iw+1)-wslev(iw))
    else
       w=0.0
    endif
    temp_to_energy_z=real(tkelvin*wte*w,R)
    return
    end function temp_to_energy_z
!---------------------------------------------------------------------------
    elemental function wind_to_energy_lev(wms,lev)
!  WIND_TO_ENERGY_LEV - return the wind (in m/s) in energy units
!  assuming that one is at level LEV in the model grid.
!  If LEV < 1 or LEV > 28, then return 0.
!
    real(R)::wind_to_energy_lev
    real(R),intent(in)::wms
    integer,intent(in)::lev
!
    if(lev.lt.1.or.lev.gt.LEVS) then
       wind_to_energy_lev=0.0
    else
       wind_to_energy_lev=real(wms*wslev(lev),R)
    endif
    return
    end function wind_to_energy_lev
!---------------------------------------------------------------------------
    elemental function wind_to_energy_z(wms,z)
!  WIND_TO_ENERGY_Z - return the wind (in m/s) in energy units
!  assuming that one is at level Z in the model grid.  Do the necessary
!  linear interpolation by model level.
!  If Z < 1, then return 0.
!
    real(R)::wind_to_energy_z
    real(R),intent(in)::wms,z
!
    integer::iw
    real(D)::w
!
    iw=int(z)
    if(iw.ge.LEVS) then
       w=wslev(LEVS)
    else if(iw.ge.1) then
       w=wslev(iw)+(z-iw)*(wslev(iw+1)-wslev(iw))
    else
       w=0.0
    endif
    wind_to_energy_z=real(wms*w,R)
    return
    end function wind_to_energy_z
!---------------------------------------------------------------------------
    pure subroutine to_energy_units(phys,south,north)
!  TO_ENERGY_UNITS  - Utility routine to convert from standard units to
!  energy units (as in the original version of the data assimilation code).
!  PHYS :=: on entry, contains "standard" units for the physical grid,
!     as output by TO_STANDARD_UNITS.  Overwritten on return by the 
!     corresponding energy units.
!  This routine is the inverse of FROM_ENERGY_UNITS.
!
    integer,intent(in)::south,north
    real(GRIDKIND),intent(inout)::phys(LONF,NAVARS,south:north,LEVS)
!
!  Local variables
!
    integer::lev
!
    phys(:,PRES_TYPE,:,:)=pres_to_energy(phys(:,PRES_TYPE,:,:))
    do lev=1,LEVS
       phys(:,TEMP_TYPE,:,lev)=temp_to_energy(phys(:,TEMP_TYPE,:,lev),lev)
       phys(:,UWIND_TYPE,:,lev)=wind_to_energy(phys(:,UWIND_TYPE,:,lev),lev)
       phys(:,VWIND_TYPE,:,lev)=wind_to_energy(phys(:,VWIND_TYPE,:,lev),lev)
    enddo
    return
    end subroutine to_energy_units
!---------------------------------------------------------------------------
    elemental function energy_to_pres_r(p)
!  PRES_TO_ENERGY_R - return the surface pressure (in energy units) in terms
!  of ln(dPa).
!
    real(R)::energy_to_pres_r
    real(R),intent(in)::p
!
    energy_to_pres_r=real(p/wq,R)
    return
    end function energy_to_pres_r
!---------------------------------------------------------------------------
    elemental function energy_to_pres_d(p)
!  PRES_TO_ENERGY_D - return the surface pressure (in energy units) in terms
!  of ln(dPa).  Double-precision argument and return value.
!
    real(D)::energy_to_pres_d
    real(D),intent(in)::p
!
    energy_to_pres_d=p/wq
    return
    end function energy_to_pres_d
!---------------------------------------------------------------------------
    elemental function energy_to_temp_lev(t,lev)
!  TEMP_TO_ENERGY_LEV - return the temperature (in energy units) as Kelvin
!  assuming that one is at level LEV in the model grid.
!  If LEV < 1 or LEV > 28, then return 0.
!
    real(R)::energy_to_temp_lev
    real(R),intent(in)::t
    integer,intent(in)::lev
!
    if(lev.lt.1.or.lev.gt.LEVS) then
       energy_to_temp_lev=0.0
    else
       energy_to_temp_lev=real(t/(wte*wslev(lev)),R)
    endif
    return
    end function energy_to_temp_lev
!---------------------------------------------------------------------------
    elemental function energy_to_temp_z(t,z)
!  TEMP_TO_ENERGY_Z - return the temperature (in Kelvin) in energy units
!  assuming that one is at level Z in the model grid.  Do the necessary
!  linear interpolation by model level.
!  If Z < 1, then return 0.
!
    real(R)::energy_to_temp_z
    real(R),intent(in)::t,z
!
    integer::iw
    real(D)::w
!
    iw=int(z)
    if(iw.ge.LEVS) then
       w=wslev(LEVS)
    else if(iw.ge.1) then
       w=wslev(iw)+(z-iw)*(wslev(iw+1)-wslev(iw))
    else
       w=0.0
    endif
    energy_to_temp_z=real(t/(wte*w),R)
    return
    end function energy_to_temp_z
!---------------------------------------------------------------------------
    elemental function energy_to_wind_lev(wind,lev)
!  WIND_TO_ENERGY_LEV - return the wind (in energy units) as m/s
!  assuming that one is at level LEV in the model grid.
!  If LEV < 1 or LEV > 28, then return 0.
!
    real(R)::energy_to_wind_lev
    real(R),intent(in)::wind
    integer,intent(in)::lev
!
    if(lev.lt.1.or.lev.gt.LEVS) then
       energy_to_wind_lev=0.0
    else
       energy_to_wind_lev=real(wind/wslev(lev),R)
    endif
    return
    end function energy_to_wind_lev
!---------------------------------------------------------------------------
    elemental function energy_to_wind_z(wind,z)
!  WIND_TO_ENERGY_Z - return the wind (in energy units) as m/s
!  assuming that one is at level Z in the model grid.  Do the necessary
!  linear interpolation by model level.
!  If Z < 1, then return 0.
!
    real(R)::energy_to_wind_z
    real(R),intent(in)::wind,z
!
    integer::iw
    real(D)::w
!
    iw=int(z)
    if(iw.ge.LEVS) then
       w=wslev(LEVS)
    else if(iw.ge.1) then
       w=wslev(iw)+(z-iw)*(wslev(iw+1)-wslev(iw))
    else
       w=0.0
    endif
    energy_to_wind_z=real(wind/w,R)
    return
    end function energy_to_wind_z
!---------------------------------------------------------------------------
    subroutine from_physical_space(physgrid,spect)
!  FROM_PHYSICAL_SPACE - get one ensemble solution from the array PHYS,
!  which defines the physical grid in energy units, to spectral
!  coordinates.
!  PHYSGRID :=: On input, physical grid coeffs as described above.
!    On output, the units are changed to "standard" units,
!    viz., surface pressure in ln(dPa);
!        temperature in Kelvin;
!        wind in meters/second.
!  SPECT  :=: The Q, TE, DI, and ZE components are set and the
!     other levels and components retain their input values (if any).
!
    real(GRIDKIND),intent(inout)::physgrid(LONF,NAVARS,LATG,LEVS)
    type(spectral_coeffs),intent(inout)::spect
!
!  Local variables
!
    real(D)::gfsgrid(LONFD,2,NAVARS,LATG2)  ! because spectral codes are d.p.
    real(D)::utop(0:JCAP,2),vtop(0:JCAP,2)
    real(D)::coeff(LNTD,2,NAVARS)
    real(D)::dudt(LONFD,2,LATG2),dvdt(LONFD,2,LATG2)
    integer::k
!
    if(.not.initialized) &
      call fexit('from_physical_space: spectral_code_init must be called first')
!
    call from_energy_units(physgrid,1,LATG)
!
!  Proceed one atmospheric level at a time.  The calling sequence here
!  is not exactly the inverse of that in TO_PHYSICAL_SPACE.
!  Among other differences, FOUR2FLN calls FROMEVENODD so that an
!  explicit call to the latter is unnecessary (contrast the call to
!  TOEVENODD in TO_PHYSICAL_SPACE).
!
    do k=1,LEVS
       call from_standard_units(physgrid(:,:,:,k),gfsgrid)
       call grid2four(NAVARS,LATG2,NAVARS,gfsgrid,LATG2,wgt,LONSPERLAT)
       dudt=gfsgrid(:,:,UWIND_TYPE,:)
       dvdt=gfsgrid(:,:,VWIND_TYPE,:)
       utop=0.0  ! essential; UTOP and VTOP are intent(inout) variables
       vtop=0.0
       !
       !  To turn on the bug that was present in the original version
       !  of the code, comment out the call to UVSUMS.
       !
       call uvsums(LATG2,dudt,dvdt,utop,vtop,plntop,LATG2,LONSPERLAT)
       coeff=0.0  ! just in case
       call four2fln(NAVARS,LATG2,NAVARS,gfsgrid,coeff,pln,LATG2,LONSPERLAT)
       call uv2dz(coeff(:,:,UWIND_TYPE),coeff(:,:,VWIND_TYPE), &
          utop,vtop,spect%di(:,:,k),spect%ze(:,:,k))  ! divergence and vorticity
       spect%q=coeff(:,:,PRES_TYPE)  ! surface pressure 
       spect%te(:,:,k)=coeff(:,:,TEMP_TYPE)   ! temperature
    enddo
    return
    end subroutine from_physical_space
!---------------------------------------------------------------------------
    pure subroutine from_energy_units(phys,south,north)
!  FROM_ENERGY_UNITS  - Utility routine to convert from energy units to
!  standard units.
!  PHYS :=: on entry, contains energy units for the physical grid,
!     as output by TO_ENERGY_UNITS.  Overwritten on return by the 
!     corresponding physical units.
!  This routine is the inverse of TO_ENERGY_UNITS.
!
    integer,intent(in)::south,north
    real(GRIDKIND),intent(inout)::phys(LONF,NAVARS,south:north,LEVS)
!
!  Local variables
!
    integer::lev
!
    phys(:,PRES_TYPE,:,:)=energy_to_pres(phys(:,PRES_TYPE,:,:))
    do lev=1,LEVS
       phys(:,TEMP_TYPE,:,lev)=energy_to_temp(phys(:,TEMP_TYPE,:,lev),lev)
       phys(:,UWIND_TYPE,:,lev)=energy_to_wind(phys(:,UWIND_TYPE,:,lev),lev)
       phys(:,VWIND_TYPE,:,lev)=energy_to_wind(phys(:,VWIND_TYPE,:,lev),lev)
    enddo
    return
    end subroutine from_energy_units
!---------------------------------------------------------------------------
    pure subroutine from_standard_units(phys,gfs)
!  FROM_STANDARD_UNITS - convert from standard units in PHYS,
!  viz., surface pressure in ln(hPa);
!        temperature in Kelvin;
!        wind in meters/second
!  to units that are compatible with the GFS transform routines,
!  namely, surface pressure in ln(dPa), temperature in Kelvin, and
!  pseudo-wind.
!
!  PHYS : one atmospheric level in standard physical units (as output
!     in TO_PHYSICAL_SPACE).
!  GFS := intermediate units suitable for direct computation with GFS
!     transform routines.
!
    real(GRIDKIND),intent(in)::phys(LONF,NAVARS,LATG)
    real(D),intent(out)::gfs(LONFD,2,NAVARS,LATG2)
!
!  Local variables
!
    real(kind(gfs))::rcl
    integer::j
!
!  WARNING: going from physical to spectral space is NOT the
!  inverse procedure as from spectral to physical space!  Note especially
!  the scaling from wind to pseudo-wind.
!  Alter the code below at your own risk; the whole data assimilation
!  scheme will break if this is messed up.
!
!  The data assimilation code uses the convention that latitude 1 is
!  the latitude closest to the North Pole and latitude LATG is the latitude
!  closest to the South Pole.  The GFS code uses two subscripts: (lat,k)
!  for this purpose.  K=1 corresponds to the Northern Hemisphere and K=2
!  to the Southern Hemisphere.  The latitude index runs from 1 (pole) to
!  LATG/2 (equator).  We make these adjustments here.
!  We do not use the extra LONF+1:LONFD rows of data in the GFS grid
!  in the data assimilation but simply zero them out for safety.
!
    gfs(LONF+1:LONFD,:,:,:)=0.0
    do j=1,LATG2
       !
       !  South Pole to Equator
       !
       gfs(1:LONF,SH,PRES_TYPE,j)=phys(:,PRES_TYPE,j)
       gfs(1:LONF,SH,TEMP_TYPE,j)=phys(:,TEMP_TYPE,j)
       rcl=real(1.0/sqrt(1.0-sinlat(j)**2),kind(gfs))  ! wind -> pseudo-wind
       gfs(1:LONF,SH,UWIND_TYPE,j)=phys(:,UWIND_TYPE,j)*rcl
       gfs(1:LONF,SH,VWIND_TYPE,j)=phys(:,VWIND_TYPE,j)*rcl
       !
       !  Equator to North Pole; otherwise identical conversions
       !
       gfs(1:LONF,NH,PRES_TYPE,LATG2-j+1)=phys(:,PRES_TYPE,j+LATG2)
       gfs(1:LONF,NH,TEMP_TYPE,LATG2-j+1)=phys(:,TEMP_TYPE,j+LATG2)
       rcl=real(1.0/sqrt(1.0-sinlat(LATG2-j+1)**2),kind(gfs))
       gfs(1:LONF,NH,UWIND_TYPE,LATG2-j+1)=phys(:,UWIND_TYPE,j+LATG2)*rcl
       gfs(1:LONF,NH,VWIND_TYPE,LATG2-j+1)=phys(:,VWIND_TYPE,j+LATG2)*rcl
    enddo
    return
    end subroutine from_standard_units
! -------------------------------------------------------------------------
    subroutine read_sigma_file(fn,header,coeff)
!  READ_SIGMA_FILE - read the sigma file, extracting header information from the
!  second record and, optionally, spectral model data from subsequent records.
!  FN : name of the sigma file to open.
!  IVERB : if positive, then display forecast hour and date on the log file.
!  HEADER := the sigma file header contents.
!  COEFF := if present, the specral coefficients in the file.  If absent,
!     then reading halts after the header.
!
!  Side effects:  opens and closes INSWAP.  Also prints RMS values to the
!  log file if IVERB > VERB_TERSE.
!
    character(*),intent(in)::fn
    type(sigma_file_header),intent(out)::header
    type(spectral_coeffs),intent(out),optional::coeff
!
!  Local variables
!
!---real(D),parameter::GA2=GRAV/(REARTH**2)
!---real(D)::snnp1(LNTD)
    real(IO4)::buff(2,LNTD)
    integer::j,k,n,ktr,istat
    integer::ntraci,ntozi,ntcwi,ncldi
!
!  On Lahey, the environment variable FORT90L does not enable byte-swapping
!  of components of derived types.  So, we create a dummy real(IO4) array
!  of length 250, which is the current size of the sigma file header record,
!  read this array (which the Lahey runtime byte swaps), then copy the
!  equivalenced header to the dummy argument (sigh).  This code will work
!  correctly on systems without this problem at the price of slight
!  inefficiency, provided that REAL(IO4) and INTEGER occupy the same
!  amount of storage (which they should, assuming IO4 is default real).
!
    real(IO4)::lahey_bug_workaround(SIGMA_HEADER_LENGTH)
    type(sigma_file_header)::byte_swapped_header
    equivalence(lahey_bug_workaround,byte_swapped_header)
!
!  Skip the first record in the sigma file and read the second, which contains
!  the sigma file header.
!
    open(INSWAP,file=fn,form='unformatted',status='old',iostat=istat)
    if(istat.ne.0) call fexit('read_sigma_file: cannot open '//trim(fn),2)
!
!  File header.  Lahey does not byte-swap derived types in binary i/o,
!  which is a PITA.  So we copy the header from an object that's equivalenced
!  to a sufficiently large array, which the Lahey runtime byte-swaps.
!  This code is portable, since the header is a sequence type, and will
!  work correctly (with a slight loss of efficiency) on implementations
!  that don't have Lahey's problem.
!
    read(INSWAP,end=911)
    read(INSWAP,end=911) lahey_bug_workaround  ! to get the byte-swapped header
    header=byte_swapped_header
!
!  Adjustments in inputs per 2004 GFS code (see PARA_TREAD in mpi_io.f)
!
    if(header%fhour4.lt.1.0) header%pdryini4=0.0
!
    call dump_header(fn,LOGFILE,header,verbosity())
!
    if(.not.present(coeff)) then  ! no sense in reading the remaining data
       close(INSWAP)
       return
    endif
!
!  Geopotential height
!
    read(INSWAP,end=911) buff
    coeff%gz=transpose(buff)
!
!  These adjustments are taken from the GFS code.
!  Note: If these adjustments are made, then they must be undone in
!  WRITE_SIGMA_FILE.
!
!---   k=0
!---   do j=0,JCAP
!---      do n=j,JCAP
!---         k=k+1
!---         snnp1(k)=n*(n+1)
!---      enddo
!---   enddo
!---   coeff%gz(:,1)=coeff%gz(:,1)*snnp1*GA2
!---   coeff%gz(:,2)=coeff%gz(:,2)*snnp1*GA2
!
!  Surface pressure
!
    read(INSWAP,end=911) buff
    coeff%q=transpose(buff)
!
!  Temperature
!
    do k=1,LEVS
       read(INSWAP,end=911) buff
       coeff%te(:,:,k)=transpose(buff)
    enddo
!
!  Divergence and vorticity
!
    do k=1,LEVS
       read(INSWAP,end=911) buff
       coeff%di(:,:,k)=transpose(buff)
       read(INSWAP,end=911) buff
       coeff%ze(:,:,k)=transpose(buff)
    enddo
!
!  Relative humidity
!
    do k=1,LEVS
       read(INSWAP,end=911) buff
       coeff%rq(:,:,k)=transpose(buff)
    enddo
!
!  Ozone and other tracers
!
    coeff%oz=0.0
    ntraci=nint(header%tracers-1.0)
    if(header%vtid.gt.0.0) then
       ntcwi=nint(header%vtid/10.0)
       ntozi=nint(header%vtid-ntcwi*10)
       ncldi=nint(header%xncld)
    else if(ntraci.eq.1) then
       ntozi=1
       ntcwi=0
       ncldi=0
    else if(ntraci.eq.2) then
       ntozi=1
       ntcwi=2
       ncldi=1
    else
       ntozi=1
       ntcwi=0
       ncldi=0
    endif
!
!  Determine which tracer we're reading; this logic from the 2004 GFS code
!
    do k=1,ntraci
       if(k.eq.ntozi) then
          ktr=NTOZ
       else if(k.ge.ntcwi.and.ncldi.gt.0) then
          do n=1,ncldi
             if(k.eq.ntcwi+n-1) ktr=NTCW+n-1
          enddo
       else
          ktr=0
       endif
       do j=1,LEVS
          read(INSWAP,end=911) buff
          if(ktr.gt.0.and.ktr.le.NTRAC) coeff%oz(:,:,j,ktr)=transpose(buff)
       enddo
    enddo
!
!  Compute and print (to log file) the global RMS of each dynamical
!  variable at level 5 if requested.
!
    if(verbosity().gt.VERB_TERSE) call report_rms(coeff,5,header%tracers)
    close(INSWAP)
    return
!
!  Handle errors
!
911 continue
    call finfo('read_sigma_file: unexpected EOF on read')
    call fexit('read_sigma_file: on Lahey, export FORT90L="-Wl,-T1"')
    end subroutine read_sigma_file
!---------------------------------------------------------------------------
    subroutine write_sigma_file(fn,header,coeff)
!  WRITE_SIGMA_FILE - write out the spectral coefficients in sigma file format.
!  Note: the sigma file format uses single-precision values in the 2001/2004
!  versions of the GFS; we denote the loss of precision with explicit
!  conversions.
!  FN  : name of the output file (any predecessor is overwritten).
!  HEADER : sigma file header
!  COEFF : spectral coefficients to write out.
!
!  Side effects:  opens and closes OUTSWAP.
!
    character(*),intent(in)::fn
    type(sigma_file_header),intent(in)::header
    type(spectral_coeffs),intent(in)::coeff
!
!  Local variables
!
    character(8),parameter::LAB(4)= &
       char(0)//char(0)//char(0)//char(0)//char(0)//char(0)//char(0)//char(0)
    real(IO4)::buff(2,LNTD)
!
!  On Lahey, the environment variable FORT90L does not enable byte-swapping
!  of components of derived types.  So, we create a dummy real(IO4) array
!  of length SIGMA_HEADER_LENGTH, which is the current size of the sigma file
!  header record, read this array (which the Lahey runtime byte swaps), then 
!  copy the bits to the dummy argument (sigh).  This code will work
!  correctly on systems without this problem at the price of slight
!  inefficiency, provided that REAL(IO4) and INTEGER occupy the same
!  amount of storage (which they should, assuming IO4 is default real).
!
    real(IO4)::lahey_bug_workaround(SIGMA_HEADER_LENGTH)
!
    integer::k,n
!
    call dump_header(fn,LOGFILE,header,verbosity())
    open(OUTSWAP,file=fn,form='unformatted',action='write',position='rewind')
!
!  Write a NUL lable at the beginning of the file
!
    write(OUTSWAP) LAB
!
!  Sigma file header.
!  Lahey does not byte-swap derived types in binary i/o,
!  which is a PITA.  So we copy the header to a sufficiently large array,
!  which the Lahey runtime byte-swaps.  This code is portable, since
!  the header is a sequence type, and will work correctly (with a slight
!  loss of efficiency) on implementations that don't have Lahey's problem.
!
    lahey_bug_workaround=transfer(header,lahey_bug_workaround)
    write(OUTSWAP) lahey_bug_workaround  ! to get the byte-swapped header
!
!  Geopotential height.  Note:  If any rescaling is done in READ_SIGMA_FILE,
!  then we must undo it here.
!
    buff=real(transpose(coeff%gz),kind(buff))  ! possible double -> single 
    write(OUTSWAP) buff
!
!  Surface pressure
!
    buff=real(transpose(coeff%q),kind(buff))
    write(OUTSWAP) buff
!
!  Temperature
!
    do k=1,LEVS
       buff=real(transpose(coeff%te(:,:,k)),kind(buff))
       write(OUTSWAP) buff
    enddo
!
!  Divergence and vorticity
!
    do k=1,LEVS
       buff=real(transpose(coeff%di(:,:,k)),kind(buff))
       write(OUTSWAP) buff
       buff=real(transpose(coeff%ze(:,:,k)),kind(buff))
       write(OUTSWAP) buff
    enddo
!
!  Relative humidity
!
    do k=1,LEVS
       buff=real(transpose(coeff%rq(:,:,k)),kind(buff))
       write(OUTSWAP) buff
    enddo
!
!  Ozone and other tracers
!
    do n=1,NTRAC
       do k=1,LEVS
          buff=real(transpose(coeff%oz(:,:,k,n)),kind(buff))
          write(OUTSWAP) buff
       enddo
    enddo
    close(OUTSWAP)
!
!  Verbose output about RMS at level 5 if requested.
!
    if(verbosity().gt.VERB_TERSE) call report_rms(coeff,5,header%tracers)
    return
    end subroutine write_sigma_file
!---------------------------------------------------------------------------
    pure function rmsof(f)
    real(D)::rmsof
    real(D),intent(in)::f(LNTD,2)
!
    rmsof=sqrt(0.5*sum(f**2))
    return
    end function rmsof
!---------------------------------------------------------------------------
    subroutine report_rms(coeff,lev,tracers)
    real(IO4),intent(in)::tracers
    integer,intent(in)::lev
    type(spectral_coeffs),intent(in)::coeff
!
    real(D)::rms(6)
    character(2)::label(6)
    integer::j,n
!
    if(lev.eq.1) then
       rms(1)=rmsof(coeff%q)  ! surf pres & geopotential height at level 1 only
       label(1)='q '
       rms(2)=rmsof(coeff%gz)
       label(2)='gz'
       write(LOGFILE,100) 1,(trim(label(j)),rms(j),j=1,2)
    endif
!
    rms(1)=rmsof(coeff%te(:,:,lev))
    rms(2)=rmsof(coeff%di(:,:,lev))
    rms(3)=rmsof(coeff%ze(:,:,lev))
    rms(4)=rmsof(coeff%rq(:,:,lev))
    label(1:4)=(/'te','di','ze','rq'/)
    n=4
    if(tracers.ge.2.0) then
       n=n+1
       rms(n)=rmsof(coeff%oz(:,:,lev,1))
       label(n)='oz'
    endif
    write(LOGFILE,100) lev,(trim(label(j)),rms(j),j=1,n)
100 format('lev',i3,' rms',6(1x,a,':',es10.3))
    return
    end subroutine report_rms
!---------------------------------------------------------------------------
    subroutine output_coeffs(fn)
!  OUTPUT_COEFFS - output the spectral arrays to the named file.
!
    character(*),intent(in)::fn
!
    integer::j
!
    wte=sqrt(CP/TR)  ! these values in module constant
    wq=SQRT(RD*TR)
    open(unit=OUTNOSWAP,file=fn,status='replace',action='write')
    write(OUTNOSWAP,100) (j,sinlat(j),j=1,LATG2)
100 format('sinlat',i4,es21.14)
    write(OUTNOSWAP,101) (j,wgt(j),j=1,LATG2)
101 format('wgt',i4,es21.14)
    close(OUTNOSWAP)
    return
    end subroutine output_coeffs
!---------------------------------------------------------------------------
    subroutine dump_header(fn,iunit,header,iverb)
!  DUMP_HEADER - dump file header info for sigma file FN to the indicated unit.
!
    character(*),intent(in)::fn
    integer,intent(in)::iunit
    type(sigma_file_header),intent(in)::header
    integer,intent(in),optional::iverb
!
    integer::ichat
!
    if(present(iverb)) then
       ichat=iverb
    else
       ichat=verbosity()
    endif
    if(ichat.eq.VERB_SILENT) return
!
!  Display forcast hour and date only unless greater verbosity is requested.
!
    if(iverb.gt.VERB_TERSE) then
       write(iunit,100) trim(fn)
       write(iunit,101) 'idate: ',header%idate,'fhour4: ',header%fhour4
    endif
100 format('header info for: ',a)
101 format(a,4i5,3x,a,f8.3)
!
    if(iverb.le.VERB_TERSE) return
!
    write(iunit,102) 'xi',header%xi(1:LEVS)
102 format(a,1x,7es11.3/(3x,7es11.3))
    write(iunit,102) 'xl',header%xl
!
    write(iunit,103) 'waves: ',header%waves,'xlayers: ',header%xlayers
103 format(2(a9,1x,es11.3,1x))
    write(iunit,103) 'trun: ',header%trun,'order: ',header%order
    write(iunit,103) 'gencode: ',header%gencode,'tracers: ',header%tracers
    write(iunit,103) 'rlond: ',header%rlond,'rlatd: ',header%rlatd
    write(iunit,103) 'rlonp: ',header%rlonp,'rlatp: ',header%rlatp
    write(iunit,103) 'rlonr: ',header%rlonr,'rlatr: ',header%rlatr
    write(iunit,103) 'subcen: ',header%subcen,'ppid: ',header%ppid
    write(iunit,103) 'slid: ',header%slid,'vcid: ',header%vcid
    write(iunit,103) 'vmid: ',header%vmid,'vtid: ',header%vtid
    write(iunit,103) 'runid4: ',header%runid4,'usrid4: ',header%usrid4
    write(iunit,103) 'pdryini4: ',header%pdryini4,'xncld: ',header%xncld
    write(iunit,103) 'xgf: ',header%xgf
    return
    end subroutine dump_header
!---------------------------------------------------------------------------
    end module spectral

!  GRIDDUMP - dump the contents of a global grid file.
!  Optionally compute and display relative or absolute differences
!  between two global grid files.
!  Modification history:
!  08/08/05 - Now relies on GRIDKIND definition in support modules
!  07/26/05 - added -d option
!  07/24/05 - added old-style formatting for easier comparison with 2004 version
!  07/16/05 - version to handle energy units.
!  06/19/05 - added options to display ensemble mean and std error.
!             Deleted option for scaled displays since all output is in
!             physical units nowadays.
!  06/17/05 - changes to make the program a little smarter.
!  03/07/05 - change to accommodate new model grid i/o format.
!  11/29/04 - change to accommodate new model grid format.
!             Changed -N to -s to dump scaled values (default is unscaled).
!  05/18/04 - change the default to output values in physical units.
!             Added -N option to dump unscaled data.
!  08/31/03 - version to handle latitude-oriented indexing of grid
!             arrays.  However, for compatibility with older versions,
!             we output data with longitude indexes most rapidly varying.
!--------------------------------------------------------------------
    module dumpdefs
    use grid_io
    use spectral
    implicit none
    character(*),parameter::VERSION='08/08/05'
    integer,save::verblev=1
    logical,save::output_stats=.false.  ! by default, output each solution
    character(MAX_FILE_NAME_LEN),save::sigmafn=' '  ! no ref file by default
    character(MAX_FILE_NAME_LEN),save::diff_fn=' '  ! no diff file by default
    logical,save::model_obs_format=.false.  ! true => output like 2004 version
    logical,save::physical_units=.false.  ! default: energy units
    contains
!-------------------------------------------------------------------
    subroutine read_grid(fn,expect,nsol,south,north,grid)
!  If NSOL > 0, then it is an error if the input file does not contain
!  exactly NSOL solutions.
!
    integer,intent(inout)::nsol
    integer,intent(out)::south,north
    character(*),intent(in)::fn,expect
    real(GRIDKIND),allocatable,intent(out)::grid(:,:,:,:,:)
!
    integer::nassim,psouth,pnorth,seqno,nb
    character(80)::msg
!
!  Read grid.  This requires care: if the number of ensemble solutions
!  represented to the program differs from the number in the files,
!  then an unexpected EOF may occur.
!
    call read_grid_header(fn,expect,south,north,psouth,pnorth,nb,nassim,seqno)
!
    if(nassim.ne.NAVARS) then
       write(msg,101) nassim
101    format('griddump: header alleges ',i0,' variables; expected 4')
       call fexit(trim(msg),2)
    else if(nsol.le.0) then
       nsol=nb
    else if(nb.ne.nsol) then
       write(msg,102) nsol,nb
102    format('griddump: expected ',i3,' ensemble solutions; got ',i3)
       call fexit(trim(msg),2)
    endif
!
    allocate(grid(LONF,NAVARS,south:north,LEVS,nsol))
    call read_model_grid(grid,south,north,nsol)
    if(verblev.gt.0) then
       write(LOGFILE,110) trim(fn)
       write(LOGFILE,111) south,north,psouth,pnorth,nsol,seqno
    endif
110 format('file: ',a)
111 format('south: ',i0,' north: ',i0,' psouth: ',i0,' pnorth: ',i0/ &
       ' nsol: ',i0,' seqno: ',i0)
    return
    end subroutine read_grid
!-------------------------------------------------------------------
    subroutine dump_grid_stats(grid,south,north,nsol,lon,lat)
    integer,intent(in)::south,north,nsol,lon,lat
    real(GRIDKIND),intent(in)::grid(LONF,NAVARS,south:north,LEVS,nsol)
!
    integer::k,n,lev
    real(GRIDKIND)::mean(LONF,NAVARS,south:north,LEVS)
    real(GRIDKIND)::sdev(LONF,NAVARS,south:north,LEVS)
    real(GRIDKIND)::big(LONF,NAVARS,south:north,LEVS)
    real(GRIDKIND)::small(LONF,NAVARS,south:north,LEVS)
!
    write(LOGFILE,200)
200 format('#what lon  lat  lev  P  T  U  V')
!
    mean=0.0
    sdev=0.0
    big=-huge(big)
    small=huge(small)
!
    if(lon.gt.0) then
       if(lat.gt.0) then  ! dump stats at (lon,lat)
          if(lat.lt.south.or.lat.gt.north) &
             call fexit('specified latitude outside available strip',1)
          do n=1,nsol
             mean(lon,:,lat,:)=mean(lon,:,lat,:)+grid(lon,:,lat,:,n)
             sdev(lon,:,lat,:)=sdev(lon,:,lat,:)+grid(lon,:,lat,:,n)**2
             big(lon,:,lat,:)=max(big(lon,:,lat,:),grid(lon,:,lat,:,n))
             small(lon,:,lat,:)=min(small(lon,:,lat,:),grid(lon,:,lat,:,n))
          enddo
          mean(lon,:,lat,:)=mean(lon,:,lat,:)/nsol
          sdev(lon,:,lat,:)=sqrt(sdev(lon,:,lat,:)/nsol-mean(lon,:,lat,:)**2)
          write(LOGFILE,100)
100       format('#what lon  lat   lev   P  T  U  V')
          do lev=1,LEVS
             write(LOGFILE,101) 'mean',lon,lat,lev,mean(lon,:,lat,lev)
             write(LOGFILE,101) 'sdev',lon,lat,lev,sdev(lon,:,lat,lev)
             write(LOGFILE,101) 'max ',lon,lat,lev,big(lon,:,lat,lev)
             write(LOGFILE,101) 'min ',lon,lat,lev,small(lon,:,lat,lev)
          enddo
101       format(a,3i4,4es11.3)
       else                   ! dump stats at (lon,:)
          do n=1,nsol
             mean(lon,:,:,:)=mean(lon,:,:,:)+grid(lon,:,:,:,n)
             sdev(lon,:,:,:)=sdev(lon,:,:,:)+grid(lon,:,:,:,n)**2
             big(lon,:,:,:)=max(big(lon,:,:,:),grid(lon,:,:,:,n))
             small(lon,:,:,:)=min(small(lon,:,:,:),grid(lon,:,:,:,n))
          enddo
          mean(lon,:,:,:)=mean(lon,:,:,:)/nsol
          sdev(lon,:,:,:)=sqrt(sdev(lon,:,:,:)/nsol-mean(lon,:,:,:)**2)
          write(LOGFILE,100)
          do lev=1,LEVS
             do k=south,north
                write(LOGFILE,101) 'mean',lon,k,lev,mean(lon,:,k,lev)
                write(LOGFILE,101) 'sdev',lon,k,lev,sdev(lon,:,k,lev)
                write(LOGFILE,101) 'max ',lon,k,lev,big(lon,:,k,lev)
                write(LOGFILE,101) 'min ',lon,k,lev,small(lon,:,k,lev)
             enddo
          enddo
       endif
    else if(lat.gt.0) then  ! dump stats at (:,lat)
       do n=1,nsol
          mean(:,:,lat,:)=mean(:,:,lat,:)+grid(:,:,lat,:,n)
          sdev(:,:,lat,:)=sdev(:,:,lat,:)+grid(:,:,lat,:,n)**2
          big(:,:,lat,:)=max(big(:,:,lat,:),grid(:,:,lat,:,n))
          small(:,:,lat,:)=min(small(:,:,lat,:),grid(:,:,lat,:,n))
       enddo
       mean(:,:,lat,:)=mean(:,:,lat,:)/nsol
       sdev(:,:,lat,:)=sqrt(sdev(:,:,lat,:)/nsol-mean(:,:,lat,:)**2)
       write(LOGFILE,100)
       do lev=1,LEVS
          do k=south,north
             write(LOGFILE,101) 'mean',lon,k,lev,mean(lon,:,k,lev)
             write(LOGFILE,101) 'sdev',lon,k,lev,sdev(lon,:,k,lev)
             write(LOGFILE,101) 'max ',lon,k,lev,big(lon,:,k,lev)
             write(LOGFILE,101) 'min ',lon,k,lev,small(lon,:,k,lev)
          enddo
       enddo
    else              ! dump stats at all locations
       do n=1,nsol
          mean=mean+grid(:,:,:,:,n)
          sdev=sdev+grid(:,:,:,:,n)**2
          big(:,:,:,:)=max(big(:,:,:,:),grid(:,:,:,:,n))
          small(:,:,:,:)=min(small(:,:,:,:),grid(:,:,:,:,n))
       enddo
       mean=mean/nsol
       sdev=sqrt(sdev/nsol-mean**2)
       do n=1,LONF
          do k=south,north
             do lev=1,LEVS
                write(LOGFILE,101) 'mean',n,k,lev,mean(n,:,k,lev)
                write(LOGFILE,101) 'sdev',n,k,lev,sdev(n,:,k,lev)
                write(LOGFILE,101) 'max ',n,k,lev,big(n,:,k,lev)
                write(LOGFILE,101) 'min ',n,k,lev,small(n,:,k,lev)
             enddo
          enddo
       enddo
    endif
    return
    end subroutine dump_grid_stats
!-------------------------------------------------------------------
    subroutine dump_grid(grid,nsol,south,north,lon,lat)
    integer,intent(in)::nsol,south,north,lon,lat
    real(GRIDKIND),intent(in)::grid(LONF,NAVARS,south:north,LEVS,nsol)
!
    integer::j,k,n
!
    if(lon.gt.0) then
       if(lat.gt.0) then  ! dump solutions at (lon,lat)
          if(lat.lt.south.or.lat.gt.north) &
             call fexit('specified latitude outside available strip',1)
          do n=1,nsol
             write(LOGFILE,110) n
110          format('Ensemble solution ',i0)
             call dump_grid_point(grid,nsol,south,north,lon,lat,n)
          enddo
       else                   ! dump solutions at (lon,:)
          do n=1,nsol
             write(LOGFILE,110) n
             do k=south,north
                call dump_grid_point(grid,nsol,south,north,lon,k,n)
             enddo
          enddo
       endif
    else if(lat.gt.0) then  ! dump solutions at (:,lat)
       do n=1,nsol
          write(LOGFILE,110) n
          do k=1,LONF
             call dump_grid_point(grid,nsol,south,north,k,lat,n)
          enddo
       enddo
    else              ! dump all solutions
       do n=1,nsol
          write(LOGFILE,110) n
          do j=south,north
             do k=1,LONF
                call dump_grid_point(grid,nsol,south,north,k,j,n)
             enddo
          enddo
       enddo
    endif
    return
    end subroutine dump_grid
!-----------------------------------------------------------------------
    subroutine dump_grid_point(g,nsol,south,north,ix,iy,n)
    integer,intent(in)::ix,iy,south,north,nsol,n
    real(GRIDKIND),intent(in)::g(LONF,NAVARS,south:north,LEVS,nsol)
!
    integer::lev
    logical,save::first=.true.
!
    if(model_obs_format) then  ! output all levels together
       write(LOGFILE,100) ix,iy
100    format(' Longitude, latitude',2i4)
       write(LOGFILE,101) 'surface pressure',g(ix,PRES_TYPE,iy,1,n)
       write(LOGFILE,101) 'temp',g(ix,TEMP_TYPE,iy,:,n)
       write(LOGFILE,101) 'uwind',g(ix,UWIND_TYPE,iy,:,n)
       write(LOGFILE,101) 'vwind',g(ix,VWIND_TYPE,iy,:,n)
101    format(3x,a/(3x,7es11.3))
    else
       if(first) write(LOGFILE,110)
110    format('#lon  lat  lev  var values (for all ensemble members)')
       do lev=1,LEVS
          if(lev.eq.1) write(LOGFILE,111) ix,iy,lev,'P',g(ix,PRES_TYPE,iy,lev,:)
          write(LOGFILE,111) ix,iy,lev,'T',g(ix,TEMP_TYPE,iy,lev,:)
          write(LOGFILE,111) ix,iy,lev,'U',g(ix,UWIND_TYPE,iy,lev,:)
          write(LOGFILE,111) ix,iy,lev,'V',g(ix,VWIND_TYPE,iy,lev,:)
       enddo
111    format(3i4,1x,a1,1x,5es11.3/('> ',7es11.3))
    endif
    first=.false.
    return
    end subroutine dump_grid_point
!-----------------------------------------------------------------------------
    subroutine parseline(fn,header,nsol,locations)
!  PARSELINE - parse execute line.  Getopt works much like the C version
!  (man 3c getopt).
!  The arguments are the background, analysis, observations, and analysis mean
!  filenames, respectively.
!  Side effects:
!  - calls patch_init to initialize patch-related variables
!
    use command_line_support
    integer,intent(out)::nsol
    character(*),intent(out)::fn,locations
    character(*),intent(inout)::header
!
!  Local variables
!
    character(*),parameter::OPTIONS='d:f:mn:phl:v:H:s'
    character(80)::optarg
    integer::iopt,optind
    character::opt
!
!  Copy defaults
!
    fn=' '
    locations=' '
    nsol=0  ! get the number of solutions from input file unless -n is specified
    do
       call getopt(iopt,optarg,optind,options)
       if(iopt.lt.0) exit
       opt=char(iopt)
       select case(opt)
       case('d')  ! compute differences from selected grid
          diff_fn=optarg
       case('f')  ! implies physical units; take sigma file header from here
          sigmafn=optarg
          physical_units=.true.
       case('m')
          model_obs_format=.true.
       case('n')
          read(optarg,100) nsol
       case('h')
          write(IERR,120) VERSION
          call exit(1)
       case('p')
          physical_units=.true.  ! and use default sigma file header
       case('l')
          locations=optarg
       case('s')
          output_stats=.true.
       case('v')
          read(optarg,100) verblev
       case('H')
          header=optarg
       case default
          write(IERR,110) opt
          call exit(1)
       end select
    enddo
100 format(i12)
110 format('unknown option ',a)
!
    call getarg(optind,fn)
120 format('griddump: version ',a/ &
       ' usage: options gridfile'/ &
       ' options include: [-l long,lat] (dump at selected location)'/ &
       ' [-f ref_sigma_file (used to convert to physical units)]'/ &
       ' [-H header] (header to expect; normally "grid" or "aout")'/ &
       ' [-m (model_obs format: all levels together)]'/ &
       ' [-s (output stats)] (output mean and std error only)')
    return
    end subroutine parseline
!--------------------------------------------------------------------
    subroutine get_locations(str,ix,iy)
!  GET_LOCATIONS - str must have the form ix,iy or :,iy or ix,:
!
    character(*),intent(in)::str
    integer,intent(out)::ix,iy
!
    integer::icom 
!
    icom=index(str,',')
    if(icom.eq.0) then   ! bad string; forget it
       ix=0
       iy=0
       return
    endif
    if(str(1:icom-1).eq.':') then
       ix=0
    else
       read(str(1:icom-1),*) ix
    endif
    if(str(icom+1:).eq.':') then
       iy=0
    else
       read(str(icom+1:),*) iy
    endif
    return
    end subroutine get_locations
!--------------------------------------------------------------------
    end module dumpdefs
!--------------------------------------------------------------------
! MAIN.
    use dumpdefs
    implicit none
    character(128)::fn,locations
    character(4)::header='none'  ! by default, assume global grid
    integer::nsol,ix,iy,south,north,j,ndiff
    real(GRIDKIND),allocatable::grid(:,:,:,:,:),diffgrid(:,:,:,:,:)
       ! (LONF,NAVARS,south:north,LEVS,nsol)
    type(sigma_file_header)::sfhdr
!
    call parseline(fn,header,nsol,locations)
    if(len_trim(locations).gt.0) call get_locations(locations,ix,iy)
!
!  The grid is assumed to be in energy units; so convert to physical units
!  (pressure in hPa, temperature in K, and wind in m/s).  Both sets of units
!  maintain pressure in ln(dPa); for output purposes, convert to hPa.
!
    call read_grid(fn,header,nsol,south,north,grid)
    if(len_trim(diff_fn).gt.0) then  ! do analysis on difference grid
       call read_grid(diff_fn,header,ndiff,south,north,diffgrid)
       if(ndiff.eq.1) then  ! DIFFGRID is nature or mean grid, presumably
          do j=1,nsol
             grid(:,:,:,:,j)=grid(:,:,:,:,j)-diffgrid(:,:,:,:,1)
          enddo
       else if(ndiff.ne.nsol) then
          call fexit(trim(diff_fn)//': incompatible ensemble size')
       else
          grid=grid-diffgrid
       endif
    endif
    if(physical_units) then
       if(len_trim(sigmafn).gt.0) then
          call spectral_code_init(sigmafn,sfhdr)
       else
          call spectral_code_init  ! use defaults
       endif
       do j=1,nsol
          call from_energy_units(grid(:,:,:,:,j),south,north)
       enddo
       if(allocated(diffgrid)) then  ! show zero as 0.0, not 10 = 10*exp(0)
          where(grid(:,PRES_TYPE,:,:,:).gt.1.0e-03)
             grid(:,PRES_TYPE,:,:,:)=10.0*exp(grid(:,PRES_TYPE,:,:,:)) ! to hPa
          elsewhere
             grid(:,PRES_TYPE,:,:,:)=10.0*grid(:,PRES_TYPE,:,:,:)
          endwhere
       else
          grid(:,PRES_TYPE,:,:,:)=10.0*exp(grid(:,PRES_TYPE,:,:,:))  ! to hPa
       endif
    endif
    if(output_stats) then
       call dump_grid_stats(grid,south,north,nsol,ix,iy)
    else
       call dump_grid(grid,nsol,south,north,ix,iy)
    endif
    call exit(0)
    end
!--------------------------------------------------------------------

    use precision
    use io
    use ferror
    implicit none
    real(D),parameter::ZERO=0.0
    real(D),allocatable::a(:,:),z(:,:),mu(:),lambda(:),work(:)
    integer,allocatable::newseed(:)
    real(D)::abstol
    character(80)::arg
    integer,external::iargc
    integer::j,k,n,sz,info,nfound
!
    if(iargc().eq.0) call fexit('asize [seed]',2)
    call random_seed(size=sz)
    allocate(newseed(sz))
    if(iargc().eq.sz+1) then
       do j=1,sz
          call getarg(j+1,arg)
          read(arg,*) newseed(j)
       enddo
    else
       call random_seed(get=newseed)
    endif
    write(LOGFILE,100) newseed
100 format('seed: ',4i11)
!
    call getarg(1,arg)
    read(arg,*) n
    allocate(a(n,n),z(n,n),mu(n),work(2*n),lambda(n))
!
!  Create a random symmetric matrix A
!
    call random_number(a)
    do k=1,n-1
       do j=k+1,n
          a(j,k)=a(k,j)
       enddo
    enddo
!
!  Compute eigenvalues and eigenvectors as in assim.f90
!
    call rs(n,n,a,mu,1,z,work,work(n+1),info)
    if(info.ne.0) then
       nfound=0
    else
       nfound=n
       do j=1,nfound
          lambda(j)=mu(nfound-j+1)
          !! a(:,j)=z(:,nfound-j+1)
       enddo
    endif
    write(LOGFILE,110) info,nfound
110 format('info: ',i0,' nfound: ',i0)
    write(LOGFILE,111) lambda(1:nfound)
111 format('eigenvalues:'/(5es14.4))
    stop
    end

    module assimilation
!  SYNOPSIS
!    use assimilation
!
!  DESCRIPTION
!  The routines in this package implement Brian Hunt's and Ed Ott's
!  versions of the LEKF data assimilation scheme.
!
!  REQUIRED PACKAGES
!
!  grid_model, diagnostics - in main source directory
!  lapackmt, blasmt - in system object file library
!
!  ROUTINES IMPLEMENTED
!
!   subroutine assimilate(loc,nsol,w,diag)
!     and other private support routines.
!  The only publicly callable routine in this module is ASSIMILATE.
!
!  AUTHOR
!  Eric Kostelich, Dept. of Math. & Stat., Arizona State U.,
!  Tempe, AZ 85287-1804, kostelich@asu.edu
!
!  MODIFICATION HISTORY
!  08/08/05: Corrected normalization of Eb^T in Ed's method (the factor is
!    missing in the Szunyogh et al. paper); added optional reporting of
!    the singular values of (k-1)I+Eb^T*inv(R)*Eb in Brian's method and its
!    analogue in Ed's method.
!  08/06/05: Added enhanced variance inflation to original Ott method.
!  07/16/05: Added the original Ott et al. method as a backup in case
!    Brian's method fails for any reason.  Corrected computation E^b.
!  06/26/05: Rewrote enhanced inflation in terms of multiples of the largest
!    eigenvalue of Brian's F; rewrote EIGEN_FIXUP.
!  06/24/05: altered enhanced inflation to work on selected variables only;
!    rewrote module to re-try assimilation without enhanced inflation when
!    numerical problems arise; corrected error in multiplicative inflation.
!  06/21/05: added enhanced variance inflation.
!  03/11/05: Removed check for "singular" Pa~ in factor of a check of the
!    forward error bound: we conclude that the computed value of Pa~ is
!    faulty if the relative forward error is larger than 1.0e-04.
!  01/19/05: Changed variable names to be consistent with the July 30, 2004
!    version of Brian's writeup describing the more efficient algorithm.
!    Added the analysis update method of Zhang, Snyder, and Sun.
!    Incorporated changes to model grid handling; this version no longer needs
!    to worry about managing the analysis grid.
!  11/23/04: Added update to analysis ensemble and ensemble mean.  Added
!    heuristic check for obviously garbled values and a new return code to
!    indicate such.
!  09/27/04: Internal changes to accommodate the change of indexing in
!    the model grid.  This new version should be more cache-friendly.
!  09/12/04: Removed ASSIM_ORIG and modified Brian's method to return
!    only the matrix E that gives the appropriate linear combinations
!    of the background ensembles.  This matrix can be used to generate
!    the analysis ensemble and to update the surface boundary conditions,
!    as well as the unassimilated variables.
!    Also removed support for adding "random" components to the background.
!    This version of the routine is preparatory to the eventual "4-d"
!    implementation.
!  08/04/04: Revamped ASSIM_ORIG to be more consistent with the final
!    Tellus version of the first LEKF paper.  Summary of changes:
!    (1) Pa^ is computed using Eq. (23) of the paper.
!    (2) A is computed using Eq. (A-19).
!    (3) Xa^ is computed using Eq. (34).
!    Also made miscellaneous corrections to the comments in ARRIM_ORIG.
!  07/30/04: Added the Eispack eigenvalue/vector routines as a backup
!    when DSYEVR fails to converge.  Fixed the simple covariance scheme in
!    Brian's method and in the old method.
!  06/28/04: added extra checks to ensure that variable and observation
!    types agree.
!  06/25/04: optimization to operate on just the variables comprising the
!    center column of the patch in Brian's method.
!  06/16/04: added original method as a backup to Brian's.
!  06/11/04: first implementation.
!
!  Required packages:
!
    use grid_obs
    use diagnostics
    use blas
!
    implicit none
    private
    public::assimilate
    contains
!------------------------------------------------------------------------------
    subroutine assimilate(loc,nsol,w,diag)
!  ASSIMILATE - Perform the Ott et al. data assimilation step for one spatial
!  patch of data.  Attempt Brian's optimized method first, and if that
!  fails, then use the original version.
!  Arguments:
!  LOC  :  (x,y,z) grid coordinates defining the center of the patch.
!  NSOL : number of ensemble members
!  W := NSOL x NSOL array giving linear combination of background covariance
!     needed to give the analysis at the center of the patch.  See Brian's
!     writeup.
!  DIAG := diagnostics include the return code DIAG%INFO, which is
!     0 unless an error occurs.
!     Error indications (each of which is positive):
!     INFLATION_FAIL: could not compute inv(I+F/eps) for enhanced var inflation
!     PA_NO_EV:  could not compute square root of analysis covariance matrix
!     P_NEG_EV:  error: negative eigenvalue from covariance matrix
!     NO_OBS_UPDATE:  no observations available to do the update.
!     Also includes information about reciprocal condition number of Pa~
!     and number of observations in the patch.
!
    type(patch_index),intent(in)::loc
    integer,intent(in)::nsol
    real(D),intent(out)::w(nsol,nsol)
    type(patch_diag),intent(inout)::diag
!
!  Local variables
!
    integer::patchsz,nc
!
    patchsz=patchsize(loc)
    call center_column_height(loc,nc)
    call brian(loc,nsol,patchsz,nc,w,diag)
    if(diag%info.ne.0.and.diag%info.ne.NO_OBS_UPDATE) then
       diag%brian_failed=.true.
       call ed(loc,nsol,patchsz,nc,w,diag,nsol-1)
    else
       diag%brian_failed=.false.
    endif
    return
    end subroutine assimilate
!---------------------------------------------------------------------------
    subroutine brian(loc,nsol,patchsz,nc,w,diag)
!  BRIAN - Brian Hunt's implementation of the Ott et al. data assimilation
!  step for one spatial patch of data.
!  This version avoids direct eigenvector decompositions of the background
!  covariance matrix.
!
!  Arguments:
!  LOC  :  (x,y,z) grid coordinates defining the center of the patch.
!  NSOL  : number of ensemble members
!  PATCHSZ  : patch size; number of dynamical variables in the patch
!  NC  : height of center column at logical center of patch
!  W := NSOL x NSOL array giving linear combination of background covariance
!     needed to give the analysis at the center of the patch.  See Brian's
!     writeup.
!  DIAG := diagnostics include the return code DIAG%INFO, which is
!     0 unless an error occurs.
!     Error indications (each of which is positive):
!     INFLATION_FAIL: could not compute inv(I+F/eps) for enhanced var inflation
!     PA_NO_EV:  could not compute square root of analysis covariance matrix
!     P_NEG_EV:  error: negative eigenvalue from covariance matrix
!     NO_OBS_UPDATE:  no observations available to do the update.
!     Also includes information about reciprocal condition number of Pa~
!     and number of observations in the patch.
!
    type(patch_index),intent(in)::loc
    integer,intent(in)::nsol,patchsz,nc
    real(D),intent(out)::w(nsol,nsol)
    type(patch_diag),intent(inout)::diag
!
!  Local storage - preparatory steps (1-3).
!
!  Background ensemble: For implementation efficiency, the background difference
!  array (Xb in Brian's notation) is NSOL x PATCHSIZE (K x M).
!  Brian assumes M x K.  TYPELIST(J,K) holds the dynamical type of the
!  value in XBACK(J,K) and XBAR(K).
!
    real(D)::xbar(patchsz)  ! background mean over the patch
    real(D)::xback(nsol,patchsz)  ! background ensemble differences over patch
    integer::typelist(nsol,patchsz)
    real(D)::cmean(nc)  ! patch mean at logical center
    real(D)::center(nsol,nc)  ! analysis at center of patch
!
!  Observations; the arrays are allocated in COPY_FROM_OBS.
!
    real(D),allocatable::c(:,:)  ! NSOL x NOBS array = Eb^T*inv(R)
    real(D)::cyb(nsol)  !  C * (YOBS - H(XBAR)) in writeup
    real(D)::ceb(nsol,nsol)  ! C * Eb
    real(D),allocatable::yobs(:)  ! local copy of observations
    real(D),allocatable::ebtr(:,:)  ! H(x(k)) - HBAR
    real(D),allocatable::hbar(:)  ! H(XBAR) = Y^b in writeup
    real(D),allocatable::rdiag(:)  ! obs covariance matrix R (assumed diagonal)
    !!real(D),allocatable::hx(:,:)  ! Sun only; avoids compiler segfault
!
!  Analysis ensemble
!
    type(inflation_info)::inflate
    real(D)::pa(nsol,nsol)  ! analysis covar mtx; see Brian's writeup.
    real(D)::s
!
!  Miscellaneous
!
    real(D)::badval
    integer::nobs,info,j,error,var,varlist(NAVARS)
    logical::debug_dump
!
    info=0 
    debug_dump=loc.eq.dump_loc
!
!  Step 1.  Get differences of background ensemble from background mean
!  over the patch.  XBACK (=Xb^T in Brian's writeup) is NOT normalized by 
!  the square root of the rank of the ensemble, as it is in the original
!  Ott el al. paper.
!
    call copy_from_ensemble(loc,xback,nsol,patchsz,typelist)
    if(ensemble_diffs_precomputed()) then
       call copy_from_mean(loc,xbar,patchsz)
    else
       do j=1,patchsz
          xbar(j)=sum(xback(:,j))/nsol
          xback(:,j)=xback(:,j)-xbar(j)
       enddo
    endif
!
!  Check that the columns of Xb (=rows of xback) sum to zero
!  if great verbosity is requested.
!
    if(verbosity().ge.VERB_CHATTY) then
       write(LOGFILE,100,advance='no') loc
       s=0.0
       do j=1,patchsz
          s=max(s,abs(sum(xback(:,j))))
       enddo
       write(LOGFILE,101) ' ||colsum(xback)||: ',s
    endif
100 format('brian: loc:',4i5)
101 format(a,es11.3)
!
!  Step 2.  Get observations Y and respective interpolations from
!  the model grid.  EBTR=(Eb)^T and YB = H*XBAR, using Brian's notation.
!  If we have no observations in the local patch, then just return the
!  background.
!
    call copy_from_obs(loc,yobs,hbar,rdiag,nsol,nobs,dh=ebtr)  ! HX: Sun only
    diag%nobs=nobs
    if(nobs.eq.0) then
       info=NO_OBS_UPDATE
       goto 911  ! return background
    endif
!
    if(debug_dump) then
       open(DUMPUNIT,file='assim.dump',status='replace',recl=1024)
       write(DUMPUNIT,500) patchsz,nsol,nobs
500    format(3i8)
       write(DUMPUNIT,501) 0,xbar
       do j=1,patchsz
          write(DUMPUNIT,501) j,xback(:,j)
       enddo
501    format(i5,40es24.15/('>    ',40es24.15))
    endif
!
!  Step 3.
!  Form C = Eb^T*inv(R).  If R is variable, then it may be more efficient
!  to solve R*transpose(C)=H~ for C than to compute inverse(R) directly.
!
    allocate(c(nsol,nobs))
    do j=1,nobs
       c(:,j)=ebtr(:,j)/rdiag(j)
    enddo
!
!  Step 4.  Form Pa~T either with or without enhanced variance inflation.
!  If enhanced inflation causes problems (singular analysis covariance
!  matrix or garbage values in the analysis), then abandon it and attempt
!  the calculaton without enhanced inflation.
!
    ceb=matmul(c,transpose(ebtr))  ! C*Eb = Eb^T*inv(R)*Eb
    yobs=yobs-hbar  ! y0 - yb
    cyb=matmul(c,yobs)  ! C(y0-yb)
    call inflation(loc,inflate,varlist)
    info=0
    if(inflate%enhanced.gt.0.0) then  ! perform enhanced inflation
       call enhanced(ceb,nsol,patchsz,xback,typelist,varlist, &
          inflate%enhanced,pa,diag)
       if(diag%info.eq.0) call update(loc,nsol,patchsz,nc,xback,xbar,pa,cyb, &
          inflate,w,diag%edim,cmean,center,info)
    endif
!
!  If we have problems, re-try without enhanced inflation.
!
    if(info.ne.0.or.inflate%enhanced.le.0.0) then
       do j=1,nsol
          ceb(j,j)=ceb(j,j)+(nsol-1)  ! (k-1)*I + C*Eb
       enddo
       if(allocated(diag%iceb_sing)) call singular_vals(ceb,diag%iceb_sing,nsol)
       call invert(ceb,nsol,pa,diag%rcondice,info)  ! Pa~ = inv((k-1)/rhoI+C*Eb)
       call update(loc,nsol,patchsz,nc,xback,xbar,pa,cyb,inflate, &
          w,diag%edim,cmean,center,info)
    endif
    diag%info=info
    if(debug_dump) then
       write(DUMPUNIT,'(a)') 'pa'
       do j=1,nsol
          write(DUMPUNIT,501) j,pa(j,:)
       enddo
    endif
!
!  If there are no errors, then we're done!
!
    if(debug_dump) close(DUMPUNIT)
    if(info.eq.0) return
!
!  If numerical problems have caused us to compute junk, then attempt to
!  report some useful data by re-trying the failed operation to get
!  some statistics.
!
    if(info.eq.INF_OR_NAN.or.info.eq.BAD_VALUE) then
       call copy_to_analysis(loc,nc,nsol,center,error,var,badval)
       if(error.eq.INF_OR_NAN) then
          write(IERR,110) 'inf or nan',TYPEOF(var),loc
       else
          write(IERR,110,advance='no') 'bad value',TYPEOF(var),loc
          write(IERR,111) badval
       endif
       info=GARBAGE_VALUES
110    format('assim: ',a,': var: ',a1,' at: ',3i3)
111    format(' value: ',es13.4)
    endif
!
911 continue
    diag%info=info
    call return_background(loc,xbar,xback,nsol,patchsz,nc,w)
    return
    end subroutine brian
!---------------------------------------------------------------------------
    subroutine update(loc,nsol,patchsz,nc,xback,xbar,pa,cyb,inflate,w,edim, &
       cmean,center,info)
!  UPDATE - Perform Steps 5-9 of Brian's update procedure.
!  LOC  : location of the logical center of the patch
!  NSOL  : number of ensemble solutions
!  PATCHSZ : number of dynamical variables in the patch.
!  NC  : number of variables at the logical center of the patch.
!  XBACK  : (J,K)th element holds Jth component of Kth ensemble diff
!  XBAR  : ensemble mean over the patch.
!  PA  : estimated analysis covariance matrix
!  CYB  : C * (YOBS - H(XBAR)); see Brian's writeup.
!  INFLATE : info on multiplicative and Snyder-Zhang variance inflation
!  W  :=  NSOL x NSOL matrix giving the linear combination of ensemble
!     differences that generate the analysis differences.
!  EDIM := a surrogate for the E-dimension over the patch.  The E-dimemsion
!     is defined in terms of the eigenvalues of the background covariance
!     matrix; we use the analysis covariance matrix instead.
!  CMEAN := analysis mean at the logical center of the patch.
!  CENTER := Kth row holds Kth analysis member at logical center of patch.
!  INFO := set to zero unless an error occurs.  If an error occurs, then
!     the output variables are undefined.
!  Eric: this calling interface could be simplified by having a get_center_col
!  routine in GRID_MODEL; also have RETURN_BACKGROUND do all the work so
!  we don't need to pass around CENTER and CMEAN.
!
    type(patch_index),intent(in)::loc
    integer,intent(in)::nsol,patchsz,nc
    real(D),intent(in)::xback(nsol,patchsz)  ! ensemble diffs (over patch)
    real(D),intent(in)::xbar(patchsz)  ! background mean (over patch)
    real(D),intent(in)::pa(nsol,nsol)  ! estimated covariance mtx Pa~
    real(D),intent(in)::cyb(nsol)   ! C * (YOBS - H(XBAR)) in writeup
    type(inflation_info),intent(in)::inflate
    real(D),intent(out)::w(nsol,nsol)  ! the update matrix W
    real(D),intent(out)::edim  ! surrogate for E-dimension on patch
    real(D),intent(out)::cmean(nc)   ! analysis mean at center column
    real(D),intent(out)::center(nsol,nc)  ! analysis at center of patch
    integer,intent(out)::info
!
!  Local variables
!
    real(D)::xa(nsol,nsol)  !  Xa~; analysis covariance in tilde space
    real(D)::cdiff(nsol,nc)  !  analysis diff at logical center of patch
    real(D)::lambda(nsol)  ! eigenvalues of Pa~
    real(D)::v(nsol)  ! Pa~ *[C*(YOBS-YB)]; step 6 of Brian's writeup
    integer::j,offset,effrank
!
!  Step 5.  Form Xa~=sqrt((k-1)*Pa~).  Do multiplicative variance inflation
!  here if requested.
!
    w=pa*(nsol-1)*(inflate%covar+1.0)  ! W is work array here
    call sym_sqrt(w,nsol,xa,lambda,effrank,info)  ! Xa~ in Brian's writeup
    if(info.ne.0) then   ! can't compute Xa~
       info=PA_NO_EV
       return
    endif
!
!  Use the eigenvalues of Pa~ as a surrogate for the background's E-dimension.
!
    edim=sum(lambda)**2/dot_product(lambda,lambda)
!
!  Step 6. Form v = Pa~ [C(y-y^b)] and add to each column of Xa~, giving W.
!
    v=matmul(pa,cyb)
    do j=1,nsol
       w(:,j)=xa(:,j)+v
    enddo
!
!  Step 7.  Update the background with the analysis.  Since we don't need
!  the entire patch, it's much faster to right-multiply Xb with W
!  only for those rows of Xb that correspond to the dynamical variables
!  in the center of the patch.  XBACK is the transpose of Brian's Xb,
!  so we compute W^T*XBACK.  CDIFF holds the analysis perturbations.
!
    offset=patch_offset(loc,0,0)
    cdiff=matmul(transpose(w),xback(:,offset:offset+nc-1))
!
!  Step 8.  Update the analysis ensemble and the ensemble mean.
!  If requested, first apply the modified update of Zhang, Snyder, and Sun,
!  MWR 132 (May 2004), 1238-1253.  The analysis that we use is a homotopy
!  from the background differences to the analysis differences computed
!  according to our scheme; if alpha=0, then we use our scheme without
!  modification; if alpha=1, we'd return the background spread; if alpha=0.5,
!  then the analysis dfferences are the average of the background and
!  what we have obtained above.
!
    do j=1,nc
       center(:,j)=cdiff(:,j)+xbar(offset+j-1)
       cmean(j)=sum(center(:,j))/nsol
    enddo
    if(inflate%alpha.gt.0.0) then
       do j=1,nc
          center(:,j)=cmean(j)+(1.0-inflate%alpha)*cdiff(:,j)+ &
             inflate%alpha*xback(:,offset+j-1)
       enddo
    endif
!
!  Step 9.  Check that numerical problems haven't caused us to compute junk.
!  If we have, then flag an error.
!
    call copy_to_analysis(loc,nc,nsol,center,info)
    if(info.eq.0) call copy_to_mean(loc,nc,cmean)  ! also store analysis mean
    return
    end subroutine update
!---------------------------------------------------------------------------
    subroutine enhanced(ceb,nsol,patchsz,xback,typelist,var,enh,patilde,diag)
!  ENHANCED - implement enhanced inflation according to Brian's writeup.
!  We regard eigenvalues of F that are less than ENH times the largest
!  eigenvalue as negligible.  Then, we add EPSILON to each of the remaining
!  eigenvalues, where EPSILON is LAMBDA(1)*ENH.  Thus, the inflation at
!  most doubles the size of the nontrivial eigenvalues of F.
!  Smaller values of ENH affect more of the spectrum, but they add smaller
!  increments; larger values affect less of the spectrum but add larger
!  increments.
!
!  Arguments:
!  CEB  : The product (C*Eb).
!  NSOL : number of ensemble solutions; must be > 1
!  PATCHSZ  : number of variables in the patch
!  XBACK  : covariance matrix of all variables in the patch (i.e., the 
!     dynamical variables with the means subtracted off).
!  TYPELIST  : (J,K)th element gives the type of the corresponding variable in
!     XBACK.
!  VAR : list of the variables whose covariances will be used to compute
!     the inflation.  Use 0 for those variables that are omitted;
!     otherwise, some of PRES_TYPE, TEMP_TYPE, UWIND_TYPE, VWIND_TYPE.
!  ENH  : enhanced inflation factor.
!  PATILDE := Brian's Pa~ on success; see writeup.
!  RCOND := reciprocal of estimated condition number of resulting Pa~.
!  DIAG := patch diagnostics; we update the error code and elements relating
!     to the enhanced variance inflation only.  If DIAG%INFO is nonzero on
!     returnkthe contents of PATILDE are undefined.  This can occur 
!     if PATILDE^(-1) is numerically singular.
!
    integer,intent(in)::nsol,patchsz
    real(D),intent(in)::ceb(nsol,nsol),xback(nsol,patchsz)
    real(R)::enh
    integer,intent(in)::typelist(nsol,patchsz),var(NAVARS)
    real(D),intent(out)::patilde(nsol,nsol)
    type(patch_diag),intent(inout)::diag
!
    real(D)::f(nsol,nsol),dx(nsol,patchsz),pinv(nsol,nsol),work(nsol,nsol), &
       u(nsol,nsol),sigma(nsol),g(nsol,nsol),epsilon
    real(D),allocatable::svdwork(:)
    integer::j,lwork,effrank,info
!
    if(enh.le.0.0.or.nsol.le.1) then
       diag%info=INFLATION_FAIL
       return
    endif
!
!  Use only those elements of the covariance array 
!  corresponding to the variables for which the inflation is to be performed.
!
    if(all(var.ne.0)) then
       dx=xback
    else
       dx=0.0 
       do j=1,NAVARS
          if(var(j).gt.0) where(typelist.eq.var(j)) dx=xback
       enddo
    endif
    dx=dx/sqrt(real(nsol-1,kind(dx)))
!
!  Next find the eigenvectors U of F using the singular value decomposition
!  of DX.  (The call to DGESVD destroys the contents of DX, which is why
!  we copy XBACK to it in the event that all dynamical variables participate
!  in the inflation.  (PINV is not referenced in the calls below; see the
!  LAPACK documentation, available online from netlib.org.)
!  Upon successful return, SIGMA**2 is the eigenvalues of F.
!
    call dgesvd('A','N',nsol,patchsz,dx,nsol,sigma,u,nsol,pinv,nsol, &
       work,-1,info)  ! workspace query
    lwork=nint(work(1,1))
    allocate(svdwork(lwork))
    call dgesvd('A','N',nsol,patchsz,dx,nsol,sigma,u,nsol,pinv,nsol, &
       svdwork,lwork,info)
    if(info.lt.0) then
       call fabort('enhanced: illegal value in call to DGESVD')
    else if(info.gt.0) then  ! DGESVD did not converge
       diag%info=INFLATION_FAIL
       return
    endif
    sigma=sigma**2
!
!  Threshold the eigenvalues of F to determine its effective rank and
!  to determine the variance inflation factor EPSILON.
!
    epsilon=enh
    call eigen_fixup(sigma,nsol,effrank,1,info,epsilon)
    diag%effrank=effrank
    diag%smax=sigma(1)
    if(effrank.eq.0) then
       diag%info=INFLATION_FAIL
       return
    endif
    epsilon=enh*sigma(1)
!
!  Compute PINV = inv(I + F/eps) and G = UU^T, where we include only those
!  columns of U that correspond to nontrivial eigendirections of F.
!
    f=matmul(dx,transpose(dx))/epsilon
    do j=1,nsol
       f(j,j)=f(j,j)+1.0
    enddo
    call invert(f,nsol,pinv,diag%rcondpb,info)
    if(info.ne.0) then
       diag%info=INFLATION_FAIL
       return
    endif
    g=matmul(u(:,1:effrank),transpose(u(:,1:effrank)))
!
!  Next obtain inv(P^i), which, from p. 14 of Brian's revised writeup, is
!  (1-k)[inv(I+F/eps) + UU^T - 2I].
!
    pinv=pinv+g
    do j=1,nsol
       pinv(j,j)=pinv(j,j)-2.0
    enddo
    work=ceb+pinv*(1-nsol)
    call invert(work,nsol,patilde,diag%rcondice,info)
    diag%info=merge(0,INFLATION_FAIL,info.eq.0)
    return
    end subroutine enhanced
!-----------------------------------------------------------------------------
    subroutine ed(loc,nsol,patchsz,nc,w,diag,rank)
!  ED - Ed Ott and Brian Hunt's original data assimilation algorithm for
!  one spatial patch of data.
!  The equation numbers follow those in Ott et al.,
!  "A Local Ensemble Kalman Filter for Atmospheric Data Assimilation",
!  Tellus 56A (2004), 415-428.
!
!  Arguments:
!  LOC  :  (x,y,z) grid coordinates defining the center of the patch.
!  NSOL : number of ensemble members
!  PATCHSZ : number of dynamical variables in the patch
!  NC  : center column height (at logical center of patch)
!  W := NSOL x NSOL array giving linear combination of background covariance
!     needed to give the analysis at the center of the patch.  See Brian's
!     writeup.
!  DIAG := diagnostics include the return code DIAG%INFO, which is
!     0 unless an error occurs.
!     Error indications (each of which is positive):
!     INFLATION_FAIL: could not compute inv(I+F/eps) for enhanced var inflation
!     PA_NO_EV:  could not compute square root of analysis covariance matrix
!     P_NEG_EV:  error: negative eigenvalue from covariance matrix
!     NO_OBS_UPDATE:  no observations available to do the update.
!     Also includes information about reciprocal condition number of Pa~
!     and number of observations in the patch.
!  RANK : rank of the projections used (usually NSOL-1 in this implementation).
!
    type(patch_index),intent(in)::loc
    integer,intent(in)::nsol,rank,patchsz,nc
    real(D),intent(out)::w(nsol,nsol)
    type(patch_diag),intent(inout)::diag
!
!  Local storage
!
!  Ensemble data over the local patch
!
    real(D)::xback(nsol,patchsz) ! ensemble background diffs
    real(D)::xbar(patchsz) ! background mean over patch
    integer::typelist(nsol,patchsz)  ! dynamical variable types
!
!  Observations
!
    real(D),allocatable::yobs(:) ! local copy of observations
    real(D),allocatable::hbar(:)  ! H(xbar)
    real(D),allocatable::ebtr(:,:) ! Kth col is H(x(k))-HBAR for Kth ensemble.
    real(D),allocatable::rdiag(:)   ! obs covariance matrix (assumed diagonal)
    integer::nobs
!
!  Covariance matrix and eigenvectors
!
    real(D)::q(patchsz,nsol)  ! Orthonormal eigenvectors of Pb.
    real(D)::lambda(nsol)  ! Eigenvalues of Pb, sorted in descending order.
    real(D)::pbhat(rank)  ! Pb^ in eigenvector coords, which is diagonal
    real(D)::renorm  ! normalization factor for Xb, Xa, and hat versions
    integer::info
    type(inflation_info)::inflate
!
!  Data assimilation step
!
    real(D),allocatable::c(:,:)  ! Eb^T*inv(R)
    real(D)::innov(nsol)  ! C*innovation 
    real(D)::iceb(nsol,nsol)  ! I+C*Eb
    real(D)::icebinv(nsol,nsol)  ! inv(I+C*Eb)
    real(D)::rcond  ! reciprocal condition number of ICEB
    real(D)::pahat(rank,rank) ! analysis covariance mtx in eigenvector coords
    real(D)::xbhat(nsol,rank)  ! transpose of Ed's Xb^
    real(D)::xahat(nsol,rank)  ! transpose of Ed's Xa^
    real(D)::xicebinv(rank,nsol) ! work array
    real(D)::dxamn(rank)  ! adjustment to local analysis mean
!
!  Analysis step
!
    real(D)::pdiff(rank,rank) ! Pa^ - Pb^
    real(D)::work(nsol,rank)
    real(D)::a(nsol,nsol)  ! determines Pa^ in Potter's method
    real(D)::center(nsol,nc)  ! analysis at center of patch
    real(D)::trace
!
    integer::j,offset,effrank
!
!  Get background ensemble mean and perturbations therefrom.
!  Henceforth, XBACK(:,k) holds the difference between the emsemble
!  mean and the Kth ensemble solution in the patch whose logical center
!  is LOC.
!
    call copy_from_ensemble(loc,xback,nsol,patchsz,typelist)
    if(ensemble_diffs_precomputed()) then
       call copy_from_mean(loc,xbar,patchsz)
    else
       do j=1,patchsz
          xbar(j)=sum(xback(:,j))/nsol
          xback(:,j)=xback(:,j)-xbar(j)
       enddo
    endif
!
!  Normalize by the square root of one less than the ensemble size, Eq. (5).
!
    renorm=sqrt(real(rank,kind(renorm)))
    xback=xback/renorm
!
!  Get observations, if any.  If there are none, then return the background.
!  The normalization of Eb^T is missing in Szunyogh et al.
!
    call copy_from_obs(loc,yobs,hbar,rdiag,nsol,nobs,dh=ebtr)
    ebtr=ebtr/sqrt(real(nsol-1,kind(ebtr)))
    if(nobs.eq.0) then
       call return_background(loc,xbar,xback,nsol,patchsz,nc,w,renorm)
       diag%info=NO_OBS_UPDATE
       return
    endif
!
!  Find Q, the eigenvector decomposition of P^b, Eq. (11).
!
    call get_pb_eigen(xback,patchsz,nsol,lambda,q,info)
    if(info.ne.0) then  ! SVD did not converge
       call return_background(loc,xbar,xback,nsol,patchsz,nc,w,renorm)
       diag%info=PB_NO_EV
       return
    else
       diag%rcondpb=lambda(rank)/lambda(1)  ! reciprocal condition number of P^b
       diag%edim=sum(sqrt(lambda))**2/sum(lambda)
    endif
!
!  Next do multiplicative covariance inflation if requested.
!
    pbhat=lambda(1:rank)
    call inflation(loc,inflate)
    if(inflate%covar.gt.0.0) then
       pbhat=pbhat*(inflate%covar+1.0)
       xback=xback*sqrt(inflate%covar+1.0)
    endif
    if(verbosity().ge.VERB_CHATTY) write(IOUT,100) loc,inflate%covar
100 format('ed: loc:',3i4,' covar:',f6.3)
!
!  Compute the analysis covariance matrix using Eq. (A-24) of the 
!  Szunyogh et al paper (all matrices in the hat space):
!  Pa = Xb*inv(I + Eb^T*inv(R)*Eb)*(Eb^T*inv(R))*(yobs-H(xbar)).
!  We'll define the matrix C (as in Brian's writeup) to be Eb^T*inv(R).
!
    allocate(c(nsol,nobs))
    do j=1,nobs
       c(:,j)=ebtr(:,j)/rdiag(j)
    enddo
    yobs=yobs-hbar
    innov=matmul(c,yobs)
    iceb=matmul(c,transpose(ebtr))
    do j=1,nsol
       iceb(j,j)=iceb(j,j)+1.0
    enddo
    if(allocated(diag%iceb_sing)) call singular_vals(iceb,diag%iceb_sing,nsol)
    call invert(iceb,nsol,icebinv,rcond,info)
    if(info.ne.0) then
       diag%info=PA_SINGULAR
       return
    endif
    xbhat=matmul(xback,q(:,1:rank))  ! gives transpose of Ed's Xb^
    xicebinv=matmul(transpose(xbhat),icebinv)
    dxamn=matmul(xicebinv,innov)  ! Eq. (A-25) of Szunyogh et al.
    pahat=matmul(xicebinv,xbhat)
!
!  Enhanced variance inflation if requested.
!
    if(inflate%enhanced.gt.0.0) then  ! Pa^ -> Pa^ + (eps*tr(Pa~)/k)*I, Eq. (42)
       trace=pahat(1,1)
       do j=2,rank
          trace=trace+pahat(j,j)
       enddo
       trace=trace*inflate%enhanced/(nsol-1)
       do j=1,rank
          pahat(j,j)=pahat(j,j)+trace
       enddo
    endif
!
!  Compute Y = I + Xb^T*inv(Pb^)*(Pa^-Pb^)*inv(Pb^)*Xb^, Eq. (41)
!
    pdiff=pahat
    do j=1,rank
       pdiff(j,j)=pdiff(j,j)-pbhat(j)  ! since Pb^ is diagonal
    enddo
    do j=1,rank
       work(:,j)=xbhat(:,j)/pbhat(j)  ! Xb^T*inv(Pb^)
    enddo
    xahat=matmul(work,pdiff)   ! XAHAT is work array here
    a=matmul(xahat,transpose(work))
    do j=1,nsol
       a(j,j)=a(j,j)+1.0
    enddo
    call sym_sqrt(a,nsol,w,lambda,effrank,info)
    if(info.ne.0) then
       call return_background(loc,xbar,xback,nsol,patchsz,nc,w,renorm)
       diag%info=SYM_SQRT_FAIL
       return
    endif
!
!  Get the analysis perturbations, Eq. (34).  W (=Y) is symmetric, and our
!  XAHAT and XBHAT are the transposes of Ed's.  Also undo the normalization;
!  see Eq. (35) of Ott et al.
!
    xahat=matmul(w,xbhat)*renorm
    xbar=xbar+matmul(q(:,1:rank),dxamn)  ! new analysis mean (in model coords)
!
!  Remember that XAHAT is the tranpose of Ed's Xa^.  Save time by applying
!  the update only to the center column of the patch.
!
    offset=patch_offset(loc,0,0)
    center=matmul(xahat,transpose(q(offset:offset+nc-1,1:rank))) ! Eq. (26)
    do j=1,nc
       center(:,j)=center(:,j)+xbar(offset+j-1)
    enddo
    call copy_to_analysis(loc,nc,nsol,center,diag%info)
    if(diag%info.eq.0) then
       call copy_to_mean(loc,nc,xbar(offset:offset+nc-1))
    else
       call return_background(loc,xbar,xback,nsol,patchsz,nc,w,renorm)
    endif
    return
    end subroutine ed
!---------------------------------------------------------------------------
    subroutine return_background(loc,xbar,xback,nsol,patchsz,nc,w,c)
!  RETURN_BACKGROUND - return the corresponding elements of the background.
!  Service routine for cases where the data assimilation routine fails.
!  LOC  : location of logical center of patch
!  XBAR  : background mean over the patch
!  XBACK : holds background perturbations over the patch
!  NSOL : number of the ensemble solutions
!  PATCHSZ : number of dynamical variables in the patch
!  W  := set to the identity matrix.
!  C, if present, undoes any scaling that may have been applied to XBACK.
!
    type(patch_index),intent(in)::loc
    integer,intent(in)::nsol,patchsz,nc
    real(D),intent(in)::xback(nsol,patchsz),xbar(patchsz)
    real(D),intent(out)::w(nsol,nsol)
    real(D),intent(in),optional::c
!
    real(D)::cmean(nc),center(nsol,nc)
    integer::offset,j
!
    offset=patch_offset(loc,0,0)
    do j=1,nc
       cmean(j)=xbar(offset+j-1)
       if(present(c)) then
          center(:,j)=xbar(offset+j-1)+xback(:,offset+j-1)*c
       else
          center(:,j)=xbar(offset+j-1)+xback(:,offset+j-1)
       endif
    enddo
    call copy_to_analysis(loc,nc,nsol,center)
    call copy_to_mean(loc,nc,cmean)
    call identity(w,nsol)
    return
    end subroutine return_background
!---------------------------------------------------------------------------
    subroutine sym_sqrt(a,n,b,lambda,effrank,info)
!  Return the symmetric square root of A in B.  The square root is
!  computed as a product of the orthonormal matrix M of eigenvectors of A:
!  B = (sqrt(lambda)*M)*transpose(M), where lambda is
!  the diagonal matrix of eigenvalues of A.
!  We do not consider a singular matrix to be an error here.
!  Packages required:
!
!  Arguments:
!  A  :  N x N matrix, assumed symmetric.
!  B  := N x N positive symmetric square root of A, if INFO=0.
!  LAMBDA := the N eigenvalues of B (which equal the eigenvalues of A,
!    except that we zero out small negative eigenvalues that arise from
!    numerical roundoff).  Entries undefined if INFO != 0.
!  EFFRANK := the effective rank of B (number of unambiguously positive
!    eigenvalues).  Value undefined if INFO != 0.
!  INFO := set to 0 unless the eigenvector decomposition fails.
!
    integer,intent(in)::n
    real(D),intent(in)::a(n,n)
    real(D),intent(out)::b(n,n),lambda(n)
    integer,intent(out)::effrank,info
!
!  Local variables
!
    real(D)::work(n,n)
    integer::j,nfound
!
    b=a
    call get_eigenspace(b,n,lambda,nfound)  ! B holds eigenvectors of A
    if(nfound.lt.n) then
       info=PA_NO_EV
       return
    endif
    call eigen_fixup(lambda,n,effrank,0,info)
    if(info.ne.0) then
       info=P_NEG_EV
       return
    endif
    do j=1,n
       work(:,j)=b(:,j)*sqrt(lambda(j))
    enddo
    b=matmul(work,transpose(b))   ! gives sqrt(B)
    info=0
    return
    end subroutine sym_sqrt
!---------------------------------------------------------------------------
    subroutine get_eigenspace(a,n,lambda,nfound)
!  GET_EIGEN - Overwrite the symmetric matrix A with its eigenvectors.
!  Arguments:
!  N    :   dimension of A, which is NxN.
!  A  :=:  On input, the covariance matrix.  On output, the Kth
!      column is the eigenvector corresponding to the Kth eigenvalue.
!  LAMBDA := On return, the largest NFOUND eigenvalues of A, from
!      largest to smallest in absolute value.
!  NFOUND := the number of successfully computed eigenvalues and eigenvectors.
!
    integer,intent(in)::n
    real(D),intent(inout)::a(n,n)
    real(D),intent(out)::lambda(n)
    integer,intent(out)::nfound
!
!  Local variables
!
    real(D),parameter::ZERO=0.0
    real(D)::work(70*n) ! work array for dsyev
    real(D)::mu(n)    ! holds eigenvalues from dsyev
    real(D)::abstol   ! convergence tolerance for dsyev
    real(D)::z(n,n)   ! Jth column holds Jth eigenvalue from dsyev
    real(D)::abak(n,n) ! backup copy of A in case DSYEVR doesn't converge
    integer::iwork(10*n),isuppz(2*n)  ! more work arrays for dsyev
    integer::j,info
!
!  DSYEVR and RS return the eigenvalues in ascending order.
!  Note: the convergence of DSYEVR and DSYEVX depends on how ABSTOL
!  is set.  Looser tolerances (e.g., ABSTOL=sqrt(machine epsilon)) often
!  cause an internal failure in DSYEVR, as some eigenvectors don't
!  converge.  The higher tolerance appears to be better, based on
!  experiments with the Lorenz model.
!
    abstol=2.0*tiny(a)
    abak=a
    lambda=0.0
    call dsyevr('v','i','u',n,a,n,ZERO,ZERO,1,n, &
       abstol,nfound,mu,z,n,isuppz,work,size(work),iwork,size(iwork),info)
    if(info.lt.0) then   ! bad argument - definitely a bug in caller
       call fabort('get_eigenspace: bad call to dsyevr')
    else if(info.gt.0) then  ! internal error in dsyevr; try EISPACK routines
       call rs(n,n,abak,mu,1,z,work,work(n+1),info)
    endif
    if(info.eq.0) then
       do j=1,nfound
          lambda(j)=mu(nfound-j+1)
          a(:,j)=z(:,nfound-j+1)
       enddo
    else
       nfound=0
    endif
    return
    end subroutine get_eigenspace
!---------------------------------------------------------------------------
    pure subroutine eigen_fixup(lambda,n,effrank,ignore,info,threshold)
!  EIGEN_FIXUP - LAMBDA is a list of eigenvalues that are supposed to be
!  nonzero (e.g., they come from a symmetric real matrix) and that are
!  sorted in descending order (this is not checked).
!  We check for nontrivial negative eigenvalues, in which case INFO flags
!  an error.  Assuming none are found, then EFFRANK is set to the number
!  of eigenvalues that are larger than LAMBDA(1) times the THRESHOLD.
!  All eigenvalues less than this product are set to zero on ordinary
!  return.  If THRESHOLD is not supplied, then we use the square root
!  of the machine precision.
!
!  Arguments:
!  LAMBDA :=: must be sorted in descending order on entry (not checked).
!    On return, the last IGNORE values are replaced by 0, as are
!    any of the first N-IGNORE values that are less than LAMBDA(1)*THRESHOLD. 
!    (If THRESHOLD is absent, then we use the square root of the machine
!    precision.)  On return, LAMBDA(1:EFFRANK) are the only nonzero values.
!  N  : number of eigenvalues in LAMBDA.
!  EFFRANK := set to number of nonzero eigenvalues after processing.
!  IGNORE : the last IGNORE eigenvalues are assumed zero (and are set to 0).
!     For example, if the matrix in question is expected to have rank
!     at most n-1, for instance, then we'd call this function with IGNORE=1.
!     Otherwise, if the matrix in principle can have full rank, then
!     call with IGNORE=0.
!  INFO := set to 0 unless some element of LAMBDA is negative and fails the
!       smallness test, in which case LAMBDA is unchanged.
!  THRESHOLD : if present, eigenvalues smaller than THRESHOLD*LAMBDA(1)
!   are assumed to be negligible.  We use the maximum of THRESHOLD and the
!   square root of the machine precision.
!
    integer,intent(in)::n,ignore
    real(D),intent(inout)::lambda(n)
    integer,intent(out)::effrank
    integer,intent(out)::info
    real(D),intent(in),optional::threshold
!
!  Local variables
!
    real(D)::thresh
!
!  Check whether we have a nontrivial negative eigenvalue (or a negative
!  threshold).  If we do, then flag an error and return.
!
    if(present(threshold)) then
       thresh=lambda(1)*max(threshold,sqrt(epsilon(lambda)))
    else
       thresh=lambda(1)*sqrt(epsilon(lambda))
    endif
    if(lambda(1).lt.0.0.or.any(lambda(1:n-ignore).lt.-thresh)) then
       info=P_NEG_EV
       return
    endif
!
!  Otherwise assume that negative eigenvalues and suitably small positive
!  eigenvalues correspond to numerical roundoff.
!
    if(ignore.gt.0) lambda(n-ignore+1:n)=0.0
    where(lambda.lt.thresh) lambda=0.0
    effrank=count(lambda.gt.0.0)
    info=0
    return
    end subroutine eigen_fixup
!---------------------------------------------------------------------------
    subroutine invert(a,n,ainv,rcond,info)
!  INVERT - utility routine to compute the inverse of the input array A.
!  On successful returnk AINV holds inv(A) and RCOND holds an estimate of the
!  reciprocal condition number of A.  We regard the computation of the
!  inverse as a failure if the estimate of the forward error in any column
!  of AINV exceeds EXCESS_ERR and return a nonzero value of INFO.
!  A   :  matrix to be inverted
!  N   :  size of A
!  AINV := set to the inverse of A unless INFO is nonzero.
!  RCOND := reciprocal of the estimated condition number of A.
!  INFO  := set to 0 unless the inverse cannot be computed with acceptable
!     relative accuracy.
!
    integer,intent(in)::n
    real(D),intent(inout)::a(n,n)
    real(D),intent(out)::ainv(n,n),rcond
    integer,intent(out)::info
!
!  Variables for DGESVX
!
    real(D),parameter::EXCESS_ERR=1.0e-04_D
    character::equed
    real(D)::af(n,n),rowscale(n),colscale(n),berr(n),ferr(n)
    real(D)::rvec(n*4),rhs(n,n)
    integer::iwork(n),ipiv(n)
!
!  We use the expert driver to solve AX=I for X; it computes estimates of the
!  forward and backward error in the solution.
!
    call identity(rhs,n)
    call dgesvx('E','N',n,n,a,n,af,n,ipiv,equed,rowscale, &
       colscale,rhs,n,ainv,n,rcond,ferr,berr,rvec,iwork,info)
    if(info.lt.0) call fabort('invert: dgesvx: illegal argument')
    if(any(ferr.gt.EXCESS_ERR)) info=1
    return
    end subroutine invert
!---------------------------------------------------------------------------
    subroutine get_pb_eigen(xback,patchsz,nsol,lambda,q,info)
!  GET_PB_EIGEN - compute the eigenvector spectrum of the background
!  covariance matrix, XBACK*transpose(XBACK) using the singular value
!  decomposition.  The SVD is chosen because it is expected to be numerically
!  stable even if XBACK is ill-conditioned.  (Note: XBACK has at least
!  one zero singular value in principle, as its rank is at most NSOL-1.)
!  My XBACK is the transpose of Ed's X^b.  The required eigenvector matrix Q
!  of X^b consists of the left singular vectors of transpose(XBACK).
!  Arguments:
!  XBACK : the Kth row holds the Kth ensemble state vector, K<=NSOL,
!     with the ensemble mean subtracted off.
!  PATCHSZ := the number of dynamical variables in the patch.
!  LAMBDA := on successful return, holds the largest NSOL-1 eigenvalues
!     in ascending order by index.
!  Q := on successful return, Kth column holds the eigenvector
!     corresponding to LAMBDA(K).
!  INFO := Set to 0 unless an error occurs.
!
    integer,intent(in)::patchsz,nsol
    real(D),intent(in)::xback(nsol,patchsz)
    real(D),intent(out)::lambda(nsol)
    real(D),intent(out)::q(patchsz,nsol)
    integer,intent(out)::info
!
!  Local storage
!
    real(D),allocatable::work(:)
    integer::lwork
    real(D)::extra(1)
!
!  We assume that XBACK has already been normalized by one less than
!  the ensemble size, Eq. (5) of the Tellus paper.  We compute the left
!  singular vectors XBACK and place them in Q; the right singular vectors
!  are not computed.
!
    q=transpose(xback)
    call dgesvd('O','N',patchsz,nsol,q,patchsz,lambda,extra,patchsz, &
       extra,nsol,extra,-1,info)  ! workspace query
    lwork=nint(extra(1))
    allocate(work(lwork))
    call dgesvd('O','N',patchsz,nsol,q,patchsz,lambda,extra,patchsz, &
       extra,nsol,work,lwork,info)
    if(info.lt.0) then
       call fabort('get_pb_eigen: illegal argument to DGESVD')
    else if(info.eq.0) then
       lambda=lambda**2  ! eigenvals of P^b are squares of singular values
    endif
    return
    end subroutine get_pb_eigen
!---------------------------------------------------------------------------
    pure subroutine identity(a,n)
!  IDENTITY - return the NxN identity matrix.
!
    integer,intent(in)::n
    real(D),intent(out)::a(n,n)
!
    integer::j
!
    a=0.0
    do j=1,n
       a(j,j)=1.0
    enddo
    return
    end subroutine identity
!---------------------------------------------------------------------------
    subroutine singular_vals(c,sing,n)
!  SINGULAR_VALS - find the singular values of the matrix C.  If the SVD
!  fails, then set the singular values to 0.
!
    integer,intent(in)::n
    real(D),intent(inout)::c(n,n)
    real(D),intent(out)::sing(n)
!
    real(D)::copy(n,n),wsize(1)
    integer::lwork,info
    real(D),allocatable::work(:)
!
    call dgesvd('N','N',n,n,copy,n,sing,copy,n,copy,n,wsize,-1,info)
    lwork=nint(wsize(1))
    allocate(work(lwork))
    copy=c
    call dgesvd('N','N',n,n,copy,n,sing,copy,n,copy,n,work,lwork,info)
    if(info.lt.0) then
       call fabort('singular_vals: argument error to DGESVD')
    else if(info.gt.0) then  ! no convergence
       sing=0.0
    endif
    return
    end subroutine singular_vals
!---------------------------------------------------------------------------

    end module assimilation

    module ferror
    use io,only:IERR  ! standard error unit number
    contains
!------------------------------------------------------------------------
    subroutine fexit(msg,errcode,unit)
!  FEXIT - print the indicated message and halt with an exit code (default 1).
!  ERRCODE : if present, the exit error code to return to the shell (default 1).
!  UNIT    : if present, the logical unit number on which to diplay msg
!            (default 0, std error).
!
    use command_line_support,only:program_exit
    character(*),intent(in)::msg
    integer,intent(in),optional::errcode,unit
!
    character(80)::progname
    integer::iunit
!
    call getarg(0,progname)
    if(present(unit)) then
       iunit=unit
    else
       iunit=IERR
    endif
    if(len_trim(progname).gt.0) &
       write(iunit,100,advance='no') trim(progname)//': '
100 format(a)
    write(iunit,100) msg
    if(present(errcode)) then
       call program_exit(errcode)
    else
       call program_exit(1)
    endif
    end subroutine fexit
!------------------------------------------------------------------------
    subroutine fabort(msg,unit)
!  FABORT - print the indicated message and abort.
!  UNIT    : if present, the logical unit number on which to diplay msg
!            (default 0, std error).
!
    character(*),intent(in)::msg
    integer,intent(in),optional::unit
!
    character(80)::progname
    integer::iunit
!
    call getarg(0,progname)
    if(present(unit)) then
       iunit=unit
    else
       iunit=IERR
    endif
    if(len_trim(progname).gt.0) &
       write(iunit,100,advance='no') trim(progname)//': '
100 format(a)
    write(iunit,100) msg
    call abort
    end subroutine fabort
!------------------------------------------------------------------------
    subroutine finfo(msg,unit)
!  FINFO - print the indicated message and return.
!  UNIT    : if present, the logical unit number on which to diplay msg
!            (default 0, std error).
!
    character(*),intent(in)::msg
    integer,intent(in),optional::unit
!
    character(80)::progname
    integer::iunit
!
    call getarg(0,progname)
    if(present(unit)) then
       iunit=unit
    else
       iunit=IERR
    endif
!
    if(len_trim(progname).gt.0) &
       write(iunit,100,advance='no') trim(progname)//': '
100 format(a)
    write(iunit,100) trim(msg)
    return
    end subroutine finfo
!------------------------------------------------------------------------
    end module ferror

    module random_normal
    use precision
    contains
!-------------------------------
    subroutine rnor(z,n,var)
!  RNOR - generate N normally distributed random numbers of mean 0 and
!  variance VAR.  Place them into Z on return.
!  Adapted from code by
!     Alan Miller
!     CSIRO Division of Mathematical & Information Sciences
!     Private Bag 10, Clayton South MDC
!     Clayton 3169, Victoria, Australia
!     Phone: (+61) 3 9545-8016      Fax: (+61) 3 9545-8080
!     e-mail: amiller @ bigpond.net.au
!  which in turn came from Fortran 77 code:
!      ALGORITHM 712, COLLECTED ALGORITHMS FROM ACM.
!      THIS WORK PUBLISHED IN TRANSACTIONS ON MATHEMATICAL SOFTWARE,
!      VOL. 18, NO. 4, DECEMBER, 1992, PP. 434-435.
!
!  The function random_normal() returns a normally distributed pseudo-random
!  number with zero mean and unit variance.
!
!  The algorithm uses the ratio of uniforms method of A.J. Kinderman
!  and J.F. Monahan augmented with quadratic bounding curves.
!
    integer,intent(in)::n
    real(R),intent(in)::var
    real(R),intent(out)::z(n)
!
!  Local variables
!
    real(R),parameter::S=0.449871_R,T=-0.386595_R,A=0.19600_R,B=0.25472_R, &
       R1=0.27597_R,R2=0.27846_R,R3=1.7156_R
    real(R)::u(n),v(n),x,y,q
    integer::j,left,have
!
!  First generate N(0,1) deviates.
!  For each deviate, generate P = (u,v) uniform in rectangle 
!  enclosing acceptance region.  Accept P if it is inside the ellipse
!  determined by the quadratic form Q.
!
    have=0
    do while(have.lt.n)
       left=n-have
       call random_number(u(1:left))
       call random_number(v(1:left))
       do j=1,left
          x=u(j)-S
          v(j)=R3*(v(j)-0.5)
          y=abs(v(j))-T
          q=x**2+y*(A*y-B*x)
          if(q.lt.R1.or.q.le.R2.and.v(j)**2.lt.-4.0*log(u(j))*u(j)**2) then
             have=have+1
             z(have)=v(j)/u(j)
          endif
       enddo
    enddo
    z=z*sqrt(var)  !  Convert to N(0,var)
    return
    end subroutine rnor
    end module random_normal

   module constant
   use precision
   implicit none
!     FORTPREP CONSTANTS AS SET IN NMC HANDBOOK FROM SMITHSONIAN TABLES.
!     PHYSICAL CONSTANTS ARE GIVEN TO 5 PLACES, MATH CONSTANTS TO 7.
!     90/04/30: G AND RD ARE MADE CONSISTENT WITH NWS USAGE.

      real(D)::REARTH,GRAV,OMEGA,RD,RV,RVRDM1,CP,CVAP,CLIQ,HVAP, &
           HFUS,PSAT,SBC,SOLR,T0C,TTP,JCAL,PI,SQRT2,SQRT3,FV,TR

!               NAME   VALUE         DESCRIPTION                     UNITS
!               ----   -----         -----------                     -----
      parameter(REARTH=6.3712E+6_D)!   RADIUS OF EARTH                 (M)
!     parameter(GRAV  =9.8062E+0_D)!   GRAVITATIONAL ACCELERATION      (M/S2)
      parameter(GRAV  =9.8000E+0_D)!
      parameter(OMEGA =7.2921E-5_D)!   ANGULAR VELOCITY OF EARTH       (1/S)
!     parameter(RD    =2.8704E+2_D)!   GAS CONSTANT OF DRY AIR         (J/KG/K)
      parameter(RD    =2.8705E+2_D)!
      parameter(RV    =4.6150E+2_D)!   GAS CONSTANT OF H2O VAPOR       (J/KG/K)
      parameter(RVRDM1=0.6077338_D)!   0.61 APPROX.                    (J/KG/K)
      parameter(CP    =1.0046E+3_D)!   SPECIFIC HEAT OF AIR @PRESSURE  (J/KG/K)
!      parameter(CV    =7.1760E+2_D)!   SPECIFIC HEAT OF AIR @VOLUME    (J/KG/K)
      parameter(CVAP  =1.8460E+3_D)!   SPECIFIC HEAT OF H2O VAPOR      (J/KG/K)
      parameter(CLIQ  =4.1855E+3_D)!   SPECIFIC HEAT OF LIQUID H2O     (J/KG/K)
      parameter(HVAP  =2.5000E+6_D)!   LATENT HEAT OF H2O CONDENSATION (J/KG)
      parameter(HFUS  =3.3358E+5_D)!   LATENT HEAT OF H2O FUSION       (J/KG)
      parameter(PSAT  =6.1078E+2_D)!   PRESSURE AT H2O TRIPLE POINT    (PA)
      parameter(SBC   =5.6730E-8_D)!   STEFAN-BOLTZMANN CONSTANT       (W/M2/K4)
      parameter(SOLR  =1.3533E+3_D)!   SOLAR CONSTANT                  (W/M2)
      parameter(T0C   =2.7315E+2_D)!   TEMPERATURE AT ZERO CELSIUS     (K)
      parameter(TTP   =2.7316E+2_D)!   TEMPERATURE AT H2O TRIPLE POINT (K)
      parameter(JCAL  =4.1855E+0_D)!   JOULES PER CALORIE              ()
      parameter(PI    =3.1415926535897932_D)
      parameter(SQRT2 =1.41421356237309504878_D)  ! SQUARE ROOT OF 2
      parameter(SQRT3 =1.73205080756887729351_D)  ! SQUARE ROOT OF 3
      parameter(FV=RV/RD-1.0_D)       ! used in virtual temp. equation  ()
      parameter(TR    =2.7E+2_D)     ! reference temperature
   end module constant

    module split_defs
! SPLIT_DEFS - utility routines.
!  Modification history:
!  11/20/04 - added routines to support distribution of actual observations
!             among the processors
!  08/18/03 - split along latitudes instead of longitudes.
!
    implicit none
    contains
!----------------------
    subroutine imod(iproc,iwidth,nstrips,ywin,startlat,endlat,psouth,pnorth)
! IMOD - given the patch width, number of available processors,
! and the number NSTRIPS of latitudes, determine
! a splitting of the data and decide how many processors to use.
!  IPROC  :=: on input, the number of available processors; on return,
!             the number of processors on which to run.
!  IWIDTH :=  Kth entry is the width of each latitude strip (i.e., number
!             of vertical grid points) that the Kth processor should handle.
!  NSTRIPS :  the number of latitudes to use.
!  YWIN  : minimum Y (latitude) radius that can be centered at each point
!      between each latitude strip defined by STARTLAT and ENDLAT.
!  STARTLAT := the starting latitude for the model grid for processor K.
!  ENDLAT := the stopping latitude for the model grid for processor K.
!  The splitting is determined so that the width of the strips is as least
!  as great as the latitude width (YWIN) of a patch.
!  PSOUTH, PNORTH := Kth entries are the southern- and northernmost
!  latitudes at which patches can be centered for the data assimilation.
!
    use resolution,only:LATG
    use grid_indexing
    use ferror
    implicit none
    integer,intent(inout)::iproc
    integer,allocatable,intent(out)::iwidth(:),startlat(:),endlat(:)
    integer,allocatable,intent(out)::psouth(:),pnorth(:)
    integer,intent(in)::nstrips,ywin
!
!   Local variables
!
    integer::per_proc,left,j,n
!
!  First determine the number of latitude strips that each processor will
!  handle.  The lowest-numbered processors handle up to one extra strip
!  than higher-numbered ones (partially compensates for slowness of data
!  movement across the cluster).  Revise the total number of processors
!  to be used as needed.
!
    n=min(iproc,nstrips)
    per_proc=nstrips/n
    left=mod(nstrips,n)
    allocate(iwidth(n))
    iwidth(1:left)=per_proc+1  ! distribute leftovers
    iwidth(left+1:n)=per_proc
    iproc=n
!
    allocate(startlat(n),endlat(n))
    allocate(psouth(n),pnorth(n))
!
!  First determine processor assignments; processor J centers points
!  along latitudes STARTLAT(J) to ENDLAT(J) inclusive.
!
    startlat(1)=1
    endlat(1)=iwidth(1)
    do j=2,n
       startlat(j)=endlat(j-1)+1
       endlat(j)=startlat(j)+iwidth(j)-1
    enddo
    if(endlat(n).gt.LATG) call fabort('imod: processor allocation botched')
    psouth=startlat
    pnorth=endlat
!
!  Now add padding: up to YWIN latitudes to the north of ENDLAT and to the
!  south of STARTLAT so that we can center patches at each point along
!  the southernmost and northernmost latitudes.
!
    do j=1,n
       startlat(j)=max(startlat(j)-ywin,1)
       endlat(j)=min(endlat(j)+ywin,LATG)
    enddo
    return
    end subroutine imod
!----------------------
    end module split_defs

      SUBROUTINE DLARRE( N, D, E, TOL, NSPLIT, ISPLIT, M, W, WOFF,
     $                   GERSCH, WORK, INFO )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            INFO, M, N, NSPLIT
      DOUBLE PRECISION   TOL
*     ..
*     .. Array Arguments ..
      INTEGER            ISPLIT( * )
      DOUBLE PRECISION   D( * ), E( * ), GERSCH( * ), W( * ), WOFF( * ),
     $                   WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  Given the tridiagonal matrix T, DLARRE sets "small" off-diagonal
*  elements to zero, and for each unreduced block T_i, it finds
*  (i) the numbers sigma_i
*  (ii) the base T_i - sigma_i I = L_i D_i L_i^T representations and
*  (iii) eigenvalues of each L_i D_i L_i^T.
*  The representations and eigenvalues found are then used by
*  DSTEGR to compute the eigenvectors of a symmetric tridiagonal
*  matrix. Currently, the base representations are limited to being
*  positive or negative definite, and the eigenvalues of the definite
*  matrices are found by the dqds algorithm (subroutine DLASQ2). As
*  an added benefit, DLARRE also outputs the n Gerschgorin
*  intervals for each L_i D_i L_i^T.
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The order of the matrix.
*
*  D       (input/output) DOUBLE PRECISION array, dimension (N)
*          On entry, the n diagonal elements of the tridiagonal
*          matrix T.
*          On exit, the n diagonal elements of the diagonal
*          matrices D_i.
*
*  E       (input/output) DOUBLE PRECISION array, dimension (N)
*          On entry, the (n-1) subdiagonal elements of the tridiagonal
*          matrix T; E(N) need not be set.
*          On exit, the subdiagonal elements of the unit bidiagonal
*          matrices L_i.
*
*  TOL     (input) DOUBLE PRECISION
*          The threshold for splitting. If on input |E(i)| < TOL, then
*          the matrix T is split into smaller blocks.
*
*  NSPLIT  (input) INTEGER
*          The number of blocks T splits into. 1 <= NSPLIT <= N.
*
*  ISPLIT  (output) INTEGER array, dimension (2*N)
*          The splitting points, at which T breaks up into submatrices.
*          The first submatrix consists of rows/columns 1 to ISPLIT(1),
*          the second of rows/columns ISPLIT(1)+1 through ISPLIT(2),
*          etc., and the NSPLIT-th consists of rows/columns
*          ISPLIT(NSPLIT-1)+1 through ISPLIT(NSPLIT)=N.
*
*  M       (output) INTEGER
*          The total number of eigenvalues (of all the L_i D_i L_i^T)
*          found.
*
*  W       (output) DOUBLE PRECISION array, dimension (N)
*          The first M elements contain the eigenvalues. The
*          eigenvalues of each of the blocks, L_i D_i L_i^T, are
*          sorted in ascending order.
*
*  WOFF    (output) DOUBLE PRECISION array, dimension (N)
*          The NSPLIT base points sigma_i.
*
*  GERSCH  (output) DOUBLE PRECISION array, dimension (2*N)
*          The n Gerschgorin intervals.
*
*  WORK    (input) DOUBLE PRECISION array, dimension (4*N???)
*          Workspace.
*
*  INFO    (output) INTEGER
*          Output error code from DLASQ2
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Inderjit Dhillon, IBM Almaden, USA
*     Osni Marques, LBNL/NERSC, USA
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE, TWO, FOUR, FOURTH
      PARAMETER          ( ZERO = 0.0D0, ONE = 1.0D0, TWO = 2.0D0,
     $                   FOUR = 4.0D0, FOURTH = ONE / FOUR )
*     ..
*     .. Local Scalars ..
      INTEGER            CNT, I, IBEGIN, IEND, IN, J, JBLK, MAXCNT
      DOUBLE PRECISION   DELTA, EPS, GL, GU, NRM, OFFD, S, SGNDEF,
     $                   SIGMA, TAU, TMP1, WIDTH
*     ..
*     .. External Functions ..
      DOUBLE PRECISION   DLAMCH
      EXTERNAL           DLAMCH
*     ..
*     .. External Subroutines ..
      EXTERNAL           DCOPY, DLASQ2
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, MIN
*     ..
*     .. Executable Statements ..
*
      INFO = 0
      EPS = DLAMCH( 'Precision' )
*
*     Compute Splitting Points
*
      NSPLIT = 1
      DO 10 I = 1, N - 1
         IF( ABS( E( I ) ).LE.TOL ) THEN
            ISPLIT( NSPLIT ) = I
            NSPLIT = NSPLIT + 1
         END IF
   10 CONTINUE
      ISPLIT( NSPLIT ) = N
*
      IBEGIN = 1
      DO 170 JBLK = 1, NSPLIT
         IEND = ISPLIT( JBLK )
         IF( IBEGIN.EQ.IEND ) THEN
            W( IBEGIN ) = D( IBEGIN )
            WOFF( JBLK ) = ZERO
            IBEGIN = IEND + 1
            GO TO 170
         END IF
         IN = IEND - IBEGIN + 1
*
*        Form the n Gerschgorin intervals
*
         GL = D( IBEGIN ) - ABS( E( IBEGIN ) )
         GU = D( IBEGIN ) + ABS( E( IBEGIN ) )
         GERSCH( 2*IBEGIN-1 ) = GL
         GERSCH( 2*IBEGIN ) = GU
         GERSCH( 2*IEND-1 ) = D( IEND ) - ABS( E( IEND-1 ) )
         GERSCH( 2*IEND ) = D( IEND ) + ABS( E( IEND-1 ) )
         GL = MIN( GERSCH( 2*IEND-1 ), GL )
         GU = MAX( GERSCH( 2*IEND ), GU )
         DO 20 I = IBEGIN + 1, IEND - 1
            OFFD = ABS( E( I-1 ) ) + ABS( E( I ) )
            GERSCH( 2*I-1 ) = D( I ) - OFFD
            GL = MIN( GERSCH( 2*I-1 ), GL )
            GERSCH( 2*I ) = D( I ) + OFFD
            GU = MAX( GERSCH( 2*I ), GU )
   20    CONTINUE
         NRM = MAX( ABS( GL ), ABS( GU ) )
*
*        Find the number SIGMA where the base representation
*        T - sigma I = L D L^T is to be formed.
*
         WIDTH = GU - GL
         DO 30 I = IBEGIN, IEND - 1
            WORK( I ) = E( I )*E( I )
   30    CONTINUE
         DO 50 J = 1, 2
            IF( J.EQ.1 ) THEN
               TAU = GL + FOURTH*WIDTH
            ELSE
               TAU = GU - FOURTH*WIDTH
            END IF
            TMP1 = D( IBEGIN ) - TAU
            IF( TMP1.LT.ZERO ) THEN
               CNT = 1
            ELSE
               CNT = 0
            END IF
            DO 40 I = IBEGIN + 1, IEND
               TMP1 = D( I ) - TAU - WORK( I-1 ) / TMP1
               IF( TMP1.LT.ZERO )
     $            CNT = CNT + 1
   40       CONTINUE
            IF( CNT.EQ.0 ) THEN
               GL = TAU
            ELSE IF( CNT.EQ.IN ) THEN
               GU = TAU
            END IF
            IF( J.EQ.1 ) THEN
               MAXCNT = CNT
               SIGMA = GL
               SGNDEF = ONE
            ELSE
               IF( IN-CNT.GT.MAXCNT ) THEN
                  SIGMA = GU
                  SGNDEF = -ONE
               END IF
            END IF
   50    CONTINUE
*
*        Find the base L D L^T representation
*
         WORK( 3*IN ) = ONE
         DELTA = EPS
         TAU = SGNDEF*NRM
   60    CONTINUE
         SIGMA = SIGMA - DELTA*TAU
         WORK( 1 ) = D( IBEGIN ) - SIGMA
         J = IBEGIN
         DO 70 I = 1, IN - 1
            WORK( 2*IN+I ) = ONE / WORK( 2*I-1 )
            TMP1 = E( J )*WORK( 2*IN+I )
            WORK( 2*I+1 ) = ( D( J+1 )-SIGMA ) - TMP1*E( J )
            WORK( 2*I ) = TMP1
            J = J + 1
   70    CONTINUE
         DO 80 I = IN, 1, -1
            TMP1 = SGNDEF*WORK( 2*I-1 )
            IF( TMP1.LT.ZERO .OR. WORK( 2*IN+I ).EQ.ZERO .OR. .NOT.
     $          ( TMP1.GT.ZERO .OR. TMP1.LT.ONE ) ) THEN
               DELTA = TWO*DELTA
               GO TO 60
            END IF
            J = J - 1
   80    CONTINUE
*
         J = IBEGIN
         D( IBEGIN ) = WORK( 1 )
         WORK( 1 ) = ABS( WORK( 1 ) )
         DO 90 I = 1, IN - 1
            TMP1 = E( J )
            E( J ) = WORK( 2*I )
            WORK( 2*I ) = ABS( TMP1*WORK( 2*I ) )
            J = J + 1
            D( J ) = WORK( 2*I+1 )
            WORK( 2*I+1 ) = ABS( WORK( 2*I+1 ) )
   90    CONTINUE
*
         CALL DLASQ2( IN, WORK, INFO )
*
         TAU = SGNDEF*WORK( IN )
         WORK( 3*IN ) = ONE
         DELTA = TWO*EPS
  100    CONTINUE
         TAU = TAU*( ONE-DELTA )
*
         S = -TAU
         J = IBEGIN
         DO 110 I = 1, IN - 1
            WORK( I ) = D( J ) + S
            WORK( 2*IN+I ) = ONE / WORK( I )
*           WORK( N+I ) = ( E( I ) * D( I ) ) / WORK( I )
            WORK( IN+I ) = ( E( J )*D( J ) )*WORK( 2*IN+I )
            S = S*WORK( IN+I )*E( J ) - TAU
            J = J + 1
  110    CONTINUE
         WORK( IN ) = D( IEND ) + S
*
*        Checking to see if all the diagonal elements of the new
*        L D L^T representation have the same sign
*
         DO 120 I = IN, 1, -1
            TMP1 = SGNDEF*WORK( I )
            IF( TMP1.LT.ZERO .OR. WORK( 2*IN+I ).EQ.ZERO .OR. .NOT.
     $          ( TMP1.GT.ZERO .OR. TMP1.LT.ONE ) ) THEN
               DELTA = TWO*DELTA
               GO TO 100
            END IF
  120    CONTINUE
*
         SIGMA = SIGMA + TAU
         CALL DCOPY( IN, WORK, 1, D( IBEGIN ), 1 )
         CALL DCOPY( IN-1, WORK( IN+1 ), 1, E( IBEGIN ), 1 )
         WOFF( JBLK ) = SIGMA
*
*        Update the n Gerschgorin intervals
*
         DO 130 I = IBEGIN, IEND
            GERSCH( 2*I-1 ) = GERSCH( 2*I-1 ) - SIGMA
            GERSCH( 2*I ) = GERSCH( 2*I ) - SIGMA
  130    CONTINUE
*
*        Compute the eigenvalues of L D L^T.
*
         J = IBEGIN
         DO 140 I = 1, IN - 1
            WORK( 2*I-1 ) = ABS( D( J ) )
            WORK( 2*I ) = E( J )*E( J )*WORK( 2*I-1 )
            J = J + 1
  140    CONTINUE
         WORK( 2*IN-1 ) = ABS( D( IEND ) )
*
         CALL DLASQ2( IN, WORK, INFO )
*
         J = IBEGIN
         IF( SGNDEF.GT.ZERO ) THEN
            DO 150 I = 1, IN
               W( J ) = WORK( IN-I+1 )
               J = J + 1
  150       CONTINUE
         ELSE
            DO 160 I = 1, IN
               W( J ) = -WORK( I )
               J = J + 1
  160       CONTINUE
         END IF
         IBEGIN = IEND + 1
  170 CONTINUE
      M = N
*
      RETURN
*
*     End of DLARRE
*
      END

!  PRECISION - select the basic precision for the computations.
!  We want (roughly) IEEE double precision for most of this, but
!  single precision suffices for the actual grid and observation data.
!  Alter as needed for different architectures.
!
module precision
   integer,parameter::R=kind(1.0)    ! IEEE single precision or similar
   integer,parameter::D=kind(1.0d0)  ! IEEE double precision or similar
end module precision

    module grid_obs
!  GRID_OBS - support for "real" observations.
!  
!  SYNOPSIS
!    use grid_obs
!
!  DESCRIPTION
!    GRID_OBS contains initial support for handling "real" observations.
!    The routines here take input files consisting of one raw_obs datum
!    per record and massage the values into a model_obs datum that contains
!    a subset of the information required for the data assimilation program
!    and also scales the observation values and standard errors accordingly.
!    In addition, GRID_OBS contains the initial implementation of the H
!    operator, which for now calls only a simple linear interpolation routine
!    to interpolate the model state to each observation.  In the future,
!    additional routines will be implemented for nonlinear interpolations.
!
!  TYPES DEFINEED
!    type(raw_obs) - the "raw" observation format (after prepbufr preprocessing)
!    type(model_obs) - a condensed observation format used in the data
!      assimilation code
!    type(ensemble_stat) - statistics on the relevant ensemble solutions
!      interpolated to the observation location
!
!  ROUTINES IMPLEMENTED
!    subroutine obs_init(ofile,expect,nobs,nsol)
!    private subroutine retained(obs,nobs)
!    subroutine h_operator(nsol,nobs,kept)
!    private subroutine linear_interp(obs,n,hx,grid,ensstat)
!    subroutine apply_consistency_check(checktype)
!    subroutine set_observation_types(list,temp_units)
!    pure subroutine get_observation_types(list,num,temp_units)
!    subroutine set_qcm_threshold(q)
!    subroutine linear_interp(idx,nsol,hx,gridname,ensstat,dh)
!    subroutine gridpt_interp(x,ix,iadj,dx)
!    subroutine obs_energy_units(obs,nobs)
!    subroutine copy_from_obs(loc,yobs,hbar,rdiag,nsol,nobs,hx,dh)
!    private subroutine quality_control(obslist,es,nobs,kept,index)
!    subroutine validate(obslist,nobs,info)
!    private subroutine move_to_head(list,nobs,kept,index)
!    subroutine dump_obs(obs,msg,[optval],[raw])
!    pure subroutine kth_obs(k,obs,ierr,bg)
!    pure subroutine obs_count(kept,total)
!    subroutine read_obs_slice(ofile,expect,nobs,obsarray)
!    subroutine write_obs_slice(ofile,tag,south,north,obs,nobs)
!
!  REQUIRED PACKAGES
!    grid_model - in main source directory
!    spectral - in main source directory (for energy scalings)
!    interpolate - in main source directory (for linear interpolations)
!
!  MODIFICATION HISTORY
!  10/30/05 - Fixed "observation" quality control criterion to be the
!    maximum of 6.0 times the background or 6.0 times the observation 
!    standard error.
!  10/25/05 - Modified OBS_CONSISTENCY_CHECK to apply the quality control
!    only to the surface pressure for the time being.
!  10/10/05 - Updates to OBS_CONSISTENCY_CHECK: added the simple covariance
!    inflation (where applicable) to the background and added the "absdiff"
!    check.
!  10/08/05 - Fixes to interpolation algorithm in LINEAR_INTERP and SIGMA_FIXUP;
!     changed threshold in OBS_CONSISTENCY_CHECK from 5 to 6 times the 
!     approporiate standard error.
!  09/27/05 - Altered handling of vertical levels to vary by the interpolated
!     surface pressure of each ensemble member.  Rewrote SIGMA_FIXUP
!     and incorporated new energy unit conversion routines in spectral.f90.
!  08/23/05 - Fixed gridpt_interp to use XY_ADJUST to handle interpolations
!     correctly for patches over the poles.
!  08/07/05 - replaced KD tree with lookup that handles all 3 dimensions;
!     added code to include surface pressure observations in all patches.
!  07/25/05 - added artificial pressure sdev's for synthetic grid observations
!  07/18/05 - added DHX array.
!  06/29/05 - now converts observations to energy units.
!  06/15/05 - added support for interpolating values from a nature grid to
!     the location of each accepted observation.
!  06/02/05 - use z_grd, which is the sigma value computed from the interpolated
!     background surface pressure mean, instead of precomputed sigma from 
!     Gyorgyi's code, which assumed a fixed constant background surface 
!     pressure.
!  03/29/05 - modifications to accommodate new observation consistency checks.
!  02/04/05 - added checks to omit data with quality control marks above
!     a selected threshold (given by qcm_max).
!  01/21/05 - version to handle real data.  Added PHI, LAMBDA, and TIME_DIFF
!     components.  This version uses the background surface pressure to
!     obtain the sigma level of each datum.  However, for the moment,
!     we still use Gyorgyi's precomputed sigma levels.  Eventually,
!     changes will be required to obs_init to substitute the new z_grd
!     variable, which is computed from p_lev and the interpolated
!     background mean of the surface pressure.
!     Also added routines to select the observation types that are assimilated.
!  10/11/04 - initial version.  We assume that all observations are one of
!     the four model dynamical variables: surface pressure, virtual temperature,
!     u- or v-wind components.  Only simple linear interpolation is performed
!     from the model grid space to the observation space.
!
!  AUTHOR
!     Eric Kostelich, kostelich@asu.edu, 480-965-5006.
!
    use grid_model
    use spectral
    use interpolate
    implicit none
    integer,parameter::NUM_OBS_TYPES=4  ! number of different obs types
!-----------
!  Observation data types:
!   raw_obs is the "raw" data format derived from NCEP and other observation
!      files.
!   model_obs is the "processed" data format used in the data assimilation
!      step.  It contains the observation and its standard error in energy
!      units.
!   obs_stat contains statistical information for a given observation that
!      is used in the diagnostics package.
!-----------
!
!  ENSEMBLE_STAT is used to apply the observation consistency checks
!  and to compute the innovations in the Kalman filter.  Extra precision
!  is maintained here.
!
    type ensemble_stat
       real(D)::mean ! interpolated ensemble mean at observation location
       real(D)::sdev ! ensemble standard error (about interpolated mean)
    end type
!
!-----------
!  The RAW_OBS data type is used in the "real fake" datasets and in the
!  "actual" datasets as supplied by NCEP and filtered by Gyorgyi, with the
!  exceptions as noted before.  This observational information is passed
!  to preanalysis, which distributes the relevant subset to each processor 
!  for the data assimilation step.  The meaning of the components is as follows.
!
!  TYP         is an integer number assigned to all observations by NCEP. It
!              tells not only the type of the observed field
!              (e.g., temperature, wind, surface pressure, etc.)
!              but also the type of the instrument that took the
!              observation (e.g. radio-sonde, drop-sonde, aircraft,
!              etc.)
!
!  LEV         is equal to k, if this is the kth observation taken by
!              the same instrument (e.g., a radio-sonde)
!
!  X_grd       observational location in the x-direction in grid point units
!              (e.g. X_grd=15.8 means an observation between grid points
!              15 and 16, but four times closer to 16 than 15.  This field
!              is likely to be omitted in the future, as it can be computed
!              from LAMBDA.
!
!  Y_grd       observational location in the y-direction in grid point units.
!              This field is likely to be omitted in the future, as it can be
!              computed from PHI.
!
!  PHI         The latitude of the observation in degrees (-90 = south pole,
!              90 = north pole)
!
!  LAMBDA      The longitude of the observation in degrees;
!              0 <= LAMBDA < 360.  (0 = Greenwich, 180 = international dateline)
!
!  TIME_DIFF   difference between the actual observation time and the
!              date of the observation file in hours (e.g., when the 00Z
!              observation file is used and the data was taken at 23:30Z,
!              the value of TIME_DIFF is -0.5)
!
!  SIGMA   observational location in the z-direction (vertical
!          direction) in sigma units. Sigma is computed as the ratio
!          between the pressure at the observational location and
!          the surface pressure in the reference field (this field is
!          defined by the background mean in most cases).
!          For the moment, we use this value, instead of Z_grd, in the code;
!          Gyorgyi has precomputed it assuming a background surface pressure
!          of 1010 hPa.  Eventually, this field will be removed.
!
!  P_LEV       The pressure level in hPa; used to compute the sigma level
!              and model vertical coordinate of the observation.
!
!  VALUE       the numerical value of the observation in appropriate units.
!
!  SDEV        standard deviation of the assumed observational error for
!              the given type of observation (dependent on the type of
!              the observed field and the observing instrument)
!
!  QCM         quality control mark, the larger the value the more
!              likely that the observation has quality problem
!
!  CAT         extra information about the observation:
!              0 - surface level (mass report only)
!              1 - mandatory level (upper-air profile reports,
!                  e.g., radiosondes)
!              2 - significant temperature level (upper-air profile reports)
!              3 - winds-by-pressure level (upper-air profile reports)
!              4 - winds-by-height level (uperr-air profile reports)
!              5 - tropopause level (uperr-air profile reports)
!              6 - reports on a single level (e.g., aircraft, satellite wind,
!                  surface wind, precipitable water retrievals, etc.)
!                  [default value]
!              7 - Auxiliary levels generated via interpolation from
!                  spanning levels (upper-air profile reports)
!
!  PRSS        surface pressure in the reference field; this value is
!              used in the calculation of SIGMA
!  GRP         observation group (it may be useful when testing the
!              effects of different observation groups; e.g observations
!              by commercial aircraft)
!              ADPUPA - upper air (RAOB, PIBAL, RECCO, DROPS) reports
!                       RAOB - radio sonde
!                       PIBAL - drifting balloons for wind
!                       RECCO - reonnaissance mission
!                       DROPS - drop sondes
!              AIRCAR - Aicraft Commercial Addressing and Reporting
!                       System (ACARS) automated weather observations
!              AIRCFT - conventional (AIREP and PIREP) and ASDAR aircraft
!                       reports (all reported by the pilots)
!              SATWIND - satellite-derived wind reports
!              PROFLR - wind profiler reports
!              VADWND - VAD (NEXRAD) wind reports
!                       VAD - Velocity Azimuth Display (vertical profile
!                             of wind speed)
!                       NEXRAD - Doppler radar
!              SATEMP - NESDIS POES sounding, retrieval, radiance data
!                       (ATOVS)
!                       TOVS - Tiros N Operational Vertical Sounder
!              ADPSFC - surface land (SYNOPTIC, METAR) reports
!                       SYNOPTIC - surface observations at main synoptic
!                                   times (0Z, 06Z, 12Z, and 18Z)
!                       METAR - hourly surface land reports
!              SFCSHP - surface marine (SHIP, BOUY, C-MAN platform) reports
!              SFCBOG - mean sea-level pressure bogus reports
!              SPSSMI - DMSP SSM/I retrieval products (reprocessed wind
!                       speed, TPW)
!                       SSM - Special Sensor Microwave sounder
!                       (SSM/I is operated by the Air Force)
!              SYNDAT - synthetic tropical cyclone bogus reports
!              ERS1DA - ERS scatterometer data (reprocessed wind speed)
!                       ERS - Earth Remote Sensing (winds over oceans)
!              GOESND - NESDIS GOES sounding, retrieval, radiance data
!              QKSWND - QUICKSCAT scatterometer data (preprocessed wind
!                       speed; winds over ocean)
!
!  PRSS        surface pressure in the reference field; this value is not
!              used in this version
!
!  SID         id of the meteorological station that collected the
!              observation
!
!  FIELD       type of the observed meteorological field, the possible
!              values are:
!              P    - pressure [mb]=[hPa]
!              SP   - humidity [mg/kg]
!              T    - temperature [C]
!              H    - height [m]
!              U    - u component of wind [m/s]
!              V    - v component of wind [m/s]
!              WD   - wind direction [deg]
!              WS   - wind speed [knots]
!              TPW  - total precipitable water [mm]
!              RR   - rain rate [mm/h]
!              PW1  - precipitable water in the layer 1>sigma>0.9 [mm]
!              PW2  - precipitable water in the layer 0.9>sigma>0.7 [mm]
!              PW3  - precipitable water in the layer 0.7>sigma>0.3 [mm]
!              PW4  - precipitable water in the layer 0.3>sigma>0 [mm]
!              CTP  - cloud top pressure [mb]
!              CTT  - cloud top temperature [K]
!              TCC  - total cloud cover [%]
!
    integer,parameter::OBSKIND=R  ! real type of observations
    type raw_obs
       integer::typecode ! Code number for observation type
       integer::lev  ! serial # of obs. at given location
       real(R)::x_grd  ! observational location in x-direction
       real(R)::y_grd  ! observational location in y-direction
       real(R)::lambda  ! longitude grid location in radians
       real(R)::phi  ! latitude grid location in radians 
       real(R)::time_diff  ! drift time in hours
       real(R)::sigma  ! observational location in sigma
       real(OBSKIND)::p_lev ! pressure level in hPa
       real(OBSKIND)::value  ! observed value
       real(OBSKIND)::sdev  ! standard error of the observation
       real(OBSKIND)::qcm  ! quality control mark
       integer::cat  ! extra information about data
       real(OBSKIND)::prss   ! surface pressure
       character(8)::grp  ! observation group (e.g. ADPUPA)
       character(8)::sid  ! station id
       character(4)::field  ! observed meteorological field
    end type raw_obs
!
!  The MODEL_OBS type contains only the subset of the RAW_OBS data that
!  is most applicable to the data assimilation algorithm.  Prior to
!  the main assimilation step, each processor applies a reduction
!  of the components and a rescaling of selected observed values
!  and standard errors.  The LAMBDA and PHI components are copied from
!  those in RAW_OBS, but are not used except for listing in the diagnostics.
!
    type model_obs
       real(R)::x_grd(3)  ! longitude, latitude, and sigma level relative to
                          ! model grid index
       real(R)::lambda  ! longitude grid location in radians
       real(R)::phi  ! latitude grid location in radians 
       real(R)::time_diff ! observation time (relative to analysis time)
       real(OBSKIND)::p_lev  ! pressure level in hPa
       real(OBSKIND)::value  ! observed value, scaled to energy units
       real(OBSKIND)::sdev  ! standard deviation; scaled to energy units
       integer::typ  ! observation variable type (e.g., PRES_TYPE)
       integer::typecode ! code number for obs type (e.g., radiosondes)
       logical::kept  ! true if this obs is retained for the data assimilation
       !!real(D)::bgmean  ! duplicates BGSTAT entries for debugging
       !!real(D)::bgsdev  ! duplicates BGSTAT entries for debugging
    end type model_obs
!
!  Note: ZLEV and SURFPRES, below, could be allocatable arrays that are
!  part of the MODEL_OBS type.  I have elected to make them separate
!  arrays in part to avoid lots of separate heap allocations.
!
!  ZLEV(J,K) holds the interpolated vertical model grid coordinate for the
!  Kth observation using the surface pressure for the Jth ensemble member.
!  In addition, I'm not sure how compilers will treat the allocatable
!  members when the MODEL_OBS array elements are shuffled around as the
!  observations are processed.
!
    real,allocatable,save,private::zlev(:,:)  ! (nsol,nobs)
!
!  SURFPRES(J,K) is the interpolated surface pressure of the Jth ensemble
!  member corresponding to the Kth observation.
!
    real(D),allocatable,save,private::surfpres(:,:)  ! (nsol,nobs)
    private::raw_to_model_obs,quality_control,move_to_head,retained
!----------------------------------------------------------------------------
!  Private module data
!
!  TYPELIST contains all the observation types that we will assimilate
!  (default:  all observation types).  No leading or intervening blanks
!  are permitted in the string.
!
    character(NUM_OBS_TYPES),save,private::typelist='PTUV'
!
!  Units for temperature observations: C=Celsium, K=Kelvin, U=unknown
!  (determine from data).
!
    character,save,private::obs_temperature_units='U'
!
!  SURFHEIGHT holds the height of the model surface in meters.
!  For future use with real obs.
!
    real(D),allocatable,save,private::surfheight(:,:)
!
!  OBSLIST holds all the observations for the current latitude strip.
!
    type(model_obs),allocatable,save,private::obslist(:)
!
!  QCM_MAX gives the threshold for data acceptability; we retain only those
!  observations whose QCM < QCM_MAX.
!
    real(R),save,private::qcm_max=4.0
!
!  TOTAL_OBS_KEPT - the number of input observations whose type is one that
!  is to be assimilated.
!
    integer,save,private::total_obs_kept=0
!
!  HXBACK - set by H_OPERATOR.  The Kth column is H(X), where X is the
!  vector of ensemble background states closest to OBSLIST(K).
!  We retain extra precision here to try to offset cancelation that occurs
!  in the finite differences of the linear interpolation.
!
    real(D),allocatable,save,private::hxback(:,:)  ! (nsol,nobs)
!
!  BGSTAT - set by H_OPERATOR.  The Kth entry contains statistics like
!  the ensemble mean and standard error evaluated at the location of OBSLIST(K).
!
    type(ensemble_stat),allocatable,save,private::bgstat(:)  ! (nobs)
!
!  DHX - set by H_OPERATOR.  The Kth column is H(X(:)) - H(XBAR), where
!  X(:) is the ensemble solution interpolated to the Kth observation.
!  Extra precision is maintained here.
!
    real(D),allocatable,save,private::dhx(:,:)  ! (nsol,nobs)
!
!  Observation consistency checks
!
    integer,parameter,private::NO_CHECK=0,WHITAKER_CHECK=1,OBSERR_CHECK=2, &
       ABSDIFF_CHECK=3
    integer,save,private::consistency_checktype=NO_CHECK
    contains
!----------------------------------------------------------------------------
    subroutine copy_from_obs(loc,yobs,hbar,rdiag,nsol,nobs,hx,dh)
!  COPY_FROM_OBS - copy available observations from global grid to
!     a patch centered at grid location LOC = (ix,iy,iz).
!  NOBS  := on return, the number of available observations.
!  YOBS  := vector of observations
!  HBAR := vector of NOBS entries whose Kth entry is the Kth component of
!     H(xbar), where xbar is the ensemble mean over the patch.
!  RDIAG := vector whose Kth entry is R(K,K) (R is assumed diagonal).
!  NOBS := number of observations in the patch.
!  NSOL : number of ensemble solutions.
!  HX := If present, NSOL x NOBS matrix whose Kth column contains
!     H(x) for the Kth ensemble solution.  
!  DH := if present, (J,K)th element is the difference between H(x(j)) and
!     the mean of H(x) over the ensemble for the Kth observation.  DH is
!     the transpose of the matrix EB in Brian's writeup (and in Eq. A-22 of 
!     Szunyogh et al).
!  Note 1: The order in which variables are copied into YOBS must match
!  the ordering in copy_from_grid.
!  Note 2: We include the surface pressure in each vertical analysis.
!
    type(patch_index),intent(in)::loc
    real(D),allocatable,intent(out)::yobs(:),hbar(:),rdiag(:)
    real(D),allocatable,intent(out),optional::hx(:,:),dh(:,:)
    integer,intent(in)::nsol
    integer,intent(out)::nobs
!
!  Local variables
!
    integer::k,zlow,zhigh,xwin,ywin,idx,nobs2
    type(patch_index)::low,high
    type(obsinfo),allocatable::found(:),found2(:)
    logical::debug_dump
!
!  First look at the patch consisting of XWIN latitudes on either side of LOC.
!
    call patch_radius(loc,xwin,ywin)
    call zdiam(loc,zlow,zhigh)
    low%x=loc%x-xwin
    if(low%x.lt.0) low%x=low%x+LONF  ! wrap at 0 degrees
    low%y=max(loc%y-ywin,1)  ! no further south than the South Pole
    low%z=zlow
    high%x=loc%x+xwin
    if(high%x.gt.LONF) high%x=high%x-LONF
    high%y=min(loc%y+ywin,LATG)  ! no further north than the North Pole
    high%z=zhigh
    call search(low,high,found,nobs)
!
!  Include any surface pressure observations in the geographical region if
!  the patch doesn't otherwise include the surface.
!
    if(zlow.gt.1) then
       low%z=1  ! we assume surface pressure is at level 1 always
       high%z=1
       call search(low,high,found2,nobs2,(/PRES_TYPE/))  ! pressure obs only
       if(nobs2.gt.0) then  ! append to existing list
          call enlarge(found,nobs+nobs2)
          found(nobs+1:nobs+nobs2)=found2(1:nobs2)
          nobs=nobs+nobs2
       endif
    endif
!
!  Next check whether this patch extends over one of the poles.  If so, then
!  search the corresponding patch 180 degrees opposite.
!
    if(loc%y-ywin.lt.1.or.loc%y+ywin.gt.LATG) then  ! go across the pole
       low%x=low%x+LONF/2
       if(low%x.gt.LONF) low%x=low%x-LONF
       high%x=high%x+LONF/2
       if(high%x.gt.LONF) high%x=high%x-LONF
       low%z=zlow  ! in case we changed it looking for pressure obs
       high%z=zhigh
       if(loc%y-ywin.lt.1) then  ! narrower strip bordering appropriate pole
          low%y=1
          high%y=1-(loc%y-ywin)
       else
          high%y=LATG
          low%y=2*LATG-(loc%y+ywin)+1
       endif
       call search(low,high,found2,nobs2) 
       if(nobs2.gt.0) then  ! append to existing list
          call enlarge(found,nobs+nobs2)
          found(nobs+1:nobs+nobs2)=found2(1:nobs2)
          nobs=nobs+nobs2
       endif
!
!  Include any surface pressure obs on the opposite side of the pole.
!
       if(zlow.gt.1) then
          low%z=1
          high%z=1
          call search(low,high,found2,nobs2,(/PRES_TYPE/))
          if(nobs2.gt.0) then  ! append to existing list
             call enlarge(found,nobs+nobs2)
             found(nobs+1:nobs+nobs2)=found2(1:nobs2)
             nobs=nobs+nobs2
          endif
       endif
    endif
!
    if(nobs.eq.0) return
!
    allocate(yobs(nobs),hbar(nobs),rdiag(nobs))
    debug_dump=loc.eq.dump_loc
    if(debug_dump) open(DUMPUNIT,file='yobs.dump',status='replace')
    do k=1,nobs
       idx=found(k)%index
       yobs(k)=obslist(idx)%value
       rdiag(k)=obslist(idx)%sdev**2
       hbar(k)=bgstat(idx)%mean
       if(debug_dump) &
          write(DUMPUNIT,500) typelist(obslist(idx)%typ:obslist(idx)%typ), &
             obslist(idx)%x_grd,yobs(k),rdiag(k),found(k)%index
    enddo
500 format(a,1x,3f7.1,2es13.5,i6)
    if(debug_dump) close(DUMPUNIT)
    if(present(hx)) then
       allocate(hx(nsol,nobs))
       do k=1,nobs
          hx(:,k)=hxback(:,found(k)%index)
       enddo
    endif
    if(present(dh)) then
       allocate(dh(nsol,nobs))
       do k=1,nobs
          dh(:,k)=dhx(:,found(k)%index)
       enddo
    endif
    return
    end subroutine copy_from_obs
!----------------------------------------------------------------------------
    subroutine obs_init(ofile,expect,nobs,nsol)
!  OBS_INIT - read the observations, apply quality controls, and compute H.
!  OFILE  : name of observation file 
!  EXPECT : header to expect in ofile; 'none' if none.
!  NOBS  := number of observations that are retained and that pass 
!     applicable consistency checks.
!  NSOL  : number of ensemble solutions.
!  Side effects:
!  - reads and allocates OBSLIST and heaps it into a KD tree
!  - Precomputes H(x) for each observation Y by allocating and initializing
!    HXBACK and HXBAR.
!  Note: SET_OBSERVATION_TYPE must have been called first.
!
    character(*),intent(in)::ofile,expect
    integer,intent(out)::nobs
    integer,intent(in)::nsol
!
!  Local variables
!
    integer::j,info,kept,nobs_in
    type(obsinfo),allocatable::klist(:)
    type(raw_obs),allocatable::rawobs(:)
    type(model_obs),allocatable::obslist_temp(:)
    real::z(nsol)
    real(D)::pinterp(nsol)
    real,allocatable::zlev_temp(:,:)
    real(D),allocatable::surfpres_temp(:,:)
    logical::keep
!
!  NOTE:  The order in which the steps are performed is important, as the
!  various routines allocate and update the observation arrays and related
!  data.  Alter the order of the calls at your own risk!
!--------
!  Step 1.
!  Initialize OBSLIST with selected fields from the raw_obs input array
!  corresponding ONLY to those observations that we have decided to assimilate.
!
    call read_obs_slice(ofile,expect,nobs,rawobs)
    call raw_to_model_obs(obslist_temp,rawobs,nobs)
    deallocate(rawobs)
    nobs_in=nobs
!
!  Step 2.  Validate the observation values.  If any observation flunks this
!  validation test, then the program exits here.
!
    call validate(obslist_temp,nobs,info)
    if(info.ne.0) then
       write(IERR,100) j,info
       call fexit('obs_init: bad observation',1)
    endif
100 format('obs_init: bad observation :',i8,' info: ',i3)
!
!  Step 3.  Apply the conversion to energy units to match the units used in
!  the model grid.
!
    call obs_energy_units(obslist_temp,nobs)
!
!  Step 4A.  Obtain (x,y,z) model grid coords from the (lambda,phi,sigma)
!  entries and the background mean.
!
    where(obslist_temp(1:nobs)%kept) &
       obslist_temp(1:nobs)%kept=obslist_temp(1:nobs)%x_grd(3).ge.1.0.and. &
          obslist_temp(1:nobs)%x_grd(3).le.LEVS
    call move_to_head(obslist_temp,nobs,kept)
    nobs=kept
!
!  Step 4B.  Scale the vertical coordinate of each observation relative to
!  the surface pressure of each ensemble member.  KEEP is TRUE if the
!  vertical level associated with each ensemble member is between 1 and LEVS.
!  Note: the model surface pressure is in ln(dPa).
!
    allocate(zlev_temp(nsol,nobs),surfpres_temp(nsol,nobs))
    kept=0
    do j=1,nobs
       call sigma_fixup(obslist_temp(j),z,pinterp,nsol,keep)
       if(keep) then
          kept=kept+1
          obslist_temp(kept)=obslist_temp(j)
          zlev_temp(:,kept)=z
          surfpres_temp(:,kept)=pinterp
       endif
    enddo
    nobs=kept
    total_obs_kept=nobs  ! module variable
    write(LOGFILE,111) kept
111 format(i8,' observations retained with 1 <= sigma <= LEVS')
    call retained(obslist_temp,nobs)
!
!  Step 5.  Allocate the final observation list.
!  OBSLIST holds only those observations of the type that we will assimilate
!  and for which 1 <= sigma <= LEVS.  All other arrays related to grid model
!  interpolation are expected to be the same size as OBSLIST.
!  Life is MUCH easier if we allocate all the module arrays to be the
!  same size, so order the allocations to try to minimize holes in the heap.
!
    allocate(hxback(nsol,total_obs_kept),bgstat(total_obs_kept), &
       dhx(nsol,total_obs_kept))
    allocate(obslist(total_obs_kept))
    obslist=obslist_temp(1:total_obs_kept)
    deallocate(obslist_temp)
!
    allocate(zlev(nsol,total_obs_kept))
    zlev=zlev_temp(:,1:total_obs_kept)
    deallocate(zlev_temp)
!
    allocate(surfpres(nsol,total_obs_kept))
    surfpres=surfpres_temp(:,1:total_obs_kept)
    deallocate(surfpres_temp)
!
!  Step 5.
!  Precompute H(x) for x=background mean and x=individual ensemble members.
!  This procedure also fills in the sigma level for each observation
!  using the background mean.  H_OPERATOR also computes the interpolated
!  ensemble mean and standard error at each observation location and applies
!  observation consistency checks if requested.
!
    nobs=total_obs_kept
    call h_operator(nsol,nobs,kept)
    call retained(obslist,kept)
    nobs=kept
    total_obs_kept=nobs  ! module variable
!
!  Step 6.
!  Make the obslist into a KD tree using longitude and vertical coordinates.
!  Use the OBSINFO constructor to ensure that all components of KLIST are
!  initialized.
!
    write(LOGFILE,120) (100.0*total_obs_kept)/nobs_in
120 format(f8.2,' percent obs retention fraction')
    allocate(klist(total_obs_kept))
    do j=1,total_obs_kept
       klist(j)=obsinfo(obslist(j)%x_grd,j,obslist(j)%typ)
    enddo
    call build_kdtree(klist,total_obs_kept)
    return
    end subroutine obs_init
!----------------------------------------------------------------------------
    subroutine retained(obs,nobs)
!  RETAINED - report the number of observations by type.
!
    integer,intent(in)::nobs
    type(model_obs),intent(in)::obs(nobs)
!
    integer::j,obscount(NUM_OBS_TYPES)
!
    obscount=0
    do j=1,nobs
       obscount(obs(j)%typ)=obscount(obs(j)%typ)+1
    enddo
    write(LOGFILE,100) (TYPEOF(j),obscount(j),j=1,size(obscount))
100 format(9x,'retained observations by type'/9x,'type',3x,'count'/ &
       (9x,a1,3x,i8))
    return
    end subroutine retained
!----------------------------------------------------------------------------
    subroutine sigma_fixup(obs,z,pinterp,nsol,keep)
!  SIGMA_FIXUP - compute the appropriate vertical level of the observation 
!  relative to the interpolated surface pressure of each ensemble member.
!  For observations other than surface pressure:
!  sigma is determined based on the P_LEV value and the background mean
!  of the surface pressure (using linear interpolation from the model grid
!  to the observation location).  Z is determined by interpolating
!  the value of sigma so obtained with the fixed list of sigma levels
!  in resolution.f90.
!  NOTE: The observations and the background MUST be in consistent units
!  *before* this routine is called!
!  We discard observations whose Z value is outside the interval [1,LEVS].
!  OBS :=: the current observation (model_obs format).  The Z component
!     of the position is adjusted to 1 if the obs is surface pressure.
!  Z  := the interpolated observation height for each ensemble member
!  PINTERP := the interpolated surface pressure for each ensemble member
!  NSOL : number of ensemble solutions
!  KEEP := set to "true" if all the Z's are between 1 and LEVS.
!
    type(model_obs),intent(inout)::obs
    integer,intent(in)::nsol
    real,intent(out)::z(nsol)
    real(D),intent(out)::pinterp(nsol)
    logical,intent(out)::keep
!
!  Local variables
!
    real::x(3),dx(3),sigma(nsol),plev,ppa(nsol)
    real(D)::base(nsol),de(nsol,3),mu(0:2)
    type(patch_index)::loc,ix,iadj
    integer::j
!
    if(obs%p_lev.le.0.0) call fabort('sigma_fixup: obs p_lev <= 0')
!
!  Surface pressure observations don't have the Z coordinate defined.
!  We'll supply a value of 1.0 for our purposes.
!
    if(obs%typ.eq.PRES_TYPE) obs%x_grd(3)=1.0
!
!  Find the nearest integer-valued horizontal model grid indices that contain
!  the observation, accounting for the longitude wrap at LONF
!  (which is congruent to 0).
!
    x=obs%x_grd
    call gridpt_interp(x,ix,iadj,dx)
!
!  Interpolate the background surface pressure mean at X(1:2).
!  First the base point...
!
    loc=patch_index(ix%x,ix%y,1)
    call copy_grid_point(loc,base,PRES_TYPE,'background')
    if(ensemble_diffs_precomputed()) &
       call copy_grid_point(loc,mu(0:0),PRES_TYPE,'bmean')
!
!  ... then the nearest adjoining point to the north or south...
!  (making sure that the second index of DE matches DX!)
!
    loc=patch_index(ix%x,iadj%y,1)
    call copy_grid_point(loc,de(:,2),PRES_TYPE,'background')
    if(ensemble_diffs_precomputed()) &
       call copy_grid_point(loc,mu(2:2),PRES_TYPE,'bmean')
!
!  ... then the nearest adjoining point to the east or west.
!
    loc=patch_index(iadj%x,ix%y,1)
    call copy_grid_point(loc,de(:,1),PRES_TYPE,'background')
    if(ensemble_diffs_precomputed()) &
       call copy_grid_point(loc,mu(1:1),PRES_TYPE,'bmean')
!
!  Linearly interpolate between the adjoining points using the finite
!  difference approximation of the gradient vector.  Add back the
!  ensemble mean when the latter is precomputed, because we need the
!  interpolated surface pressure for each ensemble member.
!
    pinterp=base+dx(1)*(de(:,1)-base)+dx(2)*(de(:,2)-base)
    if(ensemble_diffs_precomputed()) &  ! interpolate respective means
       pinterp=pinterp+(mu(0)+dx(1)*(mu(1)-mu(0))+dx(2)*(mu(2)-mu(0)))
!
!  The p_lev pressure level measurement must be scaled in the same way as
!  the background surface pressure.  Here we assume energy units.
!
    if(obs%typ.eq.PRES_TYPE) then  ! model Z value is 1
       z=1.0
       keep=.true.
    else
       ppa=real(10.0*exp(energy_to_pres(pinterp)),kind(ppa))  ! to hPa
       sigma=real(obs%p_lev/ppa,kind(sigma))
       do j=1,nsol
          z(j)=index_interp(sigma(j),SIGMA_LEV,LEVS)
       enddo
       keep=all(z.ge.1.0.and.z.le.LEVS)
    endif
    return
    end subroutine sigma_fixup
!----------------------------------------------------------------------------
    subroutine h_operator(nsol,nobs,kept)
!  H_OPERATOR - implement the H operator that maps the model space to
!  the observation space.  In this version, we call it once at startup
!  to interpolate to each of the available observations.
!  For now, we do a linear interpolation of each observation to the
!  model grid.  (In the future, other interpolations might be done depending
!  on the variable type.)  In addition, we apply any requested data
!  consistency checks.
!  Arguments:
!  NSOL : number of ensemble solutions
!  NOBS : the number of entries in OBSLIST.
!  KEPT := the number of observations that are retained (e.g., which pass
!    any applicable internal consistency checks)
!
!  Side effects:
!  HXBACK := Kth col holds interpolated model grid values at the obs location
!    (i.e., H(x)) for each of the NSOL ensemble solutions corresponding to 
!    the observation type (e.g., the NSOL interpolated values of the
!    temperature if the Kth obs is a temperature observation).
!  DHX := Kth column is H(x(k))-H(xbar) at Kth obs location
!  BGSTAT := Kth entry is interpolated ensemble mean and std error at 
!    the location of the Kth obs.
!
!  Note:  Any scaling to the observations and model variables 
!  MUST have already been performed!
!
    integer,intent(in)::nsol,nobs
    integer,intent(out)::kept
!
!  Local variables
!
    integer::k
!
    if(nobs.eq.0) return
    do k=1,nobs
       call linear_interp(k,nsol,hxback(:,k),'background',bgstat(k),dhx(:,k))
    enddo
    if(consistency_checktype.eq.NO_CHECK) then
       kept=nobs
    else
       call quality_control(obslist,bgstat,nobs,kept)
    endif
    return
    end subroutine h_operator
!----------------------------------------------------------------------------
    subroutine linear_interp(idx,n,hx,gridname,ensstat,dh)
!  LINEAR_INTERP - interpolate the model grid to the model_obs OBS
!  by linear interpolation from the nearest model grid points.
!  IDX  : index of the observation (MODEL_OBS format)
!  N  : number of ensemble solutions, either ENSEMBLE_SIZE() or 1.
!     In the latter case, we assume interpolation using the ensemble mean.
!     Otherwise, iwe work with all the individual ensemble solutions.
!  HX := interpolated model grid values at the observation location (i.e., H(x))
!    for each of the N ensemble solutions corresponding to the observation
!    type (e.g., the N interpolated values of the temperature if OBS is
!    a temperature observation).
!  GRIDNAME : which model grid: 'background', 'analysis', or 'nature'.
!  ENSSTAT := Holds ensemble mean and standard error at the interpolated 
!    point corresponding to the observation (with the same scaling as applied
!    to the rest of the observations).
!  DH := if present, Kth entry is the the difference between H(x(k)) and
!    the mean of the H's, where x(k) is the kth ensemble solution.
!
    integer,intent(in)::idx,n
    real(D),intent(out)::hx(n)
    character(*),intent(in)::gridname
    type(ensemble_stat),intent(out),optional::ensstat
    real(D),intent(out),optional::dh(n)
!
!  Local variables
!
    type(model_obs)::obs
    real(D)::base(n),dg(n,3),mu(n,0:3),dmu(n),dz(n)
    type(patch_index)::ix,iadj,loc
    real(kind(obs%x_grd))::x(3),dx(3)
    integer::j,iz(n),iadz(n)
    character(5)::themean
!
!  Ensure that this is a variable type that we know how to handle.
!  For now this is 1, 2, 3, or 4 - see grid_types for labeling.
!
    if(idx.lt.1.or.idx.gt.size(obslist)) &  ! was total_obs_kept
       call fabort('linear_interp: obs index out of range')
    if(n.ne.1.and.n.ne.ensemble_size()) &
       call fabort('linear_interp: bad solution count')
    obs=obslist(idx)
    if(obs%typ.lt.1.or.obs%typ.gt.NAVARS) &
       call fabort('linear_interp: unknown obs type')
!
!  Special case:  Surface pressure and background grid.
!  We've already done the required interpolations when we
!  computed the observation height in SIGMA_FIXUP.
!
    if(obs%typ.eq.PRES_TYPE.and.gridname(1:1).eq.'b') then  ! background
       if(n.eq.1) then  ! ensemble mean
          hx(1)=sum(surfpres(:,idx))/ensemble_size()
       else
          hx=surfpres(:,idx)  ! previously interpolated background
       endif
       call ensstat_and_dh
       return
    endif
!
!  Otherwise we have a measurement that we need to interpolate according
!  to the vertical height of the observation (except for the surface pressure).
!  The height in turn depends on the surface pressure in each ensemble member
!  (except for surface pressure, for which z=1 identically).
!
    x(1:2)=obs%x_grd(1:2)  ! longitude and latitude only
    do j=1,n
       x(3)=merge(1.0,zlev(j,idx),obs%typ.eq.PRES_TYPE)
       call gridpt_interp(x,ix,iadj,dx)  ! find adjacent model grid points
       iz(j)=ix%z    ! save the varying vertical coordinate
       iadz(j)=iadj%z  ! and that of the opposite grid point
       dz(j)=abs(dx(3))
    enddo
    loc=ix  ! for the longitude and latitude indices
!
!  Interpolate the ensemble solutions.  First the base point...
!
    themean=gridname(1:1)//'mean'
    call copy_grid_z(loc,iz,base,obs%typ,gridname)
    if(n.gt.1.and.ensemble_diffs_precomputed(gridname)) &
       call copy_grid_z(loc,iz,mu(:,0),obs%typ,themean)
!
!  ...then the point to the north or south of the base point...
!  (to make this part of the code more cache-friendly - but ensure
!  that the subscripting of DG and MU is compatible with DX!)
!
    loc=patch_index(ix%x,iadj%y,ix%z)
    call copy_grid_z(loc,iz,dg(:,2),obs%typ,gridname)
    if(n.gt.1.and.ensemble_diffs_precomputed(gridname)) &
       call copy_grid_z(loc,iz,mu(:,2),obs%typ,themean)
    dg(:,2)=dg(:,2)-base
!
!  ...then the point above or below as appropriate...
!  (to make this part of the code more cache-friendly)
!
    if(obs%typ.ne.PRES_TYPE) then
       loc=ix
       call copy_grid_z(loc,iadz,dg(:,3),obs%typ,gridname)
       if(n.gt.1.and.ensemble_diffs_precomputed(gridname)) &
          call copy_grid_z(loc,iadz,mu(:,3),obs%typ,themean)
       dg(:,3)=dg(:,3)-base
    endif
!
!  ...and finally the point to the east or west.
!
    loc=patch_index(iadj%x,ix%y,ix%z)
    call copy_grid_z(loc,iz,dg(:,1),obs%typ,gridname)
    if(n.gt.1.and.ensemble_diffs_precomputed(gridname)) &
       call copy_grid_z(loc,iz,mu(:,1),obs%typ,themean)
    dg(:,1)=dg(:,1)-base
!
!  Linear interpolation.  The longitude and latitude
!  components are constant for all ensemble members; the last term
!  completes the interpolation in the vertical direction for non-pressure obs.
!
    hx=base+dg(:,1)*dx(1)+dg(:,2)*dx(2)
    if(obs%typ.ne.PRES_TYPE) hx=hx+dg(:,3)*dz
!
!  If N=1 then we're already interpolating the background or analysis
!  mean, presumably.  Otherwise add back the interpolated
!  mean when the ensemble differences are precomputed.
!  The update is mu(0) + (mu(1)-mu(0))*dx(1) + (mu(2)-mu(0))*dx(2) +
!  (mu(3)-mu(0))*dz; the latter term includes all individual
!  vertical displacements.
!
    if(n.gt.1.and.ensemble_diffs_precomputed(gridname)) then
       dmu=1.0-dx(1)-dx(2)-dz
       hx=hx+mu(:,0)*dmu+mu(:,1)*dx(1)+mu(:,2)*dx(2)
       if(obs%typ.ne.PRES_TYPE) hx=hx+mu(:,3)*dz
    endif
    call ensstat_and_dh
    return
!
!  If requested, compute statistics about the observation and the model
!  grid at the corresponding location.
!
    contains
       subroutine ensstat_and_dh
       real(D)::emean,ediff(n)
!
       if(present(ensstat).or.present(dh)) then
          emean=sum(hx)/ensemble_size()
          ediff=hx-emean
          !!obslist(idx)%bgmean=emean  !debug
          !!obslist(idx)%bgsdev=sqrt(dot_product(ediff,ediff)/n)  !debug
       endif
       if(present(dh)) dh=ediff
       if(present(ensstat)) then
          ensstat%mean=emean
          ensstat%sdev=sqrt(dot_product(ediff,ediff)/n)
       endif
       return
       end subroutine ensstat_and_dh
    end subroutine linear_interp
!----------------------------------------------------------------------------
    subroutine apply_consistency_check(checktype)
!  APPLY_CONSISTENCY_CHECK - argument determines which type of observation
!  consistency check to apply to the data.
!
    character(*),intent(in)::checktype
!
    select case(checktype)
    case('Whitaker','whitaker')
       consistency_checktype=WHITAKER_CHECK
    case('observation','obs','Observation','Obs')
       consistency_checktype=OBSERR_CHECK
    case('absdiff')
       consistency_checktype=ABSDIFF_CHECK
    case('none')
       consistency_checktype=NO_CHECK
    case default
       call fabort('apply_consistency_check: unknown check type ' &
          //trim(checktype))
    endselect
    write(LOGFILE,100) trim(checktype)
100 format('observation consistency check: ',a)
    return
    end subroutine apply_consistency_check
!----------------------------------------------------------------------------
    subroutine set_observation_types(list,temp_units)
!  SET_OBSERVATION_TYPES - determine which observation types will be
!  assimilated.
!  The current procedure uses single-letter variable names; later we'll have
!  to devise another convention.  For now, they are:
!  'P' or 'p' for surface pressure;
!  'T' or 't' for virtual temperature;
!  'U' or 'u' for u-wind components;
!  'V' or 'v' for v-wind components.
!  TEMP_UNITS is either 'C' or 'K' for observations in Celsius or Kelvin,
!     respectively.
!
    character(*),intent(in),optional::list
    character(*),intent(in),optional::temp_units
!
    integer::j,n
!
    if(present(list)) then
       n=0
       typelist=' '  ! clear all previous entries
       do j=1,min(len(typelist),len(list))
          select case(list(j:j))
          case('P','p')
             n=n+1
             typelist(n:n)='P'
          case('T','t')
             n=n+1
             typelist(n:n)='T'
          case('U','u')
             n=n+1
             typelist(n:n)='U'
          case('V','v')
             n=n+1
             typelist(n:n)='V'
          endselect
       enddo
    endif
    if(present(temp_units)) then
       if(index('CKU',temp_units(1:1)).gt.0) then
          obs_temperature_units=temp_units(1:1)
       else
          call fexit('set_observation_types: unknown temp_units value: '// &
             temp_units,2)
       endif
    endif
    return
    end subroutine set_observation_types
!----------------------------------------------------------------------------
    pure subroutine get_observation_types(list,num,temp_units)
!  GET_OBSERVATION_TYPES - obtain the number and type of the observations
!  that are being assimilated.
!  NUM  - if present, the number of observation types that are assimilated.
!  LIST - if present, a character string of length NUM_OBS_TYPES whose first
!  NUM entries on return contain a list of the observation types being
!  assimilated.
!  TEMP_UNITS - if present, either set to 'C' or 'K' for Celsius or Kelvin,
!     respectively,
!
    integer,intent(out),optional::num
    character(*),intent(out),optional::list,temp_units
!
    if(present(num)) num=len_trim(typelist)
    if(present(list)) list=typelist
    if(present(temp_units)) temp_units=obs_temperature_units
    return
    end subroutine get_observation_types
!----------------------------------------------------------------------------
    subroutine set_qcm_threshold(q)
!  SET_QCM_THRESHOLD - set the QCM_MAX threshold past which we omit data.
!
    real,intent(in)::q
!
    if(q.le.1.0) call fexit('set_qcm_threshold: bad value',2)
    qcm_max=q
    return
    end subroutine set_qcm_threshold
!----------------------------------------------------------------------------
    subroutine raw_to_model_obs(mdlobs,raw,nobs)
!  RAW_TO_MODEL_OBS - For each of the observation types that we will assimilate,
!  copy a subset of the raw_obs components to the model_obs.
!  Filter the data according to quality control mark and omit those observations
!  whose QCM >= QCM_MAX.
!  Note 1: NO SCALING is applied here; VALIDATE, below, should be
!  called to check for sensible observation values and to apply any scaling
!  consistent with the model grid.
!  Note 2: The sigma level of the observation is obtained from the P_LEV
!  and PRSS members of RAW.  We discard observations whose model Z valud is
!  less than 1 or greater than LEVS.
!  NOBS :=: On entry, the number of observations in RAW.  On return,
!     the number of observations of the types that we will assimilate,
!     which is also the allocated size of MDLOBS.
!
    integer,intent(inout)::nobs
    type(model_obs),allocatable,intent(out)::mdlobs(:)
    type(raw_obs),intent(in)::raw(nobs)
!
    integer::j,n,obscount(NUM_OBS_TYPES)
    logical::kept(nobs)
    character(4)::field
    character(NUM_OBS_TYPES)::list
    real::sigma
!
!  Count and flag the observations that are of a type that we will
!  assimilate.  Also retain only those observations whose quality control
!  marks are sufficiently low.
!
    do j=1,nobs
       field=adjustl(raw(j)%field)
       kept(j)=index(typelist,field(1:1)).ne.0.and.raw(j)%qcm.lt.qcm_max
    enddo
    n=count(kept)
    allocate(mdlobs(n))
!
!  This version handles synthetic data only.  Eventually we will alter
!  the handling of the PRSS field.  For the moment, we obtain the vertical
!  level of the observation from the SIGMA field of the raw observation.
!
    n=0
    obscount=0
    do j=1,nobs
       if(.not.kept(j)) cycle
       n=n+1
       mdlobs(n)%x_grd(1)=xgrid(raw(j)%lambda)
       mdlobs(n)%x_grd(2)=ygrid(raw(j)%phi)
       mdlobs(n)%x_grd(3)=raw(j)%sigma
       mdlobs(n)%lambda=raw(j)%lambda
       mdlobs(n)%phi=raw(j)%phi
       mdlobs(n)%time_diff=raw(j)%time_diff
       mdlobs(n)%p_lev=raw(j)%p_lev
       mdlobs(n)%value=raw(j)%value
       mdlobs(n)%sdev=raw(j)%sdev
       mdlobs(n)%typecode=raw(j)%typecode  ! code number for observation type
       mdlobs(n)%kept=.true.  ! unless it fails a later consistency check
       field=adjustl(raw(j)%field)
       select case(field)  ! which must appear in TYPELIST
       case('P')
          mdlobs(n)%typ=PRES_TYPE
       case('T')
          mdlobs(n)%typ=TEMP_TYPE
       case('U')
          mdlobs(n)%typ=UWIND_TYPE
       case('V')
          mdlobs(n)%typ=VWIND_TYPE
       endselect
       obscount(mdlobs(n)%typ)=obscount(mdlobs(n)%typ)+1
    enddo
    call get_observation_types(list)
    write(LOGFILE,100) list
100 format('raw_to_model_obs: Observation types assimilated: ',a)
    write(LOGFILE,101) qcm_max
101 format('observation quality control threshold:',f5.1)
    write(LOGFILE,102) nobs,'observations in data file'
102 format(i8,1x,a)
    write(LOGFILE,102) n,'obs retained based on type and quality control'
    nobs=n
    call retained(mdlobs,nobs)
    return
    end subroutine raw_to_model_obs
!----------------------------------------------------------------------------
    subroutine gridpt_interp(x,ix,iadj,dx)
!  GRIDPT_INTERP - given an observation at location X(1:3), which is a
!  floating-point number relative to the model grid units, find the nearest
!  point IX on the model grid (i.e., integer coordinates) and the next
!  closest adjoining model grid point.
!  X  : the (x,y,z) coordinates of the point (as a 3-vector)
!  IX  := PATCH_INDEX (integer) coordinates of the nearest corner point
!  IADJ := PATCH_INDEX (integer) coordinates of the opposite corner to IX.
!  DX  := a 3-vector giving the |X-IX| (pointwise *distances*)
!  Note 1:  We cannot yet handle the case where X(3) < 1; if we get a vertical
!  coordinate that lies "below" the first model level, we abort.
!  Note 2:  If an observation is above the top level of the model atmosphere,
!  then treat it as though it were exactly at the top of the atmosphere.
!
    real,intent(in)::x(3)
    type(patch_index),intent(out)::ix,iadj
    real,intent(out)::dx(3)
!
!  IX is the nearest integer grid point.
!
    ix=patch_index(nint(x(1)),nint(x(2)),nint(x(3)))
    dx=(/x(1)-ix%x,x(2)-ix%y,x(3)-ix%z/)
    call xy_adjust(ix,0,0,iadj)  ! handle longitude wrap if necessary
    ix=iadj
!
!  Project obs above top of model atmosphere onto the top.
!
    if(x(3).gt.LEVS) then 
       ix%z=LEVS
       dx(3)=0.0
    endif
!
!  Find the opposite corner of the smallest enclosing box, handling regions
!  over the poles and straddling the 0-degree longitude line as needed.
!
    call xy_adjust(ix,signum(dx(1)),signum(dx(2)),iadj)
    iadj%z=min(max(ix%z+signum(dx(3)),1),LEVS)
    dx=abs(dx) ! convert to distances
    return
    end subroutine gridpt_interp
!----------------------------------------------------------------------------
    subroutine quality_control(obslist,es,nobs,kept)
!  QUALITY_CONTROL - Retain only those observations for which
!  the interpolated ensemble mean is sufficiently close to the 
!  observation value.
!
!  The Whitaker criterion requires that the obs value and the background
!  mean lie within 5 ensemble standard deviations of each other when the
!  background ensemble grid is interpolated to the observation location.
!  The "obserr" criterion is similar but the obs value and mean must lie
!  with 6 times the maximum of either the obs std error or the ensemble std err.
!  The "absdiff" criterion is like the obserr criterion except that
!  the threshold is further expanded to be the larger of the 0.1 * observation
!  absolute value or the obserr threshold.
!  NOBS  :  the number of available observations.
!  OBSLIST :=: On entry, the list of observations.  On return, the KEPT field
!    is updated to reflect whether the Kth observation should be retained.
!    On return the first KEPT entries are the retained observations and
!    the remainder are not used in the data assimilation.
!  ES  :=:  On entry, Kth entry is to the interpolated ensemble mean
!     and standard error corresponding to the Kth input observation.
!     On return, entries are shuffled to match OBSLIST.  
!  KEPT := scalar giving the total number of retained observations.
!  NOTE: Take care that both the ensemble and the observation variables
!  are scaled consistently!
!
!  Side effects:
!    Shuffles HXBACK, ES, DHX, ZLEV, and SURFPRES so that their Kth
!    entries correspond to the Kth entry of OBSLIST.
!
    integer,intent(in)::nobs
    integer,intent(out)::kept
    type(model_obs),intent(inout)::obslist(nobs)
    type(ensemble_stat),intent(inout)::es(nobs)
!
!  Local variables
!
    real(OBSKIND)::threshold
    type(inflation_info)::infl
    type(patch_index)::loc
    integer::j,ix(3),vars(NAVARS),index(nobs)
!
    if(consistency_checktype.eq.NO_CHECK) return
!
    do j=1,nobs
       threshold=6.0*es(j)%sdev
       ix=nint(obslist(j)%x_grd)
       loc=patch_index(ix(1),ix(2),ix(3))
       call inflation(loc,infl,vars)
       if(any(vars.eq.obslist(j)%typ)) threshold=threshold*(1.0+infl%covar)
       if(consistency_checktype.ne.WHITAKER_CHECK) then
          threshold=max(threshold,real(6.0*obslist(j)%sdev,kind(threshold)))
       else if(consistency_checktype.eq.ABSDIFF_CHECK) then
          threshold=max(threshold, &
             real(abs(obslist(j)%value)/10.0,kind(threshold)))
       endif
       if(abs(es(j)%mean-obslist(j)%value).gt.threshold) obslist(j)%kept=.false.
    enddo
!
!  Move retained observations to the head of the list and
!  shuffle related arrays so that all related entries correspond.
!
    do j=1,nobs
       index(j)=j
    enddo
    call move_to_head(obslist,nobs,kept,index)
    if(kept.lt.nobs) then
       hxback=hxback(:,index)
       es=es(index)
       dhx=dhx(:,index)
       zlev(:,1:nobs)=zlev(:,index)
       surfpres=surfpres(:,index)
    endif
    write(LOGFILE,100) kept
100 format(i8,' observations pass quality control checks')
    return
    end subroutine quality_control
!----------------------------------------------------------------------------
    subroutine validate(obs,nobs,info)
!  VALIDATE - make a sequence of heuristic checks on the observation
!  data and compute (x,y) grid coordinates from the supplied (lambda,phi)
!  coordinates.  Set INFO to 0 if all checks are passed and to a nonzero value
!  otherwise.   
!  NOTE 1: this routine intuits the temperature units (either C or K) and
!  converts them as required to K.  Otherwise, it does not perform any other
!  scalings.
!  NOTE 2: Some of the "real fake" data sets have sigma=9999 for surface
!  pressure observations.  Replace these with sigma=1.
!
    integer,intent(in)::nobs
    type(model_obs),intent(inout)::obs(nobs)
    integer,intent(out)::info
!
    integer::j
!
    info=0
!
    do j=1,nobs
       select case(obs(j)%typ)
       case(PRES_TYPE)  ! can be either hPa or ln(dPa)
          if(obs(j)%value.le.0.0) then
             call dump_obs(obs(j),'nonpositive pressure',real(info))
             exit
          endif
          obs(j)%x_grd(3)=1.0
       case(TEMP_TYPE)  ! internal units are Kelvin; convert C to K as needed
          if(obs_temperature_units.eq.'U') then  ! intuit units from first obs
             if(obs(j)%value.le.0.0) then
                obs_temperature_units='C'
             else if(obs(j)%value.ge.150.0) then
                obs_temperature_units='K'
             else
                call fexit('validate: can''t determine temperature units',2)
             endif
          endif
          if(obs_temperature_units.eq.'C') then
             obs(j)%value=obs(j)%value+273.15
          else if(obs(j)%value.le.0.0) then
             info=12
             call dump_obs(obs(j),'nonpositive temperature',real(info))
             exit
          endif
       case(UWIND_TYPE:VWIND_TYPE)  ! in m/s
          if(abs(obs(j)%value).ge.500.0) then
             info=13
             call dump_obs(obs(j),'huge wind speed',real(info))
             exit
          endif
       case default  ! unknown type
          info=5
          call dump_obs(obs(j),'unknown obs type',real(info))
          exit
       endselect
!
       if(obs(j)%sdev.le.0.0) then
          info=4
          call dump_obs(obs(j),'nonpositive standard error',real(info))
          exit
       endif
    enddo
    return
    end subroutine validate
!----------------------------------------------------------------------------
    subroutine obs_energy_units(obs,nobs)
!  OBS_ENERGY_UNITS - rescale the observation array to energy units.
!  The components of OBS are assumed to have been validated.
!  NOTE:  The energy unit conversion is fixed by the sigma level of
!  the observation, which is independent of the vertical positioning
!  of the observation based on the individual ensemble members.
!
    integer,intent(in)::nobs
    type(model_obs),intent(inout)::obs(nobs)
!
    integer::j
!
!  Ensure that the spectral coefficients are initialized.
!
    call spectral_code_init
!
    do j=1,nobs
    !
    !  Pressure values < 10 are assumed to be in ln(dPa); if sdev <= 0.001
    !  then substitute a synthetic value (4.0e-04, to match gridded obs)
    !  The pressure level (P_LEV) field is always in hPa.
    !
       if(obs(j)%typ.eq.PRES_TYPE) then
          if(obs(j)%value.le.10.0) then  ! assume ln(dPa) already
             obs(j)%value=pres_to_energy(obs(j)%value)
             if(obs(j)%sdev.le.1.0e-03) then  ! substitute artificial value
                obs(j)%sdev=pres_to_energy(1.0)*4.0e-04  ! wq*val
             else
                obs(j)%sdev=pres_to_energy(1.0)*obs(j)%sdev  ! wq*val
             endif
          else    ! hPa -> ln(dPa) * energy scaling
             obs(j)%sdev=pres_to_energy(obs(j)%sdev/obs(j)%value)
                         ! log((v+s)/10) ~ log(v/10)+s/v 
             obs(j)%value=pres_to_energy(log(obs(j)%value/10.0))
          endif
          if(obs(j)%value.le.0.0) call fabort('obs_energy_units: P < 0')
       else
          if(obs(j)%typ.eq.TEMP_TYPE) then
             obs(j)%value=temp_to_energy(obs(j)%value,obs(j)%x_grd(3))
             obs(j)%sdev=temp_to_energy(obs(j)%sdev,obs(j)%x_grd(3))
             if(obs(j)%value.le.0.0) call fabort('obs_energy_units: T < 0')
          else
             obs(j)%value=wind_to_energy(obs(j)%value,obs(j)%x_grd(3))
             obs(j)%sdev=wind_to_energy(obs(j)%sdev,obs(j)%x_grd(3))
          endif
       endif
       if(obs(j)%sdev.le.0.0) call fabort('obs_energy_units: negative sdev')
    enddo
    return
    end subroutine obs_energy_units
!----------------------------------------------------------------------------
    subroutine move_to_head(list,nobs,kept,index)
!  MOVE_TO_HEAD - Move retained observations to the head of each list.
!  LIST :=: array of NOBS observations, shuffled as needed so that the
!     entries 1:KEPT contain retained observations and KEPT+1:NOBS holds
!     the rest.
!  INDEX :=: if present, an index array.  The elements of this array are
!     moved so that if INDEX(K) corresponds to LIST(K) on entry, then
!     the same is true on return.
!
    integer,intent(in)::nobs
    integer,intent(out)::kept
    type(model_obs),intent(inout)::list(nobs)
    integer,intent(inout),optional::index(nobs)
!
    type(model_obs),allocatable::otemp(:)  ! avoid stack overflow
    integer,allocatable::newindex(:)  ! avoid stack overflow
    integer::j,k,d
!
!  Copy the original list to a new one: retained observations at the
!  beginning, deleted ones at the end.
!
    allocate(otemp(nobs))
    k=0
    d=nobs+1
    if(present(index)) then
       allocate(newindex(nobs))
       do j=1,nobs
          if(list(j)%kept) then
             k=k+1
             otemp(k)=list(j)
             newindex(k)=index(j)
          else
             d=d-1
             otemp(d)=list(j)
             newindex(d)=index(j)
          endif
       enddo
       index=newindex
    else
       do j=1,nobs
          if(list(j)%kept) then
             k=k+1
             otemp(k)=list(j)
          else
             d=d-1
             otemp(d)=list(j)
          endif
       enddo
    endif
    kept=k
    list=otemp
    return
    end subroutine move_to_head
!----------------------------------------------------------------------------
    subroutine dump_obs(obs,msg,optval,raw)
    use io
    type(model_obs),intent(in)::obs  ! unscaled entries
    character(*),intent(in)::msg
    real,intent(in),optional::optval
    type(raw_obs),intent(in),optional::raw
!
    write(IERR,900) msg
900 format('------------'/'model_obs dump: ',a)
    write(IERR,901) 'location (x,y,z): ',obs%x_grd
901 format(a,3f11.3)
    if(present(optval)) write(IERR,901) 'optval: ',optval
    write(IERR,902) 'value, sdev: ',obs%value,obs%sdev
902 format(a,2es13.4)
    write(IERR,903) 'p_lev, type: ',obs%p_lev,obs%typ
903 format(a,e12.3,i4)
!
    if(.not.present(raw)) return
    write(IERR,910) raw%typecode,raw%lev
910 format('raw_obs dump: typecode: ',i0,' lev: ',i0)
    write(IERR,911) raw%x_grd,raw%y_grd,raw%lambda,raw%phi
911 format('x_grd, y_grd: ',2f11.4,' lambda, phi: ',2f11.4)
    write(IERR,912) raw%sigma,raw%p_lev
912 format('sigma, p_lev: ',f11.4,es12.3)
    write(IERR,913) raw%value,raw%sdev,raw%qcm
913 format('value, sdev, qcm: ',3es13.4)
    return
    end subroutine dump_obs
!----------------------------------------------------------------------------
    pure subroutine kth_obs(k,obs,ierr,bg,zmean)
!  KTH_OBS - return the Kth retained model_obs.  Convenience function.
!  K : the observation to get.
!  OBS := the Kth observation, if available.
!  IERR := set to 0 unless K > NOBS or K < 1.
!  BG := if present, and if K is in range, then the background ensemble
!     statistics computed in LINEAR_INTERP corresponding to the Kth observation.
!  ZMEAN := if present, and K is in range, then the average value of the
!    model Z coordinate, based on the surface pressure adjustment from the
!    background.
!
    integer,intent(in)::k
    type(model_obs),intent(out)::obs
    integer,intent(out)::ierr
    type(ensemble_stat),intent(out),optional::bg
    real,intent(out),optional::zmean
!
    if(k.ge.1.and.k.le.size(obslist)) then
       obs=obslist(k)
       if(present(bg)) bg=bgstat(k)
       if(present(zmean)) zmean=sum(zlev(:,k))/ensemble_size()
       ierr=0
    else
       ierr=-1
    endif
    return
    end subroutine kth_obs    
!----------------------------------------------------------------------------
    pure subroutine obs_count(kept,total)
!  OBS_COUNT - return the total number of observations read in and the
!  total number of obs that are retained.
!
    integer,intent(out),optional::kept,total
!
    if(present(kept)) kept=total_obs_kept
    if(present(total)) total=size(obslist)
    return
    end subroutine obs_count
!----------------------------------------------------------------------------
    subroutine read_obs_slice(ofile,expect,nobs,obsarray)
!  READ_OBS_SLICE - read a raw_obs file corresponding to a slice
!  of the background grid.
!  The latitudinal strip to which the observations correspond must
!  exactly match SOUTH and NORTH.
!  OFILE   : name of observations file
!  EXPECT  : 4-character header to expect ('none' => no header)
!  NOBS  := number of observations read and stored into OBSLIST after
!    passing simple validity tests.
!  Side effects:
!  - opens and closes INNOSWAP.
!  - allocates and fills OBSLIST
!  - heaps the observations into a KD tree for fast lookup
!
    character(*),intent(in)::ofile,expect
    integer,intent(out)::nobs
    type(raw_obs),allocatable,intent(out)::obsarray(:)
!
!  Local variables
!
    integer::istart,istop,iseq,info,south,north,nobsin
    character(4)::ftype
    character(80)::msg
    type(raw_obs)::obs
!
    open(unit=INNOSWAP,form='unformatted',status='old',file=ofile,iostat=info)
    if(info.ne.0) call fexit(trim(ofile)//': cannot open',2)
    if(verbosity().gt.VERB_TERSE) call finfo('reading '//trim(ofile)//'...')
!
!  Check headers for consistency with the expected latitude strip.
!  Endian issues are generally evident at this point.
!
    if(expect.ne.'none') then
       read(INNOSWAP) ftype,iseq,istart,istop,nobsin
       if(ftype.ne.'obs') then
          call finfo(trim(ofile)//': wrong header: '//ftype)
          call fexit(trim(ofile)//': not a split obs file',2)
       endif
       if(nobsin.lt.0) call fexit(trim(ofile)//': negative number of obs',2)
       call model_grid_boundary(south,north)
       if(istart.gt.south.or.istop.lt.north) then
          write(IERR,100) trim(ofile),istart,istop,south,north
100       format(a,' obs file has istart=',i0,' istop=',i0, &
             ' but program requires south=',i0,' and north=',i0)
          call fexit(trim(ofile)//': latitude limits disagree with grid',2)
       endif
    else
       read(INNOSWAP) iseq
    endif
    if(iseq.ne.seqid()) then
       write(IERR,110) trim(ofile),iseq,seqid()
110    format(a,': sequence id is: ',i0,' expected: ',i0)
       call fexit(trim(ofile)//': unexpected sequence id in input',2)
    endif
!
!  Allocate, read, and verify the observation grid.
!
    allocate(obsarray(nobsin))
    nobs=0
    do
       read(INNOSWAP,end=10) obs
       nobs=nobs+1
       if(nobs.gt.size(obsarray)) call grow(obsarray)
       obsarray(nobs)=obs
    enddo
 10 continue
    if(nobs.ne.nobsin) then
       write(msg,115) nobsin,nobs
       call fabort(msg)
    endif
115 format('read_obs_slice: expected ',i0,' obs; got ',i0)
    close(INNOSWAP)
    if(verbosity().gt.VERB_TERSE) then
       write(msg,120) 'number of observations: ',nobs
       call finfo(trim(msg))
       call finfo('done reading observations')
    endif
120 format(a,i8)
    return
    contains
! -------------------
       subroutine grow(f)
   !  GROW - enlarge F by 50% or 1 element, whichever is greater.
   !  Preserve the initial elements in F.
   !
       type(raw_obs),allocatable,intent(inout)::f(:)
   !
       type(raw_obs),allocatable::temp(:)
       integer::sz
   !
       sz=size(f)
       allocate(temp(sz))
       temp=f
       deallocate(f)
       allocate(f(max(3*sz/2,sz+1)))
       f(1:sz)=temp
       deallocate(temp)
       return
       end subroutine grow
! -------------------
    end subroutine read_obs_slice
!----------------------------------------------------------------------------
    subroutine write_obs_slice(ofile,tag,south,north,obs,nobs)
! WRITE_OBS_SLICE - write a section of the global observation grid
!  to the indicated output file in latitude-major format.
!  Halt the program if an error occurs.
!  OFILE   : name of output observation file
!  TAG  : 4-character header tag to use.  If set to 'none', we
!            write no tag other than the sequence id.
!  SOUTH  :  Southernmost latitude index of output observations.
!  NORTH  :  Northernmost latitude index of output observations.
!  OBS  :  Array containing all global observations.
!  NOBS  : Number of observations in OBS (not necessarily the number
!      written out)
!  Side effects:
!  - Opens and closes OUTNOSWAP.
!  - Halts the code if OFILE cannot be opened for writing
!
    character(*),intent(in)::ofile
    character(*),intent(in)::tag
    integer,intent(in)::south,north,nobs
    type(raw_obs),intent(in)::obs(nobs)
!
!  Local variables
!
    integer::info,j,nobsout
    character(4)::ftype
    real(kind(obs(1)%phi))::y
!
    open(unit=OUTNOSWAP,file=ofile,form='unformatted',action='write', &
       position='rewind',iostat=info)  ! overwrite any predecessor
    if(info.ne.0) call fexit(trim(ofile)//': cannot open',errcode=2)
!
    nobsout=count(obs%phi.ge.RLATS(south).and.obs%phi.le.RLATS(north))
!
    if(verbosity().gt.VERB_TERSE) call finfo('writing '//trim(ofile)//'...')
    ftype=tag
    if(ftype.ne.'none') then
       write(OUTNOSWAP) ftype,seqid(),south,north,nobsout
    else
       write(OUTNOSWAP) seqid()
    endif
!
!  Get the PHI value corresponding to the model grid latitudes defined by
!  SOUTH and NORTH.
!
    do j=1,nobs
       y=obs(j)%phi
       if(y.ge.RLATS(south).and.y.le.RLATS(north)) write(OUTNOSWAP) obs(j)
    enddo
    close(OUTNOSWAP)
    return
    end subroutine write_obs_slice
!----------------------------------------------------------------------------
    end module grid_obs

!  Make a fake dataset with pressure obs only.
!
    use grid_obs,only:raw_obs
    use resolution
    use ferror
    use io
    implicit none
    type(raw_obs)::obs
    character(MAX_FILE_NAME_LEN)::infn,outfn
    integer::iseq
! 
    call getarg(1,infn)
    call getarg(2,outfn)
    open(unit=INNOSWAP,file=infn,form='unformatted',status='old')
    read(INNOSWAP) iseq
    open(OUTNOSWAP,file=outfn,form='unformatted',status='replace')
    write(OUTNOSWAP) iseq
    do
       read(INNOSWAP,end=10) obs
       if(adjustl(obs%field).eq.'T'.and. &
          obs%lambda.ge.164.0.and.obs%lambda.le.165.0.and. &
          obs%phi.ge.-77.and.obs%phi.le.-74.0) write(OUTNOSWAP) obs
    enddo
 10 continue
    stop
    end

    use grid_obs,only:raw_obs
    use resolution
    use ferror
    use io
    type(raw_obs)::obs
    character(MAX_FILE_NAME_LEN)::fn
    character(7)::asigma
    integer::k,iseq,istart,istop,nobsin
    integer,external::iargc  ! g95 intrinsic
    character(4)::tag
    logical::partial_grid
 
    call parseline(partial_grid,fn)
    open(unit=INNOSWAP,file=fn,form='unformatted',status='old')
    k=0
    if(partial_grid) then
       read(INNOSWAP) tag,iseq,istart,istop,nobsin
    else
       read(INNOSWAP) iseq
       istart=1
       istop=LATG
       nobsin=0
    endif
    write(IOUT,103) trim(fn)
103 format('data file: ',a)
    write(IOUT,101) iseq,istart,istop,nobsin
101 format('sequence number: ',i0,' starting lat: ',i0,' ending lat: ',i0, &
        ' nobs: ',i0)
102 format('#',4x,'k',' type',3x,'x_grd',3x,'y_grd',3x,'sigma',3x,'lambda', &
       5x,'phi',6x,'value',6x,'stdev',6x,'p_lev',6x,'prss',' qcm','  cat', &
       ' field')
    do
       read(INNOSWAP,end=10) obs
       if(mod(k,50).eq.0) write(IOUT,102)
       k=k+1
       if(obs%sigma.lt.LEVS+1) then
          write(asigma,'(f7.3)') obs%sigma
       else
          asigma='  undef'
       endif
       write(IOUT,100) k,obs%typecode,obs%x_grd,obs%y_grd,asigma, &
          obs%lambda,obs%phi,obs%value,obs%sdev,obs%p_lev,obs%prss,obs%qcm, &
          obs%cat,trim(obs%field)
    enddo
 10 continue
100 format(i7,i5,2f8.3,a7,1x,2f8.3,2es11.3,2f11.3,1x,f4.1,1x,i5,1x,a)
    stop
    end
!--------------------------------------------------------------------------
    subroutine parseline(partial_grid,fn)
    use command_line_support
    implicit none
    logical,intent(out)::partial_grid
    character(*),intent(out)::fn
!
    character(*),parameter::OPTIONS='a'
    character(80)::optarg
    character::opt
    integer::iopt,optind
!
    partial_grid=.true.
    do
       call getopt(iopt,optarg,optind,OPTIONS)
       if(iopt.lt.0) exit
       opt=char(iopt)
       select case(opt)
       case('a')   ! global grid
          partial_grid=.false.
       case default
          call usage
       endselect
    enddo
    call getarg(optind,fn)
    return
       contains
       subroutine usage
       use io
       write(IERR,100)
100    format('ydump: [-a (all obs/global grid)] obsfile')
       return
       end subroutine usage
    end subroutine parseline

      implicit none
      integer,parameter::D=kind(1.0d0)
      integer::k10,k11,ieee
      integer::beta,t,emin,emax
      real(D)::eps,rmin,rmax
      logical::rnd
      integer,external::ilaenv,ieeeck
      namelist/out/ beta,t,rnd,eps,emin,rmax,rmax
      namelist/out2/ k10,k11,ieee
      k10 = ILAENV( 10, 'DLASQ2', 'N', 1, 2, 3, 4 )
      k11 = ILAENV( 11, 'DLASQ2', 'N', 1, 2, 3, 4 )
      call dlamc2(beta,t,rnd,eps,emin,rmin,emax,rmax) 
      write(6,out) 
      ieee=ieeeck(1,0.0,1.0)
      write(6,out2)
      stop
      end

    module grid_indexing
!
!  SYNOPSIS
!    use grid_indexing
!
!  DESCRIPTION
!
!  GRID_INDEXING contains utility indexing routines for managing the
!  model grids.  Wherever possible, these routines are declared PURE
!  to make them candidates for inlining by optimizing compilers.
!
!  REQUIRED PACKAGES
!   assim_vars, grid_setup, interpolate - in source code directory
!
!  AUTHOR
!   Eric Kostelich, kostelich@asu.edu, 480-065-5006
!
!  MODIFICATION HISTORY
!  10/13/05 - added optional OVER_POLE flag to XY_ADJUST so we can know when
!             an increment takes us over one of the poles.
!  07/30/05 - corrected XY_ADJUST so that patches over the North Pole are
!             indexed correctly.
!
    use grid_setup
    use resolution,only:LONSPERLAT,LONF,LATG,RLATS
    implicit none
    contains
!-----------------------------------------------------------------------------
    pure integer function patchsize(loc)
!  PATCHSIZE - return the number of dynamical variables that are assimilated
!  into a patch centered at LOC.  
!
    type(patch_index),intent(in)::loc
!
    integer::offset,low,high,ix,iy
    type(patch_index)::newloc
!
!  PATCH_OFFSET returns the number of variables PLUS 1 that appear
!  before the upper right corner of the patch.  See comments in PATCH_OFFSET
!  regarding the treatment of surface pressure.
!
    call patch_radius(loc,ix,iy)
    offset=patch_offset(loc,ix,iy)-1
    call xy_adjust(loc,ix,iy,newloc,low,high)
    offset=offset+(NAVARS-1)*(high-low+1)+1  ! and add pressure back
    patchsize=offset
    return
    end function patchsize
!-----------------------------------------------------------------------------
    pure subroutine xy_adjust(loc,inclon,inclat,newloc,low,high,over_pole)
!  XY_ADJUST - convenience routine for indexing an offset (INCLON,INCLAT)
!  from a grid point at LOC.  This version handles points near
!  the poles and the 0-degree line.
!  LOC    :  (LON,LAT,Z)
!  NEWLOC := (LON+INCLON,LAT+INCLAT,Z), with appropriate adjustments near poles
!            and 0-degree line.
!  LOW, HIGH := beginning and ending vertical levels centered at NEWLOC.
!  OVER_POLE := if present, set to TRUE if the incrementation moves us over
!            one of the poles.
!  We provide a simple modulus, assuming that |LON| and |LAT| are
!  not too large.
!
    implicit none
    type(patch_index),intent(in)::loc
    type(patch_index),intent(out)::newloc
    integer,intent(in)::inclon,inclat
    integer,intent(out),optional::low,high
    logical,intent(out),optional::over_pole
!
    integer::zlow,zhigh
!
    newloc%x=loc%x+inclon
    newloc%y=loc%y+inclat
    newloc%z=loc%z
!
    if(newloc%y.lt.1) then     ! adjust at south pole: 0 => 1, -1 => 2, etc.
       newloc%y=1-newloc%y
       newloc%x=newloc%x+LONF/2  ! go across pole 180 degrees
       if(present(over_pole)) over_pole=.true.
    else if(newloc%y.gt.LATG) then ! adjust at north pole: LATG+1 => LATG etc.
       newloc%y=2*LATG-newloc%y+1
       newloc%x=newloc%x+LONF/2  ! go across pole 180 degrees
       if(present(over_pole)) over_pole=.true.
    else
       if(present(over_pole)) over_pole=.false.
    endif
!
    if(newloc%x.lt.1) then
       newloc%x=newloc%x+LONF
    else if(newloc%x.gt.LONF) then
       newloc%x=newloc%x-LONF
    endif
    if(present(low).or.present(high)) then
       call zdiam(newloc,zlow,zhigh)
       if(present(low)) low=zlow
       if(present(high)) high=zhigh
    endif
    return
    end subroutine xy_adjust
!-----------------------------------------------------------------------------
    pure integer function patch_offset(loc,dx,dy)
!  PATCH_OFFSET - For an offset (dx,dy) from the center of a patch
!  centered at (IX,IY), find the index that corresponds to the start of
!  the dynamical variables for the associated grid point.
!  We allow for the possibility that the height of each cube varies by
!  coordinate of the patch array.
!  both longitude and latitude.
!  Arguments:
!  LOC     :  (lon,lat,z) coords of center of patch
!  DX, DY  :  (lon,lat) offset from center
!  OFFSET  := points to the index of the surface pressure component
!             at (lon+dx,lat+dy,z)
!
    implicit none
    type(patch_index),intent(in)::loc
    integer,intent(in)::dx,dy
!
    integer::j,k,low,high,nlev,offset,xrad,yrad
    type(patch_index)::newloc
!
!  Return a value that's sure to cause a crash if arguments are out of range
!
    call patch_radius(loc,xrad,yrad)
    if(abs(dx).gt.xrad.or.abs(dy).gt.yrad) then
       offset=huge(1)
       return
    endif
!
!  Surface pressure is a special case: we always include it in every patch,
!  even those that don't contain the surface.  All the other dynamical
!  variables included in the assimilation appear at each level of the
!  atmosphere.  NAVARS is the number of such dynamical variables,
!  including surface pressure, written out to the model grid by preanalysis.
!  In the computations below, we include the surface pressure once (at the
!  "lowest" level of the patch) followed by all other dynamical variables
!  at each level contained in the patch.
!
!  First sum up across all columns to the left of that defined by DX...
!
    offset=0
    do j=-xrad,dx-1
       do k=-yrad,yrad
          call xy_adjust(loc,j,k,newloc,low,high)
          nlev=high-low+1
          offset=offset+(NAVARS-1)*nlev+1  ! include pressure => +1
       enddo
    enddo
!
!  ... and all rows below that defined by DY.
!
    do k=-yrad,dy-1
       call xy_adjust(loc,dx,k,newloc,low,high)
       nlev=high-low+1
       offset=offset+(NAVARS-1)*nlev+1  ! include pressure => +1
    enddo
    patch_offset=offset+1   ! so we point to first component
    return
    end function patch_offset
!-----------------------------------------------------------------------------
    pure subroutine center_column_height(loc,height,offset)
!  CENTER_COLUMN_HEIGHT - return the number of variables in any array
!  returned by copy_from_grid corresponding to the center 
!  (longitude,latitude) grid point.
!  OFFSET  :=  Optional argument giving the offset corresponding to the first
!  variable in the center column of the patch.
!
    implicit none
    type(patch_index),intent(in)::loc
    integer,intent(out)::height
    integer,intent(out),optional::offset
!
    integer::zlow,zhigh
!
    if(present(offset)) offset=patch_offset(loc,0,0)
    call zdiam(loc,zlow,zhigh)
    height=(NAVARS-1)*(zhigh-zlow+1)+1
    return
    end subroutine center_column_height
!-----------------------------------------------------------------------------
    elemental logical function valid_dynamical_type(t)
!   VALID_DYNAMICAL_TYPE - return TRUE if T presents a dynamical variable
!   that is stored in the model grid.
!   We'll need to update this routine as more dynamical variables are
!   assimilated.
!
    integer,intent(in)::t
!
    valid_dynamical_type=t.ge.1.and.t.le.VWIND_TYPE
    return
    end function valid_dynamical_type
!-----------------------------------------------------------------------------
    elemental integer function signum(x)
!  SIGNUM - the usual signum function: return -1 if X is negative, 1 if
!  positive, and 0 otherwise.  The latter condition is important: we don't
!  want to interpolate measurements that coincide with a model grid point.
!
    real(R),intent(in)::x
!
    if(x.eq.0.0) then
       signum=0
    else
       signum=merge(1,-1,x.gt.0.0)
    endif
    return
    end function signum
!-----------------------------------------------------------------------------
    elemental real function xgrid(lambda)
!  XGRID - Given a longitude location in degrees (0 <= LAMBDA < 360),
!  return the same location relative to the model grid as an
!  interpolated subscript value.  That is, if LAMBDA is halfway between
!  the model longitude points J and J+1, then we return J+0.5 (as a real number).
!  The model longitude coordinates in this version are equally spaced,
!  with 360/LONF degrees per grid point.  Our convention in this code
!  is the 0 degrees longitude corresponds to the model grid location x=1;
!  longitudes in [360-360/LONF, 360) map to [LONF,LONF+1) in the model grid.
!  If LAMBDA is not in [0, 360), then return -1.
!
    use interpolate
    real,intent(in)::lambda
!
    if(lambda.lt.0.0.or.lambda.ge.360.0) then
       xgrid=-1.0   ! flag invalid longitude
    else
       xgrid=lambda*(LONF/360.0)+1.0  ! offset: 0 degrees -> x=1
    endif
    return
    end function xgrid
!-----------------------------------------------------------------------------
    elemental real function ygrid(phi)
!  YGRID - Given a latitude location in degrees (-90 <= PHI <= 90),
!  return the same location relative to the model grid as an
!  interpolated subscript value.  That is, if LAMBDA is halfway between
!  the model latitude points J and J+1, then we return J+0.5 (as a real number).
!  The model latitude coordinates in this version appear in a Gaussian grid
!  whose spacings depend on the model resolution; see the module resolution
!  in the support directory.
!  The GFS model grid does not go all the way to the poles.  The convention
!  in this code is that the south pole corresponds to YGRID=0 and the north
!  pole to YGRID=LATG+1.  Otherwise, if PHI < -90 or PHI > 90, then return -1.
!
    use interpolate
    real,intent(in)::phi
!
    real,parameter::SBDY(2)=(/0.0,RLATS(1)/)  ! latitudes to south pole
    real,parameter::NBDY(2)=(/RLATS(LATG),90.0/) ! latitudes to north pole.
    real::y
!
    if(phi.lt.-90.0.or.phi.gt.90.0) then
       ygrid=-1.0   ! flag invalid latitude
       return
    endif
!
    y=index_interp(phi,RLATS,LATG)
    if(y.lt.1.0) then  ! interpolate points S of the southernmost grid bdy
       y=index_interp(phi,SBDY,2)-1.0
    else if(y.gt.LATG) then  ! interpolate points N of northernmost grid bdy
       y=index_interp(phi,NBDY,2)+(LATG-1)
    endif
    ygrid=y
    return
    end function ygrid
!-----------------------------------------------------------------------------
    end module grid_indexing

!  SDUMP - dump the contents of a sigma file.
!  Usage:  sdump [options] file
!  Options:  -l lev  : dump only for level LEV
!            -v var  : one of gz, q, te, di, sz, rq, oz

    module sdump
    use spectral
    use io
    use command_line_support
    implicit none
    integer,parameter::HEADONLY=1,RMSONLY=2,PRINTVALS=3
    contains
!-------------------------------------------------------------------------
    subroutine parseline(fn,lev,var,action)
    character(*),intent(in)::fn
    character(*),intent(out)::var
    integer,intent(out)::lev,action
!
    character(*),parameter::OPTLIST='hHl:v:'
    integer::iopt,optind,nargs
    character(MAX_FILE_NAME_LEN)::optarg
    character::opt
    integer,external::iargc
!
    var='all'
    lev=0
    action=0
    nargs=iargc()
    if(nargs.lt.1) then
       write(IERR,100)
       call program_exit(1)
    endif
100 format('sdump [-H] [-v var] [-l level] file'/ &
       'Default is RMS output by level for all variables'/ &
       '-H dumps the sigma file header only'/ &
       '-v dumps individual coefficients for the indicated level (if given)'/ &
       'var is one of gz, q, te, di, ze, rq, or oz'/ &
       'If -l is unspecified then all levels are shown (lots of output!)'/ &
       'On Lahey, export FORT90L="-Wl,-T1"')
!
    do
       call getopt(iopt,optarg,optind,OPTLIST)
       if(iopt.lt.0) exit
       opt=char(iopt)
       select case(opt)  
       case('h')
          write(IERR,100)  ! print usage
          call program_exit(1)
       case('H')
          if(action.ne.0) call fexit('only one of -H or -v may be specified')
          action=HEADONLY
       case('l')
          read(optarg,*) lev
       case('v')
          if(action.ne.0) call fexit('only one of -H or -v may be specified')
          var=optarg
          action=PRINTVALS
       case default
          write(IERR,110) opt
          call program_exit(1)
       endselect
    enddo
    if(action.le.0) action=RMSONLY
110 format('unknown option ',a)
!
    call getarg(nargs,fn)
    return
    end subroutine parseline
!-------------------------------------------------------------------------
    subroutine rmsoutput(a,nlev,label)
    character(*),intent(in)::label
    integer,intent(in)::nlev
    real(D),intent(in)::a(LNTD,2,nlev)
!
    integer::k
    real(D)::rms(nlev)
!
    do k=1,nlev
       rms(k)=rmsof(a(:,:,k))
    enddo
    write(LOGFILE,100) label
100 format(a,' rms by level')
    write(LOGFILE,101) rms
101 format(7es11.3)
    return
    end subroutine rmsoutput
!-------------------------------------------------------------------------
    subroutine output(a,lev,label,action)
    character(*),intent(in)::label
    integer,intent(in)::lev,action
    real(D),intent(in)::a(LNTD,2,LEVS)
!
    integer::h,j,k,idx
!
    write(LOGFILE,'(a)') label
    if(action.eq.RMSONLY) then
       do k=merge(lev,1,lev.gt.0),merge(lev,LEVS,lev.gt.0)
          write(LOGFILE,102) 'level',k,rmsof(a(:,:,k))
       enddo
       return
    endif
!
    do h=1,2
       write(LOGFILE,101) 'hemisphere',h
       do k=merge(lev,1,lev.gt.0),merge(lev,LEVS,lev.gt.0)
          write(LOGFILE,102) 'level',k,rmsof(a(:,:,k))
          idx=1
          do j=1,LNTD,7
	  write(LOGFILE,100) idx,a(idx:idx+6,h,k)
	  idx=idx+7
          enddo
       enddo
    enddo
100 format(i4,': ',7es11.3)
101 format(a,1x,i3)
102 format(a,1x,i3,' rms ',es11.3)
    return
    end subroutine output
!-------------------------------------------------------------------------
    subroutine process_file(fn,lev,var,action)
    character(*),intent(in)::fn,var
    integer,intent(in)::lev,action
!
    type(spectral_coeffs)::coeff
    type(sigma_file_header)::header
    integer::k
!
    call read_sigma_file(fn,header,coeff)
    if(action.eq.HEADONLY) then
       call dump_header(fn,LOGFILE,header,VERB_CHATTY)
       return
    else if(action.eq.RMSONLY) then
       call rmsoutput(coeff%gz,1,'gz: geopotential height')
       call rmsoutput(coeff%q,1,'q: surface pressure')
       call rmsoutput(coeff%te,LEVS,'te: temperature')
       call rmsoutput(coeff%di,LEVS,'di: divergence')
       call rmsoutput(coeff%ze,LEVS,'ze: vorticity')
       call rmsoutput(coeff%rq,LEVS,'rq: relative humidity')
       call rmsoutput(coeff%oz,LEVS,'oz: ozone')
       return
    endif
!
    select case(var)
    case('gz')
       call output(coeff%gz,1,'gz: geopotential height',action)
    case('q')
       call output(coeff%q,1,'q: surface pressure',action)
    case('te')
       call output(coeff%te,lev,'te: temperature',action)
    case('di')
       call output(coeff%di,lev,'di: divergence',action)
    case('ze')
       call output(coeff%ze,lev,'ze: vorticity',action)
    case('rq')
       call output(coeff%rq,lev,'rq: relative humidity',action)
    case('oz')
       call output(coeff%oz,lev,'oz: ozone',action)
    case default
       call fexit('unknown variable '//var,1)
    endselect
    return
    end subroutine process_file
!-------------------------------------------------------------------------
    end module sdump
!-------------------------------------------------------------------------
    use sdump
    character(MAX_FILE_NAME_LEN)::fn
    integer::lev,action
    character(3)::var
!
    call parseline(fn,lev,var,action)
    call process_file(fn,lev,var,action)
    call program_exit(0)
    end

    module io
! IO - unit numbers for the data analysis subroutines.
!
!  SYNOPSIS
!     use io
!
!  DEPENDENCIES
!     None.
!   
!  MODIFICATION HISTORY
!  08/08/05 - Added dump unit for optional debugging.
!  07/22/04 - Revised by Eric to clean up swapped and unswapped units.
!
!  IN and OUT correspond to the standard input and output.
!  IERR is the standard error.  These are intended for use with text i/o.
!  Unit 0 is an extension of the Fortran standard, but it is commonly used
!  for the standard error.  However, I know of one implementation where
!  the standard error is mapped to unit 7.  Alter as appropriate.
!
    integer,parameter::IN=5,IOUT=6,IERR=0
!
!  DIAGUNIT is reserved for the output of diagnostics related
!  to the data assimilation method.  This is intended for text output.
!
    integer,parameter::DIAGUNIT=8
!
!  Logical unit to which we write a log of our actions if verbose
!  output is requested.  In this implementation, the log file coincides
!  with the standard output.
!
    integer,parameter::LOGFILE=IOUT
!
!  Four units are used for input and output of binary data, depending
!  on whether byte-swapping may be required.
!  if desired.
!
    integer,parameter::INSWAP=1,OUTSWAP=2,INNOSWAP=3,OUTNOSWAP=4
!
!  Dump unit for debug output; this may be either formatted or unformatted,
!  though care must be taken in the latter case because of endian issues.
!
    integer,parameter::DUMPUNIT=5
!
!  MAX_FILE_NAME_LEN is the length of the longest supported filename
!  in this implementation.
!
    integer,parameter::MAX_FILE_NAME_LEN=128
    end module io

    module ferror
!  FERROR - MPI version.  This module is used by the MPI wrappers (mp.f90)
!  and so must be compiled first.  It does not use the MPI shutdown
!  calls to avoid a circular dependency between this module and the mp module.
!
!  Required packages:
!
    use io
    use mpi
    contains
!------------------------------------------------------------------------
    subroutine fexit(msg,errcode,unit,mpid)
!  FEXIT - print the indicated message and halt with an exit code (default 0).
!  ERRCODE : if present, the exit error code to return to the shell.
!  UNIT    : if present, the logical unit number on which to diplay msg
!            (default 0, std error).
!  MPID : if present, the MPI process rank.  If MPI is used, then there may be
!  no reliable way to report ERRCODE; we'll call exit with ERRCODE but
!  there are no guarantees that it is reported to the environment.
!
    implicit none
    character(*),intent(in)::msg
    integer,intent(in),optional::errcode,unit,mpid
!
    character(MAX_FILE_NAME_LEN)::progname
    integer::iunit,ierr,code
    logical::mpinit
!
    call getarg(0,progname)
    if(present(unit)) then
       iunit=unit
    else
       iunit=IERR
    endif
    if(present(errcode)) then
       code=errcode
    else
       code=1
    endif
    if(len_trim(progname).gt.0) &
       write(iunit,100,advance='no') trim(progname)//': '
100 format(a)
    write(iunit,100) msg
    call mpi_initialized(mpinit,ierr)
    if(mpinit) then
       if(present(mpid)) write(iunit,101) 'MPI id:',mpid
       if(present(errcode)) write(iunit,101) 'error code:',code
       call mpi_finalize(ierr)
    else
       call exit(code)
    endif
101 format(a,1x,i0)
    stop
    end subroutine fexit
!------------------------------------------------------------------------
    subroutine fabort(msg,unit,mpid)
!  FABORT - print the indicated message and abort.  Depending on the
!  environment, this routine may produce a memory dump.
!  UNIT    : if present, the logical unit number on which to diplay msg
!            (default 0, std error).
!
    implicit none
    character(*),intent(in)::msg
    integer,intent(in),optional::unit,mpid
!
    character(MAX_FILE_NAME_LEN)::progname
    integer::iunit
    logical::mpinit
!
    call getarg(0,progname)
    if(present(unit)) then
       iunit=unit
    else
       iunit=IERR
    endif
    if(len_trim(progname).gt.0) &
       write(iunit,100,advance='no') trim(progname)//': '
100 format(a)
    call mpi_initialized(mpinit,ierr)
    if(mpinit) then
       if(present(mpid)) write(iunit,101,advance='no') mpid
       write(iunit,100) msg
       call mpi_abort(MPI_COMM_WORLD,2,ierr)  ! 1 is usual MPI error exit code
       call exit(1)  ! just in case
    else
       write(iunit,100) msg
       call abort
    endif
101 format('MPI id: ',i0,': ')
    !  Never returns
    end subroutine fabort
!------------------------------------------------------------------------
    subroutine finfo(msg,unit,mpid)
!  FINFO - print the indicated message and return.
!  UNIT    : if present, the logical unit number on which to diplay msg
!            (default 0, std error).
!  MPID : if present, the MPI process rank
!
    implicit none
    character(*),intent(in)::msg
    integer,intent(in),optional::unit,mpid
!
    character(MAX_FILE_NAME_LEN)::progname
    integer::iunit
    logical::mpinit
!
    call getarg(0,progname)
    if(present(unit)) then
       iunit=unit
    else
       iunit=IERR
    endif
!
    if(len_trim(progname).gt.0) &
       write(iunit,100,advance='no') trim(progname)//': '
100 format(a)
    call mpi_initialized(mpinit,ierr)
    if(mpinit.and.present(mpid)) write(iunit,101,advance='no') mpid
101 format('MPI id: ',i0,': ')
    write(iunit,100) trim(msg)
    return
    end subroutine finfo
!------------------------------------------------------------------------
    end module ferror

    module grid_model
!
!  SYNOPSIS
!    use grid_model
!
!  DESCRIPTION
!    GRID_MODEL contains support routines for copying variables to and from
!    model grid arrays, whether the global ensemble grid, the analysis grid,
!    or the nature run grid.
!    In addition, GRID_MODEL contains the initial implementation of the H
!    operator, which for now calls only a simple linear interpolation routine
!    to interpolate the model state to each observation.  In the future,
!    additional routines will be implemented for nonlinear interpolations.
!
!  ROUTINES IMPLEMENTED
!   subroutine copy_grid_point(loc,x,typ,what)
!   subroutine copy_from_ensemble(loc,x,nsol,patchsz,typelist)
!   subroutine copy_from_mean(loc,x,patchsz,typelist)
!   subroutine copy_grid_z(loc,iz,x,typ,what)
!   private subroutine copy_from(loc,x,patchsz,grid,south,north,nsol,typelist)
!   private subroutine copy_to(loc,nc,agrid,south,north,nsol,center)
!   subroutine model_grid_init(bfile,afile,mfile,dfile,expect)
!   subroutine model_grid_fini(have_model_grid)
!   subroutine transpose_grid(inbuf,outbuf,south,north,nsol)
!   subroutine precompute_ensemble_differences
!
!  REQUIRED PACKAGES
!  assim_vars, grid_io,  interpolate - in main source directory
!  ferror - in support directory
!
!  MODIFICATION HISTORY
!  10/13/05 - changed COPY_TO to account for change in wind direction
!     when going over the poles.
!  09/22/05 - added COPY_GRID_Z.
!  08/06/05 - added GRIDKIND to manage internal types of model grids.
!  06/19/05 - removed diagnostics; added support for nature grid.
!  06/10/05 - incorporated diagnostics from previous small and seaparate
!    module.
!  01/19/05 - changes to accommodate real observations (finally).
!     Added code to get the sigma level (relative to model grid) from the
!     background mean surface pressure and the P_LEV observation value.
!  10/11/04 - further changes to accommodate real observations.
!     Installed new i/o format for the model grid.  First version of the
!     H operator (linear interpolation from nearly model grid points).
!  09/27/04 - intermediate version to prepare for actual observations.
!     Only surface pressure, virtual temperature, and u- and v-wind components
!     are assimilated in this version.  The grid indexing is changed
!     for greater cache coherency.   The model_vars type has been eliminated
!     in favor of a single large array.
!  AUTHOR
!     Eric Kostelich, kostelich@asu.edu, 480-965-5006.
!
    use grid_io
    use command_line_support,only:program_exit
    implicit none
!
!  Flags used in check_model_grid
!
    integer,parameter::NONE=0,BAD_VALUE=1,INF_OR_NAN=2
!
!  Private module data
!  -------------------
!  BACKGROUND defines the model background (forecast).
!  BMEAN contains the ensemble mean.
!  ANALYSIS contains the analysis.
!  AMEAN contains the analysis mean.
!  When the ensemble differences are precomputed, BACKGROUND eventually
!  holds the differene between the actual model background and the
!  background mean (an optimization to avoid recomputing them on each
!  patch when doing the data assimilation).
!  ANALYSIS and AMEAN are smaller grids than the
!  background and the background mean, because they omits the padding
!  necessary to center patches at every boundary point.
!
!  NOTE:  All model variables are scaled to energy units!
!  See to_energy_units and from_energy_units in spectral.f90.
!
    real(GRIDKIND),allocatable,save,private::background(:,:,:,:,:) 
                                         ! (nsol,south:north,LEVS,LONF,NVAR)
    real(GRIDKIND),allocatable,save,private::bmean(:,:,:,:)
                                         ! (south:north,LEVS,LONF,var)
    real(GRIDKIND),allocatable,save,private::analysis(:,:,:,:,:)
                                         ! (nsol,psouth:pnorth,LEVS,LONF,NVAR)
    real(GRIDKIND),allocatable,save,private::amean(:,:,:,:)
                                         ! (psouth:pnorth,LEVS,LONF,var)
    logical,save,private::did_diffs=.false.  ! true if ensemble diffs are
                                             ! precomputed
!
!  The "true" model variables from the nature run, if available;
!  natgrid is not associated otherwise.
!
    real(GRIDKIND),allocatable,save,private::natgrid(:,:,:,:) 
                                           ! (south:north,LEVS,LONF,NVAR)
!
!  Names of the output files containing the analysis and analysis mean
!
    character(MAX_FILE_NAME_LEN),save,private::analysis_filename=' '
    character(MAX_FILE_NAME_LEN),save,private::amean_filename=' '
!
!  Internal work routines
!
    private::copy_from,copy_to
    contains
!----------------------------------------------------------------------------
    subroutine model_grid_init(bfile,afile,mfile,dfile,expect)
!  MODEL_GRID_INIT - initialize the model grid by reading in the physical
!  space data output by preanalysis and ecomputing the ensemble means.
!  BFILE : background grid file
!  AFILE : output analysis grid file
!  MFILE : output analysis mean file
!  DFILE : output diagnostics file
!  EXPECT : header to expect in background grid file
!
    character(*),intent(in)::bfile,afile,expect,mfile,dfile
!
!  Local variables
!
    integer::south,north,psouth,pnorth,nb,nsol,nassim,seqno,info,k, &
       errtype,var
    type(patch_index)::loc
    character(MAX_FILE_NAME_LEN+80)::msg
    real(GRIDKIND),allocatable::buf(:,:,:,:,:),avg(:,:,:,:)
    real(D)::badval
!
    call read_grid_header(bfile,expect,south,north,psouth,pnorth, &
       nb,nassim,seqno)
    call set_model_grid_boundary(south,north,psouth,pnorth)
!
!  Sanity checks
!
    nsol=ensemble_size()
    if(nb.ne.nsol) then
       write(msg,110) trim(bfile),nb,ensemble_size()
110    format(a,': ensemble size is: ',i0,' expected: ',i0)
       call fexit(trim(msg),2)
    else if(seqno.ne.seqid()) then
       write(IERR,111) trim(bfile),seqno,seqid()
111    format(a,' has sequence number: ',i0,' expected: ',i0)
       call fexit(trim(msg),2)
    else if(nassim.ne.NAVARS) then
       write(msg,112) NAVARS,nassim
       call fexit(trim(msg),2)
112    format('model_grid_init: expected ',i3,' variables; got ',i3)
    endif
!
!  Read in the ensemble solutions and initialize the global grid.
!
    allocate(background(nsol,south:north,LEVS,LONF,NAVARS),stat=info)
    if(info.ne.0) then
       write(msg,120) 'background',south,north
       call fexit(trim(msg),2)
    endif
120 format('model_grid_init: cannot allocate ',a,' latitudes: ',i3,' to ',i3)
!
!  Temporary input buffer.  Note: we can modify the structure of
!  READ_MODEL_GRID to read one solution per call; at the risk of slightly
!  more complicated open/close file logic, we would only need BUF to
!  be large enough to hold one solution.  This could become a factor
!  when the ensemble sizes get big enough.
!
    allocate(buf(LONF,NAVARS,south:north,LEVS,nsol),stat=info)
    if(info.ne.0) then
       write(msg,120) 'buf',south,north
       call fexit(trim(msg),2)
    endif
    call read_model_grid(buf,south,north,nsol)
!
!  Convert the input buffer to the subscript order that's most efficient
!  for the rest of the data assimilation algorithm.
!
    call transpose_grid(buf,background,south,north,nsol)
!
!  Do perfunctory checks on the data to try to identify definite garbage values.
!
    call check_model_grid(background,nsol,south,north,errtype,loc,var,badval)
    if(errtype.ne.0) then
       if(errtype.eq.INF_OR_NAN) then
          write(IERR,150) trim(bfile),'inf or nan',TYPEOF(var),loc
       else
          write(IERR,150,advance='no') trim(bfile),'bad value',TYPEOF(var),loc
          write(IERR,151) badval
       endif
150    format(a,': '/a,': variable ',a1,' at lon:',i4,' lat:',i4,' lev:',i3)
151    format(' value: ',es13.4)
       call fexit('read_model_grid: bad value/infinity detected on input',2)
    endif
!
!  Get ensemble means (needed by the H operator).  Use a cache-friendly
!  algorithm, then convert to the subscript storage order needed elsewhere.
!
    allocate(avg(LONF,NAVARS,south:north,LEVS),stat=info)
    if(info.ne.0) then
       write(msg,120) 'avg',south,north
       call fexit(trim(msg),2)
    endif
    avg=buf(:,:,:,:,1)
    do k=2,nsol
       avg=avg+buf(:,:,:,:,k)
    enddo
    avg=avg/nsol
    deallocate(buf)
!
    allocate(bmean(south:north,LEVS,LONF,NAVARS),stat=info)
    if(info.ne.0) then
       write(msg,120) 'bmean',south,north
       call fexit(trim(msg),2)
    endif
    call transpose_grid(avg,bmean,south,north,1)
    deallocate(avg)
!
!  Store the names of the analysis output files.  We must allocate space
!  the analysis mean if diagnostics are requested, because we need the
!  analysis grid and mean to compare with the observations.  And of course
!  we need to allocate the analysis mean if its computation is requested.
!  Eric: potential optimization: copy background mean to analysis mean and
!  the background ensemble to the analysis ensemble; then return_background
!  isn't necessary when nobs=0 in the assimilation step.
!
    analysis_filename=afile
    if(len_trim(mfile).gt.0.or.len_trim(dfile).gt.0) then
       amean_filename=mfile
       allocate(amean(psouth:pnorth,LEVS,LONF,NAVARS),stat=info)
       if(info.ne.0) then
          write(msg,120) 'analysis mean',psouth,pnorth
          call fexit(trim(msg),2)
       endif
    endif
!
!  The analysis is a narrower latitude strip, in general, because we
!  don't need the extra padding to center patches.
!
    allocate(analysis(nsol,psouth:pnorth,LEVS,LONF,NAVARS),stat=info)
    if(info.ne.0) then
       write(msg,120) 'analysis',psouth,pnorth
       call fexit(trim(msg),2)
    endif
    return
    end subroutine model_grid_init
!----------------------------------------------------------------------------
    subroutine model_grid_fini
!  MODEL_GRID_FINI - output the analysis and optionally the analysis mean
!  and sum of squares (so we can compute global RMS error).
!
    integer::asouth,anorth,nsol
!
    nsol=ensemble_size()
    call assimilation_boundary(asouth,anorth)
    call output_analysis(analysis,asouth,anorth,nsol,analysis_filename,'aout')
    if(len_trim(amean_filename).gt.0.and.allocated(amean)) &
       call output_analysis(amean,asouth,anorth,1,amean_filename,'mean')
    return
    end subroutine model_grid_fini
!----------------------------------------------------------------------------
    subroutine copy_grid_point(loc,x,typ,what)
!  COPY_GRID_POINT - copy the ensemble solutions for the given dynamical
!  variable at the point on the model grid specified by LOC.
!  If LOC has invalid entries, or if LOC specifies a location that is
!  not available on the latitude strip on which we are working, then
!  the routine aborts with an error message.
!  LOC  : specifies the model grid location
!  X   := gets as many ensemble solution values as will fit.
!  TYP  : the dynamical variable type to obtain (one of PRES_TYPE, etc.)
!  WHAT : one of 'background', 'bmean', 'analysis', 'amean', or 'nature'.
!     (Only the first two letters are significant.  MUST be in lower case.)
!
    type(patch_index),intent(in)::loc
    integer,intent(in)::typ
    real(D),intent(out)::x(:)
    character(*),intent(in)::what
!
    integer::n
    character(80)::msg
!
    if(loc%x.lt.1.or.loc%x.gt.LONF.or.loc%z.lt.1.or.loc%z.gt.LEVS) &
       call fabort('copy_grid_point: bad index')
!
!  Ensure that LOC%Y corresponds to a latitude contained in the appropriate
!  grid.
!
    if(valid_dynamical_type(typ)) then
       select case(what(1:2))
       case('ba')
          if(loc%y.lt.lbound(background,2).or.loc%y.gt.ubound(background,2)) &
             goto 911
          n=min(size(x),ensemble_size())
          x(1:n)=background(1:n,loc%y,loc%z,loc%x,typ)
       case('bm')
          if(loc%y.lt.lbound(bmean,1).or.loc%y.gt.ubound(bmean,1)) goto 911
          x=bmean(loc%y,loc%z,loc%x,typ)
       case('an')
          if(loc%y.lt.lbound(analysis,2).or.loc%y.gt.ubound(analysis,2)) &
             goto 911
          n=min(size(x),ensemble_size())
          x(1:n)=analysis(1:n,loc%y,loc%z,loc%x,typ)
       case('am')
          if(loc%y.lt.lbound(amean,1).or.loc%y.gt.ubound(amean,1)) goto 911
          x=amean(loc%y,loc%z,loc%x,typ)
       case('na')
          if(.not.allocated(natgrid)) &
             call fabort('copy_grid_point: no nature grid')
          if(loc%y.lt.lbound(natgrid,1).or.loc%y.gt.ubound(natgrid,1)) goto 911
          x=natgrid(loc%y,loc%z,loc%x,typ)
       case default
          call fabort('copy_grid_point: unknown source')
       endselect
    else
       call fabort('copy_grid_point: bad type')
    endif
    return
!
!  Oops
!
911 continue
    write(msg,100) what,loc
100 format('copy_grid_point: bad index for ',a,': loc: ',3i4)
    call fabort(msg)
    end subroutine copy_grid_point
!----------------------------------------------------------------------------
    subroutine copy_grid_z(loc,iz,x,typ,what)
!  COPY_GRID_Z - like COPY_GRID_POINT, but the Jth value returned in X
!  is the dynamical value at (LOC%X,LOC%Y,IZ(J)).
!  LOC  : specifies the longitude and latitude of the model grid location
!  IZ  : vector of vertical positions to obtain.
!  X  := Jth entry is dynamical variable at (LOC%X,LOC%Y,IZ(J)).  Must be
!     same size as IZ.
!  TYP  : the dynamical variable type to obtain (one of PRES_TYPE, etc.)
!  WHAT : one of 'background', 'bmean', 'analysis', 'amean', or 'nature'.
!     (Only the first two letters are significant.  MUST be in lower case.)
!
    type(patch_index),intent(in)::loc
    integer,intent(in)::iz(:),typ
    real(D),intent(out)::x(:)
    character(*),intent(in)::what
!
    integer::j
    character(80)::msg
!
    if(loc%x.lt.1.or.loc%x.gt.LONF.or.any(iz.lt.1).or.any(iz.gt.LEVS)) &
       call fabort('copy_grid_z: bad index')
    if(size(iz).ne.size(x)) call fabort('copy_grid_z: array size mismatch')
!
!  Ensure that LOC%Y corresponds to a latitude contained in the appropriate
!  grid.
!
    if(valid_dynamical_type(typ)) then
       select case(what(1:2))
       case('ba')
          if(loc%y.lt.lbound(background,2).or.loc%y.gt.ubound(background,2)) &
             goto 911
          do j=1,size(x)
             x(j)=background(j,loc%y,iz(j),loc%x,typ)
          enddo
       case('bm')
          if(loc%y.lt.lbound(bmean,1).or.loc%y.gt.ubound(bmean,1)) goto 911
          do j=1,size(x)
             x(j)=bmean(loc%y,iz(j),loc%x,typ)
          enddo
       case('an')
          if(loc%y.lt.lbound(analysis,2).or.loc%y.gt.ubound(analysis,2)) &
             goto 911
          do j=1,size(x)
             x(j)=analysis(j,loc%y,iz(j),loc%x,typ)
          enddo
       case('am')
          if(loc%y.lt.lbound(amean,1).or.loc%y.gt.ubound(amean,1)) goto 911
          do j=1,size(x)
             x(j)=amean(loc%y,iz(j),loc%x,typ)
          enddo
       case('na')
          if(.not.allocated(natgrid)) call fabort('copy_grid_z: no nature grid')
          if(loc%y.lt.lbound(natgrid,1).or.loc%y.gt.ubound(natgrid,1)) goto 911
          do j=1,size(x)
             x(j)=natgrid(loc%y,iz(j),loc%x,typ)
          enddo
       case default
          call fabort('copy_grid_z: unknown source')
       endselect
    else
       call fabort('copy_grid_z: bad type')
    endif
    return
!
!  Oops
!
911 continue
    write(msg,100) what,loc
100 format('copy_grid_z: bad index for ',a,': loc: ',3i4)
    call fabort(msg)
    end subroutine copy_grid_z
!----------------------------------------------------------------------------
    subroutine copy_from_ensemble(loc,x,nsol,patchsz,typelist)
!  COPY_FROM_ENSEMBLE - copy the relevant model dynamical variables from the
!  background ensemble to an array representing a patch whose logical
!  center is LOC.  If the ensemble mean has been subtracted off, then
!  the values returned are the _differences_ from the mean, not the
!  original background values.
!
!  Arguments:
!  LOC   : (longitude,latitude,z) coordinates of center of patch
!  X     := vector whose Kth row contains the PATCHSZ dynamical variables 
!     of the Kth ensemble solution for the patch centered at (IX,IY).
!  NSOL : leading dimension of X.  Must equal actual number of ensemble
!     solutions.
!  TYPELIST := integer array whose (J,K)th element is the variable type in
!    X(J,K).  Optional argument.
!
!  Variables are copied into X from bottom to top and left to right
!  (i.e., in order of increasing latitude, then increasing longitude).
!  X(1) contains the surface pressure; X(2:NLEV+1) holds the temperature
!  at the vertical levels in question, and so on.  At each point,
!  X holds 3*NLEV+1 dynamical quantities, where NLEV is the number of
!  vertical levels in the patch.  We include the surface pressure
!  in each analysis, even in columns that aren't near the surface.
!
    integer,intent(in)::nsol,patchsz
    type(patch_index),intent(in)::loc
    real(D),intent(out)::x(nsol,patchsz)
    integer,intent(out),optional::typelist(nsol,patchsz)
!
!  Local variables
!
    integer::south,north
!
    if(patchsz.lt.patchsize(loc).or.nsol.ne.ensemble_size()) &
       call fabort('copy_from_ensemble: array X is wrong size')
    call model_grid_boundary(south,north)
    call copy_from(loc,x,patchsz,background,south,north,nsol,typelist)
    return
    end subroutine copy_from_ensemble
!----------------------------------------------------------------------------
    subroutine copy_from_mean(loc,x,patchsz,typelist)
!  COPY_FROM_MEAN - return in X the mean solution over the patch whose
!  logical center is LOC.  The ordering of the variables must be consistent
!  with that in COPY_FROM_ENSEMBLE.
!
    integer,intent(in)::patchsz
    type(patch_index),intent(in)::loc
    real(D),intent(out)::x(patchsz,1)
    integer,intent(out),optional::typelist(patchsz)
!
    integer::south,north
!
    call model_grid_boundary(south,north)
    call copy_from(loc,x,patchsz,bmean,south,north,1,typelist)
    return
    end subroutine copy_from_mean
!----------------------------------------------------------------------------
    subroutine copy_from(loc,x,patchsz,grid,south,north,nsol,typelist)
!  COPY_FROM_RG - copy variables from the model grid array into 
!  a vector that represents the dynamical variables on a patch.
!  Internal work routine.  This routine defines the ordering of the 
!  model dynamical variables in a patch.
!  Note: we always copy the surface pressure into the patch, even if it
!  does not intersect the surface.
!
    integer,intent(in)::patchsz,south,north,nsol
    type(patch_index),intent(in)::loc
    real(GRIDKIND),intent(in)::grid(nsol,south:north,LEVS,LONF,NAVARS)
    real(D),intent(out)::x(nsol,patchsz)
    integer,intent(out),optional::typelist(nsol,patchsz)
!
!  Local variables
!
    integer::offset,j,k,zlo,zhi,xwin,ywin,nlev,ix,iy
    type(patch_index)::newloc
    logical::over_pole
!
    if(patchsz.lt.patchsize(loc)) &
       call fabort('copy_from_mean: array X is too small')
!
    call patch_radius(loc,xwin,ywin)
    do j=-xwin,xwin
       do k=-ywin,ywin
          call xy_adjust(loc,j,k,newloc,zlo,zhi,over_pole)
          offset=patch_offset(loc,j,k)
          nlev=zhi-zlo+1
          if(offset+3*nlev.gt.patchsz)  &
             call fabort('copy_from: patch offset out of range')
          ix=newloc%x
          iy=newloc%y
          x(:,offset)=grid(:,iy,1,ix,PRES_TYPE)
          if(present(typelist)) typelist(:,offset)=PRES_TYPE
          x(:,offset+1:offset+nlev)=grid(:,iy,zlo:zhi,ix,TEMP_TYPE)
          if(present(typelist)) typelist(:,offset+1:offset+nlev)=TEMP_TYPE
          offset=offset+nlev
!
!  An east wind at a point centered near the pole is blowing west relative to
!  a point centered opposite.
!
          if(over_pole) then
             x(:,offset+1:offset+nlev)=-grid(:,iy,zlo:zhi,ix,UWIND_TYPE)
          else
             x(:,offset+1:offset+nlev)=grid(:,iy,zlo:zhi,ix,UWIND_TYPE)
          endif
          if(present(typelist)) typelist(:,offset+1:offset+nlev)=UWIND_TYPE
          offset=offset+nlev
          if(over_pole) then
             x(:,offset+1:offset+nlev)=-grid(:,iy,zlo:zhi,ix,VWIND_TYPE)
          else
             x(:,offset+1:offset+nlev)=grid(:,iy,zlo:zhi,ix,VWIND_TYPE)
          endif
          if(present(typelist)) typelist(:,offset+1:offset+nlev)=VWIND_TYPE
          offset=offset+nlev
       enddo
    enddo
    return
    end subroutine copy_from
!----------------------------------------------------------------------------
    subroutine copy_to_analysis(loc,nc,nsol,center,error,var,badval)
!  COPY_TO_ANALYSIS - copy the analysis at the CENTER of the patch at
!  location LOC to the analysis grid.
!  NC  : Number of variables in the center Column of the patch
!  NSOL : ensemble size
!  CENTER : Kth column contains the NC variables for the Kth ensemble solution.
!  If either of ERROR or VAR is present, then check for nonsense values
!  and flag any that are found in ERROR and note the bad variable type in VAR.
!  ERROR (if present) is set to 0 unless a problem is found.
!
    type(patch_index),intent(in)::loc
    integer,intent(in)::nc,nsol
    real(D),intent(in)::center(nsol,nc)
    integer,intent(out),optional::error,var
    real(D),intent(out),optional::badval  ! if any
!
    integer::asouth,anorth,err,which
    real(D)::val
!
    call assimilation_boundary(asouth,anorth)
    call copy_to(loc,nc,analysis,asouth,anorth,nsol,center)
    if(present(error).or.present(var)) then
       call check_grid_at(analysis,nsol,asouth,anorth,loc,err,which,val)
       if(present(error)) error=err
       if(present(var)) var=which
       if(present(badval)) badval=val
    endif
    return
    end subroutine copy_to_analysis
!----------------------------------------------------------------------------
    subroutine copy_to_mean(loc,nc,cmean)
!  COPY_TO_MEAN - store the analysis mean at the center of the patch at LOC.
!  NC  : Number of variables in the center Column of the patch
!  CMEAN : Kth entry is the mean of the Kth row of CENTER.
!
    type(patch_index),intent(in)::loc
    integer,intent(in)::nc
    real(D),intent(in)::cmean(nc)
!
    integer::asouth,anorth
!
    if(allocated(amean)) then
       call assimilation_boundary(asouth,anorth)
       call copy_to(loc,nc,amean,asouth,anorth,1,cmean)
    endif
    return
    end subroutine copy_to_mean
!----------------------------------------------------------------------------
    subroutine copy_to(loc,nc,agrid,asouth,anorth,nsol,center)
!  COPY_TO - copy CENTER to AGRID, which can be either the full analysis
!  grid or the analysis mean.  Internal work routine.
!  The order in which variables are copied back must be compatible with
!  the ordering defined in COPY_FROM.
!  LOC=(IX,IY,IZ) to an analysis grid.  
!  NC : number of dynamical variables (including the surface pressure)
!     included in the vertical column at CENTER.
!  AGRID : destination grid from latitudes ASOUTH to ANORTH.
!  NSOL  : number of ensemble solutions to copy
!  CENTER : array containing the dynamical variables at the logical center
!     of the patch.
!  Note 1:  although the surface pressure is always included in the analysis,
!  we copy it to the analysis grid only for vertical columns
!  that are intended to give a surface analysis.
!  The ordering of the variables in CENTER depends on copy_from_grid.
!  Note 2:  any deliberate type conversions (single/double) are performed
!     with intrinsic REAL.
!
    integer,intent(in)::asouth,anorth,nsol,nc
    type(patch_index),intent(in)::loc
    real(GRIDKIND),intent(inout)::agrid(nsol,asouth:anorth,LEVS,LONF,NAVARS)
    real(D),intent(in)::center(nsol,nc)
!
!  Local variables
!
    integer::off,ix,iy,iz,zlow,zhigh,nlev
!
!  Sanity checks
!
    if(loc%y.lt.asouth.or.loc%y.gt.anorth)  &
       call fabort('copy_to: bad latitude index')
    if(loc%x.lt.1.or.loc%x.gt.LONF) call fabort('copy_to: bad longitude index')
!
!  When we copy the solution at the center, we compute not only
!  the (x,y) offset to obtain the center of the grid, but we also
!  copy only the dynamical variables at the logical center of the patch.
!  (The logical center differs from the actual
!  center at patches at the surface or at the top of the atmosphere.)
!  When we have vertical localization, the logical center is a single
!  point; otherwise, it is the entire vertical column.
!
    call zdiam(loc,zlow,zhigh)
    nlev=zhigh-zlow+1
    ix=loc%x
    iy=loc%y
    if(nlev.eq.LEVS) then   ! no vertical localization
       do iz=1,LEVS
          agrid(:,iy,iz,ix,PRES_TYPE)=real(center(:,1),kind(agrid))
       enddo
       off=2
       do iz=1,LEVS
          agrid(:,iy,iz,ix,TEMP_TYPE)=real(center(:,off+iz-1),kind(agrid))
       enddo
       off=off+LEVS
       do iz=1,LEVS
          agrid(:,iy,iz,ix,UWIND_TYPE)=real(center(:,off+iz-1),kind(agrid))
       enddo
       off=off+LEVS
       do iz=1,LEVS
          agrid(:,iy,iz,ix,VWIND_TYPE)=real(center(:,off+iz-1),kind(agrid))
       enddo
       off=off+LEVS
       if(off.ne.nc+1) then  ! OFF should point exactly 1 above the top
          call fabort('copy_to: center indexing botched')
       endif
    else
       if(loc%z.eq.1) then ! include surface pressure
          do iz=1,LEVS
             agrid(:,iy,iz,ix,PRES_TYPE)=real(center(:,1),kind(agrid))
          enddo
       endif
       iz=loc%z
       off=iz-zlow+2  ! point to temperature at level iz
       agrid(:,iy,iz,ix,TEMP_TYPE)=real(center(:,off),kind(agrid))
       off=off+nlev
       agrid(:,iy,iz,ix,UWIND_TYPE)=real(center(:,off),kind(agrid))
       off=off+nlev
       agrid(:,iy,iz,ix,VWIND_TYPE)=real(center(:,off),kind(agrid))
       off=off+zhigh-iz
       if(off.gt.nc) then
          call fabort('copy_to: center indexing botched')
       endif
    endif
    return
    end subroutine copy_to
!----------------------------------------------------------------------------
    subroutine transpose_grid(inbuf,outbuf,south,north,nsol)
!  TRANSPOSE_GRID - Convert the input buffer from the subscript order that's
!  most efficient for spectral transforms to the order that's most efficient
!  for the rest of the data assimilation algorithm.
!  This part of the code is not cache-friendly.  If it becomes
!  a problem, we can do an intermediate transposition step to reduce the
!  number of cache misses before performing the scaling.
!
    integer,intent(in)::south,north,nsol
    real(GRIDKIND),intent(in)::inbuf(LONF,NAVARS,south:north,LEVS,nsol)
    real(GRIDKIND),intent(out)::outbuf(nsol,south:north,LEVS,LONF,NAVARS)
!
    integer::k,lat,lev
!
    do k=1,nsol
      do lat=south,north
         do lev=1,LEVS
             outbuf(k,lat,lev,:,:)=inbuf(:,:,lat,lev,k)
         enddo
       enddo
    enddo
    return
    end subroutine transpose_grid
!----------------------------------------------------------------------------
    subroutine precompute_ensemble_differences
!  PRECOMPUTE_ENSEMBLE_DIFFERENCES -
!  Precompute the ensemble differences: we compute BMEAN, whose
!  (Y,Z,X,V) entry is the ensemble mean of variable V at (X,Y,Z),
!  and subtract from BACKGROUND, whose (K,Y,Z,X,V)th entry becomes the 
!  difference between the Kth ensemble solution and the corresponding mean.
!
    integer::k
!
    if(did_diffs) return   ! don't do this twice
    do k=1,size(background,1)
       background(k,:,:,:,:)=background(k,:,:,:,:)-bmean(:,:,:,:)
    enddo
    did_diffs=.true.
    write(LOGFILE,'(a)') 'ensemble differences precomputed'
    return
    end subroutine precompute_ensemble_differences
!----------------------------------------------------------------------------
    logical function ensemble_diffs_precomputed(grid)
!  ENSEMBLE_DIFFS_PRECOMPUTED - return true or false according as
!  the ensemble differences have been precomputed for the indicated grid.
!  If GRID is omitted, it defaults to the background.
!
    character(*),intent(in),optional::grid
!
    if(present(grid)) then
       ensemble_diffs_precomputed=grid.eq.'background'.and.did_diffs
    else
       ensemble_diffs_precomputed=did_diffs
    endif
    return
    end function ensemble_diffs_precomputed
!----------------------------------------------------------------------------
    pure subroutine check_grid_at(grid,nsol,south,north,loc,errtype,var,badval)
!  CHECK_GRID_AT - perform heuristic checks for obvious problems with
!  the dynamical variables in GRID at LOC.  On return, ERROR is set if
!  VAR at LOC fails the test.
!  The checks are as follows:
!  1) NaN (not-a-number) value
!  2) surface pressure <= 0
!  3) temperature <= 0 
!  4) wind speed >= 500 m/s
!  ERRTYPE is set to 0 for no error, 1 for bad value, 2 for inf/NaN.
!  BADVAL is set to the first bad value (if any) that is found, provided that
!     ERRTYPE is BAD_VALUE.  The output value is undefined if ERRTYPE
!     is inf/NaN or if ERRTYPE is 0.
!  NOTE: This routine is to be called AFTER any internal scalings are applied!
!
    use inf_and_nan
    integer,intent(in)::nsol,south,north
    real(GRIDKIND),intent(in)::grid(nsol,south:north,LEVS,LONF,NAVARS)
    type(patch_index),intent(in)::loc
    integer,intent(out)::errtype
    integer,intent(out)::var
    real(D),intent(out)::badval
!
    real(D)::val
    integer::j
!
!  In energy units, values larger than this are likely trouble
!
    real(D),parameter::WINDMAX=10000.0 
!
!  Check for ridiculous values of surface pressure if the patch includes
!  the surface
!
    errtype=NONE
    var=PRES_TYPE
    if(any(isnan(grid(:,loc%y,loc%z,loc%x,PRES_TYPE)))) then
       errtype=INF_OR_NAN
    else if(loc%z.eq.1) then
       do j=1,nsol
          val=grid(j,loc%y,loc%z,loc%x,PRES_TYPE)
          if(val.le.0.0) then  ! in energy units, ln(dPa)*scale < 0 is trouble
             errtype=BAD_VALUE
             badval=val
             exit
          endif
       enddo
    endif
    if(errtype.ne.NONE) return
!
!  Check temperature
!
    errtype=NONE
    var=TEMP_TYPE
    if(any(isnan(grid(:,loc%y,loc%z,loc%x,TEMP_TYPE)))) then
       errtype=INF_OR_NAN
    else 
       do j=1,nsol
          val=grid(j,loc%y,loc%z,loc%x,TEMP_TYPE)
          if(val.le.0.0) then
             errtype=BAD_VALUE
             badval=val
             exit
          endif
       enddo
    endif
    if(errtype.ne.NONE) return
!
!  Check wind
!
    errtype=NONE
    var=UWIND_TYPE
    if(any(isnan(grid(:,loc%y,loc%z,loc%x,UWIND_TYPE)))) then
       errtype=INF_OR_NAN
    else
       do j=1,nsol
          val=abs(grid(j,loc%y,loc%z,loc%x,UWIND_TYPE))
          if(val.ge.WINDMAX) then
             errtype=BAD_VALUE
             badval=val
             exit
          endif
       enddo
    endif
    if(errtype.ne.NONE) return
!
    errtype=NONE
    var=VWIND_TYPE
    if(any(isnan(grid(:,loc%y,loc%z,loc%x,VWIND_TYPE)))) then
       errtype=INF_OR_NAN
    else
       do j=1,nsol
          val=abs(grid(j,loc%y,loc%z,loc%x,VWIND_TYPE))
          if(val.ge.WINDMAX) then
             errtype=BAD_VALUE
             badval=val
             exit
          endif
       enddo
    endif
    if(errtype.eq.NONE) var=NONE
    return
    end subroutine check_grid_at
!----------------------------------------------------------------------------
    pure subroutine check_model_grid(grid,nsol,south,north,errtype,loc,var,bad)
!  CHECK_MODEL_GRID - check whether the grid contains suspect entries.
!  If there are such entries, then toggle ERROR and
!  set LOC to the (J,K,LEV) index and variable type VAR
!  at which such an entry is found.
!
    use inf_and_nan
    integer,intent(in)::nsol,south,north
    real(GRIDKIND),intent(in)::grid(nsol,south:north,LEVS,LONF,NAVARS)
    integer,intent(out)::errtype
    type(patch_index),intent(out)::loc
    integer,intent(out)::var
    real(D),intent(out)::bad
!
    integer::ix,iy,iz
!
    do ix=1,LONF
       do iz=1,LEVS
          do iy=south,north
             loc=patch_index(ix,iy,iz)
             call check_grid_at(grid,nsol,south,north,loc,errtype,var,bad)
             if(errtype.ne.NONE) return
          enddo
       enddo
    enddo
    return
    end subroutine check_model_grid
! ----------------------------------------------------------------------
    subroutine read_nature_grid(header,truthfn,seq)
!  READ_NATURE_GRID - read the nature grid and scale its entries to be 
!  compatible with those used in the rest of the data assimilation code.
!  Side effects:
!   - allocates and defines natgrid
!
!   Arguments:
!   HEADER : character label to expect, if any, in the nature grid file
!   TRUTHFN : file name containing the nature grid
!
    character(*),intent(in)::header,truthfn
    integer,intent(in)::seq
!
    integer::psouth,pnorth,isouth,inorth,nassim,iens,seqno,south,north,info
    real(GRIDKIND),allocatable::buf(:,:,:,:,:)
!
    call read_grid_header(truthfn,header,isouth,inorth,psouth,pnorth,iens, &
       nassim,seqno)
    call model_grid_boundary(south,north)
    if(isouth.ne.south.or.inorth.ne.north) then
       write(IERR,900) isouth,south,inorth,north,psouth,pnorth
       call fexit(trim(truthfn)//': latitude boundary mismatch',2)
    endif
900 format('read_nature_grid: bad strip boundary: isouth: ',i0, &
       ' south: ',i0, ' inorth: ',i0,' north: ',i0,' psouth: ',i0, &
       ' pnorth: ',i0)
    if(iens.ne.1) then
       call fexit(trim(truthfn)//': contains more than one solution',2)
    else if(nassim.ne.NAVARS) then
       call fexit(trim(truthfn)//': number of model variables is wrong',2)
    else if(seqno.ne.seq) then
       call fexit(trim(truthfn)//': sequence number mismatch',2)
    endif
    allocate(buf(LONF,NAVARS,south:north,LEVS,1),stat=info)
    if(info.ne.0) then
       write(IERR,911) 'buf',info
       call program_exit(1)
    endif
911 format('diag_init: cannot allocate ',a,' info: ',i0)
    allocate(natgrid(south:north,LEVS,LONF,NAVARS),stat=info)
    if(info.ne.0) then
       write(IERR,911) 'natgrid',info
       call program_exit(1)
    endif
    call read_model_grid(buf,south,north,1)
    call transpose_grid(buf,natgrid,south,north,1)
    return
    end subroutine read_nature_grid
! ----------------------------------------------------------------------
    end module grid_model

    module command_line_support
! COMMAND_LINE_SUPPORT - support routines for parsing command-line options,
! filename manipulation, and miscellaneous run-time support.
    contains
!----------------------
    subroutine program_exit(code)
!  PROGRAM_EXIT - halt the program and return CODE to the shell.
!  If absent, CODE defaults to 0.
!
    integer,intent(in),optional::code
!
    integer::retcode
!
    if(present(code)) then
       retcode=code
    else
       retcode=0
    endif
    call exit(retcode)  ! nonstandard call
    end subroutine program_exit
!----------------------
    subroutine numeric_filename(template,repl,ival,fn)
!  NUMERIC_FILENAME - given a template, a replacement text, and
!  an integer value, return a new name that is the template with the 
!  first occurrence of the replacement text in the template
!  replaced by the decimal representation of the integer.
!  Example:  numeric_filename('myfile.%n','%n',3,fn) returns fn as 'myfile.3'.
!  Example:  if you just want to suffix the template with the numerical
!  value, use a blank replacement text: numeric_filename(template,' ',ival,fn).
!  (This assumes that the filename contains no significant embedded blanks.)
!  Caveats:
!  - The decimal integer representation does NOT contain leading zeros.
!  - The template must be sufficiently long to accommodate
!  the substitution of the integer value without discarding nonblank
!  characters.
!  - If the replacement text isn't found in the template, the template
!  string itself is returned with the decimal representation of ival
!  appended.
!
    implicit none
    character(*),intent(in)::template,repl
    integer,intent(in)::ival
    character(*),intent(out)::fn
!
!  Local variables
!
    integer::lenr,istart,leni
    character(10)::aval
!
!  Find the location of the replaceable text (which may contain blanks)
!  in the template.  If the text isn't there, then return the template.
!  
    lenr=len(repl)   ! may contain blanks
    write(aval,'(i10)') ival
    call no_leading_blanks(aval)
    istart=index(template,repl)   
    if(istart.eq.0) then       ! repl not in template; append value
       fn=trim(template)//aval
    else                       ! replace repl with ival
       fn=template(1:istart-1)//trim(aval)//template(istart+lenr:)
    endif
    return
    end subroutine numeric_filename
!----------------------
    subroutine no_leading_blanks(s)
!  NO_LEADING_BLANKS - modify the string S so it contains no leading blanks.
!
    implicit none
    character(*),intent(inout)::s
!
    integer::j,k,n 
!
    n=len(s)
    k=0
    do j=1,n  ! put number of leading blanks into k
       if(s(j:j).eq.' ') then
          k=k+1
       else
          exit
       endif
    enddo
    if(k.gt.0.and.k.lt.n) then
       s(1:n-k)=s(k+1:n)
       s(n-k+1:n)=' '
    endif
    return
    end subroutine no_leading_blanks
!------------------------------------
    subroutine getopt(iopt,optarg,optind,control)
!  GETOPT - parse an execute line for options and their arguments.
!  Designed for one sequence of consecutive calls to parse the command line.
!  This is designed to have similar functionality to the Posix standard
!  getopt.
!  IOPT    := when positive, the integer such that CHAR(IOPT) is the option 
!                letter; -1 indicates the end of the option list.
!                If an option is found that is not in the control string,
!                IOPT is set such that CHAR(IOPT) is '?'.
!  OPTARG  := character string set to the corresponding argument of the
!                option, if any.
!  OPTIND  := Set to the index of the next unexamined argument.
!  CONTROL  : control string containing the list of all valid options.
!                Option letters which take arguments are followed by a colon.
!                (See getopt(3c)).
!
    integer,parameter::ARGLEN=128,STDERR=0
    integer,intent(out)::iopt,optind
    character(*),intent(out)::optarg
    character(*),intent(in)::control
!
!  Local variables
!
    integer::idx,numarg
    character(ARGLEN)::arg
    character::unk
    integer,save::argnum=1,argidx=2
    integer,external::iargc
    external getarg
!
!  ARGNUM is the number of the argument (as a consecutive word) to fetch
!  in the next call.  ARGIDX is the index within an argument to check for
!  an option letter.  Both must be properly set before the call proceeds.
!  Check for end of options.
!
    numarg=iargc()
    if(argnum.gt.numarg) goto 90
    call getarg(argnum,arg)
    if(arg(1:1).ne.'-') goto 90
    if(arg(1:2).eq.'--') then
       argnum=argnum+1
       goto 90
    endif
!
!  Find position of option letter in control string.  0 means it's not
!  there, so it's not valid.
!
    idx=index(control,arg(argidx:argidx))
    if(idx.eq.0) then
       iopt=ichar('?')
       unk=arg(argidx:argidx)
       call getarg(0,arg)
       write(STDERR,910) trim(arg),unk
       argidx=argidx+1
       if(arg(argidx:argidx).eq.' ') then
          argnum=argnum+1
          argidx=2
       endif
    else
       iopt=ichar(arg(argidx:argidx))
       argidx=argidx+1
!
!  Get option argument, which may or may not be separated from the
!  option by a blank.
!
       idx=idx+1
       if(control(idx:idx).eq.':') then
          if(arg(argidx:argidx).ne.' ') then
             optarg=arg(argidx:ARGLEN)
          else
             argnum=argnum+1
             if(argnum.gt.numarg) then
                optarg=' '
                unk=arg(argidx-1:argidx-1)
                call getarg(0,arg)
                write(STDERR,900) trim(arg),unk
             else
                call getarg(argnum,optarg)
             endif
          endif
          argnum=argnum+1
          argidx=2
!
!  No option for argument - check if next option is appended to same string.
!
       else 
          if(arg(argidx:argidx).eq.' ') then
             argidx=2
             argnum=argnum+1
          endif
          optarg=' '
       endif
    endif
    optind=argnum
    return
!
!  Out of options
!
 90 continue
    iopt=-1
    optind=argnum
    optarg=' '
    return
!
  900 format(a,': option ',a1,' requires an argument')
  910 format(a,': unknown option ',a1)
    end subroutine getopt
!------------------------------------
     subroutine getsubopt(string,list,n,status,value,parse_err)
!  GETSUBOPT: like XPG4 version in C.
!  Given an option string like abc=3,def=4, decompose the string
!  into name, value pairs as follows:
!  STRING:=:  contains the string to be parsed.  On return, contains
!    only the unparsed bits, corresponding to unmatched options, if any.
!  LIST  : holds a list of potential options
!  N     : length of list
!  STATUS:= logical array of length N.  Set to .true. if corresponding
!           option is found.
!  VALUES := Kth element is set to matching value, if any is found,
!           of corresponding option.  If there is no corresponding
!           value, then the entry is set to 0.
!  LIMITATIONS:
!  If one suboption is an initial substring of another, then the shorter
!  option must appear first in any argument string.
!  EXAMPLE:  suppose that list(1)="abc"
!  and list(2)="abcdef".  The string abc=1,abcdef=2 is parsed correctly,
!  but abcdef=2,abc=1 is not.
!  Therefore, in production code, it is best to avoid suboptions such
!  that one is a leading substring of another.
!
    implicit none
    integer,intent(in)::n
    character(*),intent(in)::list(n)
    character(*),intent(inout)::string
    logical,intent(out)::status(n),parse_err
    integer,intent(out)::value(n)
!
!  Local variables
!
    integer::k,istart,iend,icom,optend,ios,lenstring
    character(len(string))::valstr
!
    parse_err=.false.
    status=.false.
    value=0
    lenstring=len_trim(string)
    do k=1,n
       valstr=' '
       call delimit(trim(list(k)),string,istart,iend)
       if(istart.gt.0) then
          if(iend.lt.lenstring) then    ! look for possible subopt=valstr
             if(string(iend+1:iend+1).eq.'=') then
                icom=index(string(iend+1:),',')
                if(icom.eq.1) then      ! have subopt=,
                   optend=iend+2
                   valstr=' '
                   parse_err=.true.
                else if(iend+1.eq.lenstring) then ! have subopt= at end
                   optend=iend+1
                   valstr=' '
                   parse_err=.true.
                else if(icom.eq.0) then    ! subopt=valstr lies at end
                   optend=lenstring
                   valstr=string(iend+2:optend)
                else
                   optend=iend+icom
                   valstr=string(iend+2:optend-1)
                endif
             else       ! no = after subopt
                icom=index(string(iend+1:),',')
                optend=iend+icom
             endif
          else
             optend=iend
          endif
          status(k)=.true.
          if(len_trim(valstr).gt.0) then
             read(valstr,*,iostat=ios) value(k)
             if(ios.ne.0) then
                parse_err=.true.
                value(k)=0.0
             endif
          else
             value(k)=0.0
          endif
          string(istart:)=string(optend+1:)
       endif
    enddo
   !
   ! If anything is unparsed, then there are extra options not in LIST.
   ! Note: previous version replaced istart:optend with blanks instead
   ! of moving down the contents of string each time.  That was a hazard
   ! as it didn't always identify . instead of , as separator.  If .
   ! was used accidentally, there was a possibility that all subsequent
   ! values after the . would be erased.  This version sometimes accepts
   ! . instead of , but its presence is harmless if it isn't detected -
   ! usually it is, and parse_err is set, depending on the order in which
   ! the options are tested.
   !
    if(len_trim(string).gt.0) parse_err=.true.
    return
    contains
      !
      ! DELIMIT checks whether sym is a substring of another possible
      ! symbol.  If sym doesn't exist in str, then ISTART=0.
      ! Otherwise, ISTART and IEND delimit the starting and ending
      ! indices, respectively, of SYM.  The remaining code needs to check
      ! whether etring(iend+1) is an '=' or ',' as appropriate.
      !
       subroutine delimit(sym,str,istart,iend)
       implicit none
       character(*),intent(in)::sym,str
       integer,intent(out)::istart,iend
       !
       integer::j,m,lensym,lenstr
       !
       lensym=len_trim(sym)
       lenstr=len_trim(str)
       istart=0
       j=1
       do while(j.le.lenstr)
          m=index(str(j:),sym)-1
          if(m.lt.0) then         ! sym does not exist in str
             istart=0
             exit
          else if(m.eq.0) then    ! sym is an initial substring
             istart=j
          else                    ! sym may be an initial substring; check
             istart=j+m
             if(index('=, ',str(istart-1:istart-1)).eq.0) then
                j=istart          ! it's not; look further on in str
                cycle
             endif
          endif
          iend=istart+lensym      ! 1 past tentative end of symbol
          if(iend.eq.lenstr+1) then  ! it's at end, so it matches
             iend=iend-1
             exit
          else if(index('=, ',str(iend:iend)).eq.0) then  ! just a substring
             j=istart+lensym
             cycle
          else       ! we have a match; don't include trailing =
             iend=iend-1
             exit
          endif
       enddo
       if(j.gt.lenstr) istart=0
       return 
       end subroutine delimit
    end subroutine getsubopt
!------------------------------------
    end module command_line_support

! POSTANALYSIS - combine one or a family of output files from the
! assim or assim_p programs into a collection of sigma files, one
! per ensemble solution.
!  Modification history:
!  08/25/05 - Added compatibility to both 2004 and 2001 GFS versions.
!  06/17/05 - Added capability to convert physical perturbation files
!             directly to sigma file format.
!  06/16/05 - Changes to accommodate overhauled spectral code.
!  05/25/05 - Changes to handle sigma file format for 2004 GFS; added option
!             for namelist input (for debugging); simplified interface:
!             -f file now specifies a sigma file from which all unassimilated
!             variables are taken.
!  03/07/05 - Uses new spectral transform routines to fix N/S hemisphere
!             indexing.
!  12/14/04 - altered array indexing of input model grid format for more
!             cache-friendly processing.  Also put burden of rescaling
!             onto the data assimilation code.
!  10/12/04 - changes to read the new output model grid format.
!  08/25/04 - made compatible with revised grid manager code and
!             eliminated support for longitude-major formats (except
!             for the debug output model grid).
!  07/27/04 - added handling of surface analysis files from GFS code.
!  05/17/04 - added -q and -z options for selective copying of humidity and
!             ozone.
!  02/20/04 - Fixed the handling of humidity and ozone
!             when a sigma file for the analysis mean is requested.
!             When a mean sigma file is requested, these
!             values are averaged from those in each of the reference sigma
!             files.  (Note: divergence and vorticity are computed from
!             the analyses.)
!  10/17/03 - version by Eric that can input grid formats in either
!             longitude- or latitude-major format
!  08/28/03 - version by Eric to handle new grid format that slices
!             latitudinally rather than longitudinally.
!  05/30/03 - version by Eric to handle families of grid files.
!  10/04/02 - initial version by Istvan Szunyogh.
!-----------------------------------------
!  Implementation note on the Karman/Keckwulf clusters:
!  The input and output sigma files need to be in big-endian format,
!  as this is the format that the GFS code uses.  For correct operation,
!  the environment variable FORT90L must be set as follows:
!     export FORT90L="-Wl,-T1,-T2"
!  This is a Lahey-specific environment variable.
!-----------------------------------------
! COMMAND LINE OPTIONS:
!  postanalysis -f name [options] [input_grid_file]
!  -f name : (no default) This is a required option.  NAME specifies
!            a sigma file containing scaling coefficients and all unassimilated
!            data.
!            Two cases:
!            (1) If name is a template name, then name refers to a family
!            of sigma files, one for each ensemble member, from which
!            unassimilated values are copied.
!            (2) If name is not a template name, then unassimilated variables
!            are copied from this file into EACH of the output sigma files,
!            one per ensemble member (as well as to the mean sigma file
!            if -m is specified).  In this case, name should refer
!            to the appropriate sigma file from the nature run or NCEP analysis.
!  -d date : The date, in yyyymmddhh format, used to document the output
!            sigma files.  (Otherwise y=m=d=h=0 is used.)
!  -v lev  : (default: lev=0) Set the verbosity level to LEV.
!            0 gives silent operation (unless an error occurs).
!            1 gives brief status, 2 shows many details.
!  -m mean : (default: none) The name of the sigma file containing the
!            spectral transform of the analysis mean.
!  -n nsol : (default: nsol=1) number of ensemble members.
!  -p np   : (default: np=1) number of input grid files to expect.
!            The value for NP _must_ agree with that used in the
!            corresponding invocation of preanalysis; otherwise, some grid
!            points may have garbage values.
!  -s name : (default: name="sigma.out") Base name for the output sigma
!            files.  If NSOL=1, then name is the actual name of the
!            output file.  If NSOL > 1, then name is a template name.
!            NSOL output files are created, named name1, ..., nameNSOL.
!            If name contains the substring %n, then %n is replaced with
!            the numbers 1 ... NSOL to create the sequence of output
!            sigma files.  Example: -s pnew%n.00 would yield files named
!            pnew1.00, pnew2.00, etc.
!  -S name : (no default)  If present, name must be a template name that
!            specifies a family of surface analysis files, one for each
!            ensemble solution, that are output from the GFS model.
!            These are averaged together to create a mean file that is
!            indicated with %n replaced by 0.  If omitted, the program does
!            not process any surface analysis files.
!  -h      : print a summary of the command-line options and halt.
!  input_grid_file :  (default "egrid.out")  The name of the file from
!            the data assimilation step.  If -p is specified, then there
!            are NP slices to the data, and input_grid_file should specify
!            a template file.  Substitutions in the name are performed as
!            described in the -s option above.
!
    module postanalysis
    use spectral
    use fsplit
    use surface
    use command_line_support
    use gfs_ids
    implicit none
!
    character(*),parameter::VERSION='08/25/05 (2001/04 models, energy units)'
!
    character(MAX_FILE_NAME_LEN),save::phys_grid_fn='egrid.out'
!
!  Output file, which is a template name if nsol > 1
!
    character(MAX_FILE_NAME_LEN),save::sigma_out_fn='sigma.out'
!
!  Optional output file containing the analysis mean in spectral coords
!
    character(MAX_FILE_NAME_LEN),save::mean_sigma_fn=' '
!
!  Required sigma reference file for spectral data and any unassimilated
!  variables (-f flag).
!
    character(MAX_FILE_NAME_LEN),save::ref_sig_fn=' '  ! no default
!
!  Optional surface analysis file family (-S flag).
!
    character(MAX_FILE_NAME_LEN),save::sfc_fn=' '
!
    integer,parameter::HEADER_TAG_LEN=4
    character(HEADER_TAG_LEN),save::expected_tag='aout'
!
!  Number of partitions of output grid files from data assimilation
!
    integer,save::nsplit=1
!
!  By default, the input consists of latitude strips processed by the
!  data assimilation code.  But if -P is specified, then the input
!  consists of physical grid perturbation files that will be transformed
!  directly to sigma.
!
    logical,save::input_is_pert=.false.
    contains
!------------------------------------------------------------------------------
    subroutine do_everything
!  DO_EVERYTHING - so we don't have to go to the end of the file to
!  see the main program
!
    character(10)::cdate=' '   ! in yyyymmddhh format
    type(sfcanl)::avg
    character(MAX_FILE_NAME_LEN)::sfc_out
    real(R)::fhour
    integer::nsol
!
    if(verbosity().gt.VERB_TERSE) write(IOUT,100) version
100 format('postanalysis: version ',a)
    call parseline(cdate,nsol)
    call convert_to_sigma(cdate,nsol,ref_sig_fn)
!
!  Surface average is member 0
!
    if(len_trim(sfc_fn).gt.0) then
       call read_surface_files(sfc_fn,avg,fhour,nsol)
       call numeric_filename(sfc_fn,'%n',0,sfc_out)
       call write_sfcanl(sfc_out,avg,0.0,cdate) ! new initial condition
    endif
    return
    end subroutine do_everything
!-----------------------------------------------------------------------------
    subroutine convert_to_sigma(cdate,nsol,ufn)
!  CONVERT_TO_SIGMA - convert from physical to spectral coordinates and
!  write out a family of sigma files, one for each ensemble member, suitable
!  for input to the GFS model to run a forecast.
!  CDATE is a time stamp of the form yyyymmddhh that is written into
!  each of the sigma files.
!  UFN : the name of a family of sigma files from which to copy
!     the coefficients of any unassimilated variables.  This name is a 
!     template name if it contains "%n".  Otherwise, ALL output files
!     will contain the SAME values of any unassimilated variables.
!
    character(*),intent(in)::cdate,ufn
    integer,intent(in)::nsol
!
!  Local variables.
!
    type(sigma_file_header)::header
    type(spectral_coeffs)::spect    ! coeffs for assimilated variables
    type(spectral_coeffs)::unspect  ! coeffs for unassimilated variables
    type(spectral_coeffs)::avgspect  ! coeffs for averaged variables
    real(GRIDKIND),allocatable::egrid(:,:,:,:,:),mean(:,:,:,:)
    integer::nc,ns,verblev
    character(MAX_FILE_NAME_LEN)::sfn,refname,fn
    logical::template_ref_name
!
!  Initialize.  The reference sigma file has the same endian convention
!  as the output sigma files from this program: it may require byte-swapping.
!  We regard the reference sigma file as a template name if it contains
!  the substring "%n".  Copy all unassimilated variables from it.
!
    template_ref_name=index(ufn,'%n').gt.0
    if(template_ref_name) then  ! use the first one for initialization
       call numeric_filename(ufn,'%n',1,refname)
    else
       refname=ufn
    endif
    call spectral_code_init(refname,header,unspect)
!
    verblev=verbosity()
    if(verblev.gt.VERB_SILENT) &
       write(LOGFILE,'(2a)') 'postanalysis: output family: ',trim(sigma_out_fn)
!
!  Read the model grids in physical coordinates.
!
    allocate(egrid(LONF,NAVARS,LATG,LEVS,nsol))
    ns=nsplit
    if(len_trim(mean_sigma_fn).gt.0) then
       allocate(mean(LONF,NAVARS,LATG,LEVS))
       avgspect%gz=0.0
       avgspect%rq=0.0
       avgspect%oz=0.0
    endif
!
    if(input_is_pert) then
       if(allocated(mean)) mean=0.0
       do nc=1,nsol
          if(nsol.eq.1) then
             fn=phys_grid_fn
          else
             call numeric_filename(phys_grid_fn,'%n',nc,fn)
          endif
          call read_perturbation_file(fn,egrid(1,1,1,1,nc))
          if(allocated(mean)) mean=mean+egrid(:,:,:,:,nc)
       enddo
       if(allocated(mean)) mean=mean/nsol
    else if(allocated(mean)) then
       call read_grid_files(phys_grid_fn,egrid,nsol,ns,mean)
    else
       call read_grid_files(phys_grid_fn,egrid,nsol,ns)
    endif
! 
!  Convert assimilated variables to spectral coordinates,
!  merge unassimilated variables from reference sigma files,
!  and write out the merged coefficients.  Compute the mean of the
!  spectral coefficients as we go along if the mean field is requested.
!
    do nc=1,nsol 
       call from_physical_space(egrid(1,1,1,1,nc),spect)
       call numeric_filename(sigma_out_fn,'%n',nc,sfn)
       if(verblev.gt.VERB_TERSE) &
          write(LOGFILE,'(2a)') 'postanalysis: writing ',trim(sfn)
       if(template_ref_name.and.nc.gt.1) then  ! 1st file was read previously
          call numeric_filename(ref_sig_fn,'%n',nc,refname)
          call read_sigma_file(refname,header,unspect)
       endif
       call writeout(header,unspect,spect,cdate,sfn)
       if(allocated(mean)) then  ! average unassimilated humidity and ozone
          avgspect%gz=avgspect%gz+spect%gz
          avgspect%rq=avgspect%rq+spect%rq
          avgspect%oz=avgspect%oz+spect%oz
       endif
    enddo
!
!  Transform and output the analysis mean as needed.  
!
    if(allocated(mean)) then
       if(verblev.gt.0) &
          write(LOGFILE,'(2a)') 'postanalysis: writing ',trim(mean_sigma_fn)
       call from_physical_space(mean,avgspect)
       unspect%gz=avgspect%gz/nsol
       unspect%rq=avgspect%rq/nsol
       unspect%oz=avgspect%oz/nsol
       call writeout(header,unspect,avgspect,cdate,mean_sigma_fn)
    endif
    return
    end subroutine convert_to_sigma
! ----------------------------------------------------------------------------
    subroutine writeout(header,unspect,spect,cdate,fn)
!  WRITEOUT - write a sigma file, taking the spectral coefficients of
!  unassimilated variables from UNSPECT and merging them with SPECT,
!  which contains the spectral coefficients of the assimilated variables.
!  Arguments:
!  HEADER :=: header to place in the output sigma file.  The date field
!  is updated with CDATE.
!  UNSPECT : spectral coefficients of unassimilated variables, currently
!     ozone and relative humidity.
!  SPECT :=: on input, spectral coefficients of assimilated variables;
!     unassimilated components are copied from UNSPECT on return.
!  CDATE  : character date in yyyymmddhh format; placed in HEADER>
!  FN  : name of the sigma file to which we write the data.
!  VERBLEV  : if > 1, then we output the rms mean of each dynamical variable
!     at level 5 to the standard output.
!
!  SIDE EFFECTS
!    Opens and closes OUTSWAP.
!
    type(sigma_file_header),intent(inout)::header
    type(spectral_coeffs),intent(in)::unspect
    type(spectral_coeffs),intent(inout)::spect
    character(*),intent(in)::fn,cdate
!
!  Local variables
!
    integer::idate(4)
!
!  Copy coeffs of unassimilated humidity and ozone variables; also retain
!  the geopotential height!
!
    spect%gz=unspect%gz
    spect%rq=unspect%rq
    spect%oz=unspect%oz
!
!  The input date string has the format yyyymmddhh, but the date
!  format in the GFS sigma files is hh mm dd yyyy.
!
    if(len_trim(cdate).eq.10) then
       read(cdate,'(i4,3i2)') idate(4),idate(2),idate(3),idate(1)
    else
       idate=0
    endif
    header%fhour4=0.0
    header%idate=idate
    call write_sigma_file(fn,header,spect)
    return
    end subroutine writeout
!-----------------------------------------------------------------------------
    subroutine read_grid_files(abase,analysis,nsol_expect,npart,mean)
!  READ_GRID_FILES - read one or more files containing the model grid
!  from the data assimilation code.
!  ABASE  : this is the base name for the analysis files.  This is a
!           template name if NS > 1.
!  ANALYSIS  := holds the global analysis grid.
!  NSOL_EXPECT  : number of ensemble solutions to expect
!  NPART  : The number of partitions of the assimilation output files;
!     may be adjusted on return according to the same algorithm used
!     to compute the number of splits in preanalysis.
!  MEAN  := If present, the ensemble mean is computed and stored here
!
    implicit none
    character(*),intent(in)::abase
    integer,intent(in)::nsol_expect
    integer,intent(inout)::npart
    real(GRIDKIND),intent(out)::analysis(LONF,NAVARS,LATG,LEVS,nsol_expect)
    real(GRIDKIND),intent(out),optional::mean(LONF,NAVARS,LATG,LEVS)
!
!  Local variables
!
    real(IOKIND),allocatable::buf(:,:,:,:,:)
    integer::k,n,nsol,nstrips,verblev,seqno,nassim,north,south
!
!  COVERED(i,j) is the number of times model location (i,j) is covered
!  by some assimilation grid; should be exactly 1 for every (i,j).  
!
    integer::covered(LONF,LATG)
    integer,allocatable::list(:),startlat(:),endlat(:),psouth(:),pnorth(:)
    character(len(abase)+4)::nthfile
    real(GRIDKIND),allocatable::grid(:,:,:,:,:)
!
!  Initialize.  Use the same algorithm for splitting as in preanalysis,
!  so that we compute the correct number of analysis vector files to expect.
!
    nstrips=LATG
    call imod(npart,list,nstrips,0,startlat,endlat,psouth,pnorth)
    verblev=verbosity()
    if(verblev.gt.VERB_SILENT) write(IERR,100) trim(abase)
100 format('postanalysis: input: ',a)
!
!  Loop through all partial analysis files.
!
    if(npart.eq.1) then
       call read_grid_header(abase,'none',south,north,psouth(1),pnorth(1), &
          nsol,nassim,seqno)
       if(nsol.ne.nsol_expect) then
          write(IERR,103) trim(abase),nsol,nsol_expect
103       format(a,': contains ',i0,' solutions; expected ',i0,' members')
          call fexit(trim(abase)//': unexpected number of solutions',2)
       else if(seqno.ne.seqid()) then
          write(IERR,104) trim(abase),seqno,seqid()
104       format(a,' has sequence number: ',i0,' expected: ',i0)
       endif
       allocate(buf(LONF,NAVARS,LATG,LEVS,nsol_expect))
       read(INNOSWAP) buf
       close(INNOSWAP)
       covered=1
       analysis=buf
    else
       analysis=0.0
       covered=0
       do n=1,npart
          call numeric_filename(abase,'%n',n,nthfile)
          if(verblev.gt.VERB_TERSE) write(IERR,105) trim(nthfile)
105       format('postanalysis: reading ',a)
          call read_grid_header(nthfile,expected_tag,south,north, &
             psouth(n),pnorth(n),nsol,nassim,seqno)
          if(nsol.ne.nsol_expect) then
             write(IERR,103) trim(nthfile),nsol,nsol_expect
             call fexit(trim(nthfile)//': unexpected number of solutions',2)
          else if(seqno.ne.seqid()) then
             write(IERR,104) trim(abase),seqno,seqid()
          endif
          if(nassim.ne.NAVARS) &
             call fexit(trim(nthfile)//': assimilated var types must be 4',2)
          if(verblev.gt.VERB_TERSE) write(IERR,107) psouth(n),pnorth(n)
!
          allocate(grid(LONF,NAVARS,south:north,LEVS,nsol))
          call read_model_grid(grid,south,north,nsol)
          analysis(:,:,south:north,:,:)=grid
          covered(:,south:north)=covered(:,south:north)+1
          deallocate(grid)
       enddo
    endif
107 format('assimilation region: S:',i4,' N:',i4)
!
!  Ensure that every grid point is covered exactly once.
!
    if(any(covered.ne.1)) &
       call fexit('missing or overlapping grid centers in data',errcode=2)
!
!  Compute the mean of the analysis fields if requested.
!
    if(present(mean)) then
       mean=analysis(:,:,:,:,1)
       do k=2,nsol
          mean=mean+analysis(:,:,:,:,k)
       enddo
       mean=mean/nsol
    endif
    return
    end subroutine read_grid_files
!----------------------------------------------------------------------------
    subroutine read_perturbation_file(fn,grid)
!  READ_PERTURBATION_FILE - handle the special startup case where the
!  initial condition is a physical grid in GFS format.
!  These files have wind in meters per second and the surface pressure
!  in ln(dPa).
!
    use mrf_ids   ! from support directory
    character(*),intent(in)::fn
    real(GRIDKIND),intent(out)::grid(LONF,NAVARS,LATG,LEVS)
!
    real(D)::obsgrid(LONFD,2,NVAR,LATG2,LEVS)
    integer::ierr,j,lev
!
    open(INSWAP,file=fn,form='unformatted',status='old',iostat=ierr)
    if(ierr.ne.0) call fexit('read_perturbation_file: cannot open '//trim(fn))
    if(verbosity().gt.VERB_TERSE) call finfo('preanalysis: reading '//trim(fn))
!
    read(INSWAP) obsgrid
    close(INSWAP)
!
    do lev=1,LEVS
       do j=1,LATG2
          !
          !  South Pole to Equator
          !
          grid(:,PRES_TYPE,j,lev)= &
             real(10.0*exp(obsgrid(1:LONF,SH,Q,j,lev)),kind(grid))
          grid(:,TEMP_TYPE,j,lev)=real(obsgrid(1:LONF,SH,TE,j,lev),kind(grid))
          grid(:,UWIND_TYPE,j,lev)=real(obsgrid(1:LONF,SH,UG,j,lev),kind(grid))
          grid(:,VWIND_TYPE,j,lev)=real(obsgrid(1:LONF,SH,VG,j,lev),kind(grid))
          !
          !  Equator to North Pole; otherwise identical conversions
          !
          grid(:,PRES_TYPE,j+LATG2,lev)= &
             real(10.0*exp(obsgrid(1:LONF,NH,Q,LATG2-j+1,lev)),kind(grid))
          grid(:,TEMP_TYPE,j+LATG2,lev)= &
             real(obsgrid(1:LONF,NH,TE,LATG2-j+1,lev),kind(grid))
          grid(:,UWIND_TYPE,j+LATG2,lev)= &
             real(obsgrid(1:LONF,NH,UG,LATG2-j+1,lev),kind(grid))
          grid(:,VWIND_TYPE,j+LATG2,lev)= &
             real(obsgrid(1:LONF,NH,VG,LATG2-j+1,lev),kind(grid))
       enddo
    enddo
    return
    end subroutine read_perturbation_file
!--------------------------------------------------------------------------
    subroutine read_surface_files(template,avg,fhour,nsol)
!  READ_SURFACE_FILES - read a family of surface analysis files from the MRF
!  code and compute a mean surface analysis file.
!  Arguments:
!  TEMPLATE : template name for surface analysis files.
!  AVG := averaged surface analysis, computed from all the inputs.
!  FHOUR := forecast hour represented in the input surface analysis files.
!  NB : number of ensemble solutions (and therefore surface analysis files)
!     to expect.
!  In the case of the MRF, all surface analysis files are in big-endian format
!  and so may require byte-swapping on little-endian architectures.
!
    use surface
    implicit none
    character(*),intent(in)::template
    type(sfcanl),intent(out)::avg
    integer,intent(in)::nsol
    real(R),intent(out)::fhour
!
!  Local variables
!
    type(sfcanl)::x
    real(R)::hour
    integer::j,idate(4),refdate(4)
    character(MAX_FILE_NAME_LEN)::fn
!
!  Use the first file for initialization, then sum over the remaining ones.
!
    call numeric_filename(template,'%n',1,fn)
    call read_sfcanl(fn,avg,fhour,refdate)
    do j=2,nsol
       call numeric_filename(template,'%n',j,fn)
       call read_sfcanl(fn,x,hour,idate)
       if(hour.ne.fhour.or.any(idate.ne.refdate)) &
          call fexit('read_surface_files: '//trim(fn)// &
             ' forecast hour and/or dates disagree',2)
       avg=avg+x
    enddo
    avg=avg/nsol
    return
    end subroutine read_surface_files
!------------------------------------------------------------------------------
    subroutine parseline(cdate,nsol)
!  PARSELINE - parse an execute line each of whose arguments is 
!  of the form option=value.
!
    implicit none
    character(*),intent(inout)::cdate
    integer,intent(out)::nsol
!
!  Local variables
!
    character(*),parameter::OPTLIST='d:f:hH:m:n:N:Pp:S:s:v:'
    character(MAX_FILE_NAME_LEN)::optarg,nmlfile
    integer::nargs,iopt,optind,verblev
    integer,external::iargc  ! g95 intrinsic
    character(10)::chardate
    namelist/input/ chardate,ref_sig_fn,mean_sigma_fn,nsol,nsplit, &
       sigma_out_fn,sfc_fn,verblev,phys_grid_fn
!
    nargs=iargc()  ! number of command-line arguments EXCLUDING program name
    nmlfile=' '
    chardate=cdate
    if(nargs.lt.2) call usage
    do 
       call getopt(iopt,optarg,optind,OPTLIST)
       if(iopt.lt.0) exit
       select case(char(iopt))
       case('d')         ! date to use in yyyymmddhh format
          cdate=optarg
       case('f')
          ref_sig_fn=optarg
       case('h')
          call usage
       case('H')
          expected_tag=optarg
       case('m')
          mean_sigma_fn=optarg
       case('N')    ! namelist input comes from the named file
          nmlfile=optarg
          open(IN,file=nmlfile,status='old')
          read(IN,input)
          close(IN)
          cdate=chardate
       case('n') 
          read(optarg,*) nsol
       case('P')   ! input is physical perturbation files
          input_is_pert=.true.
       case('p')
          read(optarg,*) nsplit
       case('s')
          sigma_out_fn=optarg
       case('S')
          sfc_fn=optarg
       case('v')
          read(optarg,*) verblev
          call set_verbosity(verblev)
       endselect       ! otherwise, getopt prints message
    enddo
!
!  Get the required argument if namelist input isn't specified
!
    if(len_trim(nmlfile).eq.0) then
       if(nargs.lt.optind) call usage
       call getarg(nargs,phys_grid_fn)
    endif
!
!  Brief sanity checks
!
    if(len_trim(ref_sig_fn).eq.0) &
       call fexit('-f must be used to specify a sigma file')
    if(nsol.lt.1) call fexit('nsol must be > 0')
!
!  Brief announcement if requested
!
    if(verblev.ge.VERB_TERSE) then
       write(LOGFILE,100) 'postanalysis: version ',VERSION
100    format(2a)
       write(LOGFILE,100) 'input grid: ',trim(phys_grid_fn)
       write(LOGFILE,100) 'ref sigma file (-f): ',trim(ref_sig_fn)
       write(LOGFILE,100) 'output sigma files: ',trim(sigma_out_fn)
       if(len_trim(mean_sigma_fn).gt.0) &
          write(LOGFILE,100) 'mean sigma file: ',trim(mean_sigma_fn)
       if(len_trim(sfc_fn).gt.0) &
          write(LOGFILE,100) 'surface analysis files: ',trim(sfc_fn)
    endif
    return
!---------
    contains
       subroutine usage
       write(IERR,100) VERSION
100    format('postanalysis: version ',a/ &
          'usage: [options] grid_file, where options are'/ &
          ' [-f ref_sigma_file] (required option; gives spectral coeffs)'/ &
          ' [-N input_file] - all options taken from namelist in input_file'/ &
          ' [-n number_of_ensembles]'/ &
          ' [-d date in yyyymmddhh format]'/ &
          ' [-s output_sigma_file_template]'/ &
          ' [-P (input is physical perturbation file)]'/ &
          ' [-S surface_analysis_file_template; mean placed in 0]'/ &
          ' [-H expected_tag; default "aout"]'/ &
          ' [-v verblev]'/ &
          ' [-p nsplit (number of pieces for input physical grid)]'/ &
          ' [-m output_mean_sigma_file]'/ &
          '-s specifies a family of sigma files for output, one per'/ &
          '   ensemble member; default: sigma.outN'/ &
          'grid_file specifies the name of a physical model grid file'/ &
          '   in latitude-major format')
       call program_exit(1)
       end subroutine usage
    end subroutine parseline
! ----------------------------------------------------------------------------
    end module postanalysis
! -----------------------------------------------------------------------------
!  MAIN.
!
    use postanalysis
!
    call do_everything
    call program_exit(0)
    end

    module mp
!  MP - Eric's routines for interfacing with MPI.  This version implements
!  a very simple message-passing scheme, namely blocking sends and receives
!  for an MPI_COMM_WORLD group of communicating processes.
!  Most of the routines in this module form a generic interface for
!  "send" and "receive".  That is, we can say
!    call send(value=something,dest=somewhere)
!  where value is any integer or real array and dest is an integer specifying
!  the process to which the value is to be sent.  Similarly, we can say
!    call receive(value=something,src=source,sender=p)
!  where src is an integer specifying the process that is supposed to
!  receive the value.  Sender is an optional argument that is set to the
!  process sending the data; normally, p = source, but source can also
!  be MPI_ANY_SOURCE, in which case one might want to know the identity
!  of the sender.
!  We also implement convenience functions myid() and nproc() to obtain
!  our MPI rank (identity) and the number of processes in the group,
!  respectively.  Subroutines startup and shutdown initialize and terminate
!  MPI, respectively.
!
!  Required packages:
!
    use mpi
    use ferror
    implicit none
!
    integer,parameter::ROOT=0
!
    integer,parameter,private::I_TAG=1
    integer,parameter,private::IA_TAG=11
    integer,parameter,private::R4=kind(1.0)
    integer,parameter,private::R8=kind(1.0d0)
    integer,parameter,private::R4_TAG=4
    integer,parameter,private::R8_TAG=8
    integer,parameter,private::R4A_TAG=14
    integer,parameter,private::R8A_TAG=18
    integer,save,private::me=ROOT
    integer,save,private::npes=1
!
    interface send
       module procedure send_i,send_ia,send_r4,send_r8,send_r4a,send_r8a
    end interface send
!
    interface receive
       module procedure recv_i,recv_ia,recv_r4,recv_r8,recv_r4a,recv_r8a
    end interface receive
    contains
!-----------------------------------------------------------------------
    pure integer function myid()
!  MYID - return the calling process's MPI rank.  Returns 0 if MPI is
!  not initialized by STARTUP.
!
    myid=me
    return
    end function myid
!-----------------------------------------------------------------------
    pure integer function nproc()
!  NPROC - return the number of processes in the group.  Returns 1 if MPI is
!  not initialized by STARTUP.
!
    nproc=npes
    return
    end function nproc
!-----------------------------------------------------------------------
    subroutine send_i(value,dest)
!  SEND_I - send a scalar default integer to DEST.
!
    integer,intent(in)::value,dest
!
    integer::buf(1),ierr
!
    buf(1)=value
    call mpi_send(buf,1,MPI_INTEGER,dest,I_TAG,MPI_COMM_WORLD,ierr)
    return
    end subroutine send_i
!-----------------------------------------------------------------------
    subroutine send_ia(value,dest)
!  SEND_IA - send a rank-1 default integer array to DEST.
!
    integer,intent(in)::value(:),dest
!
    integer::ierr,buf(size(value))
!
    buf=value  ! ensure contiguity
    call mpi_send(buf,size(buf),MPI_INTEGER,dest,IA_TAG,MPI_COMM_WORLD,ierr)
    return
    end subroutine send_ia
!-----------------------------------------------------------------------
    subroutine send_r4(value,dest)
!  SEND_R4 - send a scalar default real to DEST.
!
    real(R4),intent(in)::value
    integer,intent(in)::dest
!
    real(R4)::buf(1)
    integer::ierr
!
    buf(1)=value
    call mpi_send(buf,1,MPI_REAL4,dest,R4_TAG,MPI_COMM_WORLD,ierr)
    return
    end subroutine send_r4
!-----------------------------------------------------------------------
    subroutine send_r8(value,dest)
!  SEND_R8 - send a double precision real to DEST.
!
    real(R8),intent(in)::value
    integer,intent(in)::dest
!
    real(R8)::buf(1)
    integer::ierr
!
    buf(1)=value
    call mpi_send(buf,1,MPI_REAL8,dest,R8_TAG,MPI_COMM_WORLD,ierr)
    return
    end subroutine send_r8
!-----------------------------------------------------------------------
    subroutine send_r4a(value,dest)
!  SEND_R4A - send a rank-1 default real array to DEST.
!
    real(R4),intent(in)::value(:)
    integer,intent(in)::dest
!
    real(R4)::buf(size(value))
    integer::ierr
!
    buf=value  ! ensure contiguity
    call mpi_send(buf,1,MPI_REAL4,dest,R4A_TAG,MPI_COMM_WORLD,ierr)
    return
    end subroutine send_r4a
!-----------------------------------------------------------------------
    subroutine send_r8a(value,dest)
!  SEND_R8A - send a rank-1 double-precision array to DEST.
!
    real(R8),intent(in)::value(:)
    integer,intent(in)::dest
!
    real(R8)::buf(size(value))
    integer::ierr
!
    buf=value  ! ensure contiguity
    call mpi_send(buf,1,MPI_REAL8,dest,R8A_TAG,MPI_COMM_WORLD,ierr)
    return
    end subroutine send_r8a
!-----------------------------------------------------------------------
    subroutine recv_i(value,src,sender)
!  RECV_I - receive a scalar default integer value from SRC.  SRC may be
!  MPI_ANY_SOURCE, in which case the optional argument SENDER should be
!  present; the latter is set to the id of the actual sender.  Otherwise,
!  if SRC is the id of another process, then SENDER is set to SRC on return.
!
    integer,intent(out)::value
    integer,intent(in)::src
    integer,intent(out),optional::sender
!
    integer::ierr,buf(1),status(MPI_STATUS_SIZE)
!
    call mpi_recv(buf,1,MPI_INTEGER,src,I_TAG,MPI_COMM_WORLD,status,ierr)
    if(present(sender)) sender=status(MPI_SOURCE)
    value=buf(1)
    return
    end subroutine recv_i
!-----------------------------------------------------------------------
    subroutine recv_ia(value,src,sender)
!  RECV_IA - receive a default integer array from SRC.  SRC may be
!  MPI_ANY_SOURCE, in which case the optional argument SENDER should be
!  present; the latter is set to the id of the actual sender.  Otherwise,
!  if SRC is the id of another process, then SENDER is set to SRC on return.
!
    integer,intent(out)::value(:)
    integer,intent(in)::src
    integer,intent(out),optional::sender
!
    integer::ierr,count,buf(size(value)),status(MPI_STATUS_SIZE)
    character(80)::msg
!
    call mpi_recv(buf,size(buf),MPI_INTEGER,src,IA_TAG,MPI_COMM_WORLD, &
       status,ierr)
    if(present(sender)) sender=status(MPI_SOURCE)
    call mpi_get_count(status,MPI_INTEGER,count,ierr)
    if(count.ne.size(buf)) then
       write(msg,100) 'recv_ia',size(buf),count
       call fabort(msg)
    endif
    value=buf  ! in case value isn't contiguous
100 format(a,': expected: ',i0,' got: ',i0,' values')
    return
    end subroutine recv_ia
!-----------------------------------------------------------------------
    subroutine recv_r4(value,src,sender)
!  RECV_R4 - receive a scalar default real value from SRC.  SRC may be
!  MPI_ANY_SOURCE, in which case the optional argument SENDER should be
!  present; the latter is set to the id of the actual sender.  Otherwise,
!  if SRC is the id of another process, then SENDER is set to SRC on return.
!
    real(R4),intent(out)::value
    integer,intent(in)::src
    integer,intent(out),optional::sender
!
    real(R4)::buf(1)
    integer::ierr,status(MPI_STATUS_SIZE)
!
    call mpi_recv(buf,1,MPI_REAL4,src,R4_TAG,MPI_COMM_WORLD,status,ierr)
    value=buf(1)
    if(present(sender)) sender=status(MPI_SOURCE)
    return
    end subroutine recv_r4
!-----------------------------------------------------------------------
    subroutine recv_r8(value,src,sender)
!  RECV_R8 - receive a scalar double precision real value from SRC.  SRC may be
!  MPI_ANY_SOURCE, in which case the optional argument SENDER should be
!  present; the latter is set to the id of the actual sender.  Otherwise,
!  if SRC is the id of another process, then SENDER is set to SRC on return.
!
    real(R8),intent(out)::value
    integer,intent(in)::src
    integer,intent(out),optional::sender
!
    real(R8)::buf(1)
    integer::ierr,status(MPI_STATUS_SIZE)
!
    call mpi_recv(buf,1,MPI_REAL8,src,R8_TAG,MPI_COMM_WORLD,status,ierr)
    value=buf(1)
    if(present(sender)) sender=status(MPI_SOURCE)
    return
    end subroutine recv_r8
!-----------------------------------------------------------------------
    subroutine recv_r4a(value,src,sender)
!  RECV_R4A - receive a rank-1 default real array from SRC.  SRC may be
!  MPI_ANY_SOURCE, in which case the optional argument SENDER should be
!  present; the latter is set to the id of the actual sender.  Otherwise,
!  if SRC is the id of another process, then SENDER is set to SRC on return.
!
    real(R4),intent(out)::value(:)
    integer,intent(in)::src
    integer,intent(out),optional::sender
!
    real(R4)::buf(size(value))
    integer::count,ierr,status(MPI_STATUS_SIZE)
    character(80)::msg
!
    call mpi_recv(buf,size(buf),MPI_REAL4,src,R4A_TAG,MPI_COMM_WORLD,status, &
       ierr)
    if(present(sender)) sender=status(MPI_SOURCE)
    call mpi_get_count(status,MPI_REAL4,count,ierr)
    if(count.ne.size(buf)) then
       write(msg,100) 'recv_r4a',size(buf),count
       call fabort(msg)
    endif
    value=buf  ! in case value isn't contiguous
100 format(a,': expected: ',i0,' got: ',i0,' values')
    return
    end subroutine recv_r4a
!-----------------------------------------------------------------------
    subroutine recv_r8a(value,src,sender)
!  RECV_R8A - receive a rank-1 double precision array from SRC.  SRC may be
!  MPI_ANY_SOURCE, in which case the optional argument SENDER should be
!  present; the latter is set to the id of the actual sender.  Otherwise,
!  if SRC is the id of another process, then SENDER is set to SRC on return.
!
    real(R8),intent(out)::value(:)
    integer,intent(in)::src
    integer,intent(out),optional::sender
!
    real(R8)::buf(size(value))
    integer::ierr,count,status(MPI_STATUS_SIZE)
    character(80)::msg
!
    call mpi_recv(buf,size(buf),MPI_REAL8,src,R8A_TAG,MPI_COMM_WORLD,status, &
       ierr)
    if(present(sender)) sender=status(MPI_SOURCE)
    call mpi_get_count(status,MPI_REAL8,count,ierr)
    if(count.ne.size(buf)) then
       write(msg,100) 'recv_r8a',size(buf),count
       call fabort(msg)
    endif
    value=buf  ! in case value isn't contiguous
100 format(a,': expected: ',i0,' got: ',i0,' values')
    return
    end subroutine recv_r8a
!-----------------------------------------------------------------------
    subroutine startup
    integer::ierr
!
    call mpi_init(ierr)
    call mpi_comm_rank(MPI_COMM_WORLD,me,ierr)
    call mpi_comm_size(MPI_COMM_WORLD,npes,ierr)
    return
    end subroutine startup
!-----------------------------------------------------------------------
    subroutine shutdown
    integer::ierr
!
    call mpi_finalize(ierr)
    return
    end subroutine shutdown
!-----------------------------------------------------------------------
    end module mp

!  FSPLIT - split the assimilation grid and corresponding observations into
!  strips so that the pieces can be analyzed on separate
!  processors.  This manual splitting provides perfect speedup, modulo
!  the disk and memory traffic to send the data to the cpus.
!
!  Modification history:
!  10/11/04 - version to accommodate new model grid format.  Eliminated
!             option for longitudinal splitting.
!  10/17/03 - version to optionally split along longitudes for
!             testing/compatibility with old versions of the data assimilation
!             code
!  08/31/03 - version to split along latitudes instead of longitudes
!             and to add support for centering patches at poles.
!
    module fsplit
    use grid_io
    use split_defs
    use command_line_support
    contains
!-----------------------------------------------------------------------
    subroutine grid_split(egrid,gridname,nsol,nsplit,ywin,opthdr)
!  GRID_SPLIT - split GRID into NSPLIT latitudinal strips and create
!  a family of output files.
!  If NSPLIT > 1, then gridname is a template name.
!  If OPTHDR is nonblank, then we write use it as the output file header
!  when NSPLIT > 1.
!
    implicit none
    integer,intent(in)::nsol,ywin
    real(GRIDKIND),intent(in)::egrid(LONF,NAVARS,LATG,LEVS,nsol)
    character(*),intent(in)::gridname,opthdr
    integer,intent(inout)::nsplit
!
!  Local variables
!
    character(len(gridname)+6)::gname
    character(4)::hdr
    integer::n,nstrips
!
!  SOUTH(k) is the southernmost latitude contained in the split grid file
!  sent to the kth processor; similarly for NORTH(k).  ISTART(k) is the
!  southernmost latitude at which the data assimilation should begin.
!  We need a separate index because the latitude strips overlap near the
!  poles.
!
    integer,allocatable::list(:),south(:),north(:),psouth(:),pnorth(:)
!
!  Decide how to partition the data.
!
    nstrips=LATG
    call imod(nsplit,list,nstrips,ywin,south,north,psouth,pnorth)
    if(sum(list(1:nsplit)).ne.nstrips) &
       call fabort('grid_split: internal error splitting latitudes')
    if(verbosity().gt.VERB_TERSE) then
       write(LOGFILE,115) nsplit,list(1:nsplit)
    endif
115 format(' number of processors used: ',i4/ &
       ' latitudes per processor: '/(' ',19i4))
!
!  Create one file for each processor.  If NSPLIT=1, just write out the grid
!  without any name decoration or header if there's no splitting necessary.
!  Otherwise, use gridname as a template and let grid_manager handle
!  the output.
!
    if(nsplit.eq.1) then
       call write_grid_slice(gridname,'none',1,LATG,egrid,1,LATG,nsol,1,LATG)
    else 
       if(verbosity().gt.VERB_SILENT) write(LOGFILE,130) seqid()
130    format('grid_split: sequence id: ',i0)
       if(len_trim(opthdr).gt.0) then
          hdr=opthdr
       else
          hdr='grid'
       endif
       do n=1,nsplit
          call numeric_filename(gridname,'%n',n,gname)
          if(verbosity().gt.VERB_TERSE) &
             write(LOGFILE,131) trim(gname),south(n),north(n),psouth(n), &
                pnorth(n),nsol
          call write_grid_slice(gname,hdr,south(n),north(n), &
             egrid,1,LATG,nsol,psouth(n),pnorth(n))
       enddo
131    format('grid_split: writing ',a,' south:',i3,' north:',i3, &
          ' psouth:',i3,' pnorth:',i3,' nsol: ',i3)
    endif
    return
    end subroutine grid_split
!-------------------------------
    end module fsplit

    module gfs_init
    contains
!
!     ******************************************************************
!     ******************************************************************
!     ******                                                      ******
!     ******                SUBROUTINE INIT_VERT                  ******
!     ******                                                      ******
!     ******************************************************************
!     ******************************************************************
!
      SUBROUTINE init_vert(cl,sl,del,si,tov,rmu,rnu,rdel2, &
                           rk,slk,sl1,levshc)

      use resolution
      use constant
      use precision,only:D
      implicit none

      real(D) cl(levs),sl(levs),del(levs),si(levp1),tov(levs),rho(levs), &
           rmu(levs),rnu(levs),rdel2(levs),rk,slk(levs),sl1
      integer levshc

      integer k
      real(D) sigshc

      DO k=1,LEVS
        CL(k) = 1.E0 - SL(k)
      ENDDO

      DO k=1,LEVS
        DEL(k)= SI(k)-SI(k+1)
      ENDDO
      DO k=1,LEVS
        TOV(k)=300.E0
      ENDDO

      DO k=1,LEVM1
        RHO(K)=LOG(SI(K)/SI(K+1))
      ENDDO
      RHO(LEVS)=0.

      DO k=1,LEVS
        RMU(K)=1.-SI(K+1)*RHO(K)/DEL(K)
      ENDDO

      DO k=1,LEVM1
        RNU(K+1)=-1.+SI(K)*RHO(K)/DEL(K)
      ENDDO
      RNU(1)=0.

      DO k=1,LEVS
        RDEL2(k)=1./(2.*DEL(k))
      ENDDO

      RK = RD/CP
      sl1=SL(1)
      levshc=0
      sigshc=0.7
      DO k=1,LEVS
        SLK(K)=SL(K)**RK
        IF(SL(K).GT.SIGSHC) LEVSHC=K+1
      ENDDO

      RETURN
      END SUBROUTINE init_vert
!
!***********************************************************************
!
      SUBROUTINE GLATS(COLRAD,WGT,RCS2,SINLAT,COSLAT,colat1)
!
!***********************************************************************
!
      use resolution
      use precision,only:D
      implicit none
      real(D) COLRAG(LATG2),WGTG(LATG2),RCS2G(LATG2), &
           COLRAD(latg2),WGT (latg2),RCS2 (latg2), &
           SINLAT(latg2),COSLAT(latg2),colat1
      real(D) EPS,SI,RL2,SCALE,PI,DRADZ,RAD,DRAD,X,W,SN,RC,P2,P1
      integer L2,K1,K,ITER,J
      include 'machine.h'
!
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
!
! EPS IS MACHINE DEPENDENT (WORDSIZE IN BITS)
      EPS=PRECIS
!     PRINT 101
!101  FORMAT ('0 I   COLAT   COLRAD     WGT', 12X,'ITER  RES')
      SI = 1.0
      L2=2*LATG2
      RL2=L2
      SCALE = 2.0/(RL2*RL2)
      K1=L2-1
      PI = ATAN(SI)*4.E+00
      DRADZ = PI / 360.
      RAD = 0.0
      DO 1000 K=1,LATG2
!        print *, k 
        ITER=0
        DRAD=DRADZ
1       CALL POLY(L2,RAD,P2)
2       P1 =P2
        ITER=ITER+1
        RAD=RAD+DRAD
        CALL POLY(L2,RAD,P2)
!       print *, SIGN(SI,P1), SIGN(SI,P2) 
       IF(SIGN(SI,P1).EQ.SIGN(SI,P2)) GO TO 2
!       print *, DRAD, EPS
       IF(DRAD.LT.EPS)GO TO 3
        RAD=RAD-DRAD
        DRAD = DRAD * 0.25
       GO TO 1
3      CONTINUE
        COLRAG(K)=RAD
        CALL POLY(K1,RAD,P1)
        X = COS(RAD)
        W = SCALE * (1.0 - X*X)/ (P1*P1)
        WGTG(K) = W
        SN = SIN(RAD)
        W=W/(SN*SN)
        RC=1./(SN*SN)
        RCS2G(K) = RC
        CALL POLY(L2,RAD,P1)
!       PRINT 102,K,PHI,COLRAG(K),WGTG(K),ITER,P1
!102    FORMAT(1H ,I2,2X,F6.2,2X,F10.7,2X,E13.7,2X,I4,2X,D13.7)
1000  CONTINUE
!mg      PRINT 100,LATG2
!100   FORMAT(1H ,'SHALOM FROM 0.0E0 GLATS FOR ',I3)
!yt
      colat1=colrag(1)
      DO j=1,latg2
        COLRAD(j) = COLRAG(j)
        WGT(j)    = WGTG  (j)
        RCS2(j)   = RCS2G (j)
        SINLAT(j) = COS(COLRAD(j))
        COSLAT(j) = SQRT(1.0 - SINLAT(j)*SINLAT(j))
      ENDDO

      RETURN
      END SUBROUTINE GLATS
!
!***********************************************************************
!
      SUBROUTINE POLY(N,RAD,P)
!
!***********************************************************************
!
      use precision,only:D
      implicit none
      real(D) X,Y1,Y2,G,Y3,P,RAD
      integer I,N
      X = COS(RAD)
      Y1 = 1.0
      Y2=X
      DO 1 I=2,N
      G=X*Y2
      Y3=G-Y1+G-(G-Y1)/FLOAT(I)
      Y1=Y2
      Y2=Y3
1     CONTINUE
      P=Y3
      RETURN
      END SUBROUTINE POLY
!
!***********************************************************************
!
      SUBROUTINE PLN2I(PLNT,PDERT,PLNTOP,RCS2,COLRAD)
!
!***********************************************************************
!
      use resolution
      use constant
      use precision,only:D
      implicit none
      real(D) PLNT(LNTD)
      real(D) PLNV(LNUT)
      real(D) COLRAD
      real(D) PLNTOP(0:JCAP)
!
!SELA ADDED FROM GOZRIN
      real(D) PDERT(LNTD)
      real(D) RCS2
!SELA ADDED FROM GOZRIN
!
      real(D) W(0:JCAP),EPSI,REPSI,X,Y
!
      COMMON /PLN2TI/ EPSI(LNUT),REPSI(LNUT), &
                      X(0:JCAP),Y(0:JCAP)
!
      real(D) XA,XB
      COMMON /GOZCOM/ XA(LNTD),XB(LNTD)
!
      INTEGER OFFSRI
      INTEGER OFFVRI
      INTEGER N,N0,IND,I,L
      REAL(D) SINLA,COS2,PROD,WCSA
!
!     OFFSRI IS THE SCALAR REAL OR IMAGINARY TRIANGLE INDEX IN WORDS.
      OFFSRI(N,L) = JCAP*L + N + 1 + L*(1-L)/2
!
!     OFFVRI IS THE VECTOR REAL OR IMAGINARY TRIANGLE INDEX IN WORDS.
      OFFVRI(N,L) = JCAP*L + N + 1 + L*(3-L)/2
!
!     DATA IFIR /0/
!           PART BETWEEN GUARDS MADE INTO SR GPLN2I.
!           7 DEC 1990      M. ROZWODOSKI
!
      SINLA  = COS(COLRAD)
      COS2   = 1.0 - SINLA * SINLA
      PROD   = 1.0
      DO 600 L=0,JCAP
             W(L) = 0.5*PROD
!            IF (PROD .LT. 1.0E-75)  PROD=0.0
             PROD = PROD*COS2*Y(L)
  600 CONTINUE
      DO 620 L=0,JCAP
             PLNV(OFFVRI(L,L)) = SQRT(W(L))
  620 CONTINUE
!
      DO 700 L=0,JCAP
             PLNV(OFFVRI(L+1,L)) = PLNV(OFFVRI(L,L)) * X(L) * SINLA
  700 CONTINUE
!
      DO 740 N0=2,JCAP+1
      DO 720 L=0,JCAP+1-N0
             PLNV(OFFVRI(N0+L  ,L)) =                            &
          (  PLNV(OFFVRI(N0+L-1,L)) * SINLA                      &
           - PLNV(OFFVRI(N0+L-2,L)) *  EPSI(OFFVRI(N0+L-1,L))  ) &
                                    * REPSI(OFFVRI(N0+L  ,L))
  720 CONTINUE
  740 CONTINUE
!
      DO 860 L=0,JCAP
      DO 840 N=L,JCAP
             PLNT(OFFSRI(N,L)) = PLNV(OFFVRI(N,L))
  840 CONTINUE
  860 CONTINUE
!yt   Keep values for vectors
      DO l=0,JCAP
        PLNTOP(l)=PLNV(OFFVRI(JCAP1,l))
      ENDDO
!
!SELA ADDED FROM GOZRIN
!............................................................
!     COMPUTE PLN DERIVATIVES.
      WCSA=RCS2/REARTH
!
      ind=0
      DO l=0,JCAP
        ind=ind+1
        PDERT(ind)=0.
        DO n=l+1,JCAP
          ind=ind+1
          PDERT(ind)=XA(ind)*PLNT(ind-1)
        ENDDO
      ENDDO
!
      ind=0
      DO l=0,JCAP
        DO n=l,JCAP-1
          ind=ind+1
          PDERT(ind)=PDERT(ind)+XB(ind)*PLNT(ind+1)
        ENDDO
        ind=ind+1
        PDERT(ind)=PDERT(ind)+XB(ind)*PLNTOP(l)
      ENDDO
!
      DO i=1,LNT
        PDERT(i)=PDERT(i)*wcsa
      ENDDO
!
!............................................................
!SELA ADDED FROM GOZRIN
      RETURN
      END SUBROUTINE PLN2I
!
!***********************************************************************
!
      SUBROUTINE GPLN2I
!
!***********************************************************************
!
      use resolution
      use precision,only:D
      implicit none
!C
      real(D) EPSI,REPSI,X,Y,TEMP
      integer N,L
      COMMON /PLN2TI/ EPSI(LNUT),REPSI(LNUT), &
                      X(0:JCAP),Y(0:JCAP)
!CC
!C    OFFVRI IS THE VECTOR REAL OR IMAGINARY TRIANGLE INDEX IN WORDS.
      INTEGER OFFVRI
      OFFVRI(N,L) = JCAP*L + N + 1 + L*(3-L)/2
!C
      DO 240 L=0,JCAP
              EPSI(OFFVRI(L,L))=0.0
             REPSI(OFFVRI(L,L))=0.0
             DO 220 N=L+1,JCAP+1
                    TEMP=((N*N-L*L)/(4.*N*N-1.))
                     EPSI(OFFVRI(N,L))=SQRT(    TEMP)
                    REPSI(OFFVRI(N,L))=SQRT(1.0/TEMP)
  220        CONTINUE
  240 CONTINUE
!C
      DO 400 L=0,JCAP
             X(L) = (L+1)*2+1
  400 CONTINUE
      DO 420 L=0,JCAP
             Y(L) = X(L)/(X(L)-1.)
  420 CONTINUE
      DO 440 L=0,JCAP
             X(L) = SQRT(X(L))
  440 CONTINUE
!C
      RETURN
      END SUBROUTINE GPLN2I
!
!***********************************************************************
!
      SUBROUTINE GGOZRM
!
!***********************************************************************
!
      use resolution
      use precision,only:D
      implicit none
      real(D) epsi(LNT),epstop(JCAP1),XA(LNTD),XB(LNTD)
      integer ind,n,l
!
      COMMON /GOZCOM/XA,XB
!
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@c
!
      ind=0
      DO l=0,JCAP
        ind=ind+1
        epsi(ind)=0.
        DO n=l+1,JCAP
          ind=ind+1
          epsi(ind)=sqrt( (n*n-l*l)/(4.*n*n-1.) )
        ENDDO
        n=JCAP1
        epstop(l+1)=sqrt( (n*n-l*l)/(4.*n*n-1.) )
      ENDDO
!
      ind=0
      DO l=0,JCAP
        DO n=l,JCAP
          ind=ind+1
          xa(ind)=(n+1.)*epsi(ind)
        ENDDO
      ENDDO
!
      ind=0
      DO l=0,JCAP
        DO n=l,JCAP-1
          ind=ind+1
          xb(ind)=-n*epsi(ind+1)
        ENDDO
        ind=ind+1
        xb(ind)=-JCAP*epstop(l+1)
      ENDDO
!
      RETURN
      END SUBROUTINE GGOZRM
!
!***********************************************************************
!
      SUBROUTINE ToEvenOdd(num,fln)
!
!***********************************************************************
!
      use resolution
      use precision,only:D
      implicit none
      integer num,i,l,k,np,ni
      real(D) fln(lntd,num),buff(JCAP1)

      DO k=1,num
        i=1
        DO l=0,JCAP-2
          np=(JCAP1-l+1)/2
          ni=(JCAP1-l)/2
          CALL dcopy(JCAP1-l,fln(i,k),1,buff,1)
          CALL dcopy(np,buff(1),2,fln(i,k),1)
          CALL dcopy(ni,buff(2),2,fln(i+np,k),1)
          i=i+JCAP1-l
        ENDDO
      ENDDO

      RETURN
      END SUBROUTINE ToEvenOdd
!
!***********************************************************************
!
      SUBROUTINE FromEvenOdd(num,fln)
!
!***********************************************************************
!
      use resolution
      use precision,only:D
      implicit none
      integer num,i,l,k,np,ni
      real(D) fln(lntd,num),buff(JCAP1)

      DO k=1,num
        i=1
        DO l=0,JCAP-2
          np=(JCAP1-l+1)/2
          ni=(JCAP1-l)/2
          CALL dcopy(JCAP1-l,fln(i,k),1,buff,1)
          CALL dcopy(np,buff      ,1,fln(i,k),2)
          CALL dcopy(ni,buff(np+1),1,fln(i+1,k),2)
          i=i+JCAP1-l
        ENDDO
      ENDDO

      RETURN
      END SUBROUTINE FromEvenOdd
!
      end module gfs_init

    module blas
    interface
       pure function dnrm2(n,x,inc)
       use precision
       real(D)::dnrm2
       integer,intent(in)::n,inc
       real(D),intent(in)::x(n*inc)
       end function dnrm2
    end interface
    end module blas

      module gfs_transforms
!  GFS_TRANSFORMS - this module gathers together all the spectral transform
!  code from the 2001/2004 GFS.
!  Adapted from 2001 GFS code by Eric Kostelich.
!  Summary of changes:
!  (1) converted from fixed to free-form source
!  (2) explicitly declares double-precision arithmetic where needed.
!  (3) fixes illegal aliases and eliminates deprecated calls to
!      Schwartztrauber FFT routines.
!  (4) USEs the appropriate modules instead of include files.
!  (5) Avoids implicit array rank remapping except in calls to FFT routines.
!  (6) All dummy arguments have explicit INTENT attributes.
!  (7) IMPLICIT NONE added throughout with explicit declarations added as
!      necessary.
!
      use resolution
      use precision,only:D
      use constant,only:REARTH
      use gfs_init
      implicit none
      contains
!
!***********************************************************************
!
      SUBROUTINE FLN2FOUR(num,latd,nvar,FLN,GRID,PLN, &
                          nvect,ivect,FTOP,PLNTOP,nlats,nlons)
!
!***********************************************************************
!
      use resolution
      use precision,only:D
      implicit none
      integer,intent(in)::num,latd,nvar,nvect,ivect(nvect),nlats,nlons(latd)
      real(D),intent(in)::fln(LNTD,2*num),pln(LNTD,latd)
      real(D),intent(out)::GRID(LONFD,2,nvar,latd)
      real(D),intent(in):: FTOP(0:JCAP,2,nvect),PLNTOP(0:JCAP,latd)
!
!  Local variables
!
      integer l,ireal,iimag,j,lmax,i,iv,latmin
      real(D) a(latd,2*num),b(latd,2*num),ui,ur
      integer ii,ir,lenp,leni,indp,indi,i1,i2,n
!
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
!
      DO l=0,JCAP-1
        DO j=nlats,1,-1
          IF ((nlons(j)/2) .ge. l) latmin=j
        ENDDO
        n=nlats-latmin+1
        lenp=(JCAP-l+2)/2
        leni=(JCAP-l+1)/2
        indp=JCAP*l+l*(1-l)/2+1+l
        indi=indp+lenp

        CALL DGEMM('t','n',n,2*num,lenp,1._D,PLN(indp,latmin),LNTD, &
                   FLN(indp,1),LNTD,0._D,a(latmin,1),latd)
        CALL DGEMM('t','n',n,2*num,leni,1._D,PLN(indi,latmin),LNTD, &
                   FLN(indi,1),LNTD,0._D,b(latmin,1),latd)

        ir=2*l+1
        ii=2*l+2
        DO i=1,num
          i1=2*i-1
          i2=2*i
          DO j=latmin,nlats
            grid(ir,1,i,j)=a(j,i1)+b(j,i1)
            grid(ir,2,i,j)=a(j,i1)-b(j,i1)
            grid(ii,1,i,j)=a(j,i2)+b(j,i2)
            grid(ii,2,i,j)=a(j,i2)-b(j,i2)
          ENDDO
        ENDDO
      ENDDO

!     l=JCAP
!     ------
      ir=2*JCAP+1
      ii=2*JCAP+2
      DO j=nlats,1,-1
        IF ((nlons(j)/2) .ge. JCAP) latmin=j
      ENDDO
      DO j=latmin,nlats
        DO i=1,num
          i1=2*i-1
          i2=2*i
          grid(ir,1,i,j)=PLN(lnt,j)*FLN(lnt,i1)
          grid(ir,2,i,j)=PLN(lnt,j)*FLN(lnt,i1)
          grid(ii,1,i,j)=PLN(lnt,j)*FLN(lnt,i2)
          grid(ii,2,i,j)=PLN(lnt,j)*FLN(lnt,i2)
        ENDDO
      ENDDO

      DO j=1,nlats
        lmax=min(JCAP,nlons(j)/2)
        DO l=0,lmax
          ireal=2*l+1
          iimag=2*l+2
          DO i=1,nvect
            iv=ivect(i)
            ur=FTOP(l,1,i)*PLNTOP(l,j)
            ui=FTOP(l,2,i)*PLNTOP(l,j)
            grid(ireal,1,iv,j)=grid(ireal,1,iv,j)+ur
            grid(iimag,1,iv,j)=grid(iimag,1,iv,j)+ui
            IF (mod(JCAP1-l,2).eq.0) THEN
              grid(ireal,2,iv,j)=grid(ireal,2,iv,j)+ur
              grid(iimag,2,iv,j)=grid(iimag,2,iv,j)+ui
            ELSE
              grid(ireal,2,iv,j)=grid(ireal,2,iv,j)-ur
              grid(iimag,2,iv,j)=grid(iimag,2,iv,j)-ui
            ENDIF
          ENDDO
        ENDDO
      ENDDO

      RETURN
      END SUBROUTINE FLN2FOUR
!
!***********************************************************************
!
      subroutine four2grid(num,latd,nvar,grid,nlats,nlons)
!
!***********************************************************************
!
      implicit none
      integer,intent(in)::num,latd,nvar,nlats,nlons(latd)
      real(D),intent(inout)::grid(LONFD,2,nvar,latd)
!
!  Local variables
!
      real(D) scale
      real(D),allocatable::table(:),temp(:,:,:,:)
      integer::ifac(15)
      integer j,ldx,ldy,maxlons
!
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
!
      scale=1.0
      ldx=lonfd/2
      ldy=lonfd
      maxlons=maxval(nlons)
      allocate(table(maxlons))  ! per FFTPACK docs
      allocate(temp(LONFD,2,nvar,latd))   ! so we don't exhaust stack
      temp=grid  ! original aliasing is illegal
      do j=1,nlats
        call rffti1(nlons(j),table,ifac)
        call dcrft(temp(:,:,:,j),ldx,grid(:,:,:,j),ldy,nlons(j),2*num,scale, &
           table,ifac)
      enddo
      return
      end subroutine four2grid

!***********************************************************************
!  Adapted from 2001 GFS code by Eric Kostelich.
!  Summary of changes:
!  (1) from fixed to free-form source
!  (2) explicitly declares double-precision arithmetic where needed.
!  (3) fixes illegal aliases and eliminates deprecated calls to
!      Schwartztrauber FFT routines.
!
!***********************************************************************
!
      SUBROUTINE GRID2FOUR(num,latd,nvar,grid,nlats,wgt,nlons)
!
!***********************************************************************
!
      implicit none
      integer,intent(in)::num,latd,nvar,nlats,nlons(latd)
      real(D),intent(inout)::grid(LONFD,2,nvar,latd)
      real(D),intent(in)::wgt(latd)
!
!  Local variables
!
      real(D)::scale
      real(D),allocatable::table(:),temp(:,:,:,:)
      integer::ifac(15)
      integer j,ldx,ldy,maxlons
!
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
!
      ldx=lonfd
      ldy=lonfd/2
      maxlons=maxval(nlons)
      allocate(temp(LONFD,2,nvar,latd))  ! so we don't exhaust stack
      allocate(table(maxlons))       ! per FFTPACK docs
      temp=grid                      ! aliasing in original code is illegal
      do j=1,nlats
        call rffti1(nlons(j),table,ifac)
        scale=wgt(j)/nlons(j)
        call drcft(temp(:,:,:,j),ldx,grid(:,:,:,j),ldy,nlons(j),2*num, &
                   scale,table,ifac)
      enddo
      return
      end subroutine grid2four
!
!***********************************************************************
!
      SUBROUTINE UVSUMS(latd,DUDT,DVDT,UTOP,VTOP,PLNTOP, &
                        nlats,nlons)
!
!***********************************************************************
!
      implicit none
      integer,intent(in)::latd,nlats,nlons(latd)
      real(D),intent(in)::DUDT(LONFD,2,latd),DVDT(LONFD,2,latd), &
           PLNTOP(0:JCAP,latd)
      real(D),intent(inout):: UTOP(0:JCAP,2),VTOP(0:JCAP,2)
!
!  Local variables
!
      integer lev,ireal,iimag,lmax,j
      real(D) url,uil,vrl,vil
!
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
!

      DO j=1,nlats
        lmax=min(JCAP,nlons(j)/2)
        DO lev=0,lmax
          ireal=2*lev+1
          iimag=2*lev+2
          IF (mod(JCAP1-lev,2).eq.0) THEN
            url=DUDT(ireal,1,j)+DUDT(ireal,2,j)
            uil=DUDT(iimag,1,j)+DUDT(iimag,2,j)
            vrl=DVDT(ireal,1,j)+DVDT(ireal,2,j)
            vil=DVDT(iimag,1,j)+DVDT(iimag,2,j)
          ELSE
            url=DUDT(ireal,1,j)-DUDT(ireal,2,j)
            uil=DUDT(iimag,1,j)-DUDT(iimag,2,j)
            vrl=DVDT(ireal,1,j)-DVDT(ireal,2,j)
            vil=DVDT(iimag,1,j)-DVDT(iimag,2,j)
          ENDIF
          UTOP(lev,1)=UTOP(lev,1)+url*PLNTOP(lev,j)
          UTOP(lev,2)=UTOP(lev,2)+uil*PLNTOP(lev,j)
          VTOP(lev,1)=VTOP(lev,1)+vrl*PLNTOP(lev,j)
          VTOP(lev,2)=VTOP(lev,2)+vil*PLNTOP(lev,j)
        ENDDO
      ENDDO
      RETURN
      END SUBROUTINE UVSUMS
!
!***********************************************************************
!
      SUBROUTINE FOUR2FLN(num,latd,nvar,GRID,FLN,PLN,nlats,nlons)
!
!***********************************************************************
!
      implicit none
      integer,intent(in)::latd,num,nvar,nlats,nlons(latd)
      real(D),intent(out)::FLN(LNTD,2*num)
      real(D),intent(in)::GRID(LONFD,2,nvar,latd),PLN(LNTD,latd)
      integer k,lenp,leni,indp,indi,ii,ir,n,latmin,l,i,j
      real(D) a(latd,2*num),b(latd,2*num)
!
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
!
      DO l=0,JCAP-1
        DO j=nlats,1,-1
          IF ((nlons(j)/2) .ge. l) latmin=j
        ENDDO
        n=nlats-latmin+1
        ir=2*l+1
        ii=2*l+2
        lenp=(JCAP-l+2)/2
        leni=(JCAP-l+1)/2
        indp=JCAP*l+l*(1-l)/2+1+l
        indi=indp+lenp

        DO j=latmin,nlats
          DO k=1,num
            i=2*k-1
            a(j,i  )=grid(ir,1,k,j)+grid(ir,2,k,j)
            b(j,i  )=grid(ir,1,k,j)-grid(ir,2,k,j)
            a(j,i+1)=grid(ii,1,k,j)+grid(ii,2,k,j)
            b(j,i+1)=grid(ii,1,k,j)-grid(ii,2,k,j)
          ENDDO
        ENDDO

        CALL DGEMM('n','n',lenp,2*num,n,1._D,PLN(indp,latmin),LNTD, &
                   a(latmin,1),latd,0._D,FLN(indp,1),LNTD)
        CALL DGEMM('n','n',leni,2*num,n,1._D,PLN(indi,latmin),LNTD, &
                   b(latmin,1),latd,0._D,FLN(indi,1),LNTD)

      ENDDO

!     l=JCAP
!     ------
      ir=2*JCAP+1
      ii=2*JCAP+2
      DO j=nlats,1,-1
        IF ((nlons(j)/2) .ge. JCAP) latmin=j
      ENDDO
      DO j=latmin,nlats
        DO k=1,num
          i=2*k-1
          a(j,i  )=grid(ir,1,k,j)+grid(ir,2,k,j)
          a(j,i+1)=grid(ii,1,k,j)+grid(ii,2,k,j)
        ENDDO
      ENDDO
      n=nlats-latmin+1
      CALL DGEMM('n','n',1,2*num,n,1._D,PLN(lnt,latmin),LNTD, &
                 a(latmin,1),latd,0._D,FLN(lnt,1),LNTD)

      CALL FromEvenOdd(2*num,fln)

      RETURN
      END SUBROUTINE FOUR2FLN
!
!***********************************************************************
!
      SUBROUTINE DZ2UV(Div,Z,U,V,UTOP,VTOP)
!
!***********************************************************************
!
      implicit none

      real(D),intent(in)::Div(LNTD,2),Z(LNTD,2)
      real(D),intent(out)::U(LNTD,2),V(LNTD,2),UTOP(0:JCAP,2),VTOP(0:JCAP,2)
!
!  Local variables
!
      real(D) epsan(LNTD),alnnp(LNTD),epsantop(0:JCAP)
      integer first,n,l,ind,i

      SAVE first,epsan,epsantop,alnnp
      DATA first/1/
!
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
!
      IF  (first.eq.1) THEN
        ind=1
        DO l=0,JCAP
          epsan(ind)=0.
          ind=ind+JCAP1-l
        ENDDO
        ind=0
        DO l=0,JCAP
          ind=ind+1
          DO n=l+1,JCAP
            ind=ind+1
            epsan(ind)=sqrt( (n*n-l*l)/(4._D*n*n-1._D) ) * REARTH / n
          ENDDO
          epsantop(l)=sqrt((JCAP1*JCAP1-l*l)/(4.*JCAP1*JCAP1-1._D)) &
              * REARTH/JCAP1
        ENDDO

        DO i=1,JCAP1
          alnnp(i)=0.
        ENDDO
        ind=JCAP1
        DO l=1,JCAP
        DO n=l,JCAP
          ind=ind+1
          alnnp(ind)=l/(n*(n+1.)) * REARTH 
        ENDDO
        ENDDO

        first=0
      ENDIF

      DO i=1,LNT
        U(i,1)= alnnp(i)*Div(i,2)
        U(i,2)=-alnnp(i)*Div(i,1)
        V(i,1)= alnnp(i)*Z(i,2)
        V(i,2)=-alnnp(i)*Z(i,1)
      ENDDO

      ind=0
      DO l=0,JCAP
        ind=ind+1
        DO n=l+1,JCAP
          ind=ind+1
          U(ind,1)=U(ind,1)-epsan(ind)*Z(ind-1,1)
          U(ind,2)=U(ind,2)-epsan(ind)*Z(ind-1,2)
          V(ind,1)=V(ind,1)+epsan(ind)*Div(ind-1,1)
          V(ind,2)=V(ind,2)+epsan(ind)*Div(ind-1,2)
        ENDDO
      ENDDO

      ind=0
      DO l=0,JCAP
        DO n=l,JCAP-1
          ind=ind+1
          U(ind,1)=U(ind,1)+epsan(ind+1)*Z(ind+1,1)
          U(ind,2)=U(ind,2)+epsan(ind+1)*Z(ind+1,2)
          V(ind,1)=V(ind,1)-epsan(ind+1)*Div(ind+1,1)
          V(ind,2)=V(ind,2)-epsan(ind+1)*Div(ind+1,2)
        ENDDO
        ind=ind+1
      ENDDO

!     The case n=JCAP
      ind=0
      DO l=0,JCAP
        ind=ind+(JCAP1-l)
        UTOP(l,1)=-epsantop(l)*Z(ind,1)
        UTOP(l,2)=-epsantop(l)*Z(ind,2)
        VTOP(l,1)=+epsantop(l)*Div(ind,1)
        VTOP(l,2)=+epsantop(l)*Div(ind,2)
      ENDDO

      RETURN
      END SUBROUTINE DZ2UV
!
!***********************************************************************
!
      SUBROUTINE UV2DZ(U,V,UTOP,VTOP,Div,Z)
!
!***********************************************************************
!
      implicit none

      real(D),intent(out)::Div(LNTD,2),Z(LNTD,2)
      real(D),intent(in)::U(LNTD,2),V(LNTD,2),UTOP(0:JCAP,2),VTOP(0:JCAP,2)
!
!  Local variables
!
      real(D) epsl(LNTD),epstop(0:JCAP),ra,lra
      integer first,n,l,ind

      SAVE first,epsl,epstop
      DATA first/1/
!
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
!
      IF  (first.eq.1) THEN
        ind=1
        DO l=0,JCAP
          epsl(ind)=0.
          ind=ind+JCAP1-l
        ENDDO
        ind=0
        DO l=0,JCAP
          ind=ind+1
          DO n=l+1,JCAP
            ind=ind+1
            epsl(ind)=sqrt( (n*n-l*l)/(4.*n*n-1.) )
          ENDDO
          epstop(l)=sqrt((JCAP1*JCAP1-l*l)/(4.*JCAP1*JCAP1-1.))
        ENDDO
        first=0
      ENDIF

      ra = 1./REARTH

      ind=0
!     For l=JCAP-1 and l=JCAP the loop is empty
      DO l=0,JCAP-2
        ind=ind+1
        DO n=l+1,JCAP-1
          ind=ind+1
          Z(ind,1)=( -l*V(ind,2) - n*epsl(ind+1)*U(ind+1,1) &
                     + (n+1.)*epsl(ind)*U(ind-1,1) )*ra
          Z(ind,2)=(  l*V(ind,1) - n*epsl(ind+1)*U(ind+1,2) &
                     + (n+1.)*epsl(ind)*U(ind-1,2) )*ra
          Div(ind,1)=( -l*U(ind,2) + n*epsl(ind+1)*V(ind+1,1) &
                     - (n+1.)*epsl(ind)*V(ind-1,1) )*ra
          Div(ind,2)=(  l*U(ind,1) + n*epsl(ind+1)*V(ind+1,2) &
                     - (n+1.)*epsl(ind)*V(ind-1,2) )*ra
        ENDDO
        ind=ind+1
      ENDDO

!     The case n=l
      Z(1,1)=0.
      Z(1,2)=0.
      Div(1,1)=0.
      Div(1,2)=0.
      ind=1
      DO l=1,JCAP-1
        ind=ind+(JCAP2-l)
        lra=l*ra
        Z(ind,1)=( -V(ind,2) - epsl(ind+1)*U(ind+1,1) )*lra
        Z(ind,2)=(  V(ind,1) - epsl(ind+1)*U(ind+1,2) )*lra
        Div(ind,1)=( -U(ind,2) + epsl(ind+1)*V(ind+1,1) )*lra
        Div(ind,2)=(  U(ind,1) + epsl(ind+1)*V(ind+1,2) )*lra
      ENDDO

!     The case n=JCAP
      ind=0
      DO l=0,JCAP
        ind=ind+(JCAP1-l)
        Z(ind,1)=( -l*V(ind,2) - JCAP*epstop(l)*UTOP(l,1) &
                    + JCAP1*epsl(ind)*U(ind-1,1) )*ra
        Z(ind,2)=(  l*V(ind,1) - JCAP*epstop(l)*UTOP(l,2) &
                    + JCAP1*epsl(ind)*U(ind-1,2) )*ra
        Div(ind,1)=( -l*U(ind,2) + JCAP*epstop(l)*VTOP(l,1) &
                    - JCAP1*epsl(ind)*V(ind-1,1) )*ra
        Div(ind,2)=(  l*U(ind,1) + JCAP*epstop(l)*VTOP(l,2) &
                    - JCAP1*epsl(ind)*V(ind-1,2) )*ra
      ENDDO

      RETURN
      END SUBROUTINE UV2DZ
      end module gfs_transforms

    module grid_types
!  
! SYNOPSIS
!   use grid_types
!
! DESCRIPTION
!  GRID_TYPES defines the model and observation data structures
!  needed for the Maryland local ensemble Kalman filter.
!
!  Types defined include:
!
!  Numerical parameters giving each dynamical variable type (e.g., PRES_TYPE)
!     and can be used as an index into the grid arrays.
!
!  REQUIRED PACKAGES
!    resolution, in the support directory
!
!  PROGRAMMER
!  Eric Kostelich, U. Maryland and Arizona State U.  kostelich@asu.edu
!
!  LANGUAGE
!    Fortran 95
!
!  Modification history:
!  08/06/05 - Moved observation types to grid_obs; added GRIDKIND parameter 
!             to adjust internal grid precision and IOKIND parameter to
!             adjust i/o precision.
!  03/28/05 - Modifications to handle internal observation consistency checks.
!  01/12/05 - Version to handle real observations.
!    Added PHI, LAMBDA, and TIME_DIFF components to both the RAW_OBS and
!    MODEL_OBS data structures.
!  10/12/04 - New version, adapted from previous grid_manager code.
!
    use precision
    use resolution,only:LATG,LATG2,LONF,LONFD,LEVS
    implicit none
!
!  GRIDKING and IOKIND need to be here to avoid circular module dependencies
!  in GRID_IO and SCALINGS.
!
    integer,parameter::GRIDKIND=R   ! type of internal model grids
    integer,parameter::IOKIND=R  ! type of i/o buffers
!
!  Patches are indexed by x, y, and z coordinates.
!
    type patch_index
       integer::x     ! 1 (Greenwich) to LONF
       integer::y     ! 1 (south pole) to LATG
       integer::z     ! 1 (surface) to LEVS
    end type
    interface operator(.eq.)
       module procedure patch_index_eq
    end interface
!
!  Mnemonics for dynamical variable types.  The variable types must be nonzero
!  and form a consecutive sequence, as they are used for indexing the model
!  grid arrays arrays.
!
    integer,parameter::NO_TYPE=-1
    integer,parameter::PRES_TYPE=1
    integer,parameter::TEMP_TYPE=2
    integer,parameter::UWIND_TYPE=3
    integer,parameter::VWIND_TYPE=4
!
!  The number of different observation types that we can handle.
!  Must agree with the number of types in the list above.
!  
    integer,parameter::NUM_DYN_TYPES=4
!
!  TYPEOF gives a 1-character mnemonic corresponding to the observation
!  variable type.  For example, TYPEOF(PRES_TYPE) is 'P'.
!
    character,parameter::TYPEOF(NUM_DYN_TYPES)=(/'P','T','U','V'/)
    contains
! -----------------------------
    pure logical function patch_index_eq(p1,p2)
    type(patch_index),intent(in)::p1,p2
!
    patch_index_eq=p1%x.eq.p2%x.and.p1%y.eq.p2%y.and.p1%z.eq.p2%z
    return
    end function patch_index_eq
! -----------------------------
    end module grid_types

    module kdtree
!
!  SYNOPSIS
!    use kdtree
!
!  DESCRIPTION
!    These routines implement a KD tree for rapid lookup of observations
!    contained in a given patch (cube) for the data assimilation routines.
!
!  REQUIRED PACKAGES
!    ferror, resolution - in support directory
!
!  AUTHOR
!    Eric Kostelich, kostelich@asu.edu, 480-965-5006
!
!  MODIFICATION HISTORY
!    06/03/05 - searches on all 3 coordinates of any observation.
!    10/12/04 - first implementation.
!
    use grid_types
    use ferror
    use resolution
    implicit none
!--------------------
!  Public module data
!
    type obsinfo
       real::coord(3)  ! 1:x (lon), 2:y (lat), 3:sigma (z) coord of observation
       integer::index  ! into obs array
       integer::typ    ! so we can grab pressure or other selected obs types
    end type obsinfo
!
    type kdnode
       type(obsinfo)::value
       integer::left  ! index (in nodearray) of left child
       integer::right  ! index (in nodearray) of right child
       integer::depth  ! 1=root node
    end type kdnode
!------------------
!  Private module data
!
    type(kdnode),allocatable,save,private::nodearray(:)  ! the KD tree
    integer,save,private::nalloc=0  ! # of entries filled in nodearray
    private::nodealloc,insert,shuffle,lookfor,append
    contains
!-----------------------------------------------------------------------------
    subroutine search(sw,ne,found,nfound,obstype)
!  SEARCH - look for observations whose coordinates sit in the closure of
!  the box whose lower left coords are given by SW and upper right by NE.
!  The box may not straddle the poles but is allowed to straddle the
!  0-degree longitude line.
!  Place the list of nodes in FOUND and return the number of valid nodes
!  in NFOUND.  Public subroutine.
!  If OBSTYPE is present, then return only those observations whose type
!  is one of those in OBSTYPE.
!
    type(patch_index),intent(in)::sw,ne
    type(obsinfo),allocatable,intent(inout)::found(:)
    integer,intent(out)::nfound
    integer,intent(in),optional::obstype(:)
!
    integer,parameter::BUFSIZ=100
    type(obsinfo),allocatable::wfound(:),efound(:)  ! left or right of LONF
    integer::wf,ef  ! number found left or right of LONF
    type(patch_index)::bdy
!
!  First check whether the box straddles the wrap-around longitude LONF.
!  If it does (sw(x) > ne(x)) then do two searches in the KD tree:
!  one from sw(x) to LONF and another from 1 to ne(x).  The KD tree
!  does not understand modulo distances.
!
    nfound=0
    if(sw%x.gt.ne%x) then  ! wrap at LONF
       allocate(wfound(BUFSIZ),efound(BUFSIZ))
       bdy=patch_index(LONF,ne%y,ne%z)   ! x to LONF
       wf=0
       call lookfor(sw,bdy,1,1,wfound,wf,obstype)
       bdy=patch_index(1,sw%y,sw%z)  ! 1=LONF to x
       ef=0
       call lookfor(bdy,ne,1,1,efound,ef,obstype)
       nfound=wf+ef
       if(allocated(found)) then
          if(size(found).lt.nfound) then
             deallocate(found)
             allocate(found(nfound))
          endif
       else
          allocate(found(nfound))
       endif
       found(1:wf)=wfound(1:wf)
       found(wf+1:nfound)=efound(1:ef)
    else  ! ordinary lookup
       if(.not.allocated(found)) allocate(found(BUFSIZ))
       call lookfor(sw,ne,1,1,found,nfound,obstype)
    endif
    return
    end subroutine search
!-----------------------------------------------------------------------------
    recursive subroutine lookfor(low,high,t,lev,found,nfound,obstype)
!  LOOKFOR - look for nodes in the KD tree rooted at T for nodes whose coords
!  sit in the closure of the box whose lower left coords are in LOW and
!  whose upper right coords are in HIGH.  Append the coordinates of all
!  NFOUND enclosed points in the allocatable array FOUND (which may be
!  longer than NFOUND entries).
!  If OBSTYPE is present, then we gather only those nodes corresponding
!  to observations whose type is one of those in OBSTYPE.
!
    type(patch_index),intent(in)::low,high
    integer,intent(in)::t,lev
    type(obsinfo),allocatable,intent(inout)::found(:)
    integer,intent(inout)::nfound
    integer,intent(in),optional::obstype(:)
!
!  Local variables
!
    integer::nextlev
    real::nodeval(3),lowcoord(3),highcoord(3)
!
    if(t.eq.0) return  ! leaf node
    if(t.lt.0) call fabort('lookfor: botched t')
    if(lev.lt.1.or.lev.gt.3) call fabort('lookfor: botched level')
!
!  If we're inside the box, then append the node at T to the list in FOUND.
!  Append only OBS of the specified types if requested.
!
    nodeval=nodearray(t)%value%coord
    lowcoord=(/low%x,low%y,low%z/)
    highcoord=(/high%x,high%y,high%z/)
    if(all(lowcoord.le.nodeval.and.nodeval.le.highcoord)) then
       if(present(obstype)) then
          if(any(nodearray(t)%value%typ.eq.obstype)) &
             call append(nodearray(t)%value,found,nfound)
       else
          call append(nodearray(t)%value,found,nfound)
       endif
    endif
!
!  Recurse left or right as needed.
!
    nextlev=mod(lev,3)+1
    if(lowcoord(lev).le.nodeval(lev)) &
       call lookfor(low,high,nodearray(t)%left,nextlev,found,nfound,obstype)
    if(nodeval(lev).le.highcoord(lev)) &
       call lookfor(low,high,nodearray(t)%right,nextlev,found,nfound,obstype)
    return
    end subroutine lookfor
!-----------------------------------------------------------------------------
    subroutine build_kdtree(list,n)
!  BUILD_KDTREE - build a KD tree for the observations given a list of
!  N coordinates.  Public subroutine.
!
    integer,intent(in)::n
    type(obsinfo),intent(inout)::list(n)
!
    integer::j,t,depth
!
!  If there are no observations, then just allocate a dummy root node.
!  Otherwise, build the tree.
!
    if(n.eq.0) then
       allocate(nodearray(1))
       nodearray(1)%left=0
       nodearray(1)%right=0
       nodearray(1)%value%coord=0  ! so it matches no coords
       nodearray(1)%value%index=0
       nodearray(1)%depth=1
    else
       call shuffle(list,n)
       allocate(nodearray(n))
       t=0
       do j=1,n
          if(t.eq.0) then
             depth=1
          else
             depth=nodearray(t)%depth
          endif
          call insert(list(j),t,1,depth)
       enddo
    endif
    return
    end subroutine build_kdtree
!-----------------------------------------------------------------------------
    recursive subroutine insert(val,t,ic,depth)
!  INSERT - insert a node containing VAL into the KD tree rooted at T.
!  We construct the tree with ordinary comparisons on all coordinates.
!  Internal subroutine.
!  VAL  : value to be inserted
!  T :=: on entry index of node where we start searching (0=leaf node).
!      On return, the index of the node allocated for VAL.
!  IC : coordinate on which the comparison is based (1 <= IC <= 3)
!  DEPTH : current depth of the tree.
!
    type(obsinfo),intent(in)::val
    integer,intent(inout)::t
    integer,intent(in)::ic,depth
!
    if(t.eq.0) then
       t=nodealloc()
       nodearray(t)%left=0
       nodearray(t)%right=0
       nodearray(t)%value=val
       nodearray(t)%depth=depth
    else if(val%coord(ic).le.nodearray(t)%value%coord(ic)) then
       call insert(val,nodearray(t)%left,mod(ic,3)+1,depth+1)
    else
       call insert(val,nodearray(t)%right,mod(ic,3)+1,depth+1)
    endif
    return
    end subroutine insert
!-----------------------------------------------------------------------------
    integer function nodealloc()
!  NODEALLOC - return the index of a free node in NODEARRAY.  Internal function.
!
    nalloc=nalloc+1
    if(nalloc.gt.size(nodearray)) call fabort('nodealloc: out of space')
    nodealloc=nalloc
    return
    end function nodealloc
!-----------------------------------------------------------------------------
    subroutine shuffle(list,n)
!  SHUFFLE - randomize the contents of LIST, but let LIST(1) be the element
!  that is closest to the average value of each coordinate.  Use the maximum
!  norm for this purpose.  (We assume that the average is close to the median
!  for the data.)
!
    integer,intent(in)::n
    type(obsinfo),intent(inout)::list(n)
!
    type(obsinfo)::temp
    integer::j,k,minidx
    real::x,avg(size(list(1)%coord)),dmin,dv
!
    do j=1,n
       call random_number(x)
       k=int(x*n)+1
       temp=list(k)
       list(k)=list(1)
       list(1)=temp
    enddo
!
!  Find the average value of each coordinate and the index MINIDX of
!  the LIST element that is closest to the average.  Swap LIST(1) with
!  LIST(MINIDX).
!
    avg=list(1)%coord
    do j=2,n
       avg=avg+list(j)%coord
    enddo
    avg=avg/n
    minidx=1
    dmin=sum(abs(list(1)%coord-avg))
    do j=2,n
       dv=sum(abs(list(j)%coord-avg))
       if(dv.lt.dmin) then
          dmin=dv
          minidx=j
       endif
    enddo
    temp=list(minidx)
    list(minidx)=list(1)
    list(1)=temp
    return
    end subroutine shuffle
!-----------------------------------------------------------------------------
    subroutine append(val,found,nfound)
!  Append VAL to the list of FOUND nodes, and enlarge FOUND as needed.
!
    type(obsinfo),intent(in)::val
    type(obsinfo),allocatable,intent(inout)::found(:)
    integer,intent(inout)::nfound
!
    if(nfound.ge.size(found)) call enlarge(found)
    nfound=nfound+1
    found(nfound)=val
    return
    end subroutine append
!-----------------------------------------------------------------------------
    subroutine enlarge(f,n)
!  ENLARGE - If N is present, then enlarge F to size N.  Otherwise,
!  enlarge F by 50% or 1 element, whichever is greater.
!  Preserve the initial elements in F.
!
    type(obsinfo),allocatable,intent(inout)::f(:)
    integer,intent(in),optional::n
!
    type(obsinfo)::temp(size(f))
    integer::sz,newsize
!
    sz=size(f)
    if(present(n)) then
       newsize=max(n,sz)
    else
       newsize=max((3*sz)/2,sz+1)
    endif
    if(newsize.gt.sz) then
       temp=f
       deallocate(f)
       allocate(f(newsize))
       f(1:sz)=temp
    endif
    return
    end subroutine enlarge
!-----------------------------------------------------------------------------
    subroutine kdstats(nodes,maxdepth,nodecount)
!  KDSTATS - report statistics on the KD tree.
!  Arguments:
!  NODES := number of allocated nodes in the tree
!  MAXDEPTH := maximum depth of the tree
!  NODECOUNT := Kth element is number of nodes in the tree at depth K.
!
    integer,intent(out)::nodes,maxdepth
    integer,allocatable,intent(out)::nodecount(:)
!
    integer::j,idepth(nalloc)
!
    nodes=nalloc
    idepth=nodearray(1:nalloc)%depth
    maxdepth=maxval(idepth)
    allocate(nodecount(maxdepth))
    nodecount=0
    do j=1,nalloc
       nodecount(idepth(j))=nodecount(idepth(j))+1
    enddo
    return
    end subroutine kdstats
!-----------------------------------------------------------------------------
    end module kdtree

    module readobs
!  READOBS - routines for reading and dispatching the observations, used by
!  preanalysis.
!
!  06/29/05 - scale the observations to energy units.
!  01/13/05 - added filter by observation type.  For now, the first letter
!     of the FIELD component is used in each RAW_OBS type to determine whether
!     the obeervation is surfrace pressure, temperature, or u- or v- component
!     of the wind.  (These are the only observation types that we can handle
!     at the moment.)  Only the observations matching one of the selected types
!     are distributed to the processors.
!  Eventually we'll simply dispatch each observation to the appropriate
!  processors with MPI, but for now will buffer them and write them
!  out in files for distribution.
!
!  Required packages:
!
    use grid_obs
    use ferror
    use io
    use fsplit
    use resolution,only:LATG
    implicit none
!
    private::flush
    contains
!-----------------------------
    subroutine read_observations(obsfn,outfn,maxproc,ywin,list)
!  READ_OBSERVATIONS - read the observations in RAW_OBS format,
!  then create observations in the format that we need for the data
!  assimilation.
!  OBSFN : name of the file containing the observations.
!  OUTFN : name of the output file. If NPROC > 1, then OUTFN is a template name.
!  STARTLAT : Kth entry is lowest latitude that Kth processor will handle.
!  ENDLAT : Kth entry is highest latitude that Kth processor will handle.
!  MAXPROC : max number of processors to use.  The observations for the
!     data assimilation are broken into as many as MAXPROC chunks.
!  YWIN : Y (latitude) radius to allow for each strip.
!  LIST : some subset of PTUV, which determines the obs types to retain.
!  No other preprocessing or scaling of the observations is done, other
!  than to divide the observations into latitude strips that encircle
!  the globe and to retain only those observations of a given type
!  (see FILTER_BY_TYPE).
!
    implicit none
    character(*),intent(in)::obsfn,outfn,list
    integer,intent(in)::maxproc,ywin
!
!  Local variables
!
    type(raw_obs)::yobs
    integer,parameter::INITBUFSIZE=100000  ! must be > 1
    integer::nproc,nobs,idate,istat
    type(raw_obs),allocatable::obsbuf(:)
    integer,allocatable::iwidth(:),startlat(:),endlat(:),psouth(:),pnorth(:)
!
    if(verbosity().gt.VERB_SILENT) write(LOGFILE,100) trim(obsfn)
100 format('preanalysis: read_observations: input file: ',a)
    open(INNOSWAP,file=obsfn,form='unformatted',status='old',iostat=istat)
    if(istat.ne.0) call fexit('read_observations: cannot open'//trim(obsfn),2)
!
    nproc=maxproc
    call imod(nproc,iwidth,LATG,ywin,startlat,endlat,psouth,pnorth)
    if(nproc.lt.maxproc) &
       call finfo('read_observations: fewer processors used than requested')
    allocate(obsbuf(INITBUFSIZE))
!
!  The first record is the date in yyyymmddhh format, followed by one
!  observation per record.
!
    read(INNOSWAP,end=10) idate
    if(verbosity().gt.VERB_SILENT) write(LOGFILE,110) idate
110 format('date (yyyymmddhh): ',i12)
    nobs=0
    do
       read(INNOSWAP,end=10) yobs
       nobs=nobs+1
       if(nobs.gt.size(obsbuf)) call enlarge_obsbuf
       obsbuf(nobs)=yobs
    enddo
10  continue
    if(verbosity().gt.VERB_SILENT) write(LOGFILE,111) nobs,'input'
111 format('preanalysis: ',i0,' observations ',a)
!
    call filter_by_type(list,obsbuf,nobs)
    if(verbosity().gt.VERB_SILENT) write(LOGFILE,111) nobs,'retained'
    call flush(obsbuf,nobs,outfn,startlat,endlat,nproc)
    deallocate(iwidth,startlat,endlat)
    close(INNOSWAP)
    return
    contains
    !-------
       subroutine enlarge_obsbuf  ! by 50% or one element, whichever is greater
       !
       type(raw_obs)::otmp(size(obsbuf))  ! can cause stack overflow
       integer::oldsize,newsize
       !
       oldsize=size(obsbuf)
       newsize=max((oldsize*3)/2,oldsize+1)
       otmp=obsbuf
       deallocate(obsbuf)
       allocate(obsbuf(newsize))
       obsbuf(1:oldsize)=otmp
       return
       end subroutine enlarge_obsbuf
    end subroutine read_observations    
!-----------------------------
    subroutine filter_by_type(list,obsbuf,nobs)
!  FILTER_BY_TYPE - omit observations whose FIELD variable does not match
!  one of those in LIST.
!  NOBS  :=: on input, the number of observations in OBSBUF.  On return, the
!     number retained.
!  OBSBUF :=: on return, only the selected observations are retained.
!
    character(*),intent(in)::list
    integer,intent(inout)::nobs
    type(raw_obs),intent(inout)::obsbuf(nobs)
!
    integer::j,n
    character(4)::field
!
    n=0
    do j=1,nobs
       field=adjustl(obsbuf(j)%field)
       if(index(list,field(1:1)).gt.0) then
          n=n+1
          if(n.lt.j) obsbuf(n)=obsbuf(j)
       endif
    enddo
    if(n.lt.nobs) write(LOGFILE,100) n,nobs
100 format('filter_by_type: retaining ',i0,' obs of ',i0/ &
       ' input based on obs type')
    nobs=n
    return
    end subroutine filter_by_type
!-----------------------------
    subroutine flush(obsbuf,nobs,outfn,startlat,endlat,nproc)
!  FLUSH - flush the observation buffer by distributing all the observations
!  to each processor in latitude strips.
!  OBSBUF : buffer of NOBS model_obs to be distributed
!  OUTFN : template name for output observation arrays
!  STARTLAT : Kth entry is lowest latitude handled by Kth processor.
!  ENDLAT : Kth entry is highest latitude handled by Kth processor.
!  NPROC : number of processors.
!
!  Note: we create an output data file even if there are no observaitons
!  for a given latitude strip.
!
    use command_line_support,only:numeric_filename
    use grid_io
    implicit none
    character(*),intent(in)::outfn
    integer,intent(in)::nobs,nproc,startlat(nproc),endlat(nproc)
    type(raw_obs),intent(in)::obsbuf(nobs)
!
!  Local variables
!
    integer::k
    character(MAX_FILE_NAME_LEN)::fn
    character(4)::label='obs '
!
!  Distribute observations among processors in overlapping latitude strips.
!
    if(nproc.eq.1) then  ! no filename substitution
       fn=outfn
       call write_obs_slice(fn,'none',startlat(1),endlat(1),obsbuf,nobs)
       close(OUTNOSWAP)
    else
       do k=1,nproc
          call numeric_filename(outfn,'%n',k,fn)
          call write_obs_slice(fn,label,startlat(k),endlat(k),obsbuf,nobs)
          close(OUTNOSWAP)
       enddo
    endif
    return
    end subroutine flush
!-----------------------------
    end module readobs

    use precision
    use io
    use ferror
    implicit none
    real(D),parameter::ZERO=0.0
    real(D),allocatable::a(:,:),z(:,:),mu(:),lambda(:),work(:)
    integer,allocatable::newseed(:),iwork(:),isuppz(:)
    real(D)::abstol
    character(80)::arg
    integer,external::iargc
    integer::j,k,n,sz,info,nfound
!
    if(iargc().eq.0) call fexit('asize [seed]',2)
    call random_seed(size=sz)
    allocate(newseed(sz))
    if(iargc().eq.sz+1) then
       do j=1,sz
          call getarg(j+1,arg)
          read(arg,*) newseed(j)
       enddo
    else
       call random_seed(get=newseed)
    endif
    write(LOGFILE,100) newseed
100 format('seed: ',4i11)
!
    call getarg(1,arg)
    read(arg,*) n
    allocate(a(n,n),z(n,n),mu(n),work(70*n),lambda(n))
    allocate(iwork(10*n),isuppz(2*n))
    if(iargc().eq.2) then
       call getarg(2,arg)
       read(arg,*) newseed
    endif
!
!  Create a random symmetric matrix A
!
    call random_number(a)
    do k=1,n-1
       do j=k+1,n
          a(j,k)=a(k,j)
       enddo
    enddo
!
!  Compute eigenvalues and eigenvectors as in assim.f90
!
    abstol=2.0*tiny(a)
    call dsyevr('v','i','u',n,a,n,ZERO,ZERO,1,n, &
       abstol,nfound,mu,z,n,isuppz,work,size(work),iwork,size(iwork),info)
    if(info.lt.0) then   ! bad argument - definitely a bug in caller
       call fabort('testev: bad call to dsyevr')
    else if(info.gt.0) then  !internal error in dsyevr
       nfound=0
    else
       do j=1,nfound
          lambda(j)=mu(nfound-j+1)
          !! a(:,j)=z(:,nfound-j+1)
       enddo
    endif
    write(LOGFILE,110) info,nfound
110 format('info: ',i0,' nfound: ',i0)
    write(LOGFILE,111) lambda(1:nfound)
111 format('eigenvalues:'/(5es14.4))
    stop
    end

    module inf_and_nan
!  INF_AND_NAN - provide an interface for elemental procedures to check
!  for arguments that are positive infinity or NaN.
!  These routines are compiler-specific.  In particular, they depend
!  on optimizers not to eliminate the checks that they perform.
!  NaNs compare unequal to everything, including themselves; so if
!  none of .eq., .gt., or .lt. is true for two real arguments, then
!  one or both must be NaN.  Similarly, Inf is greater than any floating-point
!  quantity.
!
    use precision
    private::rcompare,dcompare
!
    interface isnan
       module procedure r_isnan
       module procedure d_isnan
    end interface 
!
    interface isinf
       module procedure r_isinf
       module procedure d_isinf
    end interface 
    contains
! ------------------------------------------------
    elemental logical function r_isnan(x)
!  R_ISNAN - is the real number X a NaN?
!
    real(R),intent(in)::x
    real(R)::y
    y=x
    r_isnan=.not.rcompare(x,y)
    return
    end function r_isnan
! ------------------------------------------------
    elemental logical function d_isnan(x)
!  D_ISNAN - is the double-precision number X a NaN?
!
    real(D),intent(in)::x
    real(D)::y
    y=x
    d_isnan=.not.dcompare(x,y)
    return
    end function d_isnan
! ------------------------------------------------
    elemental logical function r_isinf(x)
!  R_ISINF - is the real number X equal to positive infinity?
!
    real(R),intent(in)::x
    r_isinf=x.gt.huge(x)
    return
    end function r_isinf
! ------------------------------------------------
    elemental logical function d_isinf(x)
!  D_ISINF - is the double precision number X equal to positive infinity?
!
    real(D),intent(in)::x
    d_isinf=x.gt.huge(x)
    return
    end function d_isinf
! ------------------------------------------------
    elemental logical function rcompare(x,y)
!  DCOMPARE - return true if the real numbers X and Y are not NaNs.
!
    real(R),intent(in)::x,y
    rcompare=x.lt.y.or.x.gt.y.or.x.eq.y
    return
    end function rcompare
! ------------------------------------------------
    elemental logical function dcompare(x,y)
!  DCOMPARE - return true if the double-precision numbers X and Y are not NaNs.
!
    real(D),intent(in)::x,y
    dcompare=x.lt.y.or.x.gt.y.or.x.eq.y
    return
    end function dcompare
! ------------------------------------------------
    end module inf_and_nan

    module grid_setup
!
!  SYNOPSIS
!    use grid_setup
!
!  DESCRIPTION
!   GRID_SETUP contains the initialization and indexing
!   routines for managing the model grids.
!
!  REQUIRED PACKAGES
!   grid_types, covar_setup - in main source directory
!   ferror, scalings - in support directory
!
!  ROUTINES IMPLEMENTED
!
!   pure subroutine zdiam(loc,low,high)
!   pure subroutine model_grid_boundary(south,north)
!   pure subroutine patch_radius(loc,lon,lat,z)
!   pure integer function seqid()
!   pure subroutine assimilation_boundary(south,north)
!   subroutine set_model_grid_boundary(south,north,psouth,pnorth)
!   subroutine set_patch_radius(lon,lat)
!   subroutine vertical_localization_setup(zfile)
!   subroutine set_sequence_id(id)
!
!  AUTHOR
!   Eric Kostelich, kostelich@asu.edu, 480-965-5006
!
!  MODIFICATION HISTORY
!   10/12/04 - first version derived from old grid_manager code.
!
    use covar_setup
    use ferror
!
!  Patch radius defaults.
!
    integer,parameter,private::XWIN_DEFAULT=3
    integer,parameter,private::YWIN_DEFAULT=3
!
!  The prefix X refers to quantities that index the longitudinal
!  ("horizontal") direction; Y for latitudinal.
!  Data are assimilated in rectangular patches of radius XWIN and YWIN.
!  Vertical radii are level-dependent.
!
    integer,save,private::xwin=XWIN_DEFAULT
    integer,save,private::ywin=YWIN_DEFAULT
!
!  We assimilate data in latitudinal strips.  When the program is run
!  on multiple processors, each instance gets a grid and an observation
!  file with header information that identifies the range ot longitudes
!  to which the data refer.  YSOUTH and YNORTH define the boundaries of
!  the model grid, which by default is the whole globe.  ASOUTH and ANORTH
!  identify the southern- and northernmost latitudes at which patches may
!  be centered for the data assimilation procedure.
!
    integer,save,private::ysouth=1
    integer,save,private::ynorth=LATG
    integer,save,private::asouth=1
    integer,save,private::anorth=LATG
!
!  The MRF code outputs values in arrays whose leading dimension is LONFD,
!  which is greater than LONF (the size of the longitude grid).  We
!  allocate, read, and write global arrays whose longitudinal dimension
!  is at most 1:LONF.
!
!  All grid arrays are indexed by (latitude,longitude,bred_vector).
!  The leading dimension is max(1,YLEFT-NPAD):min(LATG,YRIGHT+NPAD)
!  in all cases (including the global case).
!  The service routine LEADING_DIMENSIONS returns these values.
!
!  The convenience routine XY_ADJUST handles longitude wrapping at the
!  0-degree line and at the poles, when patches encompass grid points
!  opposite the pole.
!
!  To help keep track of the correspondence between grid and observation
!  arrays, the splitting routines insert "sequence ids" into the header
!  portion of the data files.  We store it here.  A zero value means
!  the the sequence id is undefined or will not be used.  If nonzero, we
!  usually use a date field in the form yyyyddmmhh.
!
    integer,save,private::sequence_id=0
!
!  The vertical thickness of each patch is determined by zrad, whose values
!  are read in by read_vert_info_file.
!
    integer,save,private::zrad(LEVS,LATG)=LEVS ! default: no vert localization
    contains
! -------------------
    pure subroutine zdiam(loc,low,high)
!  ZDIAM - return the lower and upper indices for the vertical levels
!  contained in the patch LOC.
!
    implicit none
    type(patch_index),intent(in)::loc
    integer,intent(out)::low,high
!
    integer::z
!
    z=zrad(loc%z,loc%y)
    low=max(loc%z-z,1)
    high=min(loc%z+z,LEVS)
    return
    end subroutine zdiam
! -------------------
    pure subroutine model_grid_boundary(south,north)
!  MODEL_GRID_BOUNDARY - return the latitude boundaries of the model grids.
!
    integer,intent(out)::south,north
!
    south=ysouth
    north=ynorth
    return
    end subroutine model_grid_boundary
! -------------------
    pure subroutine assimilation_boundary(south,north)
!  ASSIMILATION_BOUNDARY - return the starting and stopping latitudes at which
!  patches may be centered for the data assimilation.  These boundaries
!  must be in the closed interior of the model and observation
!  grid latitude boundaries.
!  Note: SET_MODEL_GRID_BOUNDARY must be called first.
!
    integer,intent(out)::south,north
!
    south=asouth
    north=anorth
    return
    end subroutine assimilation_boundary
! -------------------
    pure subroutine patch_radius(loc,lon,lat,z)
!  PATCH_RADIUS - return the patch radius in longitudinal (X),
!  latitudinal (Y) coordinates, and/or vertical (Z) coordinates
!  for a patch centered at LOC.  Right now we assume a constant patch radius,
!  but in the future we can allow for patch sizes that vary with location.
!  Service routine.
!  Errors signaled by 0 return values for lon,lat,z.
!
    implicit none
    type(patch_index),intent(in),optional::loc
    integer,intent(out),optional::lon,lat,z
!
    if(present(lon)) lon=xwin
    if(present(lat)) lat=ywin
    if(present(z)) then
       if(present(loc)) then
          z=zrad(loc%z,loc%y)
       else
          z=0
       endif
    endif
    return
    end subroutine patch_radius
! -------------------
    pure integer function seqid()
!  SEQID - return the sequence id of a split grid file; 0 if none appears
!  in the file or if the file contains the whole globe.
!
    seqid=sequence_id
    return
    end function seqid
! -------------------
    subroutine set_model_grid_boundary(south,north,psouth,pnorth)
!  SET_MODEL_GRID_BOUNDARY - define the southern- and northernmost latitudes
!  contained in the model grid.  Cannot be called more than once.
!  SOUTH, NORTH : define the latitude strip that contains all model grid points.
!  PSOUTH, PNORTH : the latitude strip at which patches may be centered
!    for the data assimilation procedure.
!
    integer,intent(in)::south,north,psouth,pnorth
!
    logical,save::grid_defined=.false.
!
    if(grid_defined) then
       call fabort('set_strip_boundary: cannot reset boundary')
    else if(south.lt.1.or.north.gt.LATG) then
       call fabort('set_strip_boundary: illegal parameter value')
    endif
    ysouth=south
    ynorth=north
    asouth=psouth
    anorth=pnorth
    grid_defined=.true.
    return
    end subroutine set_model_grid_boundary
! -------------------
    subroutine set_patch_radius(lon,lat)
!  SET_PATCH_RADIUS - set the patch radius in longitudinal (X) and
!  latitudinal (Y) coordinates. 
!  For the moment, this is constant for the entire globe.  In the future,
!  we might consider radii that vary with location; these might be set
!  in the vert_info file.
!
    implicit none
    integer,intent(in),optional::lon,lat
!
    if(present(lon)) xwin=lon
    if(present(lat)) ywin=lat
    if(xwin.lt.1.or.ywin.lt.1) call fabort('set_patch_radius: illegal argument')
    return
    end subroutine set_patch_radius
! -------------------
    subroutine vertical_localization_setup(zfile)
    character(*),intent(in)::zfile
!
    call read_vert_info_file(zfile,zrad)
    return
    end subroutine vertical_localization_setup
! -------------------
    subroutine set_sequence_id(id)
!  SET_SEQUENCE_ID - If ID is negative, then create an ID.  Otherwise, set the
!  sequence id to the value of ID.
!
    integer,intent(in)::id
!
    logical,save::called=.false.
!
    if(called) call fabort('set_sequence_id: cannot be called twice')
    called=.true.
    if(id.ge.0) then
       sequence_id=id
    else
       call system_clock(sequence_id)
    endif
    return
    end subroutine set_sequence_id
! -------------------
    end module grid_setup

      module fixio
!  FIXIO - routines adapted from 2001 MRF code to read and write
!  surface analysis files.
!
!  07/21/04 - First implementation by Eric
!  07/26/04 - Major rewrite by Istvan: elimination of all but two
!             subroutines and several unncesessary variables and
!             parameters 
!
!  SYNOPSIS: PARA_FIXO_R reads an NCEP surface file (unit number 
!            nread). The surface fields are first read into a
!            real*4 buffer (buffer1, buffer2, or buffer4) and then 
!            copied to the the appropriate real*8 arrays used in the 
!            model calculation
!            PARA_FIXIO_W writes an NCEP surface file. The real*8
!            fields are first copied into a real*4 buffer 
!
      use resolution
      use precision
      use grid_indexing,only:LONSPERLAT
      contains
!***********************************************************************
!
      SUBROUTINE PARA_FIXIO_R(LONF,LONF2,LATG,LATG2,TSEA,SMC,SHELEG, &
     &           STC,TG3,ZORL,CV, &
     &           CVB, &
     &           CVT,ALVSF,ALVWF,ALNSF,ALNWF,SLMSK,VFRAC,CANOPY,F10M, &
     &           VTYPE,STYPE,FACSF,FACWF,UUSTAR,FFMM,FFHH, &
     &           nread,xhour,idate)
!
!***********************************************************************
!
      implicit none
!
      integer LONF,LONF2,LATG,LATG2
      real(D) SMC(LONF,LATG,LSOIL),STC(LONF,LATG,LSOIL), &
     &     TSEA  (LONF,LATG),SHELEG(LONF,LATG),TG3     (LONF,LATG), &
     &     ZORL  (LONF,LATG),CV    (LONF,LATG),CVB   (LONF,LATG), &
     &     CVT   (LONF,LATG),ALVSF (LONF,LATG),ALVWF (LONF,LATG), &
     &     ALNSF (LONF,LATG),ALNWF (LONF,LATG),SLMSK (LONF,LATG), &
     &     VFRAC (LONF,LATG),CANOPY(LONF,LATG),F10M  (LONF,LATG), &
     &     VTYPE (LONF,LATG),STYPE (LONF,LATG),FACSF (LONF,LATG), &
     &     FACWF (LONF,LATG),UUSTAR(LONF,LATG),FFMM  (LONF,LATG), &
     &     FFHH  (LONF,LATG)

      integer jump

!      real(R) buff1(LONF2,LATG2),buff2(LONF2,LATG2,LSOIL), &
      real(R) buff1(LONF,LATG),buff2(LONF,LATG,LSOIL), &
         buff4(LONF,LATG,4),xhour
      integer nread,i,j,k,idate(4),lonsfc,latsfc,ivssfc
      CHARACTER(8) labfix(4)
!
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
!
      REWIND nread
      READ(nread)labfix
      READ(nread)xhour,IDATE,lonsfc,latsfc,ivssfc
      do k=3,12
        read(nread)
      enddo
      READ(NREAD) buff1
      rewind nread
      read(nread)
      read(nread)

      READ(NREAD) buff1
      DO J=1,LATG
         DO I=1,LONF
            TSEA(i,j)=buff1(i,j)
         ENDDO
      ENDDO

      READ(NREAD) buff2
      DO K=1,LSOIL
         DO J=1,LATG
            DO I=1,LONF
               SMC(i,j,k)=buff2(i,j,k)
            ENDDO
         ENDDO
      ENDDO

      READ(NREAD) buff1
      DO J=1,LATG
         DO I=1,LONF
            SHELEG(i,j)=buff1(i,j)
         ENDDO
      ENDDO

      READ(NREAD) buff2
      DO K = 1, LSOIL
         DO J=1,LATG
            DO I=1,LONF
               STC(i,j,k)=buff2(i,j,k)
            ENDDO
         ENDDO
      ENDDO

      READ(NREAD) buff1
      DO J=1,LATG
         DO I=1,LONF
            TG3(i,j)=buff1(i,j)
         ENDDO
      ENDDO

      READ(NREAD) buff1
      DO J=1,LATG
         DO I=1,LONF
            ZORL(i,j)=buff1(i,j)
         ENDDO
      ENDDO

      READ(NREAD) buff1
      DO J=1,LATG
         DO I=1,LONF
            CV(i,j)=buff1(i,j)
         ENDDO
      ENDDO

      READ(NREAD) buff1
      DO J=1,LATG
         DO I=1,LONF
            CVB(i,j)=buff1(i,j)
         ENDDO
      ENDDO
        
      READ(NREAD) buff1
      DO J=1,LATG
         DO I=1,LONF
            CVT(i,j)=buff1(i,j)
         ENDDO
      ENDDO

      READ(NREAD) buff4
      DO J=1,LATG
         DO I=1,LONF
            ALVSF(i,j)=buff4(i,j,1)
            ALVWF(i,j)=buff4(i,j,2)
            ALNSF(i,j)=buff4(i,j,3)
            ALNWF(i,j)=buff4(i,j,4)
         ENDDO
      ENDDO

      READ(NREAD) buff1
      DO J=1,LATG
         DO I=1,LONF
            SLMSK(i,j)=buff1(i,j)
         ENDDO
      ENDDO

      READ(NREAD) buff1
      DO J=1,LATG
         DO I=1,LONF
            VFRAC(i,j)=buff1(i,j)
         ENDDO
      ENDDO

      READ(NREAD) buff1
      DO J=1,LATG
         DO I=1,LONF
            CANOPY(i,j)=buff1(i,j)
         ENDDO
      ENDDO

      READ(NREAD) buff1
      DO J=1,LATG
         DO I=1,LONF
            F10M(i,j)=buff1(i,j)
         ENDDO
      ENDDO

      READ(NREAD) buff1
      VTYPE=buff1
      DO J=1,LATG
         DO I=1,LONF
            VTYPE(i,j)=buff1(i,j)
         ENDDO
      ENDDO

      READ(NREAD) buff1
      DO J=1,LATG
         DO I=1,LONF
            STYPE(i,j)=buff1(i,j)
         ENDDO
      ENDDO

      READ(NREAD) buff4(:,:,1:2)
      DO J=1,LATG
         DO I=1,LONF
            FACSF(i,j)=buff4(i,j,1)
            FACWF(i,j)=buff4(i,j,2)
         ENDDO
      ENDDO

      DO j=1,LATG
         DO i=1,LONF
            UUSTAR(i,j)=1.
            FFMM(i,j)=LOG(30.)
            FFHH(i,j)=LOG(30.)
         ENDDO
      ENDDO

!szunyogh 06/16/99
!     surface files written before 03/08/99 do not contain the records:
!     uustar, ffmm, ffhh
!     if uustar is not found the no attempt is made to read the two 
!     other records 
      JUMP=1
      READ(NREAD,END=200) buff1
      JUMP=0
200   continue
      IF (jump.eq.0) THEN
         UUSTAR=buff1
            
         READ(NREAD) buff1
         DO J=1,LATG
            DO I=1,LONF
               FFMM(i,j)=buff1(i,j)
            ENDDO
         ENDDO

         READ(NREAD) buff1
         DO J=1,LATG
            DO I=1,LONF
               FFHH(i,j)=buff1(i,j)
            ENDDO
         ENDDO
      ENDIF

      RETURN
      END SUBROUTINE PARA_FIXIO_R
!
!***********************************************************************
!
      SUBROUTINE PARA_FIXIO_W(LONF,LONF2,LATG,LATG2,TSEA,SMC,SHELEG, &
     &           STC,TG3,ZORL,CV, &
     &           CVB, &
     &           CVT,ALVSF,ALVWF,ALNSF,ALNWF,SLMSK,VFRAC,CANOPY,F10M, &
     &           VTYPE,STYPE,FACSF,FACWF,UUSTAR,FFMM,FFHH, &
     &           nw,yhour,idate)
!
!***********************************************************************
!
      implicit none
!
      integer LONF,LONF2,LATG,LATG2
      real (D) SMC(LONF,LATG,LSOIL),STC(LONF,LATG,LSOIL), &
     &     TSEA  (LONF,LATG),SHELEG(LONF,LATG),TG3   (LONF,LATG), &
     &     ZORL  (LONF,LATG),CV    (LONF,LATG),CVB   (LONF,LATG), &
     &     CVT   (LONF,LATG),ALVSF (LONF,LATG),ALVWF (LONF,LATG), &
     &     ALNSF (LONF,LATG),ALNWF (LONF,LATG),SLMSK (LONF,LATG), &
     &     VFRAC (LONF,LATG),CANOPY(LONF,LATG),F10M  (LONF,LATG), &
     &     VTYPE (LONF,LATG),STYPE (LONF,LATG),FACSF (LONF,LATG), &
     &     FACWF (LONF,LATG),UUSTAR(LONF,LATG),FFMM  (LONF,LATG), &
     &     FFHH  (LONF,LATG)

      real(R) buff1(LONF,LATG),buff2(LONF,LATG,LSOIL), &
         buff4(LONF,LATG,4),yhour
      integer nw,i,j,k,idate(4)
      CHARACTER(8) labfix(4)
      integer,save:: version
      data version/200004/
!
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
!

      REWIND nw
      labfix=CHAR(0)//CHAR(0)//CHAR(0)//CHAR(0)// &
     &       CHAR(0)//CHAR(0)//CHAR(0)//CHAR(0)
      write(nw)labfix
      write(nw)yhour,IDATE,LONF,LATG,version,LONSPERLAT

      DO J=1,LATG
         DO I=1,LONF
            buff1(i,j)=real(TSEA(i,j),kind(buff1))
         ENDDO
      ENDDO
      write(nw) buff1

      DO k=1,LSOIL
         DO J=1,LATG
            DO I=1,LONF
               buff2(i,j,k)=real(SMC(i,j,k),kind(buff2))
            ENDDO
         ENDDO
      ENDDO
      write(nw) buff2

      DO J=1,LATG
         DO I=1,LONF
            buff1(i,j)=real(SHELEG(i,j),kind(buff1))
         ENDDO
      ENDDO
      write(nw) buff1

      DO K = 1, LSOIL
         DO J=1,LATG
            DO I=1,LONF
               buff2(i,j,k)=real(STC(i,j,k),kind(buff2))
            ENDDO
         ENDDO
      ENDDO
      write(nw) buff2

      DO J=1,LATG
         DO I=1,LONF
            buff1(i,j)=real(TG3(i,j),kind(buff1))
         ENDDO
      ENDDO
      write(nw) buff1

      DO J=1,LATG
         DO I=1,LONF
            buff1(i,j)=real(ZORL(i,j),kind(buff1))
         ENDDO
      ENDDO
      write(nw) buff1

      DO J=1,LATG
         DO I=1,LONF
            buff1(i,j)=real(CV(i,j),kind(buff1))
         ENDDO
      ENDDO
      write(nw) buff1

      DO J=1,LATG
         DO I=1,LONF
            buff1(i,j)=real(CVB(i,j),kind(buff1))
         ENDDO
      ENDDO
      write(nw) buff1

      DO J=1,LATG
         DO I=1,LONF
            buff1(i,j)=real(CVT(i,j),kind(buff1))
         ENDDO
      ENDDO
      write(nw) buff1

      DO J=1,LATG
         DO I=1,LONF
            buff4(i,j,1)=real(ALVSF(i,j),kind(buff4))
            buff4(i,j,2)=real(ALVWF(i,j),kind(buff4))
            buff4(i,j,3)=real(ALNSF(i,j),kind(buff4))
            buff4(i,j,4)=real(ALNWF(i,j),kind(buff4))
         ENDDO
      ENDDO
      write(nw) buff4

      DO J=1,LATG
         DO I=1,LONF
            buff1(i,j)=real(SLMSK(i,j),kind(buff1))
         ENDDO
      ENDDO
      write(nw) buff1

      DO J=1,LATG
         DO I=1,LONF
            buff1(i,j)=real(VFRAC(i,j),kind(buff1))
         ENDDO
      ENDDO
      write(nw) buff1

      DO J=1,LATG
         DO I=1,LONF
            buff1(i,j)=real(CANOPY(i,j),kind(buff1))
         ENDDO
      ENDDO
      write(nw) buff1

      DO J=1,LATG
         DO I=1,LONF
            buff1(i,j)=real(F10M(i,j),kind(buff1))
         ENDDO
      ENDDO
      write(nw) buff1

      DO J=1,LATG
         DO I=1,LONF
            buff1(i,j)=real(VTYPE(i,j),kind(buff1))
         ENDDO
      ENDDO
      write(nw) buff1

      DO J=1,LATG
         DO I=1,LONF
            buff1(i,j)=real(STYPE(i,j),kind(buff1))
         ENDDO
      ENDDO
      write(nw) buff1

      DO J=1,LATG
         DO I=1,LONF
            buff4(i,j,1)=real(FACSF(i,j),kind(buff4))
            buff4(i,j,2)=real(FACWF(i,j),kind(buff4))
         ENDDO
      ENDDO
      write(nw) buff4(:,:,1:2)

      DO J=1,LATG
         DO I=1,LONF
            buff1(i,j)=real(UUSTAR(i,j),kind(buff1))
         ENDDO
      ENDDO
      write(nw) buff1

      DO J=1,LATG
         DO I=1,LONF
            buff1(i,j)=real(FFMM(i,j),kind(buff1))
         ENDDO
      ENDDO
      write(nw) buff1

      DO J=1,LATG
         DO I=1,LONF
            buff1(i,j)=real(FFHH(i,j),kind(buff1))
         ENDDO
      ENDDO
      write(nw) buff1

      RETURN
      END SUBROUTINE PARA_FIXIO_W
!--------------------
      end module fixio

    module preanalysis
!  PREANALYSIS - convert from sigma files to physical grid, and split
!  along latitude strips for efficient parallel operation on a Beowulf cluster.
!  This version is intended for the 2001 or 2004 versions of the GFS model.
!
! SYNPOSIS:
!    [options] input_file
!
!  There are two modes of operation.
!  1)  We need to create a set of observations, where we specify -o.
!      The input_file argument is the name of an observation file.
!      Only very simple preprocessing is done: we simply copy those observations
!      that belong to the appropriate latitudinal strip.
!  2)  We need to create a grid of model variables from a sigma file.
!      In this case, the required input_file argument
!      is a sigma file, which is assumed to contain the required spectral
!      coefficients and model variables in spectral coordinates.
!      input_file is a template name if NSOL > 1 (see -n below).
!      The output is a grid file containing the data structures
!      used in the data assimilation code.
!
!  A template name describes how the program should examine a numerical
!  sequence of files.  Given a string like "input", the program looks
!  for files name input1, input2, etc., if more than one input is expected.
!  Alternatively, the template name can be something like input%n.dat,
!  where the string '%n' is substituted with 1, 2, ..., as required.
!  In this case, we look for files named input1.dat, input2.dat, etc.
!
!  OPTIONS:
!  -b name  : NAME is the name of the output file containing the model grid 
!      data.  It is a template name if NP > 1 (see -p below).
!  -P : specifies that the input is not a GFS sigma file but a physical grid 
!      perturbation file.
!  -o name  : NAME is the name of the output file containing the observations in
!      the format needed by the data assimilation code.
!      It is a template name if NP > 1 (see -p below).
!  -s name  : NAME is the name of an input sigma file to which the various 
!      coefficients are written for conversion between spectral and 
!      physical units.  The output is in text format.
!  -v lev  : (default: lev=0)  set the verbosity to level LEV.
!      0 gives silent operation, 1 gives short details, 2 shows the status
!      of every operation.
!  -y yrad :  Make output files suitable for use with patches whose
!      vertical (latitudinal) radius is <= YRAD.
!  -n nsol : (default: nsol=40)  The number of ensemble solutions.
!      Incompatible with -o.  If NSOL > 1, then input_file is a template name.
!  -H header : (default: none)  Use the indicated 4-char header when splitting
!      files for mulitple processors.  The defaults are 'obs ' for observations
!      and 'grid' for the model grid.
!  -p np    : (default: np=2)  The number of partitions that we should make
!      of the output files.  This value is the number of processors on which
!      we expect to run the data assimilation step.
!  -q seqid : sequence id (usually the date in yyyymmddhh format) to expect
!      from the input files and the sequence id to place in the output.
!
!   input_file is a sigma file if -b (and/or -n) are specified.
!   input_file is an observation file of -o is specified.
!
! OTHER INFO:
!  -This program uses INNOSWAP and INSWAP for unformatted input and OUTNOSWAP
!  for unformatted output, as defined in module io.  Use the FORT90L
!  environment variable to specify whether byte-swapping should occur on
!  logical unit INNOSWAP (Lahey only).
!
!  -Although the GFS model uses arrays with leading dimension 1:LONFD,
!  we create, write, and use only arrays with longitude dimension 1:LONF.
!  Zero pads are written as needed on output, and the information in
!  rows LONF+1:LONFD is stripped on input.
!
! ATTRIBUTES:
!    Language: Fortran 95
!    Machine : Generic (except for optional FORT90L usage, specific to Lahey)
!
!  Modification history
!    09/10/05  Altered documentation and version to reflect compatibility
!              with both the 2001 and 2004 versions of the GFS (I hope).
!    06/29/05  Output grids in energy units instead of physical units.
!    06/17/05  New version that calls overhauls spectral code and re-introduces
!              support for reading the physical grid perturbation files.
!    05/29/05  Added option for namelist input (for debugging) and made changes
!              to reflect alterations of spectral code to handle the 2004 GFS.
!    03/07/05  Used revised spectral code to fix N/S hemisphere indexing
!    01/13/05  Added -A flag for simple selection of observation types to
!              distribute to the nodes
!    12/15/04  Modifications for more efficient GFS -> model grid processing:
!              Changed array subscript ordering for model grid.
!              Also removed special initialization step, since I can't figure
!              out how the original perturbation grid was scaled.
!              Instead, we ALWAYS start with a set of sigma files.
!              Runs with this version will require the sigma files output
!              by the initialization step of the old (~/nws) code version.
!    11/24/04  Initial version by Eric and Istvan for real observations.
!              The program processes raw_obs formats and simply copies
!              each observation to the appropriate latitude strip for parallel
!              operation of the data assimilation program.
!    07/22/04  Eric Kostelich, changed handling of unit numbers for
!              byte-swapping in the Lahey Linux implementation.
!    10/10/03  Eric Kostelich, optionally writes out coefficients for
!              conversion to physical units; for diagnostics package
!    08/23/03  Eric Kostelich, removed support for averaging and changed
!              to latitude-oriented strips
!    04/29/03  Eric Kostelich, bug fixes
!    04/17/03  Eric Kostelich, modified version for Beowulf cluster
!    10/04/02  Istvan Szunyogh, original version
!
    use spectral
    use readobs
    use resolution
    use io
    use constant
    use command_line_support
    implicit none
!
    character(*),parameter::VERSION='09/10/05 (2001/04 models, energy units)'
!
!  By default, the input is a sigma file; but if -P is specified, then
!  the input is a physical grid perturbation file.
!
    logical,save::input_is_sigma=.true.
!
!  By default, the output is an array of model variables for use in the
!  data assimilation code (-b option).
!
    logical,save::output_is_grid=.true.
!
!  Required input file specification - either a sigma file or a file
!  of observations.  It is a template name if processing more than one 
!  sigma file in an ensemble of solutions.
!
    character(MAX_FILE_NAME_LEN),save::infn=' '    ! no default
!
!  The name of the output file (-b or -o)
!
    character(MAX_FILE_NAME_LEN),save::outfn='egrid'
!
!  Vertical (latitudinal) radius for which outputs can be used
!
    integer,save::ywin=3
!
!  For -H option
!
    character(4),save::optional_header=' '
!
!  Number of partitions of the output data for the assimilation step.
!
    integer,save::nsplit=2
    contains
!----------------------------------------------------------------------------
    subroutine do_everything
!  DO_EVERYTHING - so we don't have to look for the main program at the
!  end of the file.
! 
    integer::nsol=40  ! default number of ensemble solutions
    character(4)::list='PTUV'  ! types of observations to assimilate
! 
    call parseline(nsol,list)
    if(verbosity().gt.VERB_SILENT) write(LOGFILE,100) version
100 format('preanalysis: version ',a)
!
!  Process the model grid or the observations as required.
!
    if(output_is_grid) then
       if(verbosity().gt.VERB_TERSE) write(LOGFILE,101) nsol
101    format('preanalysis: nsol: ',i0)
       call create_grid(nsol)
    else
       call read_observations(infn,outfn,nsplit,ywin,list)
    endif
    return
    end subroutine do_everything
!---------------------------------------------------------------------------
    subroutine create_grid(nsol)
!  CREATE_GRID - create the physical model grid from a collection of
!  sigma files.
!  Side effects:  Opens and closes INSWAP and OUTNOSWAP.
!
    use fsplit
    integer,intent(in)::nsol
!
!  Local variables
!
    integer::k
    real(GRIDKIND),allocatable::egrid(:,:,:,:,:)
    character(MAX_FILE_NAME_LEN)::fn
    type(sigma_file_header)::header
    type(spectral_coeffs)::spect
!
!  Initialize the spectral transform package using the first (or only)
!  sigma file in the series.
!
    if(input_is_sigma) then
       if(nsol.eq.1) then    ! the given sigma file will do
          fn=infn
       else
          call numeric_filename(infn,'%n',1,fn)
       endif
       call spectral_code_init(fn,header)
    endif
!
    allocate(egrid(LONF,NAVARS,LATG,LEVS,nsol))
    if(verbosity().gt.VERB_SILENT) write(LOGFILE,111) trim(infn)
111 format('preanalysis: input sigma file(s): ',a)
!
!  Process all input files to get the physical grid for all ensemble members.
!
    do k=1,nsol
       if(nsol.eq.1) then  ! not a template name
          fn=infn
       else
          call numeric_filename(infn,'%n',k,fn)
       endif
       if(input_is_sigma) then
          call read_sigma_file(fn,header,spect)
          call to_physical_space(spect,egrid(1,1,1,1,k))
       else
          call read_perturbation_file(fn,egrid(1,1,1,1,k))
       endif
    enddo
!
    if(len_trim(optional_header).eq.0) optional_header='grid'
    if(verbosity().gt.VERB_SILENT) then
       write(LOGFILE,112) trim(outfn)
112    format('preanalysis: output: ',a)
       if(len_trim(optional_header).gt.0) &
          write(LOGFILE,113) trim(optional_header)
113    format('preanalysis: header label: ',a)
    endif
!
!  Split the physical grid into pieces for the other processors
!
    call grid_split(egrid,outfn,nsol,nsplit,ywin,optional_header)
    return
    end subroutine create_grid
!----------------------------------------------------------------------------
    subroutine read_perturbation_file(fn,grid)
!  READ_PERTURBATION_FILE - handle the special startup case where the
!  initial condition is a physical grid in GFS format.
!  These files have wind in meters per second and the surface pressure
!  in ln(dPa).
!
    use mrf_ids   ! from support directory
    character(*),intent(in)::fn
    real(GRIDKIND),intent(out)::grid(LONF,NAVARS,LATG,LEVS)
!
    real(D)::obsgrid(LONFD,2,NVAR,LATG2,LEVS)
    integer::ierr,j,lev
!
    open(INSWAP,file=fn,form='unformatted',status='old',iostat=ierr)
    if(ierr.ne.0) call fexit('read_perturbation_file: cannot open '//trim(fn))
    if(verbosity().gt.VERB_TERSE) call finfo('reading '//trim(fn))
!
    read(INSWAP) obsgrid
    close(INSWAP)
!
    do lev=1,LEVS
       do j=1,LATG2
          !
          !  South Pole to Equator
          !
          grid(:,PRES_TYPE,j,lev)= &
             real(10.0*exp(obsgrid(1:LONF,SH,Q,j,lev)),kind(grid))
          grid(:,TEMP_TYPE,j,lev)=real(obsgrid(1:LONF,SH,TE,j,lev),kind(grid))
          grid(:,UWIND_TYPE,j,lev)=real(obsgrid(1:LONF,SH,UG,j,lev),kind(grid))
          grid(:,VWIND_TYPE,j,lev)=real(obsgrid(1:LONF,SH,VG,j,lev),kind(grid))
          !
          !  Equator to North Pole; otherwise identical conversions
          !
          grid(:,PRES_TYPE,j+LATG2,lev)= &
             real(10.0*exp(obsgrid(1:LONF,NH,Q,LATG2-j+1,lev)),kind(grid))
          grid(:,TEMP_TYPE,j+LATG2,lev)= &
             real(obsgrid(1:LONF,NH,TE,LATG2-j+1,lev),kind(grid))
          grid(:,UWIND_TYPE,j+LATG2,lev)= &
             real(obsgrid(1:LONF,NH,UG,LATG2-j+1,lev),kind(grid))
          grid(:,VWIND_TYPE,j+LATG2,lev)= &
             real(obsgrid(1:LONF,NH,VG,LATG2-j+1,lev),kind(grid))
       enddo
    enddo
    return
    end subroutine read_perturbation_file
!----------------------------------------------------------------------------
    subroutine parseline(ensemble_size,list)
!  PARSELINE - parse the command line.
!
    implicit none
    integer,intent(inout)::ensemble_size
    character(*),intent(inout)::list
!
!  Local variables
!
    character(*),parameter::OPTLIST='A:b:H:hN:n:o:Pp:q:v:y:'
    character(MAX_FILE_NAME_LEN)::optarg,nmlfile
    character(8)::assimlist
    integer::nargs,iopt,optind,verblev,nsol,iseq
    logical::have_b,have_o
    namelist/input/ assimlist,infn,outfn,nsol,nsplit,verblev,ywin, &
       optional_header,output_is_grid
    integer,external::iargc  ! g95 intrinsic
!
!  NARGS is the number of command-line arguments EXCLUDING the program name
!
    nargs=iargc()
    have_b=.false.
    have_o=.false.
    nmlfile=' '
    assimlist=list
    nsol=ensemble_size
    if(nargs.lt.2) call usage
    do 
       call getopt(iopt,optarg,optind,optlist)
       if(iopt.lt.0) exit
       select case(char(iopt))
       case('A')  ! list of variables to be assimilated
          list=optarg
       case('b')
          outfn=optarg
          have_b=.true.
          output_is_grid=.true.
       case('H')
          optional_header=optarg
       case('h')
          call usage
       case('N')    ! namelist input comes from the named file
          nmlfile=optarg
          open(unit=IN,file=nmlfile,status='old')
          read(IN,input)
          close(IN)
       case('n') 
          read(optarg,*) nsol
       case('o')
          outfn=optarg
          have_o=.true.
          output_is_grid=.false.
       case('P')
          input_is_sigma=.false.
       case('p')
          read(optarg,*) nsplit
       case('q')
          read(optarg,*) iseq
          call set_sequence_id(iseq)
       case('v')
          read(optarg,*) verblev
          call set_verbosity(verblev)
       case('y')
          read(optarg,*) ywin
       case default
          call program_exit(1)     ! getopt prints message
       endselect
    enddo
!
!  Get the required argument if no namelist input is given
!
    if(len_trim(nmlfile).eq.0) then
       if(nargs.lt.optind) call usage
       call getarg(nargs,infn)
    endif
    list=assimlist
    ensemble_size=nsol
!
!  Brief sanity checks
!
    if(have_b.and.have_o) call fexit('-b and -o are mutually exclusive options')
    if(nsol.lt.1) call fexit('nsol must be > 0')
    if(nsplit.lt.1) call fexit('nsplit must be > 0')
    if(len_trim(infn).eq.0) &
       call fexit('input observation or sigma file must be specified')
    return
!
    contains
       subroutine usage
       write(IERR,101) VERSION
101    format('preanalysis: version ',a/ &
          'usage: three basic command lines:'/ &
          '1. preanalysis -b egrid [-p nproc] [-n nsol] sigma,'/ &
          '   where sigma holds the spectral coords of the '/ &
          '   GFS model grid (one file per ensemble member)'/ &
          '   and the output file family egrid#n holds the physical grid'/ &
          '   (NRPOC slices, each with NSOL members)')
       write(IERR,102)
102    format('2. preanalysis -P -b egrid [-p nproc] [-n nsol] grid,'/ &
          '   where sigref is a reference GFS sigma file'/ &
          '   and grid is a template name that specifies a family of'/ &
          '   physical grid perturbation files'/ &
          'Specify -P with -b only for the first step in a cycle.')
       write(IERR,103)
103    format('3. preanalysis -o obsgrid [-p nproc] obsdata'/ &
          '   where obsdata holds a file of "real" observations'/ &
          '   and the output file family obsgrid#n holds the NPROC'/ &
          '   slices of the obsdata, one per processor in latitude strips')
       write(IERR,104)
104    format('Other options:'/ &
          '[-A obslist] (P:pressure, T:temperature, U,V:wind components)'/ &
          '[-v verblev] (0:silent, 2:verbose)'/ &
          '[-N input_file] (read namelist data from input_file)'/ &
          '[-y padding] (default: 3)'/ &
          '[-p nsplit] (number of splits of output files: default 2)'/ &
          '[-q seqid] (sequence id, e.g., yyyymmddhh)')
       call program_exit(1)
       end subroutine usage
    end subroutine parseline
    end module preanalysis
!-------------------------------------------------------------------------
! MAIN.
!
    use preanalysis
! 
    call do_everything
    call program_exit(0)
    end

    module assim_vars
!
!  SYNOPSIS
!    use assim_vars
!
!  DESCRIPTION
!  ASSIM_VARS contains basic data assimilation variables. 
!  They are set by set_varname routines contained herein.
!  The array ERRCODES is the only "global" variable in the code, but it
!  looks enough like a function call that I've decided to leave it public
!  (though when F2003 compilers become widely available, it can be made
!  protected).
!
!  REQUIRED PACKAGES
!
!   precision, ferror, resolution - in support directory
!
!  ROUTINES IMPLEMENTED
!
!   subroutine set_ensemble_size(isol)
!   pure integer function ensemble_size()
!   subroutine set_verbosity(verb)
!   pure integer function verbosity()
!
!  AUTHOR
!   Eric Kostelich, kostelich@asu.edu, 480-965-5006.
!
    use precision
    use ferror
    implicit none
!
!  VERBLEV - 0:silent, 1:basics, 2:some status, 3:chatty
!  See set_verbosity and verbosity().
!
    integer,parameter::VERB_SILENT=0
    integer,parameter::VERB_TERSE=1
    integer,parameter::VERB_STATUS=2
    integer,parameter::VERB_CHATTY=3
    integer,save,private::verblev=VERB_TERSE
!
!  Number of Assimilated VARiables
!
    integer,parameter::NAVARS=4
!
! NSOL - number of ensemble solutions
!
    integer,save,private::nsol=40
    contains
!----------------------------
    subroutine set_ensemble_size(isol)
!  SET_ENSEMBLE_SIZE - set nsol.  Brian's method as implemented here assumes
!  that the local rank is nsol-1.
!
    integer,intent(in)::isol
    character(80)::Msg
!
    if(isol.lt.1) then
       write(msg,100) isol
100    format('set_ensemble_size: bad ensemble size: ',i0)
       call fabort(trim(msg))
    endif
    nsol=isol
    return
    end subroutine set_ensemble_size
!----------------------------
    pure integer function ensemble_size()
!  ENSEMBLE_SIZE - return the number of ensemble solutions.
! 
    ensemble_size=nsol
    return
    end function ensemble_size
!----------------------------
    subroutine set_verbosity(verb)
!  SET_VERBOSITY - we don't check the value, but the range of meaningful
!  ones is listed above.
!
    integer,intent(in)::verb
!
    if(verb.lt.VERB_SILENT) then
       verblev=VERB_SILENT
    else if(verb.gt.VERB_CHATTY) then
       verblev=VERB_CHATTY
    else
       verblev=verb
    endif
    return
    end subroutine set_verbosity
!----------------------------
    pure integer function verbosity()
!  VERBOSITY - return the verbosity level.
!
    verbosity=verblev
    return
    end function verbosity
!----------------------------
    end module assim_vars

    module grid_io
!
!  SYNOPSIS
!    use grid_io
!
!  DESCRIPTION
!   GRID_IO contains routines for reading and writing the physical model grid
!   and Gyorgyi's observation formats.
!
!  ROUTINES IMPLEMENTED
!   subroutine read_grid_header(bfile,expect,south,north,psouth,pnorth,nsol,
!      nassim,seqno)
!   subroutine read_model_grid(grid,south,north,nsol)
!   subroutine read_nature_grid(header,truthfn,seq)
!   subroutine write_grid_slice(gfile,header,south,north,grid,lower,upper,nsol,
!      psouth,pnorth)
!   subroutine output_analysis(analysis,lower,upper,nsol,afile,header)
!   subroutine read_obs_slice(ofile,expect,nobs,obsarray)
!   subroutine write_obs_slice(ofile,header,south,north,obs,nobs)
!
!  AUTHOR
!   Eric Kostelich, kostelich@asu.edu, 480-965-5006
!
!  MODIFICATION HISTORY
!  08/08/05 - added DUMP_LOC debugging parameter
!  08/06/05 - added GRIDKIND parameter to adjust internal grid precision and 
!             IOKIND parameter to adjust i/o precision
!  08/01/05 - added rescaling of grid in OUTPUT_ANALYSIS; added 
!             single-precision i/o buffers; removed GRIDKIND parameter.
!  07/31/05 - removed i/o of observations
!  01/12/05 - raw_to_model_obs removed.  This version reads and writes
!             observations in the raw_obs format only.
!  12/14/04 - altered input/output grid indices for more efficient processing
!             by pre- and postanalysis.
!  11/10/04 - rewrite to correspond to new data assimilation array indexing.
!
!
!  REQUIRED PACKAGES
!
    use grid_indexing
    use kdtree
    use ferror
    use io
    use resolution
    implicit none
!
!  DUMP_LOC is the patch location (if any) where verbose output to DUMPUNIT
!  should occur.
!
    type(patch_index),save::dump_loc=patch_index(0,0,0)  ! default none
    contains
! ---------------------------------------------------------------------
    subroutine read_grid_header(bfile,expect,south,north,psouth,pnorth,nsol, &
       nassim,seqno)
!  READ_GRID_HEADER - read the header record from a model grid file created
!  by preanalysis.  This routine opens BFILE and KEEPS it open.
!  Side effects:
!   - opens INNOSWAP and keeps it open.
!   - positions BFILE to just before the record containing the model grid.
!    READ_GRID_HEADER may be followed immediately by a call to READ_MODEL_GRID.
!
!  Arguments:
!  BFILE   : name of input file
!  EXPECT  : 4-character header string to look for.  If set to 'none',
!     then we assume that the input file contains no header data at all
!     and holds the entire global grid.
!  SOUTH  := Southernmost latitude contained in the grid file.
!  NORTH  := Northernmost latitude index contained in the grid file.
!  PSOUTH, PNORTH := Latitudes between which data assimilation patches can
!     be centered.
!  NSOL  := number of ensemble solutions in the grid file
!  NASSIM := number of model variables available for assimilation in the file.
!  SEQNO := sequence number of the grid file.
!
    character(*),intent(in)::bfile
    character(*),intent(in)::expect  ! 'none' or 'grid'
    integer,intent(out)::south,north,psouth,pnorth,nsol,nassim,seqno
!
    character(4)::ftype
    integer::info
!
    open(unit=INNOSWAP,form='unformatted',status='old',file=bfile,iostat=info)
    if(info.ne.0) call fexit(trim(bfile)//': cannot open',errcode=2)
!
!  If the file is to be the whole globe, indicated by an expected header
!  string of 'none', then the actual file contains no header record except
!  for the date in yyyymmddhh format.  Supply default values in this case.
!
    if(expect.eq.'none') then
       south=1
       north=LATG
       psouth=1
       pnorth=LATG
       nassim=NAVARS
       ftype='none'
       read(INNOSWAP) seqno,nsol
    else
       read(INNOSWAP) ftype,seqno,south,north,psouth,pnorth,nsol,nassim
       if(nassim.ne.NAVARS) then
          write(IERR,900) ftype,seqno
          write(IERR,901) south,north,psouth,pnorth
          write(IERR,902) nsol,nassim
          call fexit('read_grid_header: nassim must be 4 in this version')
       endif
    endif
900 format('read_grid_header: bad header'/'ftype: ',a,' seqno: ',i0)
901 format('read_grid_header: south: ',i0,' north: ',i0,' psouth: ',i0, &
       ' pnorth: ',i0)
902 format('read_grid_header: nsol: ',i0,' nassim: ',i0)
!
!  Sanity checks on the header
!
    if(ftype.ne.expect) then
       write(IERR,100) trim(bfile),ftype,expect
100    format(a,': header is: ',a,' expected: ',a)
       call fexit(trim(bfile)//': wrong grid file header',2)
    else if(seqno.ne.seqid()) then
       write(IERR,101) trim(bfile),seqno,seqid()
101    format(a,': sequence id is: ',i0,' expected: ',i0)
       call fexit(trim(bfile)//': unexpected sequence number',2)
    else if(south.lt.1.or.north.gt.LATG.or.south.gt.north.or.psouth.lt.south &
      .or.pnorth.gt.north) then
       write(IERR,110) trim(bfile),south,north,psouth,pnorth
       call fexit(trim(bfile)//': start/stop indices out of range',2)
    endif
110 format(a,': nonsensical values for south=',i0,' north=',i0, &
       ' psouth=',i0,' pnorth=',i0)
    return
    end subroutine read_grid_header
! ---------------------
    subroutine read_model_grid(g,south,north,nsol)
!  READ_MODEL_GRID - read a section of the background grid from a previously
!  split file (and do some basic sanity checks).
!  Exit if an error occurs.
!
!  Arguments:
!  SOUTH : Southernmost latitude expected in the grid file.
!  NORTH : Northernmost latitude index expected in the grid file.
!  NSOL : number of ensemble solutions expected in the grid file.
!  G  := Allocated grid slice containing the grid data from the file.
!     The latitude dimension goes from SOUTH to NORTH.
!  Side effects:
!  - Must be preceded by a call to READ_GRID_HEADER.
!  - Closes INNOSWAP.
!
    integer,intent(in)::south,north,nsol
    real(GRIDKIND),intent(out)::g(LONF,NAVARS,south:north,LEVS,nsol)
!
    real(IOKIND),allocatable::buf(:,:,:,:,:)
!
    if(IOKIND.ne.GRIDKIND) then
       allocate(buf(LONF,NAVARS,south:north,LEVS,nsol))
       read(INNOSWAP) buf
       g=buf
    else
       read(INNOSWAP) g
    endif
    close(INNOSWAP)
    return
    end subroutine read_model_grid
! -------------------
    subroutine write_grid_slice(gfile,header,south,north,g,lower,upper,nsol, &
       psouth,pnorth)
! WRITE_GRID_SLICE - Write a section of the global background grid
!  to the indicated output file in latitude-major format.
!  Halt the program if an error occurs.
!  GFILE   : name of output grid file
!  HEADER  : 4-character header string to use.  If set to 'none', we
!            write no header.
!  NORTH, SOUTH :   Define the boundaries of the latitudinal strip to write out.
!  ISTART  : index at which data assimilation should begin for the strip.
!    Assimilation occurs at patches centered at latitudes ISTART, ISTART+1,...
!    ISTART+YWIN-1, where YWIN is obtained from PATCH_RADIUS.
!  GRID  :=: grid of model data to output.  On return, contains converted/scaled
!    data in latitudes SOUTH to NORTH.
!  LOWER, UPPER : latitude dimensions of GRID.
!  NB      : the number of ensemble solutions to output.
!  PSOUTH, PNORTH : if present, these define the latitude strip over which
!    patches may be centered for the data assimilation (mainly useful in
!    preanalysis).  If absent, PSOUTH and PNORTH coincide with SOUTH and NORTH.
!    They are meaningful only if HEADER isn't 'NONE'.
!  Side effects:
!  - Opens and closes OUTNOSWAP.
!
    character(*),intent(in)::gfile
    character(*),intent(in)::header
    integer,intent(in)::south,north,lower,upper,nsol
    real(GRIDKIND),intent(in)::g(LONF,NAVARS,lower:upper,LEVS,nsol)
    integer,intent(in),optional::psouth,pnorth
!
!  Local variables
!
    integer::info,asouth,anorth,id
    character(4)::ftype
    real(IOKIND),allocatable::buf(:,:,:,:,:)
!
!  Sanity checks
!
    if(south.lt.lower.or.north.gt.upper.or.south.gt.north.or.nsol.lt.1.or. &
       min(south,lower).lt.1.or.max(north,upper).gt.LATG) &
          call fabort('write_grid_slice: bad arguments')
!
    open(unit=OUTNOSWAP,file=gfile,form='unformatted',action='write', &
       position='rewind',iostat=info)  ! overwrite any predecessor
    if(info.ne.0) call fexit(trim(gfile)//': cannot open',errcode=2)
!
!  Write header
!
    ftype=header
    if(ftype.ne.'none') then
       if(present(psouth)) then
          asouth=psouth
       else
          asouth=south
       endif
       if(present(pnorth)) then
          anorth=pnorth
       else
          anorth=north
       endif
       id=seqid()
       if(verbosity().gt.VERB_TERSE) &
          write(IERR,100) trim(gfile),south,north,nsol,asouth,anorth
100    format('write_grid_slice: ',a/'   south: ',i3,' north: ',i3,' nsol: ', &
          i3,' asouth: ',i3,' anorth: ',i3)
       write(OUTNOSWAP) ftype,id,south,north,asouth,anorth,nsol,NAVARS
    else
       write(OUTNOSWAP) seqid(),nsol
    endif
!
    if(IOKIND.ne.GRIDKIND) then
       allocate(buf(LONF,NAVARS,lower:upper,LEVS,nsol))
       buf=g
       write(OUTNOSWAP) buf(:,:,south:north,:,:)
    else
       write(OUTNOSWAP) g(:,:,south:north,:,:)
    endif
    close(OUTNOSWAP)
    return
    end subroutine write_grid_slice
!-------------------------------------
    subroutine output_analysis(agrid,lower,upper,nsol,afile,header)
!  OUTPUT_ANALYSIS - output the given grid.
!  AGRID  : array holding the analysis at each grid point.
!  LOWER, UPPER  : southern- and northernmost latitudes in the analysis.
!  AFILE  : must be nonblank and contain the name of the file to which
!            we output the analysis.
!  NSOL  : number of ensemble solutions to output
!  HEADER  : 4-character header to output
!  Side effects:
!  - opens and closes OUTNOSWAP (via write_grid_slice)
!
    integer,intent(in)::lower,upper,nsol
    real(GRIDKIND),intent(in)::agrid(nsol,lower:upper,LEVS,LONF,NAVARS)
    character(*),intent(in)::afile,header
!
    integer::south,north,j,k,lev
    character(4)::hdr
    real(GRIDKIND),allocatable::transgrid(:,:,:,:,:)
!
    hdr=header
    call assimilation_boundary(south,north)
    if(lower.gt.south.or.upper.lt.north) &
       call fabort('output_analysis: analysis array too small')
    if(south.eq.1.and.north.ge.LATG) then
       north=LATG
       hdr='none'
    else
       hdr=header
    endif
!
!  Copy contents of analysis grid to a grid whose dimensions match
!  what's expected for output.  This code isn't cache-friendly.
!  If it proves to be a problem then we can perform an intermediate
!  transpose to an array of shape (LONF,NAVARS,nsol,lower:upper,LEVS).
!
    allocate(transgrid(LONF,NAVARS,lower:upper,LEVS,nsol))
    do j=1,nsol
       do k=lower,upper
          do lev=1,LEVS
             transgrid(:,:,k,lev,j)=agrid(j,k,lev,:,:)
          enddo
       enddo
    enddo
    call write_grid_slice(afile,hdr,south,north,transgrid,lower,upper,nsol)
    return
    end subroutine output_analysis
! ---------------------------------------------------
    end module grid_io
